package com.csc.library.components;

import com.csc.library.utilities.ThaiUtilities;

  /**
   *  <strong>Edit 2008/09/15 by James </strong><br />
   *  <p>
   *  -  option ҧ listbox 㹡óշҧҨҡ systemcode <br/>
   *     default  false
   *    <p><ul><u>ҹ</u>
   *    <li> <code>&lt;BLANKOPTION&gt; true&lt;/BLANKOPTION&gt;</code>  protable
   *   ǹͧ component ͧŴ</li>
   *   <li> setBlank</li>
   *   </ul>
   *   </p>
   *    <blockquote><u>ŷ</u><br />&lt;select name='com_name' size='1'&gt;<br />&lt;option value=''&gt;   &lt;/option&gt;<br /> 
   *     ...<br />...<br />&lt;/select&gt;</blockquote>
   *   </p>
   */

public class ListBox extends MyTag {

	private static final long serialVersionUID = 1L;
	static final String BLANK_OPTION = "<option value=\"\">   </option>";
	String tagInput = "";
	String hspace = "";
	String checked = "";
	String sizel = "";
	String multiple = "";
	boolean blank = false;

	public ListBox() {
		this.type = "list";
	}

	public ListBox(ComponentManager cm) {
		super(cm); 
		this.setValidCode(cm.getProperty("validCode"));
		this.setMultiple(cm.getProperty("multiple"));
		this.setSizel(cm.getProperty("sizel"));
		this.setTable(cm.getProperty("table"));
		if(!cm.getString().trim().equals("")){
			this.setChecked(cm.getString().trim());
		} else {
			this.setChecked(cm.getProperty("defaultvalue").trim());
		}
		
		String blankOpt = cm.getProperty("blankoption");
		if(blankOpt !=null && "true".equalsIgnoreCase(blankOpt)) {
			setBlank(true);
		}
		this.ini();
	}
	
	/**
	 * Edit by : james <br/>
	 * Edit date: 2008-09-12 <br/>
	 *  tag options ҧ 1 ѹ <br/>
	 * <code>&lt;option value=&quot;&quot;&gt;   &lt;/option&gt;<code>
	 */
	public void ini() {
		ThaiUtilities ethai = new ThaiUtilities();
		String label2;
		String tmpV;
		String tmpL="";
		//String input2 = "";
		
		tagInput = label2 = "";
		
		StringBuilder tag = new StringBuilder();
		StringBuilder options = new StringBuilder();
		
		if (sysCode != null) {
			
			if( blank && useValidCode) {
				options.append(BLANK_OPTION);
			}
			
			for (int point = 0; point < sysCode.length; point++) {
				tmpV = sysCode[point][0];
				
				if((sysCode[point][1]==null)){
					break;
				}
				tmpL = this.spilltLang(sysCode[point][1]);	
				
				// edit ͵ͧʴ
				tmpL = ethai.ASCII2Unicode(tmpL);   
				
				if ((tmpV != null) && (tmpL != null) && (!tmpV.equals("")) && (!tmpL.equals("")) && (!tmpV.equals("null"))) {
					
					options.append("<option ");
					options.append(" value=\"").append(tmpV).append("\" ");
					
					if ((this.checked != null) && (this.checked.equalsIgnoreCase(tmpV))) {
						options.append("selected");
					}
					options.append(" >");
					options.append(tmpL).append("</option>");

				}
			}
		
			tag.append("<select name=\"").append(this.name).append("\" ");
			tag.append("size=\"").append(this.sizel).append("\" ");
			
			if("true".equalsIgnoreCase(this.disable)) {
				tag.append(" disabled ");
			}
			if( this.onClick != null && !this.onClick.equals("") ){
				tag.append("onClick=\"").append( this.onClick ).append("\" ");
		    }
		    if( this.onChange != null && !this.onChange.equals("") ){
		    	tag.append("onChange=\"").append( this.onChange ).append("sysIsEdit();").append("\" ");
		    }
			if( this.onBlur != null && !this.onBlur.equals("") ){
				tag.append("onBlur=\"").append( this.onBlur ).append("\" ");
		    }
			if( this.onKeyUp != null && !this.onKeyUp.equals("") ){
				tag.append("onKeyUp=\"").append( this.onKeyUp ).append("\" ");
		    }
			if( this.onMouseOver!= null && !this.onMouseOver.equals("") ){
				tag.append("onMouseOver=\"").append( this.onMouseOver ).append("\" ");
		    }
			if( this.onMouseOut != null && !this.onMouseOut.equals("") ){
				tag.append("onMouseOut=\"").append( this.onMouseOut ).append("\" ");
		    }
			
			if( com != null && com.getDescription() != null && com.getDescription().equals("")){
				tag.append("alt=\"").append( com.getDescription()).append("\" ");
		    }
			
			tag.append(multiple);

			tag.append(" >");
			tag.append(options.toString());
			tag.append("</select>").append(label2);
			
			this.tagInput = tag.toString();
		}
	}
	public String process() {
		this.ini();
		if ((this.point != null) && (this.point.equalsIgnoreCase("l"))) {
			return this.tagInput + this.hspace + this.label;
		} else {
			return this.label + this.hspace + this.tagInput;
		}
	}
	public void setSpace(int space) {
		for (int i = 0; i < space; i++) {
			hspace = hspace + "&nbsp;";
		}
	}
	public void setSelect(String[][] code) {
		sysCode = code;
	}
	public void setSelect(String value, String label) {
		int i = 0;
		if (this.sysCode.length != 0) {
			i = this.sysCode.length;
		}
		sysCode[i][0] = value;
		sysCode[i][1] = label;
	}
	public String getInput() {
		return this.tagInput;
	}
	public void setChecked(String check) {
		this.checked = check;
	}
	public void setSizel(String sizel) {
		this.sizel = sizel;
	}
	public void setMultiple(String multiple) {
		this.multiple = multiple;
	}
	public void setBlank(boolean blank){
		this.blank = blank;
	}
}
