package com.csc.library.components;

import org.apache.commons.lang.StringUtils;

public class Radio extends MyTag {
	private static final long serialVersionUID = 1L;
	
	private String tagInput = "";
	private String hspace = "";
	private String checked = "";
	private String br = "\n";
	
	public Radio() {
		this.type = "radio";
	}

	public Radio(ComponentManager cm) {
		super(cm);
		
		if(StringUtils.isNotBlank(cm.getString())) {
			this.setChecked(cm.getString());
		} else {
			this.setChecked(cm.getProperty("defaultvalue"));
		}
		
		this.setValidCode(cm.getProperty("validCode"));
		this.setBR(cm.getProperty("br"));
		this.ini();
	}

	public void ini() {
		
		// edit by james 24-06-2008
		
		String tmpV, tmpL;
		StringBuilder html = new StringBuilder();
		
		if (sysCode != null) {
			for (String code[]: sysCode) {
				
				tmpV = code[0];
				if((code[1] == null)) {
					break;
				}
				
				tmpL = this.spilltLang(code[1]);	

				html.append("<label>");
				html.append("<input type=\"").append(this.type).append("\" ");
				html.append("name=\"").append(this.name).append("\" ");
				html.append("value=\"").append( tmpV ).append("\" ");
				
				if ((this.checked != null) && (this.checked.equalsIgnoreCase(tmpV))) {
			    	  html.append("checked=\"checked\" ");
			    }
				
				if( this.disable != null && this.disable.equalsIgnoreCase("true") ){
			    	  html.append("disabled=\"disabled\" ");
			    }
				if( this.onMouseOver!= null && !this.onMouseOver.equals("") ){
			    	  html.append("onMouseOver=\"").append( this.onMouseOver ).append("\" ");
			    }
				if( this.onMouseOut != null && !this.onMouseOut.equals("") ){
			    html.append("onMouseOut=\"").append( this.onMouseOut ).append("\" ");
			    }
				if( this.onClick != null && !this.onClick.equals("") ){
			    	html.append("onClick=\"").append( this.onClick ).append("\" ");
			    }
			    if( this.onChange != null && !this.onChange.equals("") ){
			    	html.append("onChange=\"").append( this.onChange ).append("sysIsEdit();").append("\" ");
			    }
				if( this.onBlur != null && !this.onBlur.equals("") ){
			   	  html.append("onBlur=\"").append( this.onBlur ).append("\" ");
			    }
				if( com != null && com.getAlt() != null && com.getAlt().equals("")){
			    	html.append("alt=\"").append( com.getAlt()).append("\" ");
			    }
				
				html.append(" />").append(this.hspace).append( tmpL ).append("</label>&nbsp;").append(br);

			}
		}
		this.tagInput = html.toString();
	}

	public String process() {
		this.ini();
		return this.tagInput;
	}

	public void setSpace(int space) {
		for (int i = 0; i < space; i++) {
			hspace = hspace + "&nbsp;";
		}
	}

	public void setRadio(String value, String label) {
		int i = this.sysCode.length;
		sysCode[i][0] = value;
		sysCode[i][1] = label;

	}

	public String getInput() {
		return this.tagInput;
	}

	public void setChecked(String check) {
		this.checked = StringUtils.trim(check);
	}

	public void setValue(String val) {
		this.value = StringUtils.trim(val);
	}
	public void setBR(String br){
		if(!("").equalsIgnoreCase(br) && !("false").equalsIgnoreCase(br)){
			this.br = "<br />";	
		}
		
	}
}
