package com.csc.library.config;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ThaiUtilities;
import com.csc.library.utilities.UProfile;

public class LoadConfig {
	private UProfile upf=null;
	Element str;	
		public LoadConfig(){
		this.upf = new UProfile();
		this.upf.setDefault();
		try {
			InitialEnvironment env = new InitialEnvironment("GLOBAL");
			SAXBuilder builder = new SAXBuilder();
			String pathName="";
			pathName=env.getValue("config-dir") +"MCONFIG.xml";
			File configxml=new File(pathName);
			if(!configxml.exists()){
				createConfigXML(pathName);
			}else{
				Document stru = builder.build(new File(pathName));			
				str = stru.getRootElement();
				this.process();
			}
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}		
	}
	private void process(){
		String key = this.str.getAttributeValue("key");
		try {		
				DbRecord db = new InitialRecord(this.upf).getDbRecord("Mconfig");
				db.setColumn("*");			 
				Element data;			
				List list = str.getChildren();
				Iterator it = list.iterator();
				while (it.hasNext()) {
					data = (Element) it.next();
			    	String fm="";          
					for (StringTokenizer token = new StringTokenizer(key, ","); token.hasMoreTokens();) {
						fm = token.nextToken();
						db.set(fm, data.getChildTextTrim(fm.toUpperCase()));			                
					}  // Set Key for Search
					if(db.search()<1){ // If, Not Found, Save it
						List sub_list =data.getChildren();
						Iterator sub_it = sub_list.iterator();
						Element fm_data;
						while (sub_it.hasNext()) {
							fm_data = (Element) sub_it.next();
							db.set(fm_data.getName(), fm_data.getText());
						}						
						db.save();
					}					
				}			 
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
	}
	
	private void createConfigXML(String pathName){
	     try {
	    	 System.out.println("\tCREATE MCONFIG FILE..");
			 File configxml = new File(pathName);
			 OutputStream out = new BufferedOutputStream(new FileOutputStream(configxml));
			 PrintWriter writer = new PrintWriter(out);
			 writer.println("<?xml version=\"1.0\" encoding=\"TIS-620\"?>");
			 writer.println("<MCONFIG key=\"configid\">");

			 DbInquiry configinq=new InitialInquiry(this.upf).getDbInquiry();
			 configinq.initMyTable("mconfig","","");
			 configinq.setColumn("*");
			 configinq.refresh();
			 ThaiUtilities th=new ThaiUtilities();
			 while(configinq.next()){
				 writer.println("\t<DATA>");
				 writer.println("\t\t<CONFIGID><![CDATA["+th.ASCII2Unicode(configinq.getString("CONFIGID"))+"]]></CONFIGID>");
				 writer.println("\t\t<COMPANYID><![CDATA["+th.ASCII2Unicode(configinq.getString("COMPANYID"))+"]]></COMPANYID>");
				 writer.println("\t\t<TDESC><![CDATA["+th.ASCII2Unicode(configinq.getString("TDESC"))+"]]></TDESC>");
				 writer.println("\t\t<EDESC><![CDATA["+th.ASCII2Unicode(configinq.getString("TDESC"))+"]]></EDESC>");
				 writer.println("\t\t<CONFIG_TYPE><![CDATA["+th.ASCII2Unicode(configinq.getString("CONFIG_TYPE"))+"]]></CONFIG_TYPE>");
				 writer.println("\t\t<CONFIG_VALUE><![CDATA["+th.ASCII2Unicode(configinq.getString("CONFIG_VALUE"))+"]]></CONFIG_VALUE>");
				 writer.println("\t\t<COMPONENT><![CDATA["+th.ASCII2Unicode(configinq.getString("COMPONENT"))+"]]></COMPONENT>");
				 writer.println("\t\t<COMWIDTH><![CDATA["+th.ASCII2Unicode(configinq.getString("COMWIDTH"))+"]]></COMWIDTH>");
				 writer.println("\t\t<COMDECIMAL><![CDATA["+th.ASCII2Unicode(configinq.getString("COMDECIMAL"))+"]]></COMDECIMAL>");
				 writer.println("\t\t<GROUP_NAME><![CDATA["+th.ASCII2Unicode(configinq.getString("GROUP_NAME"))+"]]></GROUP_NAME>");
				 writer.println("\t\t<SCREEN_NAME><![CDATA["+th.ASCII2Unicode(configinq.getString("SCREEN_NAME"))+"]]></SCREEN_NAME>");
				 writer.println("\t\t<EFFECTIVEID><![CDATA["+th.ASCII2Unicode(configinq.getString("EFFECTIVEID"))+"]]></EFFECTIVEID>");
				 writer.println("\t</DATA>");
				 writer.println("");
			 }
			 writer.println("</MCONFIG>");
			 writer.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
