package com.csc.library.cscimport;

import java.util.Vector;

import org.jdom.Element;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

public class ImportXml {
	// attribute ?????? root element
	private boolean				insert;
	private boolean				update;
	private boolean				lastUpdate;
	private String				xmlType		= "";
	private String				xmlName		= "";
	private Vector				childData	= null;
	private Vector				data		= null;
	private Vector				element		= null;
	private Vector				blank		= null;
	private Vector				source		= null;
	//private Vector fieldtype = null;
	private String				initStr		= "";
	private String				impPattern	= "";
	private String				condition	= "";
	private String				processType	= "";
	private char				delim		= ' ';
	private char				wordDelim	= ' ';
	private int					recSize		= 0;
	public ImportXml(String fname) {
		this.xmlName = fname;
	}
	public String getCondition() {
		return this.condition;
	}
	public String getImpPattern() {
		return this.impPattern;
	}
	public String getInitStr() {
		return this.initStr;
	}
	public Vector getDataField() {
		return this.data;
	}
	public boolean getFlagIns() {
		return this.insert;
	}
	public boolean getFlagUp() {
		return this.update;
	}
	public boolean getFlagLastUp() {
		return this.lastUpdate;
	}
	public String getXmlType() {
		return this.xmlType;
	}
	public Vector getSource() {
		return this.source;
	}
	public Vector getBlank() {
		return this.blank;
	}
	public int getRecSize() {
		return this.recSize;
	}
	public String getProcesType() {
		return this.processType;
	}
	public String getName() {
		return this.xmlName;
	}
	public char getDelim() {
		return this.delim;
	}
	public char getWordDelim() {
		return this.wordDelim;
	}
	public Vector getChildData() {
		return this.childData;
	}
	public Vector getElement() {
		return this.element;
	}
	public boolean chkSpace() {
		if (this.xmlType == null || this.xmlType.equals("")) {
			MyLog.error(this,"In xml File Check attribute filetype");
			return false;
		} else if (this.xmlName == null || this.xmlName.equals("")) {
			MyLog.error(this,"In xml File Check attribute filename");
			return false;
		} else if (this.processType == null || this.processType.equals("")) {
			MyLog.error(this,"In xml File Check attribute processtype");
			return false;
		} else if (this.initStr == null || this.initStr.equals("")) {
			MyLog.error(this,"In xml File Check Node INIT");
			return true;
		} else if (this.impPattern == null || this.impPattern.equals("")) {
			MyLog.error(this,"In xml File Check Node IMPORTPATTERN");
			return true;
		} else if (this.condition == null || this.condition.equals("")) {
			MyLog.error(this,"In xml File Check Node CONDITION");
			return true;
		} else
			return true;
	}
	private boolean getDataLineListFL(String procType, ReadXml r) {
		source = new Vector();
		blank = new Vector();
		try {
			Element e = null;
			for (int i = 0; i < this.data.size(); i++) {
				e = (Element) data.get(i);
				source.add(e.getAttributeValue("source").toString().trim());
				blank.add(e.getAttributeValue("blank").toString().trim());
			}
		} catch (Exception ex) {
			MyLog.error(this,"In xml File Check attribute in Node COL");
			return false;
		}
		return true;
	}
	private boolean getDataLineListFR(String procType, ReadXml r) {
		source = new Vector();
		try {
			this.delim = r.getRootElement().getChild("DATA").getAttributeValue("tokendelimeter").charAt(0);
			Element e = null;
			String tmp = "";
			for (int i = 0; i < this.data.size(); i++) {
				e = (Element) data.get(i);
				source.add(e.getAttributeValue("source").toString().trim());
			}
		} catch (Exception ex) {
			MyLog.error(this,"In xml File Check attribute in Node COL");
			return false;
		}
		return true;
	}
	private boolean getDataLineStripFix(String procType, ReadXml r) {
		source = new Vector();
		blank = new Vector();
		try {
			Element e = null;
			this.recSize = new Integer(r.getRootElement().getChild("DATA").getAttributeValue("size")).intValue();
			for (int i = 0; i < this.data.size(); i++) {
				e = (Element) data.get(i);
				source.add(e.getAttributeValue("source").toString().trim());
				blank.add(e.getAttributeValue("blank").toString().trim());
			}
		} catch (Exception ex) {
			MyLog.error(this,"In xml File Check attribute in Node COL");
			return false;
		}
		return true;
	}
	private boolean getDataLineStripFree(String procType, ReadXml r) {
		source = new Vector();
		try {
			this.delim = r.getRootElement().getChild("DATA").getAttributeValue("tokendelimeter").charAt(0);
			this.wordDelim = r.getRootElement().getChild("DATA").getAttributeValue("worddelimmeter").charAt(0);
			Element e = null;
			for (int i = 0; i < this.data.size(); i++) {
				e = (Element) data.get(i);
				source.add(e.getAttributeValue("source").toString().trim());
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			//System.out.println("ERROR:In xml File Check attribute in Node COL");
			return false;
		}
		return true;
	}
	public boolean process() {
		ReadXml r = new ReadXml(this.xmlName);
		try {
			this.insert = new Boolean(r.getAttrValue(r.getRootElement(), "insert").trim()).booleanValue();
			this.update = (r.getAttrValue(r.getRootElement(), "update").trim().equals("true")) ? true : false;
			this.lastUpdate = (r.getAttrValue(r.getRootElement(), "lastupdate").equals("true")) ? true : false;
			this.xmlType = r.getAttrValue(r.getRootElement(), "filetype").trim();
			this.xmlName = r.getAttrValue(r.getRootElement(), "name").trim();
			this.processType = r.getAttrValue(r.getRootElement(), "processtype").trim();
			this.data = r.listTovec(r.getRootElement().getChild("DATA").getChildren());
			this.element = r.listTovec(r.getRootElement().getChildren());
			this.initStr = r.getString("INIT");
			this.impPattern = r.getString("IMPORTPATTERN");
			this.condition = r.getString("CONDITION");
		} catch (Exception e) {
			MyLog.error(this,"Have null data Please Check your xml file");
		}
		if (this.chkSpace()) {
			if (this.xmlType.equals("linelist")) {
				if (this.processType.equals("fixspace")) {
					return this.getDataLineListFL(this.getProcesType(), r);
				} else if (this.processType.equals("freespace")) {
					return this.getDataLineListFR(this.getProcesType(), r);
				} else {
					MyLog.error(this,"No such process type in xml filetype linelist");
					return false;
				}
			} else if (this.xmlType.equals("linestrip")) {
				if (this.getProcesType().equals("fixspace")) {
					return this.getDataLineStripFix(this.getProcesType(), r);
				} else if (this.getProcesType().equals("freespace")) {
					return this.getDataLineStripFree(this.getProcesType(), r);
				} else {
					MyLog.error(this,"No such process type in xml filetype linestrip");
					return false;
				}
			} else {
				MyLog.error(this,"type:" + this.xmlType);
				MyLog.error(this,"In XML File:No such file type in xml file");
				return false;
			}
		} else
			return false;
	}
}
