package com.csc.library.database;

import java.sql.Array;
import java.sql.Blob;
import java.sql.CallableStatement;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.NClob;
import java.sql.PreparedStatement;
import java.sql.SQLClientInfoException;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.SQLXML;
import java.sql.Savepoint;
import java.sql.Statement;
import java.sql.Struct;
import java.util.Map;
import java.util.Properties;
import java.util.Vector;

import com.csc.library.mail.SendMail;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class CscConnection implements Connection {
	private Connection con;
	private boolean isUse;
	private String dbName;
	private long starttime = 0;
	private long lasttime = 0;
	private long inittime = 0;
	private Properties prop;
	private String url = "";
	private String drv = "";
	private ConnectionPools PoolManager;
	private CscTransaction cscTransaction = null;
	private String dbVendor = "";
	private boolean isJdbc = true;
	private Vector<CscStatement> stm = new Vector<CscStatement>();
	private Vector<CscPreparedStatement> prepare = new Vector<CscPreparedStatement>();
	private Vector<CscCallableStatement> callstm = new Vector<CscCallableStatement>();
	private String className="";
	private Exception cscexp=null;
//	private String closeBy = null;
	private int openblob=0;
	private String stackTrace="";
	private String processid="";
    private boolean rollback=false;
    private int overtime=0;
    private Vector aStarttime=new Vector();

	public String getDbName() {
		return dbName;
	}

	public void setDbName(String dbName) {
		this.dbName = dbName;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getDbVendor() {
		return dbVendor;
	}

	public void setDbVendor(String dbVendor) {
		this.dbVendor = dbVendor;
	}
	
	
	public boolean isJdbc() {
		return isJdbc;
	}

	public void setJdbc(boolean isJdbc) {
		this.isJdbc = isJdbc;
	}

	/**
	 * @return Returns the starttime.
	 */
	public void setPoolManager(ConnectionPools pm) {
		this.PoolManager = pm;
	}

	public long getStarttime() {
		return starttime;
	}
	
	public long getStarttimeForFinally(){
		return ((Long)aStarttime.firstElement()).longValue();
	} 
	
	public void setVendor(String vendor) {
		this.dbVendor = vendor;
	}

	public String getVendor() {
		return this.dbVendor;
	}

	/**
	 * @param starttime The starttime to set.
	 */
	public void setStarttime(long starttime) {
		aStarttime.addElement(Long.valueOf(starttime));
		this.starttime = starttime;
	}

	public void setConnection(Connection con, String dbName) {
		this.con = con;
		this.dbName = dbName;
//		this.databaseName = dbName;
		this.isUse = false;
		this.initTime();
	}

	public void setConnection(Connection con, String dbName, String schema) {
		this.con = con;
		this.dbName = dbName;
		this.isUse = false;
		this.initTime();
	}

	public void initTime() {
		this.initTime(System.currentTimeMillis());
	}

	public void setConnection(Connection con, String dbName, Properties pro, String url, String driver) {
		this.con = con;
		this.dbName = dbName;
		this.isUse = false;
		this.initTime();
		this.url = url;
		this.prop = pro;
		this.drv = driver;
	}

	public synchronized void setUses(boolean uses) {
		this.isUse = uses;
	}

	public boolean isUses() {
		return this.isUse;
	}

	public void setInfo(String info) {
	}

	/**
	 * @see java.sql.Connection#clearWarnings()
	 */
	public void clearWarnings() throws SQLException {
		this.con.clearWarnings();
	}

	/**
	 * @see java.sql.Connection#close()
	 */
	public void endProcess(){
		try {
			StackTraceElement[] stackem= Thread.currentThread().getStackTrace();
			this.setStackTrace(stackem);			
			if(!this.rollback){
				this.commit();
			}else{
				this.con.rollback();
			}
			this.clearStatement(0);
		} catch (SQLException e) {
			e.printStackTrace();
		}finally{
			try {
				this.con.close();
				con=null;
			} catch (SQLException e) {
			}
		}
		
	}
	
	public void close() throws SQLException {
		if(this.getProcessid().length()>0)
		{
			this.commit();//ԴѭҶ connection  Զա close кзӡ commit ͹Ǩ֧ close ҡ connection process ͧ蹹͹ѹ add by pas 20111222
			return;
		}
		String finalClass="java.lang.ref.finalizer$finalizerthread";
		String finalMethod="run";
		StackTraceElement[] stackem= Thread.currentThread().getStackTrace();
		String className=stackem[stackem.length-1].getClassName().toLowerCase();
		String methodName=stackem[stackem.length-1].getMethodName().toLowerCase();
		if(className.equals(finalClass)&&methodName.equals(finalMethod)){
			/**
			 * Ǩͺա¹ finalize class 
			 * յͺҡդҹ close
			 */
			if(!this.isUses()){
				this.commit();
				this.clearStatement(0);
				if(this.aStarttime.size()>0){
					this.aStarttime.remove(0);
				}
				this.setAutoCommit(true);
				this.setCscTransaction(null);
				this.setLasttime(System.currentTimeMillis());
				stackem= Thread.currentThread().getStackTrace();
				this.setStackTrace(stackem);
				this.PoolManager.returnConnection(this);
			}else{				
				if(this.aStarttime.size()>1){
					this.aStarttime.remove(0);
					this.clearStatement(this.getStarttimeForFinally());
				}
				this.commit();
			}		
		}else{
			this.commit();// ҹ this.commit() ռŷźҧҧ commit  workflow
			if (this.getCscTransaction()==null) {
				this.clearStatement(this.getStarttime());
				if(this.aStarttime.size()>0){
					this.aStarttime.remove(0);
				}
				this.setAutoCommit(true);
				this.setLasttime(System.currentTimeMillis());
				stackem= Thread.currentThread().getStackTrace();
				this.setStackTrace(stackem);
				this.PoolManager.returnConnection(this); 
			}
		}
	}

	/**
	 * @see java.sql.Connection#commit()
	 */
	public void commit() throws SQLException { 
		if(!this.con.isClosed()){//зӧҹ੾ connection öҹ
			if(!this.rollback&&!this.getAutoCommit()){
				try{
					this.con.commit();
				}catch(Exception ex){
					MyLog.warn(this,ex);
				}
			}else{
				this.rollback=false;
			}
		}/*else{//к close  ͧ͡ҡ ǨԴ recursive
			this.closeAll();
		}*/
	}

	/**
	 * @see java.sql.Connection#createStatement()
	 */
	synchronized public Statement createStatement() throws SQLException {
		CscStatement sm=new CscStatement(this.con.createStatement(),this.getStarttime());
		sm.setClose(false);
		sm.setCscConnection(this);
		stm.add(sm);
		return sm;
//		return this.con.createStatement();
	}

	/**
	 * @see java.sql.Connection#createStatement(int, int)
	 */
	synchronized public Statement createStatement(int resultSetType,
			int resultSetConcurrency) throws SQLException {
		CscStatement sm=new CscStatement(this.con.createStatement(resultSetType, resultSetConcurrency),this.getStarttime());
		sm.setCscConnection(this);
		sm.setClose(false);
		stm.add(sm);
		return sm;
//		return this.con.createStatement(resultSetType, resultSetConcurrency);
	}

	/**
	 * @see java.sql.Connection#getAutoCommit()
	 */
	public boolean getAutoCommit() throws SQLException {
		return this.con.getAutoCommit();
	}

	/**
	 * @see java.sql.Connection#getCatalog()
	 */
	public String getCatalog() throws SQLException {
		return this.con.getCatalog();
	}

	/**
	 * @see java.sql.Connection#getMetaData()
	 */
	public DatabaseMetaData getMetaData() throws SQLException {
		try{
			return this.con.getMetaData();
		}catch(Exception ex){
			return null;
		}
	}

	/**
	 * @see java.sql.Connection#getTransactionIsolation()
	 */
	public int getTransactionIsolation() throws SQLException {
		return this.con.getTransactionIsolation();
	}

	/**
	 * @see java.sql.Connection#getTypeMap()
	 */
	public Map getTypeMap() throws SQLException {
		return this.con.getTypeMap();
	}

	/**
	 * @see java.sql.Connection#getWarnings()
	 */
	public SQLWarning getWarnings() throws SQLException {
		return this.con.getWarnings();
	}

	/**
	 * @see java.sql.Connection#isClosed()
	 */
	public boolean isClosed() throws SQLException {
		if(this.con==null){
			return true;
		}
		return this.con.isClosed();
	}

	/**
	 * @see java.sql.Connection#isReadOnly()
	 */
	public boolean isReadOnly() throws SQLException {
		return this.con.isReadOnly();
	}

	/**
	 * @see java.sql.Connection#nativeSQL(String)
	 */
	public String nativeSQL(String sql) throws SQLException {
		return this.con.nativeSQL(sql);
	}

	/**
	 * @see java.sql.Connection#prepareCall(String, int, int)
	 */
	synchronized public CallableStatement prepareCall(String sql,
			int resultSetType, int resultSetConcurrency) throws SQLException {
		CscCallableStatement call=new CscCallableStatement(this.con.prepareCall(sql, resultSetType, resultSetConcurrency),this.getStarttime());
		call.setClose(false);
		call.setCscConnection(this);
		this.callstm.add(call);
		return call;
	}

	/**
	 * @see java.sql.Connection#prepareCall(String)
	 */
	synchronized public CallableStatement prepareCall(String sql)
			throws SQLException {
		CscCallableStatement call=new CscCallableStatement(this.con.prepareCall(sql),this.getStarttime());
		call.setClose(false);
		call.setCscConnection(this);		
		this.callstm.add(call);
		return call;
	}

	/**
	 * @see java.sql.Connection#prepareStatement(String, int, int)
	 */
	synchronized public PreparedStatement prepareStatement(String sql,
			int resultSetType, int resultSetConcurrency) throws SQLException {		
		CscPreparedStatement pstm=new CscPreparedStatement(this.con.prepareStatement(sql, resultSetType,resultSetConcurrency),this.getStarttime());
		pstm.setCscConnection(this);
		pstm.setClose(false);
		prepare.add(pstm);
		return pstm;
//		return this.con.prepareStatement(sql, resultSetType,resultSetConcurrency);
	}

	/**
	 * @see java.sql.Connection#prepareStatement(String)
	 */
	synchronized public PreparedStatement prepareStatement(String sql)
			throws SQLException {
		CscPreparedStatement pstm=new CscPreparedStatement(this.con.prepareStatement(sql),this.getStarttime());
		pstm.setClose(false);
		pstm.setCscConnection(this);
		prepare.add(pstm);
		return pstm;
//		return this.con.prepareStatement(sql);
	}

	/**
	 * @see java.sql.Connection#rollback()
	 */
	public void rollback() throws SQLException {
		this.rollback=true;
		if(this.con!=null && !this.con.getAutoCommit()){
			this.con.rollback();
		}
	}

	/**
	 * @see java.sql.Connection#setAutoCommit(boolean)
	 */
	public void setAutoCommit(boolean autoCommit) throws SQLException {
		if(this.con!=null && !this.con.isClosed()){
			this.con.setAutoCommit(autoCommit);
		}
	}

	/**
	 * @see java.sql.Connection#setCatalog(String)
	 */
	public void setCatalog(String catalog) throws SQLException {
		this.con.setCatalog(catalog);
	}

	/**
	 * @see java.sql.Connection#setReadOnly(boolean)
	 */
	public void setReadOnly(boolean readOnly) throws SQLException {
		this.con.setReadOnly(readOnly);
	}

	/**
	 * @see java.sql.Connection#setTransactionIsolation(int)
	 */
	public void setTransactionIsolation(int level) {
		try{
		this.con.setTransactionIsolation(level);
		}catch (Exception ex){
			//MyLog.warn("Operation invalid at this time");
		}
	}

	public int getHoldability() {
		try {
			return this.con.getHoldability();
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return 0;
		}
	}

	public void setHoldability(int data) {
		try {
			this.con.setHoldability(data);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
		}
	}

	public Savepoint setSavepoint() {
		try {
			return this.con.setSavepoint();
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	public Savepoint setSavepoint(String s) {
		try {
			return this.con.setSavepoint(s);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	public void releaseSavepoint(Savepoint s) {
		try {
			this.con.releaseSavepoint(s);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
		}
	}

	public void rollback(Savepoint s) {
		try {
			this.con.rollback(s);
			this.con.createStatement();
		} catch (SQLException ex) {
			MyLog.error(this, ex);
		}

	}

	public Statement createStatement(int a, int b, int c) {
		try {
			CscStatement sm=new CscStatement(this.con.createStatement(a, b, c),this.getStarttime());
			sm.setCscConnection(this);
			sm.setClose(false);
			this.stm.add(sm);
			return sm;
//			return this.con.createStatement(a, b, c);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	public java.sql.CallableStatement prepareCall(String a, int b, int c, int d) {
		try {
			CscCallableStatement call=new CscCallableStatement(this.con.prepareCall(a, b, c, d),this.getStarttime());
			call.setClose(false);
			call.setCscConnection(this);			
			this.callstm.add(call);
			return call;
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	synchronized public PreparedStatement prepareStatement(String a, int b) {
		try {
			CscPreparedStatement pstm=new CscPreparedStatement(this.con.prepareStatement(a, b),this.getStarttime());
			pstm.setClose(false);
			pstm.setCscConnection(this);
			prepare.add(pstm);
			return pstm;
//			return this.con.prepareStatement(a, b);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	synchronized public PreparedStatement prepareStatement(String a, int b,
			int c, int d) {
		try {
			CscPreparedStatement pstm=new CscPreparedStatement(this.con.prepareStatement(a, b, c, d),this.getStarttime());
			pstm.setClose(false);
			pstm.setCscConnection(this);
			prepare.add(pstm);
			return pstm;
//			return this.con.prepareStatement(a, b, c, d);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	synchronized public PreparedStatement prepareStatement(String a, int b[]) {
		try {
			CscPreparedStatement pstm=new CscPreparedStatement(this.con.prepareStatement(a, b),this.getStarttime());
			pstm.setClose(false);
			pstm.setCscConnection(this);
			prepare.add(pstm);
			return pstm;
//			return this.con.prepareStatement(a, b);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	synchronized public PreparedStatement prepareStatement(String a, String b[]) {
		try {
			CscPreparedStatement pstm=new CscPreparedStatement(this.con.prepareStatement(a, b),this.getStarttime());
			pstm.setClose(false);
			pstm.setCscConnection(this);
			prepare.add(pstm);
			return pstm;
//			return this.con.prepareStatement(a, b);
		} catch (SQLException ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	/**
	 * @see java.sql.Connection#setTypeMap(Map)
	 */
	public void setTypeMap(Map map) throws SQLException {
		this.con.setTypeMap(map);
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		String returnValue = this.dbName + ": " + this.isUse + " : "+" : "+this.className+" : "+ this.con;
		return returnValue;
	}

	private CscConnection reConnection() {
		try {
			Class.forName(this.drv);
			con = DriverManager.getConnection(this.url, this.prop);
			return this;
		} catch (Exception e) {
			MyLog.error(this, e);
			return null;
		}
	}

	public boolean initConnection(String dbURL, String databaseName,
			String userName, String password, String driverName)
			throws ClassNotFoundException, SQLException {
		this.prop = new Properties();
		this.prop.put("user", userName);
		this.prop.put("password", password);
		Class.forName(driverName);
		con = DriverManager.getConnection(dbURL, prop);
		this.dbName = databaseName;
		this.url = dbURL;
		this.drv = driverName;
		if (con==null) {
			return false;
		}
		return true;
	}

	public CscConnection checkConnectionClose() {
		CscConnection con = null;
		try{
				MyLog.info(this, "    Cannot connect to server, Please check you system");
				MyLog.info(this, "    Re Connect Start.............................................");
				this.PoolManager.removeConnetionsUsed(this);
				con = this.reConnection();
				this.PoolManager.reConnection(con);
				MyLog.info(this, "    Re Connect Complete.............................................");
		}catch(Exception e){
			 String to=new InitialEnvironment("GLOBAL").getValue("MAILAUTH-default");
			 String from=new InitialEnvironment("GLOBAL").getValue("MAILAUTH-username");
			 String subject="Cann't connect to database ";
			 String content="Cann't connect to database please check log on "+new InitialEnvironment("GLOBAL").getValue("server-name");			 
			 if(to.trim().length()==0)
				 to="myhr@csc.co.th";
			 SendMail sm=new SendMail("", from, to, "", subject, content);
			 sm.send();									
		}
		return con;
	}
	
	public void setCscTransaction(CscTransaction ts) {
		this.cscTransaction = ts;
	}
	
	public CscTransaction  getCscTransaction() {
		return this.cscTransaction;
	}
	
	
	public void rollbackCscTransaction() throws SQLException{
		if (this.cscTransaction != null) {
			try {
				this.cscTransaction.rollback();
			} catch (SQLException e) {
				MyLog.error(this, e);
			}
		}else{
			this.setCscTransaction(null);
			this.close();
		}
	}
	
	public boolean isReconnect(Object ex){
		try{
			String sqlstate = "";
			if (ex instanceof SQLException) {
				sqlstate = ((SQLException) ex).getSQLState();
			} else {
			}			
			if (sqlstate == null) sqlstate = "";
			if ((sqlstate.indexOf("HY010") > -1)||(sqlstate.indexOf("080") > -1) || sqlstate.indexOf("08S") > -1 || sqlstate.indexOf("61000") > -1) {
				return true;
			}
		}catch(Exception e){
			return false;
		}		
		return false;
	}
	
//	/**
//	 * Implements Method for java 6.0
//	 * @author Dragonfire
//	 */
//
//	
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#createArrayOf(java.lang.String, java.lang.Object[])
//	 */
//	public Array createArrayOf(String typeName, Object[] elements) throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#createBlob()
//	 */
//	public Blob createBlob() throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#createClob()
//	 */
//	public Clob createClob() throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#createNClob()
//	 */
//	public NClob createNClob() throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#createSQLXML()
//	 */
//	public SQLXML createSQLXML() throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#createStruct(java.lang.String, java.lang.Object[])
//	 */
//	public Struct createStruct(String typeName, Object[] attributes) throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#getClientInfo()
//	 */
//	public Properties getClientInfo() throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#getClientInfo(java.lang.String)
//	 */
//	public String getClientInfo(String name) throws SQLException {
//		return null;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#isValid(int)
//	 */
//	public boolean isValid(int timeout) throws SQLException {
//		return false;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#setClientInfo(java.util.Properties)
//	 */
//	public void setClientInfo(Properties properties) throws SQLClientInfoException {
//		
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Connection#setClientInfo(java.lang.String, java.lang.String)
//	 */
//	public void setClientInfo(String name, String value) throws SQLClientInfoException {
//		
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Wrapper#isWrapperFor(java.lang.Class)
//	 */
//	public boolean isWrapperFor(Class<?> iface) throws SQLException {
//		return false;
//	}
//
//	/* (non-Javadoc)
//	 * @see java.sql.Wrapper#unwrap(java.lang.Class)
//	 */
//	public <T> T unwrap(Class<T> iface) throws SQLException {
//		return null;
//	}

	public long getLasttime() {
		return lasttime;
	}

	public void setLasttime(long lasttime) {
		this.lasttime = lasttime;
	}
	
	public void closeAll()throws SQLException{		
		if(!this.validate() && this.con.isClosed()){ //Ǩͺ connnection  close  	remove ͡ҡк ͧ connection  öҹ
			System.out.println("== CONNECTION CLOSE ALL =="+this);
			if(this.con!=null&&this.getProcessid().length()==0){//ͧ connection Ҩҡ process		
				this.PoolManager.removeConnetions(this);
				StackTraceElement[] stackem= Thread.currentThread().getStackTrace();
				this.setStackTrace(stackem);
				this.clearStatement(0); 
				this.con.close();
			}else if(this.con!=null&&this.getProcessid().length()>0){// Connection Ҩҡ Process  close connection 鹷к new connection   remove ͡ҡ connectionProcess
				if(!this.con.isClosed()){
					this.endProcess();
				}else{
					this.PoolManager.removeConnetions(this);
				}
				ConnectionPools.connectionProcess.remove(this.getProcessid());
			}
		}else if(this.getProcessid().length()==0){
			this.PoolManager.removeConnetions(this);
			StackTraceElement[] stackem= Thread.currentThread().getStackTrace();
			this.setStackTrace(stackem);
			this.clearStatement(0); 
			this.con.close();			
			/*
			//ѧҹ move  connection 			
			this.overtime=0;
			StackTraceElement[] stackem= Thread.currentThread().getStackTrace();
			this.commit();			
			if(this.aStarttime.size()>0){
				this.clearStatement(this.getStarttimeForFinally());
				this.aStarttime.remove(0);
			}
			this.setAutoCommit(true);
			this.setCscTransaction(null);
			this.setLasttime(System.currentTimeMillis());
			stackem= Thread.currentThread().getStackTrace();
			this.setStackTrace(stackem);
			if(this.isUses()){
				this.PoolManager.returnConnection(this);
			}else{
				if(!this.PoolManager.getConnectionsnoused().contains(this)){
					this.PoolManager.getConnectionsnoused().add(this);
				}
			}
			*/
		}
	}
	
	public boolean isOpen(){
		try{	
            DatabaseMetaData meta = this.con.getMetaData();
            if (meta != null) {
            	return true;
            }
		}catch(Exception ex){
			MyLog.debug(this,"...........Connection is close...........");
		}
            return false;
	}
	public void clearStatement(long before){
		try{
			this.setClassName("");
			if(stm!=null && stm.size()>0){
				CscStatement st=null;
				for(int i=0;i<stm.size();i++){
					st=(CscStatement)stm.get(i);
					if(st!=null&&st.isBefore(before)){ // isclose ͧҡ óշա close ҡ͹ҡ class 
							st.close();
							st=null;
					}
				}
			}
			if(prepare!=null && prepare.size()>0){
				CscPreparedStatement st=null;
				for(int i=0;i<prepare.size();i++){
					st=(CscPreparedStatement)prepare.get(i);
					if(st!=null&&st.isBefore(before)){// isclose ͧҡ óշա close ҡ͹ҡ class 
							st.close();
							st=null;
					}
				}
			}			

			if(this.callstm!=null && callstm.size()>0){
				CscCallableStatement st=null;
				for(int i=0;i<callstm.size();i++){
					st=(CscCallableStatement)callstm.get(i);
					if(st!=null&&st.isBefore(before)){// isclose ͧҡ óշա close ҡ͹ҡ class 
							st.close();
							st=null;
						}
					}
			}			
		}catch(Exception ex){
			MyLog.error(this,"Error can't clear statement.........");
			ex.printStackTrace();
		}
	}
	
	public void clearLastStatement(){
		try{
			this.setClassName("");
			if(stm!=null && stm.size()>0){
				CscStatement st=(CscStatement)stm.get(stm.size()-1);
				if(st!=null){
					st.close();
					stm.remove(stm.size()-1);
				}
			}
			if(prepare!=null && prepare.size()>0){
				CscPreparedStatement st=null;
				st=(CscPreparedStatement)prepare.get(prepare.size()-1);
				if(st!=null){
					st.close();
					prepare.remove(prepare.size()-1);
				}
			}
			
			if(this.callstm!=null && callstm.size()>0){
				CscCallableStatement st=(CscCallableStatement)callstm.get(callstm.size()-1);
					if(st!=null&&!st.isClose()){
						st.close();
						callstm.remove(callstm.size()-1);
					}
			}			
		}catch(Exception ex){
			MyLog.error(this,"Error can't clear statement.........");
		}
	}

	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	@Deprecated
	/**
	 * ҹ  getStackTrace ᷹
	 */
	public Exception getCscException() {
		return cscexp;
	}

	@Deprecated 
	/**
	 * ҹ  setStackTrace ᷹
	 */
	public void setCscException(Exception cscexp) {
		this.cscexp = cscexp;
	}
	
	public void setStackTrace(StackTraceElement[] traceElements) {
		StringBuilder temp_sb = new StringBuilder();
		for (int i = 2 ; i < traceElements.length ; i++) {
			temp_sb.append(traceElements[i]).append("\n");
		}
		this.stackTrace=temp_sb.toString();
	}

	public String getStackTrace() {
		return this.stackTrace;
	}

	public Vector<CscStatement> getStm() {
		return stm;
	}

	public Vector<CscPreparedStatement> getPrepare() {
		return prepare;
	}

	public long getInittime() {
		return inittime;
	}

	public void initTime(long inittime) {
		this.inittime = inittime;
	}

	public Vector<CscCallableStatement> getCallstm() {
		return callstm;
	}

	public void setCallstm(Vector<CscCallableStatement> callstm) {
		this.callstm = callstm; 
	}

	public int getOpenblob() {
		return openblob;
	}

	public void addOpenblob() {
		this.openblob++;
	}
  
	public boolean validate() {
		try {
			if(this.getMetaData()!=null){
				return true;
			}else{
				return false;
			}
		} catch (Exception e) {
			return false;
		}
	}

	public String getProcessid() {
		return processid;
	}

	public void setProcessid(String processid) {
		this.processid = processid;
	}

	public int getOverTime() {
		return overtime;
	}

	public void setOverTime() {
		this.overtime++;
	}

	public <T> T unwrap(Class<T> iface) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isWrapperFor(Class<?> iface) throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}


	public Clob createClob() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public Blob createBlob() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public NClob createNClob() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public SQLXML createSQLXML() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isValid(int timeout) throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}

	public void setClientInfo(String name, String value)
			throws SQLClientInfoException {
		// TODO Auto-generated method stub
		
	}

	public void setClientInfo(Properties properties)
			throws SQLClientInfoException {
		// TODO Auto-generated method stub
		
	}

	public String getClientInfo(String name) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public Properties getClientInfo() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public Array createArrayOf(String typeName, Object[] elements)
			throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public Struct createStruct(String typeName, Object[] attributes)
			throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	
}
