package com.csc.library.database;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Vector;
/**
 * 
 * @author Dragonfire
 * 
 */
public class CscStatement implements Statement {
	private Statement statment;
	private CscConnection conn=null;
	private ArrayList<ResultSet> resultset=new ArrayList<ResultSet>();
	
	private boolean close=false;
	private long createTime=0;
	
	public CscStatement(Statement stm,long createtime) {
		this.statment=stm;
		this.createTime=createtime;
//		this.isclose=false;
	}
	
	public void addBatch(String sql) throws SQLException {
		this.statment.addBatch(sql);		
	}

	public void cancel() throws SQLException {
		this.statment.cancel();
	}

	public void clearBatch() throws SQLException {
		this.statment.clearBatch();
	}

	public void clearWarnings() throws SQLException {
		this.statment.clearWarnings();
		
	}

	public void close() throws SQLException {
		if(this.statment!=null){
			this.close=true;
			this.closeResultSet();
			this.statment.close();
			if(conn!=null){
				this.conn.getStm().remove(this);	
			}			
			this.statment=null;
		}
	}

	public boolean execute(String sql) throws SQLException {
		return this.statment.execute(sql);
	}

	public boolean execute(String sql, int autoGeneratedKeys)
			throws SQLException {
		return this.statment.execute(sql, autoGeneratedKeys);
	}

	public boolean execute(String sql, int[] columnIndexes) throws SQLException {
		return this.statment.execute(sql, columnIndexes);
	}

	public boolean execute(String sql, String[] columnNames)
			throws SQLException {
		return this.statment.execute(sql, columnNames);
	}

	public int[] executeBatch() throws SQLException {
		return this.statment.executeBatch();
	}

	public ResultSet executeQuery(String sql) throws SQLException {
		ResultSet rs= this.statment.executeQuery(sql);
		this.resultset.add(rs);
		return rs;
	}

	public int executeUpdate(String sql) throws SQLException {
		return this.statment.executeUpdate(sql);
	}

	public int executeUpdate(String sql, int autoGeneratedKeys)
			throws SQLException {
		return this.statment.executeUpdate(sql, autoGeneratedKeys);
	}

	public int executeUpdate(String sql, int[] columnIndexes)
			throws SQLException {
		return this.statment.executeUpdate(sql, columnIndexes);
	}

	public int executeUpdate(String sql, String[] columnNames)
			throws SQLException {
		return this.statment.executeUpdate(sql, columnNames);
	}

	public Connection getConnection() throws SQLException {
		return this.statment.getConnection();
	}

	public int getFetchDirection() throws SQLException {
		return this.statment.getFetchDirection();
	}

	public int getFetchSize() throws SQLException {
		return this.statment.getFetchSize();
	}

	public ResultSet getGeneratedKeys() throws SQLException {
		ResultSet rs=this.statment.getGeneratedKeys();
		this.resultset.add(rs);
		return rs;
	}

	public int getMaxFieldSize() throws SQLException {
		return this.statment.getMaxFieldSize();
	}

	public int getMaxRows() throws SQLException {
		return this.statment.getMaxRows();
	}

	public boolean getMoreResults() throws SQLException {
		return this.statment.getMoreResults();
	}

	public boolean getMoreResults(int current) throws SQLException {
		return this.statment.getMoreResults(current);
	}

	public int getQueryTimeout() throws SQLException {
		return this.statment.getQueryTimeout();
	}

	public ResultSet getResultSet() throws SQLException {
		ResultSet rs=this.statment.getResultSet();
		this.resultset.add(rs);
		return rs;
	}

	public int getResultSetConcurrency() throws SQLException {
		return this.statment.getResultSetConcurrency();
	}

	public int getResultSetHoldability() throws SQLException {
		return this.statment.getResultSetHoldability();
	}

	public int getResultSetType() throws SQLException {
		return this.statment.getResultSetType();
	}

	public int getUpdateCount() throws SQLException {
		return this.statment.getUpdateCount();
	}

	public SQLWarning getWarnings() throws SQLException {
		return this.statment.getWarnings();
	}

	public void setCursorName(String name) throws SQLException {
		this.statment.setCursorName(name);
	}

	public void setEscapeProcessing(boolean enable) throws SQLException {
		this.setEscapeProcessing(enable);
	}

	public void setFetchDirection(int direction) throws SQLException {
		this.statment.setFetchDirection(direction);
	}

	public void setFetchSize(int rows) throws SQLException {
		this.statment.setFetchSize(rows);
	}

	public void setMaxFieldSize(int max) throws SQLException {
		this.statment.setMaxFieldSize(max);
	}

	public void setMaxRows(int max) throws SQLException {
		this.statment.setMaxRows(max);
	}

	public void setQueryTimeout(int seconds) throws SQLException {
		this.statment.setQueryTimeout(seconds);
	}

	public boolean isClose() {
		return close;
	}

	public void setClose(boolean isclose) {
		this.close = isclose;
	}

	private void closeResultSet(){
		try{
		if(this.resultset.size()>0){
			for(int i=0;i<this.resultset.size();i++){
				ResultSet rs=(ResultSet) this.resultset.get(i);
				if(rs!=null){
				 rs.close();
				 resultset.remove(rs);
				}
			}
		}
		}catch(Exception ex){}
	}

	@Override
	protected void finalize() throws Throwable {
		this.close();
	}
	
	public boolean isBefore(long starttime){
		if((starttime==0||this.createTime==starttime)&&this.conn.getStarttime()!=this.conn.getLasttime()){
		//if((starttime==0||this.createTime<starttime)&&this.conn.getStarttime()!=this.conn.getLasttime()){
			return true;
		}
		return false;
	}
	public CscConnection getCscConnection() {
		return conn;
	}

	public void setCscConnection(CscConnection conn) {
		this.conn = conn;
	}

	public <T> T unwrap(Class<T> iface) throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isWrapperFor(Class<?> iface) throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isClosed() throws SQLException {
		return this.close;
	}

	public void setPoolable(boolean poolable) throws SQLException {
		// TODO Auto-generated method stub
		
	}

	public boolean isPoolable() throws SQLException {
		// TODO Auto-generated method stub
		return false;
	}
}
