package com.csc.library.database;

import java.rmi.RemoteException;
import java.text.DecimalFormat;
import java.util.Calendar;

import com.csc.library.autonumber.InitialAutoNumber;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
public class FieldAutoNumber extends FieldString {

	private String autoCode = "";
	private int currNumber = 0;
	public FieldAutoNumber(String name, String code) {
		super(name);
		this.autoCode = code;
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";

	}

	public FieldAutoNumber(String name, String description, String code) {
		super(name, description);
		this.autoCode = code;
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
	}

	public FieldAutoNumber(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//   this.type = "Double";
	}

	public FieldAutoNumber(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);
		this.setDefault("0");
		this._DEFAULT_DEFAULTVALUE="0";
	}

	public FieldAutoNumber(String name, int width, String description, String code) {
		super(name, width, description);
		this.autoCode = code;
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
	}

	public FieldAutoNumber(String name, int width, int decimal, String description, String code) {
		super(name, width, decimal, description);
		this.autoCode = code;
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		this.setProperty("oldvalue", "0");
	}

	public String insAutoNumber() {
		try {
			String returnValue="1";
			String table=this.getProperty("table");
			String initv=this.getProperty("init");
			if (table.indexOf("$")!=-1) {
				table=swapFormat(table);
			}
			String format=this.getProperty("format");			
			String reset_char1=this.getProperty("reset_char1");
			String reset_char2=this.getProperty("reset_char2");
			if(this.getName().equalsIgnoreCase("RUNNO")){
				table=this.getParent().getTableName().toUpperCase()+"_RUNNO";
			}
			if(reset_char1!=null && reset_char1.length()>0 && reset_char2!=null &&reset_char2.length()>0){
				returnValue=InitialAutoNumber.getAutoNumber((UProfile)this.getUProfile().clone(),table,format,this.parent,initv,reset_char1,reset_char2);
			}else{
				returnValue=InitialAutoNumber.getAutoNumber((UProfile)this.getUProfile().clone(),table,format,this.parent,initv);
			}
			return returnValue;
		} catch (Exception ex) {
			ex.printStackTrace();
			return "1";
		}
	}
	
	public String getFieldCreate() {
		return this.getName() + " DECIMAL(" + String.valueOf(this.getWidth()) + "," + String.valueOf(this.getDecimal()) + ")";
	}
	
	private String swapFormat(String sform){
		String data="";
		/***
		 * ٻẺ =YYYY$F{FIELDNAME,2}-000000
		 * $F{FIEDNAME,digit} field in table
		 * $D{DECIMAL VALUE}  fix decimal value
		 * $U{keyname,digit}  keyname in UProfile
		 */
		
		String rp=sform.substring(sform.indexOf("$"),sform.lastIndexOf("}")+1);
		if(sform.indexOf("$")!=-1){
				if(rp.indexOf(",")>-1){
					String fieldName=rp.substring(3,rp.indexOf(","));			
					int maxlen=0;
					try{
						maxlen=Integer.parseInt(rp.substring(rp.indexOf(",")+1,rp.length()-1));
					}catch(Exception ex){
						maxlen=0;
					}
					try {
						if(sform.indexOf("$U")==-1)
							data=sform.replace(rp,parent.getString(fieldName).substring(0,maxlen));							
						else
							data=sform.replace(rp,this.getUProfile().get(fieldName).substring(0,maxlen));
					} catch (Exception e) {
						data=sform.replace(rp,"");
					}
				}else{
					String fieldName=rp.substring(3,rp.indexOf("}"));
					try {
						data=sform.replace(rp,parent.getString(fieldName));
					} catch (Exception e) {
						data=sform.replace(rp,"");
					}
				}		
		}else{
			String fieldName=rp.substring(3,rp.indexOf("}"));
			data=sform.replace(rp,fieldName);			
		}
		return data;
	}	

	/***
	 * @param x
	 * @Override ͧҡ óշ   field autonumber ͧա checkvaild жǨзԴѭҼԴ  format ö setvalue
	 * 仵Ǩͺrecordcmp0 
	 * 	
	 */
	@Override
	protected boolean setValue(String x) {
		boolean check = false;
		String tmpx = null;
		if (x != null){ 
			x=x.trim();
			tmpx = new String(x);
			} else tmpx = "";
		if (this.isWorking()) { 
			if ((this.sf == null)||(this.sf.set(this))){
				this.oValue=this.value;
				this.value= tmpx;				
				if (!this.getValue().equals(this.getOriginalData())) {
					this.modified = true;
				} else {
					this.modified = false;
				}
				this.refreshEffectField();
				check = this.isedit;
				this.setEdit(check);
			} else {
				this.setErrmess("You don't have permission to set up Value.");
				this.setEdit(false);
			}
		}
		return check;
	}	
	
}
