package com.csc.library.database;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
public class FieldDate extends MyField {
	private int d = 0;
	private int m = 0;
	private int y = 0;
	String dateFormat = "DMY"; // DATE FORMAT FOR INPUT DATE DATA

	public FieldDate(String name) {
		super(name);
		this.setDefault(defaultvalue);
		this.setDefault();
		//  this.type = "Date";
	}
	public FieldDate(String name, String description) {
		super(name, description);
		this.setDefault(defaultvalue);
		this.setDefault();
		//    this.type = "Date";
	}
	public FieldDate(String name, int width, String description) {
		super(name, width, description);
		this.setDefault(defaultvalue);
		this.setDefault();
		//  this.type = "Date";
	}
	public FieldDate(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault(defaultvalue);
		this.setDefault();
		//    this.type = "Date";
	}
	public FieldDate(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);
	}
        public String getCompareString() {
                          return this.getName()+"='"+this.getcscCalendar().getYYYYMMDD()+"'";
                //return new GenCompareString().generate(this.getName(), this);
        }
	/*public String getString() {
		if (this.getValue().equalsIgnoreCase(" ")) {
			return "1900-01-01";
		} else if (this.getValue() == null) {
			return "1900-01-01";
		} else {
			return this.getValue().substring(8, 10) + "/" + this.getValue().substring(5, 7) + "/" + this.getValue().substring(0, 4);
		}
	}*/
	public String getValueString() {
		return new GenCompareString().generate(this);
	}
	public String getDDMMYYYY() {
		return this.getValue().substring(8, 10) + "/" + this.getValue().substring(5, 7) + "/" + this.getValue().substring(0, 4);
	}
	public boolean set(CscCalendar d) {
		//System.out.println("***********  01 "+d.getTimestamp());
		String buff;
		buff = this.dateFormat;
		this.dateFormat = "YMD";
		this.setValue(d.getTimestamp().toString().substring(0, 10));
		this.dateFormat = buff;
		return true;
	}
	public boolean set(Timestamp x) {
		//System.out.println("***********  02 "+x);
		String buff;
		buff = this.dateFormat;
		this.dateFormat = "YMD";
		this.setValue(x.toString().substring(0, 10));
		this.dateFormat = buff;
		return true;
	}
	public boolean set(java.sql.Date x) {
		String buff;
		buff = this.dateFormat;
		this.dateFormat = "YMD";
		this.setValue(x.toString().substring(0, 10));
		this.dateFormat = buff;
		return true;
	}
	/************* ball edit **************/
	protected boolean setValue(String x1) {
		String x;
		if (this.isFormat && 
				((this.property.get("format") != null && 
						!this.property.get("format").equals("")) 
						|| (this.user.get("formatdate") != null && 
								!this.user.get("formatdate").equals("")))) {
			x = x1;
		} else {
			x = this.checkData(x1);
		}
		//System.out.println("Data In field date " + x);
		if (x.trim().length() > 0) {
			try {
                super.setValue(x);
            } catch (Exception e) {
                boolean temp=this.isFormat;
                this.isFormat=false;
                super.setValue(x);
                this.isFormat=temp;
            	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
            	MyLog.warn(this, this.getUProfile(), e);
            }
			return true;
		} else {
			String buff;
			buff = this.dateFormat;
			this.dateFormat = "YMD";
			x = this.checkData(x1);
			this.dateFormat = buff;
			if (x.trim().length() > 0) {
				super.setValue(x);
				return true;
			} else {
				if(this.defaultvalue.length()>0){//check conditionóշդ   null ͪͧҧ default value 
					super.setValue(this.defaultvalue);//edit by pas 20130312 add defaultvalue
				}else{
					super.setValue("1900-01-01");//edit by pas 20130312 add default 1900-01-01
				}
				return false;
			}
		}
	}
	
	/***********************************/
	public CscCalendar getcscCalendar() {
		CscCalendar d;
		d = new CscCalendar(this.getValue());
		return d;
	}
	public void setOriginal(String x) {
		try {
//			super.setOriginal(x.substring(0, 10));
			if (x==null) {
				x = "1900-01-01";
			}else if (x.trim().equals("")) {
				x = "1900-01-01";
			}
			super.setOriginal(x);
		} catch (RuntimeException e) {
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
        	MyLog.warn(this, this.getUProfile(), e);
			super.setOriginal(defaultvalue);
		}
	}
	private String checkData(String s) {
		String n = "";
		String s1 = "";
		int yearFormat = 2;
		int maxnumber = 6;
		int j = 0;
		this.d = 0;
		this.m = 0;
		this.y = 0;
		boolean error = false;
		if (yearFormat == 4) {
			maxnumber = 8;
		}
		for (int i = 0; i < s.length() && !error && j < 3; i++) {
			if (s.charAt(i) >= '0' && s.charAt(i) <= '9') {
				s1 += String.valueOf(s.charAt(i));
				if (s1.length() == maxnumber) {
					for (int p = 0; !error && j < 3; j++) {
						if (dateFormat.charAt(j) == 'D') {
							error = checkDMY(dateFormat.charAt(j), s.substring(p, p + 2));
							p += 2;
						} else {
							if (dateFormat.charAt(j) == 'M') {
								error = checkDMY(dateFormat.charAt(j), s.substring(p, p + 2));
								p += 2;
							} else {
								error = checkDMY(dateFormat.charAt(j), s.substring(p, p + yearFormat));
								p += yearFormat;
							}
						}
					}
				}
			} else {
				if (s1.trim().length() > 0) {
					error = checkDMY(dateFormat.charAt(j), s1);
				} else {
	            	MyLog.warn(this, this.getUProfile(), this.getName()+" Date Format Error!");
					error = true;
				}
				s1 = "";
				j++;
			}
		};
		if (j >= 2 && !error) {
			if (j == 2) {
				error = checkDMY(dateFormat.charAt(j), s1);
			}
			if (!error) {
				CscCalendar date = new CscCalendar(y, m, d);
				s1 = date.getTimestamp().toString().substring(0, 10);
				//        this.logger.info(s1);
				return s1;
			}
		}
		return "";
	}
	private boolean checkDMY(char type, String s1) {
		int chk;
		boolean error = false;
		if (type == 'D') {
			chk = Integer.valueOf(s1).intValue();
			if (chk < 1 || chk > 31) {
				error = true;
			} else {
				d = chk;
			}
		} else {
			if (type == 'M') {
				chk = Integer.valueOf(s1).intValue();
				if (chk < 1 || chk > 12) {
					error = true;
				} else {
					m = chk;
				}
			} else {
				chk = Integer.valueOf(s1).intValue();
				if (chk < 1900) {
					if (chk > 100) {
						error = true;
					} else {
						if (chk <= 20) {
							chk += 2000;
						} else {
							chk += 1900;
						}
					}
				}
				y = chk;
			}
		}
		return error;
	}
	public String getFieldCreate() {
		return this.getName() + " DATE";
	}

	public String getSaveString() {
		if(this.isEncrypt())
			return this.encryption();
		else
			return  String.valueOf(this.getDate());
	}
	
	public String getString() { 
		String value = super.getString(); 
		//if (this.isFormat) { 
		return value; 
		//} else { 
		//GenCompareString genCom = new GenCompareString(); 
		//value = genCom.dateString(new CscCalendar(value)); 
		//return value; 
		//} 
		} 

	protected String getFormatValue(String format, String value) { 
		String rFormat=format.substring(0,format.indexOf(":")); 
		String local=format.substring(format.indexOf(":")+1,format.length()); 
		SimpleDateFormat df = null; 
		if(local.equalsIgnoreCase("ENG")) 
		df=new SimpleDateFormat(rFormat, Locale.ENGLISH); 
		else 
		df=new SimpleDateFormat(rFormat, Locale.getDefault()); 
		CscCalendar cs = new CscCalendar(value); 
		String data = df.format(new Date(cs.getTime())); 
		return data; 
		} 

		protected String getParseValue(String format, String value) { 
		try { 
		String rFormat=format.substring(0,format.indexOf(":")); 
		String local=format.substring(format.indexOf(":")+1,format.length()); 
		SimpleDateFormat df = null; 
		if(local.equalsIgnoreCase("ENG")) 
		df=new SimpleDateFormat(rFormat, Locale.ENGLISH); 
		else 
		df=new SimpleDateFormat(rFormat, Locale.getDefault()); 
		Date date = df.parse(value); 
		CscCalendar cs = new CscCalendar(date); 
		return cs.getYYYYMMDD(); 
		} catch (ParseException e) { 
        	MyLog.warn(this, this.getUProfile(), this.getName()+"------> "+e);
		} 
		return value; 
		} 

		public String getDefault() {
			if(this.defaultvalue==null){
				this.defaultvalue=new CscCalendar().getYYYYMMDD();
			}else{
				this.defaultvalue=new CscCalendar(defaultvalue).getYYYYMMDD();
			}
			return this.defaultvalue;
		}
}
