package com.csc.library.database;

import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.rmi.RemoteException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import org.apache.commons.lang.StringUtils;

import com.csc.library.factor.Factorable;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscIndexTable;
import com.csc.library.utilities.MmInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.StrReplace;
import com.csc.library.utilities.UProfile;

public class MyInquiry extends MyDB implements DbInquiry, MmInquiry {
	private static final long serialVersionUID = 1L;

	protected DbRecord mf, mr, br, tr;

	protected String field;

	protected Vector aField;

	protected int currentRecord, recAmount = 0;

	private String oldCondition = "PIAK";

	private char usedFor = 'R';

	private byte autoRefresh = 1;

	private String filter = "";

	private String orderBy = "";

	private Vector orderByVector = new Vector();
	

	private Vector groupByVector = new Vector();

	protected Vector sumColumnVector = new Vector();

	protected Vector minColumnVector = new Vector();

	protected Vector maxColumnVector = new Vector();

	protected Vector avgColumnVector = new Vector();

	protected Vector udfColumnVector = new Vector();

	private MyHashMap groupData = new MyHashMap();

	private DataSet ds  = new DataSet();

	private int recordPage = 30;

	public SumReport sum = null;

	private String childCondi = "";

	protected String uid;

	private Vector keyfilter = new Vector();

	private String reSultSet;

	private boolean extResultSet = false;

	private String sql = "";

	private int nextIndex = 0;

	private String stringFilter = "";

	private String fixFilter = "";

	private boolean fetchAll = false;

	protected boolean isFormat = false;

	private boolean isSameCondition = false;
	
	private Vector<String> subsfilter = new Vector<String>();
	
	protected boolean isjointab=false;
	protected String orderjoin="";
	protected String groupjoin="";
	protected String filterjoin="";	
	protected boolean refreshBeforeNext=false;  
	
	private int beginRow, endRow = 0;

	public MyInquiry(UProfile user) {
		this.setUProfile(user);
	}

	public MyInquiry() {
	}


	public boolean set(String fname, String value) {
		try {
			this.getCurrentDbRecord().set(fname, value);
			return true;
		} catch (RemoteException e) {
			MyLog.warn(this, "Table : "+this.getTableName()+"   Field :"+fname);
			MyLog.warn(this, e);
			return false;
		}
	}

	public void initMyTable(String className, String filter, String order) {
		this.filter = filter;
		this.orderBy = order;
		this.startUp(className);
		this.setCompanyFilter();
	}

	protected void startUp(String ClassName) {
		String jndiName = ClassName;
		// this.logger.info("JNDI NAME : " + jndiName);
		try {
			this.mr = this.mf = this.getRecordManagement(jndiName);
			this.br = this.getRecordManagement(jndiName);
			this.tr = this.getRecordManagement(jndiName);
			this.field = mr.getFieldList();
			this.aField = mr.getArrayFieldList();
			this.stmtType = this.setTableDB(this.mr.getTableName());
			this.groupField = mr.getGroupField();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void refresh() {
		if(ds==null){ // dataSet  null  new жҵͧ
			ds=new DataSet();
		}
		if(this.isjointab){
			this.refreshJoin();
		}else{
			this.refresh(false);
		}
	}	

	private void refresh(boolean chk) {
		this.preRefresh();
		String buff = "";
		StringBuilder sql = new StringBuilder();
		buff = this.getFilter();
		buff = this.getChildFilter(buff);
		buff = this.getKeyfilter(buff);		
		buff = this.getFixFilter(buff);
		buff = this.getSecurityFilter(buff);
		buff = this.getSubsFilter(buff);
		try {

			/*
			 * Start -*****-check column to user from app to cscindextable
			 */

			if (StaticProperties.checkIndextable) {
				CscIndexTable ci = new CscIndexTable(this.userPro, this
						.getTableName(), buff);
				ci.save("W_INQ");

				ci = new CscIndexTable(this.userPro, this.getTableName(),
						orderBy);
				ci.save("O_INQ");
			}
			/*
			 * End -****-check column to user from app to cscindextable
			 */

			// this.initConnection();
			if (!buff.trim().equals("")) {								
				if(this.haveBetween()){
					String order=this.orderBy.toUpperCase();
					if (order.trim().length() == 0) {
						if(this.keyfilter.size()==0)
							order =((String)this.mr.getAllKey().get(0)).toUpperCase();
						else
							order =((String)this.keyfilter.get(0)).toUpperCase();
					}
					if(this.dbtype.equalsIgnoreCase("ORACLE")||this.dbtype.equalsIgnoreCase("MSSQL")){	
						sql.append("SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY ").append(order).append(") AS ROWNUMBER,").append(this.field).append(" FROM ")
						.append(this.mr.getTableName()).append(" WHERE ").append(buff).append(") VT").append(this.mr.getTableName()).append(" WHERE ROWNUMBER between ").append(this.beginRow).append(" and ").append(this.endRow);
					}
				}else{
					sql.append("SELECT ").append(this.field).append(" FROM ").append(this.mr.getTableName()).append(" WHERE ").append(buff);
				}				
			} else {
				if(this.haveBetween()){
					String order=this.orderBy.toUpperCase();
					if (order.trim().length() == 0) {
						if(this.keyfilter.size()==0)
							order =((String)this.mr.getAllKey().get(0)).toUpperCase();
						else
							order =((String)this.keyfilter.get(0)).toUpperCase();
					}
					if(this.dbtype.equalsIgnoreCase("ORACLE")||this.dbtype.equalsIgnoreCase("MSSQL")){	
						sql.append("SELECT * FROM (SELECT ROW_NUMBER() OVER(ORDER BY ").append(order).append(") AS ROWNUMBER,").append(this.field).append(" FROM ")
						.append(this.mr.getTableName()).append(") VT").append(this.mr.getTableName()).append(" WHERE ROWNUMBER between ").append(this.beginRow).append(" and ").append(this.endRow);
					}
				}else{
					sql.append("SELECT ").append(this.field).append(" FROM ").append(this.mr.getTableName());
				}
			}
			if (this.orderBy.trim().length() > 0) {
				if(this.haveBetween()){
					if(this.dbtype.equalsIgnoreCase("MYSQL")){
						sql.append(" ORDER BY ").append(this.orderBy).append(" LIMIT ").append(this.beginRow).append(",").append((this.endRow-this.beginRow));
					}else{
//						óշա orderby ͧ order by  
						sql.append(" ORDER BY ROWNUMBER");
						}
				}else{
					sql.append(" ORDER BY ").append(this.orderBy);
				}
				
			}
			if (this.currentRecord > 1 || !this.oldCondition.equals(buff)) {
				this.sql = sql.toString();
//				this.ds.setInfo(this.charCode("point1", sql.toString()),this.databaseName, this.getTableName());
				this.ds.setInfo(sql.toString(),this.databaseName, this.getTableName());
				this.ds.setGroupBy(this.groupByVector);
				this.ds.setFetchAll(this.fetchAll);
				this.ds.setClassName(this.mf.getActualName());
				if (this.extResultSet) {
					ds.initConnection(this.reSultSet, buff, orderBy);
				} else {
					ds.initConnection(this.getUProfile());
				}
				this.currentRecord = 0;
				this.mf.clearField();
				this.oldCondition = buff;
				this.isSameCondition = false;
			} else {
				this.refreshChild(); // ֧ͧ refresh  child Ҩеͧ refresh աù child ͡͹ Record 
				if (this.currentRecord==1) {			
					this.isSameCondition = true;
				} else {
					this.isSameCondition = false;
				}
			}
			// this.ds = new
			// InitialConnection().getDbData(this.charCode("point1",
			// sql.toString()), this.databaseName);
			this.foundData = true;
			if (this.sum != null) {
				this.sum.clearAll();
			}
			this.recAmount = this.CountNumberOfRecord();
			this.currentRecord = 0;
			this.oldCondition = buff;
			// this.mf.clearField();
			this.groupDataInitial();
			this.preNextFirstRecord();
			this.clearBetween();
			// this.nextForClose();
			// this.logger.info("Refresh Success.");
		} catch (Exception sqlex) {
			MyLog.warn(this, sqlex);
			MyLog.warn(this,"= MyInquiry.refresh() [ SQLCOMMAND : "+ sql + "]");
		}
	}
	
	public void preNextFirstRecord() {
		
	}

	public void preRefresh() {
		
	}
	
	public void postNextLastRecord() {
		
	}
	
	public void beforePrinting() {
		
	}
	
	public void preNextRecord() {
		
	}
	
	public void postNextRecord() {
		
	}
	
	public boolean isSameCondition() {
		return this.isSameCondition;
	}

	private void setwfFilter() {
		if (this.mf.wfActive()) {
			if (this.fixFilter.length() == 0)
				this.fixFilter += " wf_status ='4' ";
			else
				this.fixFilter += " and wf_status ='4' ";
		}
	}

	private String getChildFilter(String buff) {
		if (buff.trim().equals("")) {
			buff = this.childCondi	.substring(0,((this.childCondi.length() > 4) ? this.childCondi.length() - 4 : this.childCondi.length()));
		} else {
			buff = this.childCondi + buff;
		}
		return buff;
	}

	private String getFixFilter(String buff) {
		if (this.fixFilter.length() > 0) {
			if (buff.length() == 0) {
				buff = this.fixFilter;
			} else {
				buff = "( "+buff+" ) and " + this.fixFilter;
			}
		}
		return buff;
	}

	private void printSql(String sql) {
		MyLog.debug(this, "sql command :" + sql);
	}

	public void refreshNextDB() {
	}
	
	protected boolean fetch() throws Exception {
		if(this.isjointab)
			return fetchJoin();
		else
			return fetchInq();
	}
	
	protected boolean fetchInq() throws Exception {
		boolean flag;
		flag = false;
		int check = 0;
		this.mf.preInqNext();

		if (this.currentRecord > 0){
				this.groupDataClear(ds.getGroupChange());
			}

		do {
			flag = false;
			check = 0;
			ds.next();
			check = this.tr.assignField(this.ds);
			if (check == 0) {
				this.mf.setFoundData(false);
			} else {
				this.tr.setFoundData(true);
			}
			for (; (!flag) && (check == 1);) {
				this.tr.setRequiredFound(this.requiredFound);

				// Start RequireFoundTable
				this.tr.setRequireFoundTable(this.getRequireFoundTable());
				// End RequireFoundTable
				DbRecord r = this.br;
				this.br = this.mf;
				this.mf = this.tr;
				this.tr = r;
				this.rm = this.mf.getSecurity();
				this.refreshChild();
				if ((!this.chkStringSearch()) || (!this.foundData())|| (this.rm != null && !this.rm.inquiryAffter(this.mf))) {
					flag = false;
					this.mf.clearField();
					ds.next();
					check = this.tr.assignField(ds);
				} else {
					if (this.sum != null) {
						this.sum.calculate(this);
					}
					flag = true;
				}
			}
			if (flag){ 	
				this.groupDataProcess();
			}else{
				this.mf.refreshChild();
			}
		} while (this.groupByVector.size() > 0 && ds.getGroupChange() == -1
				&& check == 1);

		if (flag)
			this.groupChange(ds.getGroupChange());

		this.mf.postInqNext();
		return flag;
	}
	
	private boolean fetchJoin() throws Exception {
		boolean flag;
		flag = false;
		int check = 0;
		this.mf.preInqNext();

		if (this.currentRecord > 0)
			this.groupDataClear(ds.getGroupChange());

		do {
			flag = false;
			check = 0;
			ds.next();
			check = this.tr.assignField(this.ds);
			if (check == 0) {
				this.mf.setFoundData(false);
			} else {
				this.tr.setFoundData(true);
			}
			for (; (!flag) && (check == 1);) {
				DbRecord r = this.br;
				this.br = this.mf;
				this.mf = this.tr;
				this.tr = r;
				this.rm = this.mf.getSecurity();
				//this.refreshChild();
				this.refreshChildJoin(this.ds,this.mf);
				if ((!this.chkStringSearch()) || (!this.foundData())|| (this.rm != null && !this.rm.inquiryAffter(this.mf))) {
					flag = false;
					this.mf.clearField();
					ds.next();
					check = this.tr.assignField(ds);
				} else {
					if (this.sum != null) {
						this.sum.calculate(this);
					}
					flag = true;
				}
			}
			if (flag){ 	
				this.groupDataProcess();
			}else{
				//this.mf.refreshChild();
			}
		} while (this.groupByVector.size() > 0 && ds.getGroupChange() == -1
				&& check == 1);

		if (flag)
			this.groupChange(ds.getGroupChange());

		this.mf.postInqNext();
		return flag;
	}		

	private boolean chkStringSearch() {
		boolean b;
		if (!this.stringFilter.equals("")) {
			b = this.chkParentData();
			if (b) {
				return true;
			} else {
				return this.chkChild(this.mf);
			}
		} else
			return true;
	}

	private boolean chkParentData() {
		try {
			for (int i = 0; i < this.aField.size(); i++) {
				String fName = this.aField.get(i).toString();
				String data = this.mf.getString(fName);
				if (data.indexOf(this.stringFilter) != -1) {
					mf.set("search_info", "Found in table "
							+ this.mf.getTableName() + " field  " + fName);
					return true;
				}
			}
			return false;
		} catch (Exception e) {
			MyLog.warn(this, e);
			return false;
		}
	}

	private boolean chkChild(DbRecord db) {
		try {
			Enumeration em = db.getChildTable().keys();
			while (em.hasMoreElements()) {
				String childName = (String) em.nextElement();
				DbRecord dbCh = null;
				Object oCh = db.getChild(childName);
				if (oCh instanceof DbRecord)
					dbCh = (DbRecord) oCh;
				else if (oCh instanceof DbInquiry)
					dbCh = ((DbInquiry) oCh).getCurrentDbRecord();
				else if (oCh instanceof DbTable)
					dbCh = ((DbTable) oCh).getCurrentRecordManager();
				for (int i = 0; i < this.aField.size(); i++) {
					String fName = this.aField.get(i).toString();
					String data = dbCh.getString(fName);
					if (data.indexOf(this.stringFilter) != -1) {
						mf.set("search_info", "Found int table "
								+ dbCh.getTableName() + " field  " + fName);
						return true;
					}
				}
				if (dbCh.getChildTable().size() != 0) {
					return this.chkChild(dbCh);
				}
			}
			return false;
		} catch (Exception e) {
			MyLog.warn(this, e);
			return false;
		}
	}

	public boolean foundData() {
		boolean b = false;
		try {
			this.setRecordProperty();
			b = this.mf.foundData();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return b;
	}

	public void previous() {
		if (this.recAmount > 0 && this.currentRecord > 1) {
			this.currentRecord--;
			this.go(this.currentRecord);
		}
	}

	public boolean goPage(int page) {
		boolean b = true;
		if (page == 1) {
			b = this.go(1);
		} else {
			b = this.go(((this.recordPage - 1) * page) + 1);
		}
		return b;
	}

	public boolean go(int recno) {
		boolean b = true;
		if (this.currentRecord + 1 == recno) {
			try {
				b = this.next();
			} catch (Exception ex) {
				MyLog.warn(this, ex);
			}
		} else {
			if (this.currentRecord != recno) {
				if (this.currentRecord > recno) {
					if (!this.fetchAll) {
						this.refresh(false); 
					} else {
						this.ds.go(recno);
						this.currentRecord = recno;
						b= this.next();
					}
				}
				for (; this.currentRecord < recno && b;) {
					try {
						b = this.next();
					} catch (Exception ex) {
						MyLog.warn(this, ex);
					}
				}
			}
		}
		return b;
	}

	public void first() {
		this.refresh(false);
	}

	private String convertField(String field) {
		field = field.substring(0, 1).toUpperCase()
				+ field.substring(1, field.length()).toLowerCase();
		return field;
	}

	public int recCount() {
		String sql = "";
		CscConnection con = null;
		Statement st = null;
		ResultSet rs = null;
		try {
			if (this.extResultSet) {
				Factorable factor = (Factorable) Class.forName("com.csc.library.factor."+ this.convertField(this.reSultSet)).newInstance();
				return factor.recCount();
			}
			String buff = this.getFilter();
			buff = this.getChildFilter(buff);
			buff = this.getKeyfilter(buff);
			buff = this.getFixFilter(buff);
			buff = this.getSecurityFilter(buff);
			buff = this.getSubsFilter(buff);
			if (!this.databaseName.equals("")) {
				con = (CscConnection)StaticProperties.myConnection.getConnection(this.databaseName,this.getUProfile());
			} else {
				con =(CscConnection) StaticProperties.myConnection.getConnection(this.userPro.getDbName(),this.getUProfile());
			}
			st = con.createStatement();
			if (buff.trim().length() > 0)
				sql = "select count(*) from " + this.getTableName()
						+ " where  " + buff;
			else
				sql = "select count(*) from " + this.getTableName();
			rs = st.executeQuery(sql);
			rs.next();
			int no = rs.getInt(1);
			return no;
		}  catch (Exception e) {
			MyLog.error(this,this.getUProfile(),e.getMessage() +" : SQL : "+sql);
		}finally{
			try {
				if(rs!=null)
					rs.close();
				if(st!=null)
					st.close();
				if(con!=null)
					con.close();
			} catch (SQLException ex) {
				MyLog.warn(this, ex);
			}
		}
		return 0;
	}

	public int recCount(String sql) {
		CscConnection con = null;
		Statement st = null;
		ResultSet rs = null;
		try {
			if (this.extResultSet) {
				Factorable factor = (Factorable) Class.forName("com.csc.library.factor."+ this.convertField(this.reSultSet)).newInstance();
				return factor.recCount();
			}
			if (!this.databaseName.equals("")) {
				con = (CscConnection)StaticProperties.myConnection.getConnection(this.databaseName,this.getUProfile());
			} else {
				con =(CscConnection) StaticProperties.myConnection.getConnection(this.userPro.getDbName(),this.getUProfile());
			}
			con.setClassName("MyInquiry");
			st = con.createStatement();
			rs = st.executeQuery(sql);
			rs.next();
			int no = rs.getInt(1);
			return no;
		}  catch (Exception e) {
        	if(con.isReconnect(e)){
        		con=con.checkConnectionClose();
        	}
		}finally{
			try {
				rs.close();
				st.close();
				con.close();
			} catch (SQLException ex) {
				MyLog.warn(this, ex);
			}
		}
		return 0;
	}	
	
	private int CountNumberOfRecord() {
		int row = 0;
		try {
			// this.rs.last() ;
			// row = this.rs.getRow();
			// this.rs.beforeFirst() ;
		} catch (Exception ex) {
			MyLog.warn(this, ex);
		}
		return row;
	}

	public int recNo() {
		return this.currentRecord;
	}

	public boolean isFirst() {
		if (this.currentRecord <= 1) {
			return true;
		} else {
			return false;
		}
	}

	public boolean isLast() {
		if (this.currentRecord == this.recCount())
			return true;
		else
			return false;
	}

	public boolean setColumn(String columnList) {
		boolean ok = true;
		Vector vf = new Vector();
		if (columnList.equals("*")) {
			vf = (Vector)this.mr.getAllFieldName().clone();
		} else {
			for (StringTokenizer token = new StringTokenizer(columnList,","); token.hasMoreTokens();) {
				String tmpField = token.nextToken().trim().toLowerCase();
				if (!tmpField.equals("")) {
					vf.add(tmpField);
				}
			}
		}
		ok = this.setColumn(vf);
		return ok;
	}
	
	private boolean checkNewOldColum(Vector oldColum,Vector  newColum) {
		boolean refresh = false;
		for (int i = 0; i < newColum.size() && !refresh; i++) {
			if (!oldColum.contains(newColum.get(i))) {
				refresh = true;
			}
		}
		if (!refresh) {
			HashMap hm = (HashMap) StaticProperties.systemField.get("systemfield");
			for (int i = 0; i < oldColum.size() && !refresh; i++) {
				if (!hm.containsKey(oldColum.get(i))) {
					if (!newColum.contains(oldColum.get(i))) {
						refresh = true;
					}
				}
			}
		}
		return refresh;
	}
	
	public boolean setColumn(Vector columnList) {
		boolean ok = true;
		try {
			Vector oldColum = this.mr.getArrayFieldList();
			if (this.checkNewOldColum(oldColum, columnList)) {
				this.mr.setColumn(columnList); 
				this.mf.setColumn(columnList);
				this.tr.setColumn(columnList);
				this.br.setColumn(columnList); 
				this.field = mr.getFieldList();
				this.aField = mr.getArrayFieldList();
				ok = true;
				this.oldCondition = "PAIK";
				this.isSameCondition = false;
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return ok;
	}



	public boolean changed(String fieldName) {
		boolean b = false;
		try {
			if (this.currentRecord > 1) {
				b = !(this.br.getString(fieldName).equals(this.mf.getString(fieldName)));
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return b;
	}

	public void print() {
		try {
			// this.logger.info("Recno : " +
			// String.valueOf(this.currentRecord));
			this.mf.print();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void printList() {
		try {
			// this.logger.info("Recno :: " + String.valueOf(this.currentRecord)
			// + "::");
			this.mf.printList();
			// this.logger.info("");
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public String getString(String fieldName) {
		try {
			String tmp = mf.getString(fieldName).toString();
			if (tmp != null)
				return tmp.trim();
			else
				return tmp;
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return "";
	}

//	public String getString(int index) {
//		try {
//			String tmp = mf.getString(index);
//			if (tmp != null)
//				return tmp.trim();
//			else
//				return tmp;
//		} catch (Exception e) {
//			MyLog.warn(this, " erreor when get  fieldname :"	+ index);
//			MyLog.warn(this, e);
//		}
//		return "";
//	}	
	
	public String getString(String tableName, String fieldName) {
		try {
			return this.getChild(tableName).getString(fieldName);
		} catch (RemoteException e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+tableName+"."+ fieldName);
			MyLog.warn(this, e);
			return "";
		}
	}

	public boolean getBoolean(String fieldName) {
		try {
			return mf.getBoolean(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return false;
	}

	public byte getByte(String fieldName) {
		try {
			return mf.getByte(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return 0;
	}

	public char[] getChars(String fieldName) {
		try {
			return mf.getChars(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public char getChar(String fieldName) {
		try {
			return mf.getChar(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return '0';
	}

	public short getShort(String fieldName) {
		try {
			return mf.getShort(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return 0;
	}

	public int getInt(String fieldName) {
		try {
			return mf.getInt(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return 0;
	}

	public int getInt(String tableName, String fieldName) {
		try {
			if (tableName.equalsIgnoreCase(this.getTableName())) {
				return this.getInt(fieldName);
			} else {
				ChildManager child = this.getChild(tableName);
				if (child == null) {
					MyLog.warn(this, " erreor when get  fieldname :"	+tableName+"."+ fieldName);
					return 0;
				} else {
					return Integer.parseInt(child.getString(fieldName));
				}
			}
		} catch (RemoteException e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+tableName+"."+ fieldName);
			MyLog.warn(this, e);
			return 0;
		}
	}

	public long getLong(String fieldName) {
		try {
			return mf.getLong(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return 0L;
	}

	public float getFloat(String fieldName) {
		try {
			return mf.getFloat(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return 0f;
	}

	public double getDouble(String fieldName) {
		try {
			return mf.getDouble(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return 0;
	}

	public double getDouble(String tableName, String fieldName) {
		try {
			return Double.parseDouble(this.getChild(tableName).getString(
					fieldName));
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
			return 0;
		}
	}

	public Timestamp getTimestamp(String fieldName) {
		try {
			return mf.getTimestamp(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public BigDecimal getBigcimal(String fieldName) {
		try {
			return mf.getBigDecimal(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public Time getTime(String fieldName) {
		try {
			return mf.getTime(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public java.sql.Date getDate(String fieldName) {
		try {
			return mf.getDate(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public MyHashMap getMyHashMap() {
		return mf.getMyHashMap();
	}
	
	public MyHashMap getDataSet(String filter) {
		MyHashMap data = new MyHashMap();
		MyHashMap recData = new MyHashMap();
		String fieldName = "";
		Vector gField = null;
		// if not have field group
		if (this.groupActive.equalsIgnoreCase("all")) {
			this.setColumn("*");
		} else {
			if (!this.groupField.containsKey(this.groupActive)) {
				this.setColumn("*");
	        	MyLog.debug(this, "Can't not get FieldGroup >> " + this.groupActive);
			} else {
				 gField = (Vector) this.groupField.get(this.groupActive);
			}
			this.setColumn(gField);
		}
		if (filter != null && !filter.equals(""))
			this.setFilter(filter);
		this.refresh(false);
		try {
			DbRecord record = null;
			int recCount = 0;
			do {
				record = this.getCurrentDbRecord();
				recData.clear();
				for (int i = 0; i < this.aField.size(); i++) {
					String fName = this.aField.get(i).toString();
					recData.put(fName, record.getString(fName));
				}
				data.put(String.valueOf(recCount), recData.clone());
				recCount++;
			} while (this.next());
			return data;
		} catch (Exception e) {
			MyLog.warn(this, " set filter error :"	+ filter);
			MyLog.warn(this, e);
			return null;
		}
	}

	public CscCalendar getCscCalendar(String fieldName) {
		try {
			return mf.getCscCalendar(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public String getOldString(String fieldName) {
		try {
			return br.getString(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return "";
	}

	/*
	 * public boolean getOldBoolean(String fieldName) {return
	 * br.getBoolean(fieldName);} public byte getOldByte(String fieldName)
	 * {return br.getByte(fieldName);} public char[] getOldChars(String
	 * fieldName) {return br.getChars(fieldName);} public char getOldChar(String
	 * fieldName) {return br.getChar(fieldName);} public short
	 * getOldShort(String fieldName) {return br.getShort(fieldName);} public int
	 * getOldInt(String fieldName) {return br.getInt(fieldName);} public long
	 * getOldLong(String fieldName) {return br.getLong(fieldName);} public float
	 * getOldFloat(String fieldName) {return br.getFloat(fieldName);} public
	 * double getOldDouble(String fieldName) {return br.getDouble(fieldName);}
	 * public Timestamp getOldTimestamp(String fieldName) {return
	 * br.getTimestamp(fieldName);} public BigDecimal getOldBigcimal(String
	 * fieldName) {return br.getBigDecimal(fieldName);} public Time
	 * getOldTime(String fieldName) {return br.getTime(fieldName);} public
	 * java.sql.Date getOldDate(String fieldName) {return
	 * br.getDate(fieldName);} public cscCalendar getOldcscCalendar(String
	 * fieldName) {return br.getcscCalendar(fieldName);}
	 */

	public void setFilter(String s) {
		/*
		 * if (this.filter == null || filter.length() == 0) { this.filter = s; }
		 * else this.filter += " and " + s;
		 */
		s = this.tfSql(s);
		this.filter = s;
		// this.logger.info(this.filter);
	}

	public String getFilter() {
		return this.filter;
	}

	public void setOrderBy(String o) {
		this.orderBy = o;
	}

	public String getOrderBy() {
		return this.orderBy;
	}

	public void setGroupBy(String o) throws RemoteException {
		this.groupByVector = this.separateColumn(o);
	}

	public String getGroupBy() {
		return this.groupByVector.toString();
	}

	public void setSumColumn(String o) throws RemoteException {
		this.sumColumnVector = this.separateColumn(o);
	}

	public String getSumColumn() {
		return this.sumColumnVector.toString();
	}

	public void setMinColumn(String o) throws RemoteException {
		this.minColumnVector = this.separateColumn(o);
	}

	public String getMinColumn() {
		return this.minColumnVector.toString();
	}

	public void setMaxColumn(String o) throws RemoteException {
		this.maxColumnVector = this.separateColumn(o);
	}

	public String getMaxColumn() {
		return this.maxColumnVector.toString();
	}

	public void setAVGColumn(String o) throws RemoteException {
		this.avgColumnVector = this.separateColumn(o);
	}

	public String getAVGColumn() {
		return this.avgColumnVector.toString();
	}

	public void setUDFColumn(String o) throws RemoteException {
		this.udfColumnVector = this.separateColumnUDF(o);
	}

	public String getUDFColumn() {
		return this.udfColumnVector.toString();
	}

	private Vector separateColumn(String columList) throws RemoteException {
		Vector vf;
		String columnList;
		StrReplace rp = new StrReplace();
		columnList = columList.toLowerCase();
		columnList = rp.replace(columnList, " ", "");
		vf = new Vector();
		for (StringTokenizer token = new StringTokenizer(columnList, ","); token
				.hasMoreTokens();) {
			String tmpField = token.nextToken().trim();
			if (!(this.getField(tmpField) == null))
				vf.add(tmpField);
		}
		return vf;
	}

	public FieldManager getField(String fieldName) throws RemoteException {
		return this.mf.getField(fieldName);
	}
	
	private Vector separateColumnUDF(String columList) throws RemoteException {
		Vector vf;
		String columnList;
		StrReplace rp = new StrReplace();
		columnList = columList.toLowerCase();
		columnList = rp.replace(columnList, " ", "");
		vf = new Vector();
		for (StringTokenizer token = new StringTokenizer(columnList, ","); token
				.hasMoreTokens();) {
			String tmpField = token.nextToken().trim();
			if (this.mf.getField(tmpField) == null)
				vf.add(tmpField);
		}
		return vf;
	}

	protected void groupDataInitial() {
		this.groupData.clear();
		this.groupData.put("all", getSummaryBuffer());
		for (int i = 0; i < this.groupByVector.size(); i++) {
			this.groupData.put(String.valueOf(i).trim(), getSummaryBuffer());
		}
	}

	protected void groupDataProcess() throws RemoteException {
		this.dataProcessing((MyHashMap) this.groupData.get("all"));
		for (int i = 0; i < this.groupByVector.size(); i++) {
			this.dataProcessing((MyHashMap) this.groupData.get(String
					.valueOf(i).trim()));
		}
	}

	protected void dataProcessing(MyHashMap hm) throws RemoteException {
		int count = hm.getInt("count") + 1;
		hm.put("count", count);
		if (this.sumColumnVector.size() > 0) {
			MyHashMap hmSUM = (MyHashMap) hm.get("sum");
			for (int i = 0; i < this.sumColumnVector.size(); i++) {
				double d = hmSUM.getDouble(this.sumColumnVector.elementAt(i));
				d += this.getDouble(this.sumColumnVector.elementAt(i)
						.toString());
				hmSUM.put(this.sumColumnVector.elementAt(i), d);
			}
		}
		if (this.avgColumnVector.size() > 0) {
			MyHashMap hmAVG = (MyHashMap) hm.get("avg");
			for (int i = 0; i < this.avgColumnVector.size(); i++) {
				double d = hmAVG.getDouble("sum_"
						+ this.avgColumnVector.elementAt(i));
				double value = this.getDouble(this.avgColumnVector
						.elementAt(i).toString());
				d += value;
				hmAVG.put("sum_" + this.avgColumnVector.elementAt(i), d);
				hmAVG.put(this.avgColumnVector.elementAt(i), d / count);
			}
		}
		if (this.minColumnVector.size() > 0) {
			MyHashMap hmMIN = (MyHashMap) hm.get("min");
			for (int i = 0; i < this.minColumnVector.size(); i++) {
				String oldValue = hmMIN.get(this.minColumnVector.elementAt(i))
						.toString();
				String newValue = this.getString(this.minColumnVector
						.elementAt(i).toString());
				if (newValue.compareTo(oldValue) < 0) {
					hmMIN.put(this.minColumnVector.elementAt(i), newValue);
				}
			}
		}
		if (this.maxColumnVector.size() > 0) {
			MyHashMap hmMAX = (MyHashMap) hm.get("max");
			for (int i = 0; i < this.maxColumnVector.size(); i++) {
				String oldValue = hmMAX.get(this.maxColumnVector.elementAt(i))
						.toString();
				String newValue = this.getString(this.maxColumnVector
						.elementAt(i).toString());
				if (newValue.compareTo(oldValue) > 0) {
					hmMAX.put(this.maxColumnVector.elementAt(i), newValue);
				}
			}
		}
		if (this.udfColumnVector.size() > 0) {
			MyHashMap hmUDF = (MyHashMap) hm.get("udf");
			for (int i = 0; i < this.udfColumnVector.size(); i++) {
				Object oldValue = hmUDF.get(this.udfColumnVector.elementAt(i));
				Object newValue = this.calculate(this.udfColumnVector
						.elementAt(i).toString(), oldValue);
				if (newValue != null && newValue.toString().equals("")) {
					newValue = "0";
				} else if (newValue == null) {
					newValue = new String();
					newValue = "0";
				}
				hmUDF.put(this.udfColumnVector.elementAt(i), newValue);
			}
		}
	}

	public void printGroupDataProcess() {
		for (int i = 0; i < this.groupByVector.size(); i++) {
			System.out.println(this.groupByVector.elementAt(i).toString());
			this.printDetailDataProcessing((MyHashMap) this.groupData
					.get(String.valueOf(i).trim()));
		}
		this.printDetailDataProcessing((MyHashMap) this.groupData.get("all"));
	}

	public void printDetailDataProcessing(MyHashMap hm) {
		DecimalFormat form = new DecimalFormat("0000000000.0000");
		System.out.println(hm.getInt("count"));
		if (this.sumColumnVector.size() > 0) {
			MyHashMap hmSUM = (MyHashMap) hm.get("sum");
			for (int i = 0; i < this.sumColumnVector.size(); i++) {
				System.out.println(this.sumColumnVector.elementAt(i).toString()
						+ " | "
						+ form.format(hmSUM.getDouble(this.sumColumnVector
								.elementAt(i))));
			}
		}
		if (this.avgColumnVector.size() > 0) {
			MyHashMap hmAVG = (MyHashMap) hm.get("avg");
			for (int i = 0; i < this.avgColumnVector.size(); i++) {
				System.out.println(this.avgColumnVector.elementAt(i).toString()
						+ " | "
						+ form.format(hmAVG.getDouble(this.avgColumnVector
								.elementAt(i))));
			}
		}
		if (this.minColumnVector.size() > 0) {
			MyHashMap hmMIN = (MyHashMap) hm.get("min");
			for (int i = 0; i < this.minColumnVector.size(); i++) {
				System.out.println(this.minColumnVector.elementAt(i).toString()
						+ " | "
						+ hmMIN.getString(this.minColumnVector.elementAt(i)));
			}
		}
		if (this.maxColumnVector.size() > 0) {
			MyHashMap hmMAX = (MyHashMap) hm.get("max");
			for (int i = 0; i < this.maxColumnVector.size(); i++) {
				System.out.println(this.maxColumnVector.elementAt(i).toString()
						+ " | "
						+ hmMAX.getString(this.maxColumnVector.elementAt(i)));
			}
		}
		if (this.udfColumnVector.size() > 0) {
			MyHashMap hmUDF = (MyHashMap) hm.get("udf");
			for (int i = 0; i < this.udfColumnVector.size(); i++) {
				System.out.println(this.udfColumnVector.elementAt(i).toString()
						+ " | "
						+ hmUDF.getString(this.udfColumnVector.elementAt(i)));
			}
		}
	}

	protected void groupDataClear(int level) {
		if (level >= 0) {
			for (int i = level; i < this.groupByVector.size(); i++) {
				this.groupData
						.put(String.valueOf(i).trim(), getSummaryBuffer());
			}
		}
	}

	protected void groupChange(int level) {

	}

	protected MyHashMap getSummaryBuffer() {
		MyHashMap hm = new MyHashMap();
		hm.put("count", 0);
		if (this.sumColumnVector.size() > 0) {
			MyHashMap hmSUM = new MyHashMap();
			for (int i = 0; i < this.sumColumnVector.size(); i++) {
				hmSUM.put(this.sumColumnVector.elementAt(i), 0);
			}
			hm.put("sum", hmSUM);
		}
		if (this.avgColumnVector.size() > 0) {
			MyHashMap hmAVG = new MyHashMap();
			for (int i = 0; i < this.avgColumnVector.size(); i++) {
				hmAVG.put(this.avgColumnVector.elementAt(i), 0);
				hmAVG.put("sum_" + this.avgColumnVector.elementAt(i), 0);
			}
			hm.put("avg", hmAVG);
		}
		if (this.minColumnVector.size() > 0) {
			MyHashMap hmMIN = new MyHashMap();
			for (int i = 0; i < this.minColumnVector.size(); i++) {
				hmMIN.put(this.minColumnVector.elementAt(i),
						"??????????????????");
			}
			hm.put("min", hmMIN);
		}
		if (this.maxColumnVector.size() > 0) {
			MyHashMap hmMAX = new MyHashMap();
			for (int i = 0; i < this.maxColumnVector.size(); i++) {
				hmMAX.put(this.maxColumnVector.elementAt(i), "");
			}
			hm.put("max", hmMAX);
		}
		if (this.udfColumnVector.size() > 0) {
			MyHashMap hmUDF = new MyHashMap();
			for (int i = 0; i < this.udfColumnVector.size(); i++) {
				hmUDF.put(this.udfColumnVector.elementAt(i), null);
			}
			hm.put("udf", hmUDF);
		}
		return hm;
	}

	public MyHashMap getGroupData() {
		return this.groupData;
	}

	public int getGroupSize() {
		return this.groupByVector.size();
	}

	public Object calculate(String FieldName, Object oldValue) {
		/*
		 * if (oldValue==null) { oldValue = "PIAK1"; } else { oldValue =
		 * oldValue.toString().substring(4); Integer i =
		 * Integer.valueOf(oldValue.toString()); int k = i.intValue()+1;
		 * oldValue = "PIAK"+String.valueOf(k); }
		 */
		return (Object) oldValue;
	}

	public String getTableName() {
		try {
			return this.mr.getTableName();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public String getActualName() {
		try {
			return this.mr.getActualName();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public void setTableName(String name) {
		try {
			this.mr.setTableName(name);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void setActualName(String name) {
		try {
			this.mr.setActualName(name);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	/**
	 * Edit.................................
	 */
	public String getError() {
		return "";
	}

	public Hashtable getRelationInfo() {
		Hashtable b = null;
		try {
			b = this.mr.getRelationInfo();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return b;
	}

	public void setRelationInfo(Hashtable hashRelation) {
		try {
			this.mr.setRelationInfo(hashRelation);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public Hashtable getEffectTable() {
		Hashtable b = null;
		try {
			b = this.mr.getEffectTable();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return b;
	}

	public void setEffectTable(Hashtable hashEffectTable) {
		try {
			this.mr.setEffectTable(hashEffectTable);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public Hashtable getChildTable() {
		try {
			return this.mr.getChildTable();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public void setChildTable(Hashtable hashChild) {
		try {
			this.mr.setChildTable(hashChild);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void putRelation(Relation oRela) {
		try {
			this.mr.putRelation(oRela);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void removeRelation(String tableName) {
		try {
			this.mr.removeRelation(tableName);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public Relation getRelation(String tableName) {
		try {
			return this.mr.getRelation(tableName);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public int putChild(ChildManager oChild) {
		int ok = 0;
		try {
			ok = this.mr.putChild(oChild);
			this.mf.putChild(oChild);
			this.tr.putChild(oChild);
			this.br.putChild(oChild);
			oChild.isChild();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return ok;
	}

	public int putChild(String childName, char type, char usedFor) {
		DbRecord oRecord;
		TableManager oTable;
		ChildManager oChild = null;
		Class c;
		int ok = 0;
		return ok;
	}

	public void removeChild(String childName) {
		try {
			this.mr.removeChild(childName);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void removeAllChild() {
		try {
			this.mr.removeAllChild();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void refreshChild() {
		try {
			this.setRecordProperty();
			this.mf.refreshChild();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void refreshChild(String childName) {
		try {
			this.setRecordProperty();
			this.mf.refreshChild(childName);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	private void setRecordProperty() {
		try {
			this.mf.setRelationInfo(mr.getRelationInfo());
			this.mf.setChildTable(mr.getChildTable());
			this.mf.setEffectTable(mr.getEffectTable());
			this.mf.setActualName(mr.getActualName());
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public ChildManager getChild(String childName) {
		ChildManager b = null;
		try {
			if (childName.equalsIgnoreCase(this.getTableName()))
				b = this;
			else
				b = this.mr.getChild(childName);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return b;
	}

	public DbRecord getRecordManager(String childName) {
		try {
			return this.mr.getRecordManager(childName);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public DbRecord getCurrentRecordManager() {
		try {
			this.mf.setRelationInfo(mr.getRelationInfo());
			this.mf.setChildTable(mr.getChildTable());
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return this.mf;
	}

	public DbRecord getCurrentDbRecord() {
		try {
			this.mf.setRelationInfo(mr.getRelationInfo());
			this.mf.setChildTable(mr.getChildTable());
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return this.mf;
	}

	public DbRecord getRecordManagement(String tableName) {
		DbRecord rRemote = new InitialRecord(this.userPro, this.param)
				.getDbRecord(tableName, 'T');
		// this.logger.info("UPROFILE = " + this.userPro);
		try {
			rRemote.setUProfile(this.userPro);
		} catch (Exception ex) {
			MyLog.warn(this, ex);
		}
		return rRemote;
	}

	public Vector getAllKey() {
		Vector listKey = null;
		try {
			listKey = mf.getAllKey();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return listKey;
	}

	public DbRecord getCurrentRecordManager(int recNo) {
		try {
			if (recNo <= this.recAmount && recNo > 0) {
				this.first();
				for (; recNo != this.currentRecord; this.next()) {
					return this.getCurrentDbRecord();
				}
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public DbTable getTableManager(String childName) {
		DbTable b = null;
		try {
			b = this.mr.getTableManager(childName);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return b;
	}

	public String listChild() {
		try {
			return this.mr.listChild();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public void setAutoRefresh(byte status) {
		this.autoRefresh = status;
	}

	public byte getAutoRefresh() {
		return this.autoRefresh;
	}

	private boolean notSingleChar(String fieldName) {
		try {
			FieldManager fm = this.mf.getField(fieldName);
			String data = fm.getType();
			// return data.equalsIgnoreCase("Autonumber") ||
			// data.equalsIgnoreCase("Integer") ||
			// data.equalsIgnoreCase("Double") ||
			// data.equalsIgnoreCase("Bigdecimal");
			return data.equalsIgnoreCase("Integer")
					|| data.equalsIgnoreCase("Double")
					|| data.equalsIgnoreCase("Bigdecimal");
		} catch (RemoteException e) {
			MyLog.warn(this, e);
			return false;
		}
	}

	public int setCondition(String condition[]) {
		// this.logger.info("<-- in setCondition -->");
		Hashtable tempKey = new Hashtable();
		int ok = 0;
		int k = 1;
		int i;
		this.childCondi = "";
		if (condition.length % 2 == 0 && condition.length > 0) {
			ok = 1;
			for (i = 0; i < condition.length && ok == 1; i = i + 2) {
				if (this.notSingleChar(condition[i])) {
					this.childCondi = this.childCondi + condition[i] + "="
							+ condition[i + 1] + " and ";
				} else {
					this.childCondi = this.childCondi + condition[i] + "='"
							+ condition[i + 1] + "' and ";
				}
			}
			/*
			 * this.logger.info("*******************************");
			 * this.logger.info("***** <"+this.childCondi+">*****");
			 * this.logger.info("*******************************");
			 */
		} else {
			MyLog.warn(this, "******Conditions is not Complete!******");
		}
		return ok;
	}

	public char getUsedFor() {
		return 'R';
	}

	public int save() {
		return 1;
	}

	public int delete() {
		return 1;
	}

	// public int save(Connection myCon){return 1;}
	// public int delete(Connection myCon){return 1;}
	public void clearChild() {
		try{
			this.mf.clearChild();
			this.mr.clearChild();
			this.br.clearChild();
			this.clearOldCondition();
		}catch(Exception ex){
			MyLog.warn(this,ex);
		}
	}

	public void clearField() {
		try {
			this.mf.clearField();
			this.mr.clearField();
			this.br.clearField();
			this.clearOldCondition();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}

	}

	// ********************************************
	// Group Field Manager Method
	// ********************************************
	public int fieldGroupCount() {
		try {
			return this.mr.fieldGroupCount();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return 0;
	}

	public Vector getAllFieldGroupName() {
		try {
			return this.mr.getAllFieldGroupName();
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return null;
	}

	public void putFieldGroup(FieldGroup gf) {
		try {
			this.mr.putFieldGroup(gf);
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public FieldGroup getFieldGroup(String groupCode) {
		try {
			return this.mr.getFieldGroup(groupCode);
		} catch (Exception e) {
			MyLog.warn(this, "groupCode :"+groupCode);
			MyLog.warn(this, e);
		}
		return null;
	}

	public String getLinkFieldChild(String childName) {
		try {
			return this.mr.getLinkFieldChild(childName);
		} catch (Exception e) {
			MyLog.warn(this, "childName :"+childName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public String getLinkFieldParent(String childName) {
		try {
			return this.mr.getLinkFieldParent(childName);
		} catch (Exception e) {
			MyLog.warn(this, "childName :"+childName);
			MyLog.warn(this, e);
		}
		return null;
	}

	public boolean setColumn(FieldGroup fg) {
		try {
			return this.setColumn(fg.getFieldList());
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return false;
	}

	public boolean addChildColumn(String childName) {
		String buff = this.getLinkFieldParent(childName);
		if (buff != null) {
			return this.addColumn(buff);
		}
		return false;
	}

	public void setFieldGroupColumn(String groupCode) {
		this.setColumn(this.getFieldGroup(groupCode));
	}

	public boolean addColumn(String columnList) {
		try {
			return this.setColumn(this.mr.getFieldList() + ","
					+ columnList.trim());
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return false;
	}

	// ********************************************
	public void setJSPFilter(String condition) {
		this.setFilter(this.charCode("point3", condition));
	}

	public String getJSPString(String fieldName) {
		return this.charCode("point2", this.getString(fieldName));
	}

	public void setAllRequiredFound(boolean require) {
		try {
			ChildManager child;
			this.setRequiredFound(require);
			for (Enumeration enu = this.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setRequiredFound(require);
				this.setRequiredAllChild(child, require);
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	protected void setRequiredAllChild(ChildManager childM, boolean require) {
		try {
			ChildManager child;
			for (Enumeration enu = childM.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setRequiredFound(require);
				this.setRequiredAllChild(child, require);
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	/**
	 * set User Profile to All Child
	 * 
	 * @param uPro
	 */
	public void setAllUProfile(UProfile uPro) {
		ChildManager child;
		this.setUProfile(uPro);
		try {
			for (Enumeration enu = this.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setUProfile(uPro);
				this.setAllUProfile(child, uPro);
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	private void setAllUProfile(ChildManager childM, UProfile uPro) {
		ChildManager child;
		try {
			for (Enumeration enu = childM.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setUProfile(uPro);
				this.setAllUProfile(child, uPro);
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void setSchemaName(String schemaName) {
		this.schemaName = schemaName;
	}

	public String getSchemaName() {
		return this.schemaName;
	}

	public int tranferToRec(DbRecord tranRec) {
		int check = 0;
		try {
			Vector fieldList = tranRec.getArrayFieldList();
			String field = "";
			for (int i = 0; i < fieldList.size(); i++) {
				String fName = fieldList.get(i).toString();
				tranRec.set(field, this.getString(field));
			}
			check = tranRec.save();
		} catch (Exception re) {
			MyLog.warn(this, re);
		}
		return check;
	}

	public int tranferToRecAll(DbRecord tranRec) {
		int check = 0;
		while (this.next()) {
			check += this.tranferToRec(tranRec);
		}
		return check;
	}

	public void setProperties(boolean loadComponent) {
		try {
			this.mf.setProperties(loadComponent);
		} catch (Exception ex) {
			MyLog.warn(this, ex);
		}
	}

	public void referLangOn() {
		try {
			this.mf.referLangOn();
			this.tr.referLangOn();
			this.br.referLangOn();
			this.referLang = true;
			this.setChildReferLang(true);
		} catch (Exception ex) {
			MyLog.warn(this, ex);
		}
	}

	public void referLangOff() {
		try {
			this.mf.referLangOff();
			this.tr.referLangOff();
			this.br.referLangOff();
			this.referLang = false;
			this.setChildReferLang(false);
		} catch (Exception ex) {
			MyLog.warn(this, ex);
		}
	}

	/*
	 * public boolean next() { boolean b = false; if (this.nextIndex == 0) { if
	 * (this.tmp1 != null) { this.mf = this.tmp1; this.nextIndex++;
	 * this.currentRecord++; return true; } else return false; } else if
	 * (this.nextIndex == 1){ if(tmp2 !=null){ this.mf = tmp2; this.nextIndex++;
	 * this.currentRecord++; return true; }else return false; } else { b =
	 * this.rnext(); this.currentRecord++; //this.nexts(); } return b; }
	 */
	/*
	 * public boolean next() { this.cureent=this.tmp1; this.tmp1=tmp2;
	 * if(this.rnext()){ this.tmp2=mf; }else this.tmp2=null;
	 * this.mf=this.cureent; return !(this.mf==null); }
	 */
	public boolean next(){
		if(this.refreshBeforeNext){
			this.refresh();
			this.refreshBeforeNext=false;
		}
		if(this.isjointab)
			return nextJoin();
		else
			return nextInq();
	}
	
	public boolean nextInq() {
		boolean b = false;
		this.preNextRecord();
		try {
			if (this.isSameCondition && this.currentRecord == 0) {
				this.currentRecord++;
				b = true;
			} else {
				if (this.fetch()) {
					this.currentRecord++;
					b = true;
				} else {
					b = false;
					if (this.currentRecord==0) {
						this.isSameCondition = false;
					}
				}
			}
		} catch (Exception ex) {
			MyLog.warn(this, ex);
		}
		if (!b) {
			this.postNextLastRecord();
		} else {
			this.postNextRecord();
		}
		return b;
	}

	private boolean nextJoin() {
		boolean b = false;
		this.preNextRecord();
		try {
			if (this.isSameCondition && this.currentRecord == 0) {
				this.currentRecord++;
				b = true;
			} else {
				if (this.fetchJoin()) {
					this.currentRecord++;
					b = true;
				} else {
					b = false;
					if (this.currentRecord==0) {
						this.isSameCondition = false;
					}
				}
			}
		} catch (Exception ex) {
			MyLog.warn(this, ex);
		}
		if (!b) {
			this.postNextLastRecord();
		} else {
			this.postNextRecord();
		}
		return b;
	}
	
	private boolean containsField(String field) {
		Vector fieldList;
		fieldList = this.getCurrentDbRecord().getArrayFieldList();
		for (int i = 0; i < fieldList.size(); i++) {
			if (fieldList.get(i).toString().equalsIgnoreCase(field))
				return true;
		}
		return false;
	}

	private void setCompanyFilter() {
		try {
//			Iterator it = this.multiCompanyLink.keySet().iterator();
//			String fieldName, value;
//			while (it.hasNext()) {
//				fieldName = (String) it.next();
//				value = (String) this.multiCompanyLink.get(fieldName);
//				if (value != null ) {
//					if (((String) StaticProperties.myConfig.get("multicompanystatus")).equalsIgnoreCase("on")
//							&& this.containsField(fieldName)
//							&& !StaticProperties
//									.isGobal(this.mr.getTableName())) {
//						if (fixFilter != null && !this.fixFilter.equals(""))
//							this.fixFilter += " and " + fieldName + " ='"
//									+ value + "' ";
//						else
//							this.fixFilter = " " + fieldName + " = '" + value
//									+ "'  ";
//					}
//				}
//			}
			fixFilter =(this.containsField("companyid")&&this.getCompanyId()!=null)? " companyid='"+this.getCompanyId()+"' ":"";
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	private void setChildReferLang(boolean type) {
		String key;
		try {
			java.util.Enumeration em = this.getChildTable().keys();
			while (em.hasMoreElements()) {
				key = (String) em.nextElement();
				ChildManager ch = (ChildManager) this.getChildTable().get(key);
				if (type)
					ch.referLangOn();
				else
					ch.referLangOff();
			}
		} catch (RemoteException ex) {
			MyLog.warn(this, ex);
		}
	}

	protected String getCompanyId() {
		return this.userPro.get("companyid");
	}

	private void setCompanyData(HashMap value, HashMap data) {
		Iterator it = data.keySet().iterator();
		String key, temp, type, method;
		while (it.hasNext()) {
			key = (String) it.next();
			temp = (String) data.get(key);
			type = temp.substring(0, temp.indexOf(","));
			method = temp.substring(temp.indexOf(",") + 1, temp.length());
			if (type != null && type.equalsIgnoreCase("FIX")) {
				value.put(key, method);
			} else
				value.put(key, this.invokeMethod(method));
		}
	}

	private String invokeMethod(String method) {
		String data = "";
		try {
			Class c = MyInquiry.class;
			Method m = c.getDeclaredMethod(method, new Class[] {});
			data = data = (String) m.invoke(this, new Object[] {});
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
		return data;
	}

	public void setFilter(String fieldName, String data) {
		try {
			this.mr.set(fieldName, data);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		if (!this.keyfilter.contains(fieldName))
			this.keyfilter.add(fieldName);
	}
	
	private String getKeyfilter(String filter) {
		try {
			for (int i = 0; i < this.keyfilter.size(); i++) {
				FieldManager fm = this.mr.getField((String) this.keyfilter
						.elementAt(i));
				if (filter.equals(""))
					filter += fm.getCompareString();
				else
					filter += " and " + fm.getCompareString();
			}
		} catch (RemoteException e) {
			MyLog.warn(this, e);
		}
		return filter;
	}

	public void setResultSet(String rs) {
		this.reSultSet = rs;
		this.extResultSet = true;
	}

	public void finalize() {
			this.closeConnection();//  finalize ͹Ѻѹ
	}

	public void closeConnection() {
		try {
			if(ds!=null){ // close connection ӡ clear ds  ҡͧ¡ method refresh() comment by pas 2012-02-24
				this.ds.closeConnection();
				this.ds=null;
			}
			// clear ੾Сóշ١ Inquiry ͧҡ record  table աԴ connection ǨлԴ connection  method  ǹͧ Inquiry  hold connection  
//			this.closeConnectionChild();	// close connection ͧ child table ͧҡ  next  ١ѧnext зԴѭ next ١ú		
		} catch (Exception e) {
//			MyLog.warn(this, e); ͧ ҧ Close ǵ֧ش
		}
	}
	
	private void closeConnectionChild(Hashtable ht) throws Exception{
		Enumeration em = ht.keys();
		while (em.hasMoreElements()) {
			String childName = (String) em.nextElement();
			Object oCh = this.getChild(childName);
			 if (oCh instanceof DbInquiry){		
				 if(((DbInquiry) oCh).getChildTable().size()>0){
					 this.closeConnectionChild(((DbInquiry) oCh).getChildTable());
				 }
				 ((DbInquiry) oCh).closeConnection();
			 }
		}
	}
	
	public void closeConnectionChild(){
		 try {
				Hashtable ht =this.getChildTable();
				Enumeration em = ht.keys();
				while (em.hasMoreElements()) {
					String childName = (String) em.nextElement();
					Object oCh = this.getChild(childName);
					 if (oCh instanceof DbInquiry){		
							if(((DbInquiry) oCh).getChildTable().size()>0){
								 this.closeConnectionChild(((DbInquiry) oCh).getChildTable());
							 }
						 ((DbInquiry) oCh).closeConnection();
					 }
				}
			} catch (Exception e) {}

	}

	public void setStringFilter(String stringFilter) {
		this.stringFilter = stringFilter;
	}

	public void setFatchAll(boolean fetchAll) {
		this.fetchAll = fetchAll;
	}

	public void setFetchAll(boolean fetchAll) {
		this.setFatchAll(fetchAll);
	}

	/**
	 * addition for security 5/01/2005
	 * 
	 */
	private String getSecurityFilter(String buff) {
		RSecurityManager rm = null;
		try {
			rm = this.mf.getSecurity();
		} catch (RemoteException e) {
		}
		String sql = "";
		if (rm != null) {
			sql = rm.inquiryBefor(this.mf);
		}
		if (sql.length() > 0) {
			if (buff.length() == 0) {
				buff = sql;
			} else {
				buff += " and " + sql;
			}
		}
		return buff;
	}

	public String getType() {
		return "inquiry";
	}

	public void appendSql(String cmd, String statement) throws RemoteException {
	}

	public void setRecReport(DbRecord rec) throws RemoteException {
	}

	public void setSimColumn(String columnName, String tableName,
			String simName, String groupby, String having, String tableRelate,
			String whereCond) throws RemoteException {
	}

	public void formatOn() {
		isFormat = true;
		this.mf.formatOn();
		this.mr.formatOn();
		this.br.formatOn();
		this.tr.formatOn();
	}

	public void formatOff() {
		isFormat = false;
		this.mf.formatOff();
		this.mr.formatOff();
		this.br.formatOff();
		this.tr.formatOff();
	}

	public void setSecurityOn() {
	}

	private void setChildSecurityOff(DbRecord db) {
		try {
			Hashtable child = db.getChildTable();
			Enumeration em = child.keys();
			while (em.hasMoreElements()) {
				String key = (String) em.nextElement();
				Object obj = child.get(key);
				if (obj instanceof DbInquiry) {
					DbInquiry di = (DbInquiry) obj;
					di.setSecurityOff();
				}
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public void setSecurityOff() {
		try {
			this.mf.setSecurity(null);
			this.setChildSecurityOff(mf);
			this.mr.setSecurity(null);
			this.setChildSecurityOff(mr);
			this.br.setSecurity(null);
			this.setChildSecurityOff(br);
			this.tr.setSecurity(null);
			this.setChildSecurityOff(tr);
		} catch (RemoteException e) {
			MyLog.warn(this, e);
		}
	}

	public boolean childNext(String tableName) {
		if (this.getChild(tableName) instanceof DbInquiry)
			try {
				return ((DbInquiry) this.getChild(tableName)).next();
			} catch (RemoteException e) {
				MyLog.warn(this, e);
			}
		else if (this.getChild(tableName) instanceof DbTable) {
			try {
				((DbTable) this.getChild(tableName)).next();
			} catch (RemoteException e1) {
				MyLog.warn(this, e1);
			}
			return true;
		}
		return false;
	}

	public boolean isFieldChange(String fieldName) {
		try {
			String oldValue = this.br.getString(fieldName);
			String newValue = this.mf.getString(fieldName);
			return !newValue.equals(oldValue);
		} catch (RemoteException re) {
			MyLog.warn(this, re);
		}
		return true;
	}

	public void setParent(ChildManager ch) {
		int ok = 0;
		try {
			this.mr.setParent(ch);
			this.mf.setParent(ch);
			this.tr.setParent(ch);

		}catch(Exception e) {
			MyLog.warn(this, e);
		}
	}

	/***************************************************************************
	 * 
	 * @param field
	 *                  лСͺ仴 FieldName:Level:Aggregate Function FieldName
	 *                  ¡ Function Sum,Avg, Min, Max Level  FieldName 
	 *                  Group Aggregate Function  Function Sum,Avg, Min, Max
	 * @return
	 */
	public String getSimString(String field) {
		String data = "";
		String field_f = "";
		String level = "";
		String function = "";
		DecimalFormat form = new DecimalFormat("#0.00#");
		StringTokenizer token = new StringTokenizer(field, ":");
		field_f = token.nextToken().trim();
		level = token.nextToken().trim();
		function = token.nextToken().trim();
		MyHashMap hm = null;
		if (level.equalsIgnoreCase("all")) {
			hm = (MyHashMap) this.groupData.get("all");
		} else {
			if (Integer.parseInt(level) > this.groupByVector.size() - 1) {
				hm = (MyHashMap) this.groupData.get(String
						.valueOf(this.groupByVector.size() - 1));
			} else {
				hm = (MyHashMap) this.groupData.get(level);
			}

			if (hm == null || hm.isEmpty()) {
				return "0";
			}
		}
		if (function.equalsIgnoreCase("count")) {
			return String.valueOf(hm.getInt("count"));
		}
		if (function.equalsIgnoreCase("sum")) {
			MyHashMap hmSUM = (MyHashMap) hm.get("sum");
			return form.format(hmSUM.getDouble(field_f));
		}
		if (function.equalsIgnoreCase("avg")) {
			MyHashMap hmAVG = (MyHashMap) hm.get("avg");
			return form.format(hmAVG.getDouble(field_f));
		}

		if (function.equalsIgnoreCase("min")) {
			MyHashMap hmMin = (MyHashMap) hm.get("min");
			return form.format(hmMin.getDouble(field_f));
		}
		if (function.equalsIgnoreCase("max")) {
			MyHashMap hmMAX = (MyHashMap) hm.get("max");
			return form.format(hmMAX.getDouble(field_f));
		}
		if (function.equalsIgnoreCase("udf")) {
			MyHashMap hmUDF = (MyHashMap) hm.get("udf");
			String value = hmUDF.getString(field_f);
			if (value == null || value.equalsIgnoreCase("")
					|| value.equalsIgnoreCase("null"))
				return "0";
			else
				return hmUDF.getString(field_f);
		}
		return data;
	}

	// setfixfilter for mynote not have companyid

	public String getFixFilter() {
		return fixFilter;
	}

	public void setFixFilter(String fixFilter) {
		this.fixFilter = fixFilter;
	}

	public void clearOldCondition() {
		this.oldCondition = "$$$";
	}

	public void setVerifyOff() {
		return;
	}
	
	public String getDataFormat(String fieldName) {
		try {
			return mf.getDataFormat(fieldName);
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return "";
	}
	
	public String getDescription() throws RemoteException {
		return this.mf.getDescription();
	}
	
	public void setFilter(String fieldName, String value,String value2,String operate) {	
		operate = StringUtils.trimToEmpty(operate).toLowerCase();
		value = StringUtils.defaultString(value);
		value2 = StringUtils.defaultString(value2);
		
		if(value.trim().length()==0){
			return;
		}
		final StringBuilder sub = new StringBuilder();
		try{
			if(StringUtils.isNotEmpty(value)){
				if(operate.equalsIgnoreCase("between")){
					if(StringUtils.isNotEmpty(value2)) {
						sub.append("(").append(fieldName).append(" ").append(operate);
						sub.append(" '").append(value).append("' and '").append(value2).append("')");
						//this.subsfilter.add("("+fieldName+ " "+operate+" '"+value+"' and '"+value2+"')");
						
					} else {
						sub.append("(").append(fieldName).append(" = '").append(value).append("')");
						//this.subsfilter.add("("+fieldName+ " = '"+value+"')");
					}
					
				}else if(operate.equalsIgnoreCase("in")||operate.equalsIgnoreCase("not in")) {
					if(StringUtils.isNotEmpty(value2)){
						sub.append("(").append(fieldName).append(" "+operate).append(" ("+value);
						sub.append(",").append(value2).append("))");
						//this.subsfilter.add("("+fieldName+ " "+operate+" ("+value+","+value2+"))");
						
					} else {
						sub.append("(").append(fieldName).append(" "+operate).append(" (");
						sub.append(value).append("))");
						//this.subsfilter.add("("+fieldName+ " "+operate+" ("+value+"))");
					}
					
				} else if(operate.indexOf(",")>-1) {
					String suboper[]=operate.split(",");
					if(suboper.length<3){
						sub.append("(").append(fieldName).append(" ").append(suboper[0]);
						sub.append(" '").append(value).append("')");
						//this.subsfilter.add("("+fieldName+ " "+suboper[0]+" '"+value+"')");
					} else {
						sub.append("(").append(fieldName).append(" "+suboper[0]).append(" '");
						sub.append(value).append("' ").append(suboper[1]).append(" "+fieldName);
						sub.append(" ").append(suboper[2]).append("'").append(value2).append("')");
						//this.subsfilter.add("("+fieldName+ " "+suboper[0]+" '"+value+"' "+suboper[1]+" "+fieldName+" "+suboper[2]+"'"+value2+"')");
					}
					
				} else if(operate.equalsIgnoreCase("is")) {
					sub.append("(").append(fieldName).append(" "+operate).append(" ");
					sub.append(value).append(")");
					//this.subsfilter.add("("+fieldName+ " "+operate+" "+value+")");
					
				} else {
					sub.append("(").append(fieldName).append(" ").append(operate);
					sub.append(" '").append(value).append("')");
					//this.subsfilter.add("("+fieldName+ " "+operate+" '"+value+"')");
				}
		  } else {
			  if("ORACLE".equalsIgnoreCase(this.getDbType())) {
				  if(operate.equalsIgnoreCase("=")) {
					  sub.append("(").append(fieldName).append(" is null)");
					  //this.subsfilter.add("("+fieldName+ " is null)");
				  } else if(operate.equalsIgnoreCase("!=") || operate.equalsIgnoreCase("<>")) {
					  sub.append("(").append(fieldName).append(" is not null)");
					  //this.subsfilter.add("("+fieldName+ " is not null)");
				  }
			  } else {
				  sub.append("(").append(fieldName).append(" ").append(operate).append(" '')");
				  //this.subsfilter.add("("+fieldName+ " "+operate+" '')");
			  }
			  
		  }
			if(sub.length()>0) {
				this.subsfilter.add(sub.toString());
			}
		}catch(Exception ex){
			//ex.printStackTrace();
			MyLog.error(this, this.getUProfile(), ex);
		}
	}	
	
	private String getSubsFilter(String filter) {
		try {
			for (int i = 0; i < this.subsfilter.size(); i++) {
				if (filter.equals(""))
					filter += this.subsfilter.get(i).toString();
				else
					filter += " and " +  this.subsfilter.get(i).toString();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return filter;
	}
	
	public String getSubsFilter() {
		return this.subsfilter.toString();
	}
	
	public void clearSubFilter() {
		this.subsfilter.clear();
	}
	
	public void isJoinTable(boolean jointab){
		this.isjointab=jointab;
	}	
	
	public void setGroupJoin(String group){
		this.groupjoin=group;
	}
	
	public void setOrderJoin(String order){
		this.orderjoin=order;
	}
	
	public void setFilterJoin(String filter){
		this.filterjoin=filter;
	}
	
	private void refreshJoin(){
		this.preRefresh();
		String buff = "", sql = "", schema = "";
		buff = this.getKeyfilterJoin(buff);		
		buff = this.getFixFilterJoin(buff);
		//buff = this.getSecurityFilter(buff);
		//buff = this.getSubsFilter(buff);
		try {
			sql=this.getQueryJoin(buff);
			if (this.currentRecord > 1 || !this.oldCondition.equals(buff)) {
				this.sql = sql;
				System.out.println(this.charCode("point1", sql.toString()));
				this.ds.setInfo(this.charCode("point1", sql.toString()),	this.databaseName, this.getTableName());
				this.ds.setGroupBy(this.groupByVector);
				this.ds.setFetchAll(this.fetchAll);
				if (this.extResultSet) {
					ds.initConnection(this.reSultSet, buff, orderBy);
				} else {
					ds.initConnection(this.getUProfile());
				}
				this.currentRecord = 0;
				this.mf.clearField();
				this.oldCondition = buff;
				this.isSameCondition = false;
			} else {
				this.refreshChild(); // ֧ͧ refresh  child Ҩеͧ refresh աù child ͡͹ Record 
				if (this.currentRecord==1) {			
					this.isSameCondition = true;
				} else {
					this.isSameCondition = false;
				}
			}

			this.foundData = true;
			if (this.sum != null) {
				this.sum.clearAll();
			}
			this.recAmount = this.CountNumberOfRecord();
			this.currentRecord = 0;
			this.oldCondition = buff;
			this.groupDataInitial();
			this.preNextFirstRecord();
		} catch (Exception sqlex) {
			MyLog.warn(this, sqlex);
			MyLog.warn(this,"= MyInquiry.refresh() [ SQLCOMMAND : "+ sql + "]");
		}
		
	}
	
	private String getQueryJoin(String buff){
		StringBuilder query=new StringBuilder();
		StringBuilder from=new StringBuilder();
		StringBuilder queryStr=new StringBuilder();
		StringBuilder rela=new StringBuilder();
		try{
			this.getQueryJoin(this.mf, query, from,rela);
			queryStr.append("select ").append(query).append(" from ").append(from);
			queryStr.append(" where ").append(rela);
			if(this.filterjoin.length()>0)
				queryStr.append(" and ").append(this.filterjoin);
			if(buff.length()>0)
				queryStr.append(" and "+buff);
			if(this.groupjoin.length()>0)
				queryStr.append(" group by ").append(this.groupjoin);
			if(this.orderjoin.length()>0)
				queryStr.append(" order by ").append(this.orderjoin);
		}catch(Exception ex){
			ex.printStackTrace();
		}
		return queryStr.toString();
	}
	
	private void getQueryJoin(DbRecord dbRec,StringBuilder query,StringBuilder from,StringBuilder rela){
		try{
			if(query.length()>0)
				query.append(",");
			query.append(this.getColumnList(dbRec.getArrayFieldList(), dbRec.getAliasName()));
			if(from.length()>0)
				from.append(",");
			from.append(" "+dbRec.getTableName()+" "+dbRec.getAliasName());
			Hashtable ht=dbRec.getChildTable();
			Enumeration em = ht.keys();
			while (em.hasMoreElements()) {
				String childName = (String) em.nextElement();
				DbRecord dbCh = null;
				Object oCh = dbRec.getChild(childName);
				if (oCh instanceof DbRecord)
					dbCh = (DbRecord) oCh;
				else if (oCh instanceof DbInquiry)
					dbCh = ((DbInquiry) oCh).getCurrentDbRecord();
				else if (oCh instanceof DbTable)
					dbCh = ((DbTable) oCh).getCurrentRecordManager();

				String[] parent=dbRec.getRelation(dbCh.getActualName().toLowerCase()).getFieldListParent().split(",");
				String[] child=dbRec.getRelation(dbCh.getActualName().toLowerCase()).getFieldtListChild().split(",");
				if(rela.length()>0)
					rela.append(" and ");
				String tmpparent="";
				String tmpchild="";
				int cparent=0;
				for(int c=0;c<parent.length;c++){
					if(dbRec.getField(parent[c])==null)
						cparent++;
					//rela.append(dbRec.getAliasName()+"."+parent[c]+"="+dbCh.getAliasName()+"."+child[c]);
					tmpparent+=dbRec.getAliasName()+"."+parent[c]+"="+dbCh.getAliasName()+"."+child[c];
					tmpchild+=dbRec.getAliasName()+"."+child[c]+"="+dbCh.getAliasName()+"."+parent[c];
					if(c!=(parent.length-1)){
						tmpparent+=" and ";
						tmpchild+=" and ";
					}
				}
				if(cparent==0)
					rela.append(tmpparent);
				else
					rela.append(tmpchild);
				
				if(dbCh.getChildTable()!=null){
					this.getQueryJoin(dbCh, query, from,rela);	
				}else{
					this.getQueryJoin(dbRec, query, from,rela);
				}
			}			
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	private String getColumnList(Vector vfield,String alias){
		StringBuilder query=new StringBuilder();
		for(int v=0;v<vfield.size();v++){
			query.append(alias+"."+(String)vfield.get(v)).append(" as ").append(alias+"__"+(String)vfield.get(v));
			if(v!=vfield.size()-1)
				query.append(",");
		}
		return query.toString();
	}
	
    public void setAliasName(String aliasname){
    	this.aliasname=aliasname;
    	this.mf.setAliasName(aliasname);
    	this.br.setAliasName(aliasname);
    	this.mr.setAliasName(aliasname);
    	this.tr.setAliasName(aliasname);
    }

    private String getKeyfilterJoin(String filter) {
		try {
			for (int i = 0; i < this.keyfilter.size(); i++) {
				FieldManager fm = this.mr.getField((String) this.keyfilter.elementAt(i));
				if (filter.equals(""))
					filter += this.getCompareString(fm);
				else
					filter += " and " + this.getCompareString(fm);
			}
		} catch (RemoteException e) {
			MyLog.warn(this, e);
		}
		return filter;
	}
    
	private String getCompareString(FieldManager fm) {
		return fm.getParent().getAliasName()+"."+fm.getName() + "='" + fm.encryption() + "'";
	}

	private String getFixFilterJoin(String buff) {
		String fix=(this.containsField("companyid"))? this.mf.getAliasName()+".companyid='"+this.getCompanyId()+"'":"";
		if (fix.length() > 0) {
			if (buff.length() == 0) {
				buff =fix ;
			} else {
				buff ="( "+buff+" ) and " + fix;
			}
		}
		return buff;
	}
	
	private int assignFieldChild(DataSet rs,DbRecord dbChild) {
		//	System.out.println("*****************************");
		String tmpField;
		FieldManager fm;
		String aliasname=dbChild.getAliasName();
		if(aliasname.length()>0)
			aliasname+="__";
		int ok = 0;
		int cIndex;
		try {
			dbChild.referLangOff();
			if (rs.isEmpty()) {
				ok = 0;
				dbChild.setFoundData(false);
				/**************/
			} else {
				for (int i = 0; i < dbChild.getArrayFieldList().size(); i++) {
					fm=(FieldManager)dbChild.getArrayFieldList().get(i);
					tmpField = fm.getName();
					String value = (String) rs.getString((aliasname+tmpField).toLowerCase());
//					String value = (String) rs.getString(i);
					String type = fm.getType();
					if (value == null) {
						if (!dbChild.getSystemField().contains(tmpField)) 
							MyLog.debug(this, this.getUProfile(), "Null Value in Table >> " + dbChild.getTableName() + " Field >> " + tmpField);
						if (type.equalsIgnoreCase("integer")
								|| type.equalsIgnoreCase("double")
								|| type.equalsIgnoreCase("bigdecimal")
								|| type.equalsIgnoreCase("long")
								|| type.equalsIgnoreCase("float"))
							value = "0";
						else
							value = "";
					}
					// --------------
					//System.out.println("FNAME "+tmpField +" Value "+value);
					if (value == null) {
						value = "";
					} else {
						value = this.charCode("point4", value);
					}
					FieldManager m = (FieldManager) dbChild.getField(tmpField);
					if (m != null) {
						ok = 1;
						m.setOriginal(value);
					}
				}
				dbChild.setFoundData(true);
			}
			if (referLang)
				dbChild.referLangOn();
			else
				dbChild.referLangOff();

			return ok;
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
			if (e instanceof NullPointerException)
				if (rs != null)
					MyLog.error(this, this.getUProfile(), "MyInquiry assignFieldChild() - HaveError");
			return 0;
		}
	}
	
	private void refreshChildJoin(DataSet ds,DbRecord dbRec){
		try{
			Hashtable ht=dbRec.getChildTable();
			Enumeration em = ht.keys();
			while (em.hasMoreElements()) {
				String childName = (String) em.nextElement();
				DbRecord dbCh = null;
				Object oCh = dbRec.getChild(childName);
				if (oCh instanceof DbRecord)
					dbCh = (DbRecord) oCh;
				else if (oCh instanceof DbInquiry)
					dbCh = ((DbInquiry) oCh).getCurrentDbRecord();
				else if (oCh instanceof DbTable)
					dbCh = ((DbTable) oCh).getCurrentRecordManager();
				if(dbCh.getChildTable()!=null && dbCh.getChildTable().size()>0)
					this.refreshChildJoin(ds, dbCh);
				this.assignFieldChild(ds, dbCh);
			}
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public void setBetween(int begin, int end) {
		if (begin <= end && begin >= 0 && end >= 0) {
			this.beginRow = begin;
			this.endRow = end;
		}
	}
	
	private boolean haveBetween() {
		if (this.beginRow != 0 || this.endRow != 0) {
			return true;
		}
		return false;
	}
	
	private void clearBetween() {
		this.beginRow = 0;
		this.endRow = 0;
	}
	
	public String getDescription(String fieldName) {
		try {
			String tmp = mf.getField(fieldName).getDescription();
			if (tmp != null)
				return tmp.trim();
			else
				return tmp;
		} catch (Exception e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+ fieldName);
			MyLog.warn(this, e);
		}
		return "";
	}
	
	public String getDescription(String tableName, String fieldName) {
		try {
			Object obj = this.getChild(tableName);
			if (obj instanceof DbInquiry) {
				return ((DbInquiry)obj).getCurrentDbRecord().getField(fieldName).getDescription();
			} else if (obj instanceof DbRecord) {
				return ((DbRecord)obj).getField(fieldName).getDescription();
			} else return "";			
		} catch (RemoteException e) {
			MyLog.warn(this, " erreor when get  fieldname :"	+tableName+"."+ fieldName);
			MyLog.warn(this, e);
			return "";
		}
	}
	
  	
	public String getObjectTrace() {
		StringBuilder build=new StringBuilder();
		/**
		 * 
		 * comment by pas  
		 * comment ͷͺ memory
		 * 
		 * 		
		build.append("====MyInquiry.toString()=").append(getClass().getName() + "@" + Integer.toHexString(hashCode()));
		build.append("mf =").append(mf.getObjectTrace()).append("\n");
		build.append("mr =").append(mr.getObjectTrace()).append("\n");
		build.append("br =").append(br.getObjectTrace()).append("\n");
		build.append("tr =").append(tr.getObjectTrace()).append("\n");
		build.append("field =").append(field).append("\n");
		build.append("aField =").append(aField).append("\n");
		build.append("currentRecord =").append(currentRecord).append("\n");
		build.append("recAmount =").append(recAmount).append("\n");
		build.append("oldCondition =").append(oldCondition).append("\n");
		build.append("usedFor =").append(usedFor).append("\n");
		build.append("autoRefresh =").append(autoRefresh).append("\n");
		build.append("filter =").append(filter).append("\n");
		build.append("orderBy =").append(orderBy).append("\n");
		build.append("groupByVector =").append(groupByVector).append("\n");
		build.append("sumColumnVector =").append(sumColumnVector).append("\n");
		build.append("minColumnVector =").append(minColumnVector).append("\n");
		build.append("maxColumnVector =").append(maxColumnVector).append("\n");
		build.append("avgColumnVector =").append(avgColumnVector).append("\n");
		build.append("udfColumnVector =").append(udfColumnVector).append("\n");
		build.append("groupData =").append(groupData).append("\n");
		build.append("ds =").append(ds.getObjectTrace()).append("\n");
		build.append("recordPage =").append(recordPage).append("\n");
		build.append("sum =").append(sum).append("\n");
		build.append("childCondi =").append(childCondi).append("\n");
		build.append("uid =").append(uid).append("\n");
		build.append("keyfilter =").append(keyfilter).append("\n");
		build.append("reSultSet =").append(reSultSet).append("\n");
		build.append("extResultSet =").append(extResultSet).append("\n");
		build.append("sql =").append(sql).append("\n");
		build.append("nextIndex =").append(nextIndex).append("\n");
		build.append("stringFilter =").append(stringFilter).append("\n");
		build.append("fixFilter =").append(fixFilter).append("\n");
		build.append("fetchAll =").append(fetchAll).append("\n");
		build.append("isFormat =").append(isFormat).append("\n");
		build.append("isSameCondition =").append(isSameCondition).append("\n");
		build.append("subsfilter =").append(subsfilter).append("\n");
		build.append("isjointab =").append(isjointab).append("\n");
		build.append("orderjoin =").append(orderjoin).append("\n");
		build.append("groupjoin =").append(groupjoin).append("\n");
		build.append("filterjoin =").append(filterjoin).append("\n");
		build.append("beginRow =").append(beginRow).append("\n");
		build.append("endRow =").append(endRow).append("\n");	
		build.append("=====================");
		**/
		
		return build.toString();
	}

	public boolean isRefreshBeforeNext() {
		return refreshBeforeNext;
	}

	public void setRefreshBeforeNext(boolean preRefresh) {
		this.refreshBeforeNext = preRefresh;
	}
	
}
