package com.csc.library.database;
import java.math.BigDecimal;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp0;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscException;
import com.csc.library.utilities.CscIndexTable;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class MyTable extends MyDB implements DbTable {
	protected MyRecordGroup mRecord = new MyRecordGroup();
	protected MyRecordGroup originalRecord = new MyRecordGroup();
	protected DbRecord mf, mr, blank;
	protected Vector key = new Vector();
	protected String field;
	protected Vector aField;
	public int currentRecord, recAmount = 0;
	private Class c;
	private String oldCondition = "$$$$$";
	private char usedFor = 'U';
	private byte autoRefresh = 1;
	private String error = "";
	private String filter = "";
	private String orderBy = "";
	private String minorKey = "";
//	private boolean keyStatus = true;
	private CscCalendar lastUpDate = new CscCalendar();
	private byte refreshModel = 0;
	protected String tableName;
	private DbRecord parentDb;
	private Vector parentList = new Vector(), chList;
//	private DbInquiry di;
	private ConfigMetadata vm;
	private String message = "", keyGroup;
	private int saveReturn = 3;
	private HashMap multiCompanyLink;
	private String fixFilter = "";
	private boolean loadComponent=false;
	private String editCheck="";
	private boolean isFormat=false;
	private DbInquiry myInq=null;
	private int blankRecord = 0;
	private String childCondi = "";

	private boolean wfTransfer= false;

	private String wfRefDoc= "";
	
	public String getMessage() {
		return this.message;
	}
	public void setMessage(String message) {
		this.message = message;
	}
	public  void setLoadComponent(boolean load){
		this.loadComponent=load;
	}
	public void setLastUpdate() {
		lastUpDate = new CscCalendar();
	}
	public void setKeyGroup(String keyGroup) {
		this.keyGroup = keyGroup;
	}
	public String getLastUpdate() {
		return this.lastUpDate.getDDMMYYYYHHMMSS();
	}
	public MyTable() {
	}
	public MyTable(UProfile user, String tableName,boolean loadComponent,HashMap param) {
		this.param=param;
		setMyTable(user,tableName);
		this.loadComponent=loadComponent;
	}

	public MyTable(UProfile user, String tableName,boolean loadComponent) {
		setMyTable(user,tableName);
		this.loadComponent=loadComponent;
	}
	public MyTable(UProfile user, String tableName) {
		 setMyTable(user,tableName);
	}
	
	private void setMyTable(UProfile user, String tableName){
		this.setUProfile(user);
		this.tableName = tableName;
		long startEmp=System.currentTimeMillis();		
		this.initMyTable(this.tableName, "", "", "");
		long endEmp=System.currentTimeMillis();			
		MyLog.info(this, "Process >>> MyTable   >> MyTable(UProfile user, String tableName) Start ("+startEmp+") End ("+endEmp+") : "+(endEmp-startEmp)/100);
		try {
			this.setCompanyFilter();
			//this.setwfFilter();
		} catch (Exception e) {
			MyLog.error(this, "user name "+user.getUserName()+" tableName : "+tableName);
			MyLog.error(this, e);
		}		
	}
	public MyTable(UProfile user, String tableName,HashMap param) {
		this.param=param;
		this.setMyTable(user, tableName);
	}
	
	private boolean showRecord(DbRecord mf) {
		try {
			String editBy = this.mf.getString("edit_by");
			String user = this.userPro.getUserId();
			return true;
		} catch (Exception e) {
			MyLog.error(this, e);
			return true;
		}
	}
	protected void startUp() {
		try {
			long startEmp=System.currentTimeMillis();		
			this.mr = this.getRecordManagement(this.tableName);
			this.blank = this.getRecordManagement(this.tableName);
			this.stmtType = this.setTableDB(this.mr.getTableName());
			long endEmp=System.currentTimeMillis();			
			MyLog.info(this, "Process >>> MyTable   >> startUp(UProfile user, String tableName) Start ("+startEmp+") End ("+endEmp+") : "+(endEmp-startEmp)/100);
			this.field = mr.getFieldList();
			this.aField = mr.getArrayFieldList();
			if (mr.getSizeKey() > 0) {
				this.key.addElement(mr.getNameKey("1"));
				this.orderBy = mr.getNameKey("1");
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
	}
	public void initMyTable(String className, String condition, String filter, String order) {
		
		this.filter = filter;
		this.orderBy = order;
		this.tableName = className;
		this.startUp();
		if (condition == "*") {
			this.key.removeAllElements();
			this.refresh();
		}
		
	}
	public void initMyTable(String className, String condition[], String filter, String order) {
		this.filter = filter;
		this.orderBy = order;
		this.tableName = className;
		this.startUp();
		this.setCondition(condition);
	}
	public int setKeyName(String keyFieldList) {
		String tmpField;
		int ok = 2;
		try {
			for (StringTokenizer token = new StringTokenizer(keyFieldList, ","); token.hasMoreTokens() && ok > 0;) {
				tmpField = token.nextToken();
				if (mr.getField(tmpField) != null) {
					key.addElement(tmpField);
					ok = 1;
				} else {
					key.removeAllElements();
					ok = 0;
				}
			}
		} catch (RemoteException re) {
			MyLog.error(this, re);
		}
		return ok;
	}
	public void setKey(String data) {
		String keyField;
		try {
			if (this.key.size() > 0) {
				keyField = (String) this.key.elementAt(0);
				this.mr.set(keyField, data);
			}
		} catch (RemoteException re) {
			MyLog.error(this, "data :"+data);
			MyLog.error(this, re);
		}
	}
	public void setKey(String data[]) {
		String keyField;
		try {
			if (this.key.size() > 0) {
				for (int i = 0; i < data.length; i++) {
					keyField = (String) this.key.elementAt(i);
					this.mr.set(keyField, data[i]);
				}
			}
		} catch (RemoteException re) {
			MyLog.error(this, re);
		}
	}
	public void setCondition() {
//		this.key.removeAllElements();
		this.childCondi = "";
	}
	
	private boolean notSingleChar(String fieldName) {
		try {
			FieldManager fm = this.mr.getField(fieldName);
			String data = fm.getType();
			// return data.equalsIgnoreCase("Autonumber") ||
			// data.equalsIgnoreCase("Integer") ||
			// data.equalsIgnoreCase("Double") ||
			// data.equalsIgnoreCase("Bigdecimal");
			return data.equalsIgnoreCase("Integer")
					|| data.equalsIgnoreCase("Double")
					|| data.equalsIgnoreCase("Bigdecimal");
		} catch (RemoteException e) {
			MyLog.error(this, "fieldName : "+fieldName);
			MyLog.error(this, e);
			return false;
		}
	}

	public int setCondition(String condition[]) {
		// this.logger.info("<-- in setCondition -->");
		Hashtable tempKey = new Hashtable();
		int ok = 0;
		int k = 1;
		int i;
		this.childCondi = "";
		if (condition.length % 2 == 0 && condition.length > 0) {
			ok = 1;
			for (i = 0; i < condition.length && ok == 1; i = i + 2) {
				if (this.notSingleChar(condition[i])) {
					this.childCondi = this.childCondi + condition[i] + "="
							+ condition[i + 1] + " and ";
				} else {
					this.childCondi = this.childCondi + condition[i] + "='"
							+ condition[i + 1] + "' and ";
				}
			}
			/*
			 * this.logger.info("*******************************");
			 * this.logger.info("***** <"+this.childCondi+">*****");
			 * this.logger.info("*******************************");
			 */
		} else {
			MyLog.warn(this, "******Conditions is not Complete!******");
		}
		return ok;
	}

	private String getChildFilter(String buff) {
		if (buff.trim().equals("")) {
			buff = this.childCondi	.substring(0,((this.childCondi.length() > 4) ? this.childCondi.length() - 4 : this.childCondi.length()));
		} else {
			buff = this.childCondi + buff;
		}
		return buff;
	}

/*
	public int setCondition(String condition[]) {
		Vector tempKey = new Vector();
		int ok = 0;
		try {
			if (condition.length % 2 == 0) {
				ok = 1;
				for (int i = 0; i < condition.length && ok == 1; i = i + 2) {
					if (this.mr.set(condition[i], condition[i + 1])) {
						tempKey.addElement(condition[i]);
					} else {
						ok = 0;
						for (int j = i - 2; j >= 0; j = j - 2) {
							this.mr.restore(condition[j]);
						}
					}
				}
				if (ok == 1) {
					this.key = tempKey;
				}
			} else {
				MyLog.error(this, "Can not set Condition! ");
			}
		} catch (RemoteException re) {
			MyLog.error(this, re);
		}
		return ok;
	}
*/	
	
	/**
	 * addition for security 30/7/2556 by pas
	 * 
	 */
	private String getSecurityFilter(String buff) {
		RSecurityManager rm = null;
		try {
			if(this.mf==null){ //óշҧ dbtable Ƿӡ search ͹ mf ѧ١ҧ
				this.mf = this.getRecordManagement(this.tableName);
			}
			rm = this.mf.getSecurity();
		} catch (RemoteException e) {
		}
		String sql = "";
		if (rm != null) {
			sql = rm.inquiryBefor(this.mf);
		}
		if (sql.length() > 0) {
			if (buff.length() == 0) {
				buff = sql;
			} else {
				buff += " and " + sql;
			}
		}
		return buff;
	}
	
	public void refresh() {
		String buff, sql = "";
		DbRecord rcBuff;
		DataSet rs = null;
		buff = this.getFilter();
//		buff = this.getKeyCondition(buff);
		buff = this.getChildFilter(buff);
		buff = this.getFixFilter(buff);
		buff = this.getSecurityFilter(buff); /* addition for security 30/7/2556 by pas */
		if (this.refreshModel == 1 || !buff.equals(this.oldCondition)) {
			try {
                //this.initConnection();
				if (!buff.equals("")) {
					sql = "SELECT " + this.field + " FROM "  + this.mr.getTableName() + " WHERE " + buff;
				} else {
                    sql = "SELECT " + this.field + " FROM " + this.mr.getTableName();
				}
				if (this.orderBy.trim().length() > 0) {
					sql += " ORDER BY " + this.orderBy;
				}
				
	               /*
                 * Start -*****-check column to user from app to cscindextable
                 */
                
                if(StaticProperties.checkIndextable){
                        CscIndexTable ci=new CscIndexTable(this.userPro,this.getTableName(),buff);
                        ci.save("W_TAB");
                        
                        ci=new CscIndexTable(this.userPro,this.getTableName(),orderBy);
                        ci.save("O_TAB");                 
                }        
                /*
                 * End -****-check column to user from app to cscindextable
                 */				
				MyLog.info(this, "myTable:refresh:" + this.charCode("point1", sql));               
                mRecord.removeAllElements();
                mRecord.getVdelete().clear();
                this.foundData = false;
				rs = new DataSet(this.charCode("point1", sql.toString()), this.databaseName, this.getTableName());
				rs.setClassName(this.getActualName());
				rs.initConnection(this.getUProfile());
				this.recAmount = 0;
				this.mRecord.setMinorKey("");
				this.mf = this.getNewRecord();
				while (this.mf.assignField(this.fetchNext(rs)) == 1) {
					if (this.showRecord(mf)) {
						this.recAmount++;
						mRecord.addElement(this.mf);
						this.mf = this.getNewRecord();
					}
				}
				this.mRecord.setMinorKey(this.minorKey);
				if (this.recAmount > 0) {
					this.foundData = true;
					this.currentRecord = 1;
					this.fetch();
				} else {
					this.currentRecord = 0;
				}
				this.oldCondition = buff;
				if (this.mRecord.size() <  this.getBlankRecord()) {
					for (int i = this.mRecord.size();i <= this.getBlankRecord(); i++) {
						rcBuff = this.getNewRecord();
						this.mRecord.addElement(rcBuff);
					}
				}
				this.setLastUpdate();
				this.first();
			} catch (Exception ex) {
				MyLog.error(this, ex);
			}finally{
				rs.closeConnection();
				/*try {
					this.closeConnectionChild(this.getChildTable());
				} catch (Exception e) {
				}*/
			}
		}
	}
	private void printSql(String sql) {
		MyLog.info(this, ":" + sql);
	}
	
	public DataSet fetchNext(DataSet ds) {
		try {
			ds.next();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ds;
	}
	public void search() {
		this.refresh();
	}
	public DbRecord getRecordManagement(String tablename) throws RemoteException {
		DbRecord rec = new InitialRecord(this.userPro, this.param).getDbRecord(tableName, 'i');
		
		if(this.loadComponent){
			rec.loadHelp(true);
		}
		return rec;
	}
	public void next() {
		if (this.recAmount > 0 && this.currentRecord < this.recAmount) {
			this.currentRecord++;
			this.fetch();
		} else {			
			this.currentRecord = this.recAmount + 1;
		}
	}
	public boolean eof() {
		boolean eof;		
		if (this.currentRecord <= this.recAmount && this.recAmount > 0) {
			eof = false;
		} else {
			eof = true;
		}
		return eof;
	}
	public void previous() {
		if (this.recAmount > 0 && this.currentRecord > 1) {
			this.currentRecord--;
			this.fetch();
		}
	}
	public void first() {
		if (this.recAmount > 0) {
			this.currentRecord = 1;
			this.fetch();
		} else {
			if (this.recAmount == 0) {
				this.mf = this.blank;
				this.refreshChild();
			}
		}
	}
	public void last() {
		if (this.recAmount > 0) {
			this.currentRecord = this.recAmount;
			this.fetch();
		}
	}
	public int recCount() {
		return this.recAmount;
	}
	public int recNo() {
		return this.currentRecord;
	}
	public boolean isFirst() {
		if (this.currentRecord <= 1) {
			return true;
		} else {
			return false;
		}
	}
	public boolean isLast() {
		if (this.currentRecord == this.recAmount) {
			return true;
		} else {
			return false;
		}
	}
	public void clear() throws RemoteException {
		if (this.getBlankRecord() == 0) {
			this.mRecord.removeAllElements();
			this.recAmount = 0;
			this.currentRecord = 0;
			this.setLastUpdate();
		} else {
			this.currentRecord = this.getBlankRecord();
			this.setLastUpdate();
			if (this.mRecord.size() >  this.getBlankRecord()) {
				for (int i = this.mRecord.size(); i <= this.getBlankRecord(); i++) {
//					this.mRecord.remove(i-1);
					this.mRecord.removeElementAt(i-1);
				}
			} else {
				if (this.mRecord.size() <  this.getBlankRecord()) {
					for (int i = this.mRecord.size(); i <= this.getBlankRecord(); i++) {
						DbRecord rcBuff = this.getNewRecord();
						this.mRecord.addElement(rcBuff);
					}
				}
			} 
			for (int i = 1; i <= this.getBlankRecord(); i++) {
				if(this.getCurrentRecordManager(i)!=null){
					this.getCurrentRecordManager(i).clearField();
					if (this.getMinorKey()!=null){
						this.getCurrentRecordManager(i).set(this.getMinorKey(), i);
					}
				}
			}
			
			
			this.recAmount = this.getBlankRecord();
			this.currentRecord = 0;
		}
	}
	
	public boolean setColumn(String columnList) {
		String tmpField;
		boolean ok = true;
		DbRecord m;
		try {
			this.mr.setColumn(columnList);
			this.field = mr.getFieldList();
			this.aField = mr.getArrayFieldList();
			for (int i = 0; i < mRecord.size(); i++) {
				m = (DbRecord) mRecord.elementAt(i);
				m.setColumn(this.aField);
			}
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}
		return ok;
/*		
		String tmpField;
		boolean ok = true;
		DbRecord m;
		columnList = columnList.toUpperCase();
		try {
			if (!columnList.equals("*")) {
				for (int i = 0; i < key.size(); i++) {
					tmpField = (String) key.elementAt(i);
					columnList = columnList + "," + tmpField;
				}
			}
			if (this.mr.setColumn(columnList)) {
				this.field = mr.getFieldList();
				this.aField = mr.getArrayFieldList();
				for (int i = 0; i < mRecord.size(); i++) {
					m = (DbRecord) mRecord.elementAt(i);
					if (!m.setColumn(columnList)) {
						ok = false;
					}
				}
			} else {
				ok = false;
			}
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		return ok;
	*/
	}
	
	public boolean setColumn(Vector columnList) {
		String tmpField;
		boolean ok = true;
		DbRecord m;
		try {
			this.mr.setColumn(columnList);
			this.field = mr.getFieldList();
			this.aField = mr.getArrayFieldList();
			for (int i = 0; i < mRecord.size(); i++) {
				m = (DbRecord) mRecord.elementAt(i);
				m.setColumn(this.aField);
			}
		} catch (RemoteException e) {
			MyLog.error(this, e);
		}
		return ok;
	}

	protected String getKeyCondition(String buff) {
/*		FieldManager fd;
//		String buff = "";
		//		if (this.getFilter() != null && !this.getFilter().equals("")) {
		//			this.setKeyOff();
		//		}
		try {
			if (this.key.size() > 0 && this.keyStatus) {
				fd = (FieldManager) mr.getField((String) key.elementAt(0));
				buff = fd.getCompareString();
				for (int i = 1; i < key.size(); i++) {
					fd = (FieldManager) mr.getField((String) key.elementAt(i));
					buff += " AND " + fd.getCompareString();
				}
			}
			if ((this.getFilter() != null) && (!this.getFilter().equals(""))) {
				if (buff.trim().length() > 0) {
					buff += " AND ";
				}
				buff += this.getFilter();
			}
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		this.setKeyOn();
	*/
		return buff;
	}
	public String getListKey() {
		String keyField = "";
		if (key.size() > 0) {
			keyField = (String) this.key.elementAt(0);
			for (int i = 1; i < key.size(); i++) {
				keyField = keyField + "," + (String) this.key.elementAt(i);
			}
		}
		return keyField;
	}
	public boolean realDelete() {
		String buff, sql = "";
		CscConnection con=null;	
		try {
			StaticProperties.myConnection.beginTransaction(this.userPro, this);
			if (!this.databaseName.equals("")) { 
				con = (CscConnection)StaticProperties.myConnection.getConnection(this.databaseName, this.userPro);
			} else {	
				con = (CscConnection)StaticProperties.myConnection.getConnection(this.userPro.getDbName(), this.userPro);
			}	
			con.setClassName("MyTable");
			buff = this.getFilter();
//			buff = this.getKeyCondition(buff);
			buff = this.getChildFilter(buff);
			buff = this.getFixFilter(buff);
//			buff = this.getKeyCondition();
			if (buff.length() != 0)
				sql = "DELETE FROM " + this.schemaName + "." + mr.getTableName() + " WHERE " + buff;
			else
				sql = "DELETE FROM " + this.schemaName + "." + mr.getTableName();
			
			String pid=this.getUProfile().containsKey("processID")?(String)this.getUProfile().get("processID"):"";
			if((!mr.getTableName().toLowerCase().equals("mempl_pvf")&&pid.length()>0)||(!mr.getTableName().toLowerCase().equals("mempl_bank")&&pid.length()>0)||pid.length()==0){
					Statement stmt = con.createStatement();
					stmt.executeUpdate(this.charCode("point1", sql));
					stmt.close();
//					con.close();
			}else{
				Exception ex=new Exception();
				MyLog.debug(this,this.getUProfile(),"!!!!! Some Application used realDelete ont table "+mr.getTableName());
				ex.printStackTrace();
			}
			StaticProperties.myConnection.endTransaction(this.userPro, this);
			return true;
		} catch (Exception sqlex) {
			MyLog.error(this, sqlex);		
			this.closeConnection(con);
			try {
				StaticProperties.myConnection.rollback(this.userPro, this);
			} catch (SQLException e) {
				MyLog.error(this, e);		
			}
			return false;
		}finally{
			this.closeConnection(con);
		}
	}
	private void closeConnection(Connection con) {
		try {
			if(con!=null){
				con.close();
			}
		} catch (SQLException e) {
			MyLog.error(this, e);		
		}
	}
	public boolean realDelete(String filter) {
		if (filter == null || filter.equalsIgnoreCase("")) {
			return this.realDelete();
		} else {
			try {
				this.setFilter(filter);
				this.setKeyOff();
				boolean result = this.realDelete();
				this.setKeyOn();
				this.setFilter("");
				return result;
			} catch (Exception e) {
				MyLog.error(this, e);		
				return false;
			}
		}
	}
	public int delete() {
		int ok = -1;
		try {
			StaticProperties.myConnection.beginTransaction(this.userPro, this);
			ok = this.deleteVrecord();
			this.clear();
			StaticProperties.myConnection.endTransaction(this.userPro, this);
		} catch (RemoteException e1) {
			try {
				StaticProperties.myConnection.rollback(this.userPro, this);
			} catch (SQLException e2) {
				MyLog.error(this, e2);
			}
		} catch (SQLException e) {
			try {
				StaticProperties.myConnection.rollback(this.userPro, this);
			} catch (SQLException e2) {
				MyLog.error(this, e2);
			}
			MyLog.error(this, e);
		}/*finally{
			try {
				this.closeConnectionChild(this.getChildTable());
			} catch (Exception e) {
			}
		}*/
		return ok;
	}
	private void setMessage(String row, String field, int index) {
//		String msg = (String) this.vm.getMessage().get(String.valueOf(index));
//		if (this.message.equalsIgnoreCase(""))
//			this.message = "13#";
//		if (msg != null && !msg.equalsIgnoreCase("")) {
//			this.message += row + " " + field + "  " + msg + "\n";
//		}
	}
	public int save() {
		int mySave = 0;
		try {
	
			StaticProperties.myConnection.beginTransaction(this.userPro, this);
			if (this.parentList.size() > 0) {
				this.setNewKeyRecord();
			}
			
			if (this.preUpdateTrigger()) {
				mySave = this.rUpdate();
			}
			if(mySave>0)
				StaticProperties.myConnection.endTransaction(this.userPro, this);			
		} catch (Exception re) {
			try {
				MyLog.error(this, re);		
				StaticProperties.myConnection.rollback(this.userPro, this);
				mySave=98;
			} catch (SQLException e) {
				MyLog.error(this, e);	
				mySave=98;
			}
		}/*finally{
			try {
				this.closeConnectionChild(this.getChildTable());
			} catch (Exception e) {
			}
		}*/
		saveReturn=mySave;
		return this.saveReturn;
	}
	private int rUpdate() {
		int mySave = 2;
		DbRecord m;
		try {
			for (int i = 0; i < this.mRecord.size(); i++) {
//				RecordCmp0 rc = (RecordCmp0) this.cloneRecord((DbRecord) this.mRecord.elementAt(i)); // comment by pas 20120530 ͧ clone 
				RecordCmp0 rc = (RecordCmp0) ((DbRecord) this.mRecord.elementAt(i));
				if (!rc.checkReferenceKey()) {
					mySave = -2;
				}
			}
			if(this.deleteTmpRecord()){
				for (int i = 0; i < this.mRecord.size(); i++) {
//					m = this.cloneRecord((DbRecord) this.mRecord.elementAt(i)); // comment by pas 20120530 ͧ clone 
					m = this.cloneRecord((DbRecord) this.mRecord.elementAt(i));
					if (m.keyOK()) {
						if(this.getWFTransfer()&&this.getWFRefDoc().length()>0){ /* ǨͺҶ繡 transfer Ũҡ workflow ӡ ૵Ţ͡Ѻ record ͷӡúѹ֡  */
							m.setWFTransferOn(this.getWFRefDoc());
						}
						if (m.save()>0) {
							mySave *= 1;
							 this.mRecord.set(i, m);
						} else {
							mySave = -2;
						}
					} else {
						MyLog.error(this,this.getUProfile(), "Key field can not be empty! "+m.getKeyEmptyList());		
						StaticProperties.myConnection.rollback(this.userPro, this);
						mySave = -2;
					}
				} 
		  }else{
				MyLog.error(this,this.getUProfile(), "Can't delete some tmp Record");		
				StaticProperties.myConnection.rollback(this.userPro, this);
				mySave = -2;		  
		  }
		} catch (Exception e) {
			mySave = -2;
			MyLog.error(this, e);		
			try {
				StaticProperties.myConnection.rollback(this.userPro, this);
			} catch (SQLException e1) {
				MyLog.error(this, e);		
			}
		}
		if(mySave==2){
			this.mRecord.getVdelete().clear();
		}
		return mySave;
	}
	private DbRecord cloneRecord(DbRecord m) {
		DbRecord db = null;
		try {
			db = new InitialRecord(this.userPro).getDbRecord(m.getActualName());
			for (int i = 0; i < this.aField.size(); i++) {
				String fieldName = this.aField.get(i).toString();
				String data = m.getString(fieldName);
				db.set(fieldName, data);
			}
			db.setRelationInfo(m.getRelationInfo());
			db.setChildTable(m.getChildTable());
			db.setParam(m.getParam());
			db.setParent(((RecordCmp0)this.mr).getParent());
		} catch (RemoteException e) {
			MyLog.error(this, e);		
		}
		return db;
	}
	public DbRecord getRecordForSave() {
		DbRecord db = null;
		DbRecord rec = this.getCurrentRecordManager();
		try {
			db = new InitialRecord(this.userPro).getDbRecord(rec.getActualName());
			db.setColumn(rec.getFieldList());
			for (int i = 0; i < this.aField.size(); i++) {
				String fieldName = this.aField.get(i).toString();
				String data = rec.getString(fieldName);
				db.set(fieldName, data);
			}
			db.setRelationInfo(rec.getRelationInfo());
			db.setChildTable(rec.getChildTable());
			db.setParam(rec.getParam());
		} catch (RemoteException e) {
			MyLog.error(this, e);		
		}
		return db;
	}
	private int deleteVrecord() throws RemoteException {
		int ok = 0;
		String buff = "";
		if (this.myInq == null) {
			this.myInq = new InitialInquiry(this.userPro).getDbInquiry(this.getActualName());
		}
		this.myInq.clearOldCondition();
		buff = this.getFilter();
//		buff = this.getKeyCondition(buff);
		buff = this.getChildFilter(buff);
		if(buff.trim().length()==0)
			return ok;
		buff = this.getFixFilter(buff);
		
		this.myInq.setFilter(buff);
		this.myInq.refresh();
		DbRecord m;
		for (; this.myInq.next() && ok != -1;) {
			try {
				m = this.myInq.getCurrentDbRecord().cloneRecord(true);
				m.setParam(this.param);
				ok=m.deleteForMyTable();
			} catch (Exception e) {
				e.printStackTrace();
				ok = -1;
			}
		}
		return ok;
	}
	private void setNewKeyRecord() {
		String prfieldName, chfieldName, value;
		DbRecord db;
		String temp = "";
		for (int j = 0; j < this.mRecord.size(); j++) {
			try {
				db = (DbRecord) this.mRecord.elementAt(j);
				for (int i = 0; i < this.parentList.size(); i++) {
					prfieldName = (String) this.parentList.elementAt(i);
					chfieldName = (String) this.chList.elementAt(i);
					value = this.parentDb.getString(prfieldName);
					temp = db.getString(chfieldName);
					db.set(chfieldName, value);
				}
			} catch (Exception e) {
				MyLog.error(this, e);		
			}
		}
	}
	public void deleteRecord() {
		MyLog.info(this, "Deleting record#" + this.currentRecord);
		if (this.currentRecord > 0) {
			this.mRecord.removeElementAt(this.currentRecord - 1);
			this.recAmount--;
			this.setLastUpdate();
			this.first();
		}
	}
	
	public void clearRecord() {
//		this.clear();
		this.mRecord.clear();
		this.recAmount=0;
		this.currentRecord=0;
	}
	
	private void deleteRecord(int recNo) {
		if (this.recAmount >= recNo) {
/*			for (this.first(); this.currentRecord < recNo; this.next()) {
				;
			}
			this.deleteRecord(); */
			this.goRec(recNo,false);
			this.deleteRecord();
		}
	}
	
	public DbRecord getNewRecord() {
		
		DbRecord rcBuff = null;
		try {
			rcBuff = this.getRecordManagement(this.tableName);
			//	rcBuff.setPropDB(this.comp, this.user, this.pwd);
			rcBuff.setColumn(this.field);
			rcBuff.setActualName(mr.getActualName());
			rcBuff.setRelationInfo(this.getRelationInfo());
			Hashtable data = new Hashtable();
			Iterator it = this.getChildTable().keySet().iterator();
			while (it.hasNext()) {
				String key = (String) it.next();
				ChildManager ch = (ChildManager) this.getChildTable().get(key);
				ch.clearField();
				data.put(key, ch);
			}
			if(rcBuff.getString("companyid").equals(""))
				rcBuff.set("companyid",(String)this.getUProfile().get("companyid"));
			
			rcBuff.setChildTable(data);
			
			if(this.isFormat){ 
				rcBuff.formatOn(); 
			}
			rcBuff.setParent((ChildManager)((RecordCmp0)this.mr).getParent());
		} catch (Exception ex) {
			MyLog.error(this, ex);		
		}
		return rcBuff;
	}
	
	public void putNewRecord(DbRecord r) {
		try {
			if(r.getString("companyid").equals(""))
				r.set("companyid",(String)this.getUProfile().get("companyid"));
			this.mRecord.addElement(r);
			this.recAmount = this.mRecord.size();
			this.currentRecord = this.recAmount;
			this.fetch(); 
			this.setLastUpdate();
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	public void putNewRecord(DbRecord r, int no) {
		this.mRecord.set(no - 1, r);
		this.recAmount = this.mRecord.size();
		this.currentRecord = no;
		this.fetch();
		this.setLastUpdate();
	}
	public void addRecord() {
		DbRecord rcBuff;
		try {
			rcBuff = this.getNewRecord();
			this.mRecord.addElement(rcBuff);
			this.recAmount = this.mRecord.size();
			this.currentRecord = this.recAmount;
			this.fetch();
			this.setLastUpdate();
		} catch (Exception ex) {
			MyLog.error(this, ex);		
		}
	}
	public void fetch() {
		try {
			if((this.currentRecord)<=this.mRecord.size()){ // óշ currentRecord >ӹǹ record  ͧ÷ fetch data 
				this.mf = (DbRecord) this.mRecord.elementAt(this.currentRecord - 1);
				this.refreshChild();
			}
		} catch (Exception re) {
			MyLog.error(this, this.getUProfile(),re);		
		}
	}
	public void restore() {
		try {
			mf.restore();
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void print() {
		try {
			mf.print();
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void printAll() {
		DbRecord m;
		try {
			for (int i = 0; i < mRecord.size(); i++) {
				m = (DbRecord) mRecord.elementAt(i);
				m.printList();
				//this.logger.info("");
			}
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	
	public String getAllData() {
		String data = "";
		DbRecord m;
		for (int i = 0; i < mRecord.size(); i++) {
			m = (DbRecord) mRecord.elementAt(i);
			data +=":"+String.valueOf(i)+":"+ m.getAllData()+"   :  ";
		}
		return data;
	}

	public String getString(String fieldName) {
		try {
			return mf.getString(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return "";
	}
	public boolean getBoolean(String fieldName) {
		try {
			return mf.getBoolean(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public byte getByte(String fieldName) {
		try {
			return mf.getByte(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return 0;
	}
	public char[] getChars(String fieldName) {
		try {
			return mf.getChars(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return null;
	}
	public char getChar(String fieldName) {
		try {
			return mf.getChar(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return '0';
	}
	public short getShort(String fieldName) {
		try {
			return mf.getShort(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return 0;
	}
	public int getInt(String fieldName) {
		try {
			return mf.getInt(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return 0;
	}
	public long getLong(String fieldName) {
		try {
			return mf.getLong(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return 0;
	}
	public float getFloat(String fieldName) {
		try {
			return mf.getFloat(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return 0f;
	}
	public double getDouble(String fieldName) {
		try {
			return mf.getDouble(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return 0;
	}
	public Timestamp getTimestamp(String fieldName) {
		try {
			return mf.getTimestamp(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return null;
	}
	public BigDecimal getBigcimal(String fieldName) {
		try {
			return mf.getBigDecimal(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return null;
	}
	public Time getTime(String fieldName) {
		try {
			return mf.getTime(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return null;
	}
	public java.sql.Date getDate(String fieldName) {
		try {
			return mf.getDate(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return null;
	}
	public CscCalendar getCscCalendar(String fieldName) {
		try {
			return mf.getCscCalendar(fieldName);
		} catch (Exception e) {
			MyLog.error(this,"Get fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return null;
	}
	//set the data to myField
	public boolean set(String fieldName, String data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, boolean data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, byte data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, char data[]) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, char data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, short data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, int data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, long data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, float data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, double data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, Timestamp data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, java.sql.Date data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, BigDecimal data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, java.sql.Time data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	public boolean set(String fieldName, CscCalendar data) {
		try {
			this.setLastUpdate();
			return mf.set(fieldName, data);
		} catch (Exception e) {
			MyLog.error(this,"Set fieldName :"+fieldName);
			MyLog.error(this, e);		
		}
		return false;
	}
	protected boolean isKey(String field) {
		if (key.indexOf(field) > 0) {
			return true;
		} else {
			return false;
		}
	}
	public void setUsedFor(char usedFor) {
		this.usedFor = usedFor;
	}
	public char getUsedFor() {
		return this.usedFor;
	}
	public void setFilter(String s) {
		String tfs = this.tfSql(s);
		this.filter=tfs;
	}
	public String getFilter() {
		return this.filter;
	}
	public Vector getAllKey() {
		Vector listKey = null;
		try {
			listKey = mf.getAllKey();
		} catch (Exception ex) {
			MyLog.error(this, ex);		
		}
		return listKey;
	}
	public void setOrderBy(String o) {
		this.orderBy = o;
		//this.refresh();
	}
	public String getOrderBy() {
		return this.orderBy;
	}
	public String getTableName() {
		try {
			return this.mr.getTableName();
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return null;
	}
	public String getActualName() {
		try {
			return this.mr.getActualName();
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return "";
	}
	public void setTableName(String name) {
		try {
			this.mr.setTableName(name);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void setActualName(String name) {
		try {
			this.mr.setActualName(name);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public String getError() {
		return "";
	}
	protected boolean preUpdateTrigger() {
		return true;
	}
	protected boolean preDeleteTrigger() {
		return true;
	}
	protected void postUpdateTrigger() {
	}
	protected void postDeleteTrigger() {
	}
	public Hashtable getRelationInfo() {
		try {
			return this.mr.getRelationInfo();
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		return null;
	}
	public void setRelationInfo(Hashtable hashRelation) {
		try {
			this.mr.setRelationInfo(hashRelation);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public Hashtable getEffectTable() {
		try {
			return this.mr.getEffectTable();
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		return null;
	}
	public void setEffectTable(Hashtable hashEffectTable) {
		try {
			this.mr.setEffectTable(hashEffectTable);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public Hashtable getChildTable() {
		try {
			return this.mr.getChildTable();
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		return null;
	}
	public void setChildTable(Hashtable hashChild) {
		try {
			this.mr.setChildTable(hashChild);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void putRelation(Relation oRela) {
		try {
			this.mr.putRelation(oRela);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void removeRelation(String tableName) {
		try {
			this.mr.removeRelation(tableName);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public Relation getRelation(String tableName) {
		try {
			return this.mr.getRelation(tableName);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		return null;
	}
	public int putChild(ChildManager oChild) {
		int ok = 0;
		try {
			//this.logger.info("DBTABLE  oChild  $ UProfile :" + oChild.getUProfile());
			ok = this.mr.putChild(oChild);
			oChild.isChild();
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return ok;
	}
	public int putChild(String childName, char type, char usedFor) {
		/*recordManagement oRecord;
		         tableManager  oTable;
		         childManager oChild=null;
		         Class c;
		         int ok=0;
		         if (type=='R') {
		    try {
		        oRecord =(recordManager)Class.forName(childName).newInstance();
		        oRecord.setPropDB(this.comp, this.user, this.pwd);
		        oRecord.setUsedFor(usedFor);
		        oChild=(childManager)oRecord;
		        }catch(Exception ex){
		                   this.logger.info("initTable Exception: "+ex);
		              }
		         }else{
		    oTable=new myTable(childName);
		    oTable.setPropDB(this.comp, this.user, this.pwd);
		    oTable.setUsedFor(usedFor);
		    oChild=(childManager)oTable;
		         }
		         if (oChild!=null) ok = this.putChild(oChild);
		         return ok;*/
		return 0;
	}
	public void removeChild(String childName) {
		try {
			this.mr.removeChild(childName);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void removeAllChild() {
		try {
			this.mr.removeAllChild();
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void refreshChild() {
		try {
			this.setRecordProperty();
			this.mf.refreshChild();
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public void refreshChild(String childName) {
		try {
			this.setRecordProperty();
			this.mf.refreshChild(childName);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	private void setRecordProperty() {
		try {
			this.mf.setRelationInfo(mr.getRelationInfo());
			this.mf.setChildTable(mr.getChildTable());
			this.mf.setEffectTable(mr.getEffectTable());
			this.mf.setParent(((RecordCmp0)this.mr).getParent());			
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
	}
	public ChildManager getChild(String childName) {
		try {
			return this.mr.getChild(childName);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		return null;
	}
	public DbRecord getRecordManager(String childName) {
		try {
			return this.mf.getRecordManager(childName);
		} catch (RemoteException re) {
			MyLog.error(this, re);		
		}
		return null;
	}
	public DbRecord getRecordManager() {
		try {
			return this.mr;
		} catch (Exception re) {
			MyLog.error(this, re);		
		}
		return null;
	}
	public DbRecord getCurrentRecordManager() {
		try {
			this.mf.setRelationInfo(mr.getRelationInfo());
			this.mf.setChildTable(mr.getChildTable());
		} catch (Exception re) {
			MyLog.error(this, re);		
		}
		return this.mf;
	}
//	public DbRecord getCurrentRecordManager(String key) throws CscException {
//		boolean found = false;
//		DbRecord r = null;
//		try {
//			r = this.getCurrentRecordManager();
//			if (this.getMinorKey().trim().length() > 0) {
//				for (this.first(); !this.eof() && !found; this.next()) {
//					r = this.getCurrentRecordManager();
//					if (r.getString(this.minorKey).trim().equals(key)) {
//						found = true;
//						break;
//					}
//				}
//				if (!found) {
//					throw new CscException("Can not find minor Key. " + key);
//				}
//			} else {
//				throw new CscException("Minor Key is empty now!");
//			}
//		} catch (Exception e) {
//			MyLog.error(this, e);
//		}
//		return r;
//	}
	
	public DbRecord getCurrentRecordManager(String key) throws Exception {
		boolean found = false;
		DbRecord r = null;
		if (this.getMinorKey().trim().length() > 0) {
			for (this.first(); !this.eof() && !found; this.next()) {
				r = this.getCurrentRecordManager();
				if (r.getString(this.minorKey).trim().equals(key)) {
					found = true;
					break;
				}
			}
			if (!found) {
				throw new CscException("Can not find minor Key: " + key);
			}
		} else {
			throw new CscException("Minor Key can not be null.");
		}
		return r;
	}

	
	public DbRecord getCurrentRecordManager(int recNo) {
		if (recNo <= this.recAmount && recNo > 0) {
			this.first();
			for (; recNo != this.currentRecord; this.next()) {
				;
			}
			return this.getCurrentRecordManager();
		}
		return null;
	}
	public DbRecord addRecord(String key) throws CscException {
		boolean found = false;
		DbRecord r = null;
		if (this.getMinorKey().trim().length() > 0) {
			if (mRecord.find(this.minorKey, key) < 0) {
				this.addRecord();
				this.set(this.minorKey, key);
				r = this.getCurrentRecordManager();
			} else {
				throw new CscException("Could not add this key because it is exist!");
			}
		} else {
			throw new CscException("Minor Key is empty now!");
		}
		return r;
	}
	public void deleteRecord(String key){
		int no;
		try {
			if (this.getMinorKey().trim().length() > 0) {
				no = this.mRecord.find(this.minorKey, key);
				if (no >= 0) {
					no++;
					this.deleteRecord(no);
				}
			} else {
				throw new CscException("Minor Key is empty now!");
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	public DbTable getTableManager(String childName) {
		try {
			return this.mr.getTableManager(childName);
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return null;
	}
	public String listChild() {
		try {
			return this.mr.listChild();
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return null;
	}
	public void setAutoRefresh(byte status) {
		this.autoRefresh = status;
	}
	public byte getAutoRefresh() {
		return this.autoRefresh;
	}
	public int setMinorKey(String keyName) {
		int n = 0;
		try {
			if (keyName.trim().length() == 0 || mr.getField(keyName) != null) {
				this.minorKey = keyName;
				this.mRecord.setMinorKey(keyName);
				n = 1;
			} else {
				n = 0;
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return n;
	}
	public String getMinorKey() {
		return this.minorKey;
	}
	public void setKeyOff() {
//		this.keyStatus = false;
	}
	public void setKeyOn() {
//		this.keyStatus = true;
	}
	public boolean getKeyStatus() {
//		return this.keyStatus;
		return false;
	}
	public void clearChild() {
	}
	public void clearField() {
	}
	public String getFieldList() {
		return this.field;
	}
	public Vector getArrayFieldList() {
		return this.aField;
	}
	//********************************************
	// Group Field Manager Method
	//********************************************
	public int fieldGroupCount() {
		try {
			return this.mr.fieldGroupCount();
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return 0;
	}
	public Vector getAllFieldGroupName() {
		try {
			return this.mr.getAllFieldGroupName();
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return null;
	}
	public void putFieldGroup(FieldGroup gf) {
		try {
			this.mr.putFieldGroup(gf);
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	public FieldGroup getFieldGroup(String groupCode) {
		try {
			return this.mr.getFieldGroup(groupCode);
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return null;
	}
	public String getLinkFieldChild(String childName) {
		try {
			return this.mr.getLinkFieldChild(childName);
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return null;
	}
	public String getLinkFieldParent(String childName) {
		try {
			return this.mr.getLinkFieldParent(childName);
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
		return null;
	}
	public boolean setColumn(FieldGroup fg) {
		return this.setColumn(fg.getFieldList());
	}
	public boolean addChildColumn(String childName) {
		String buff = this.getLinkFieldParent(childName);
		if (buff != null) {
			return this.addColumn(buff);
		}
		return false;
	}
	public void setFieldGroupColumn(String groupCode) {
		this.setColumn(this.getFieldGroup(groupCode));
	}
	public boolean addColumn(String columnList) {
		return this.setColumn(this.getFieldList() + "," + columnList.trim());
	}
	//********************************************
	public void setRefreshModel(byte model) {
		if (model == 0 || model == 1) {
			this.refreshModel = model;
		}
	}
	public void setJSPFilter(String condition) {
		this.setFilter(this.charCode("point3", condition));
	}
	public void setJSPString(String fieldName, String data) {
		this.set(fieldName, this.charCode("point3", data));
	}
	public String getJSPString(String fieldName) {
		return this.charCode("point2", this.getString(fieldName));
	}
	public void setAllRequiredFound(boolean require) {
		try {
			ChildManager child;
			this.setRequiredFound(require);
			for (Enumeration enu = this.getChildTable().elements(); enu.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setRequiredFound(require);
				this.setRequiredAllChild(child, require);
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	private void setRequiredAllChild(ChildManager childM, boolean require) {
		try {
			ChildManager child;
			for (Enumeration enu = childM.getChildTable().elements(); enu.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setRequiredFound(require);
				this.setRequiredAllChild(child, require);
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	public boolean foundData() {
		boolean flag = true;
		if (requiredFound == true) {
			if (!this.foundData) {
				flag = false;
			}
		}
		return flag;
	}
	/**
	 * Set User Profile to All Child Table
	 * @param uPro
	 */
	public void setAllUProfile(UProfile uPro) {
		ChildManager child;
		this.setUProfile(uPro);
		try {
			for (Enumeration enu = this.getChildTable().elements(); enu.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setUProfile(uPro);
				this.setAllUProfile(child, uPro);
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	/**
	 * Set User Profile to  Child Table
	 * @param childM
	 * @param uPro
	 */
	private void setAllUProfile(ChildManager childM, UProfile uPro) {
		ChildManager child;
		try {
			for (Enumeration enu = childM.getChildTable().elements(); enu.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setUProfile(uPro);
				this.setAllUProfile(child, uPro);
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	public void referLangOn() {
		try {
			if (mf != null) {
				this.mf.referLangOn();
				this.mr.referLangOn();
				this.blank.referLangOn();
				this.mRecord.referLangOn();
				/***********ball edit 19-03-04**********/
				this.referLang = true;
			}
			/***********************/
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	public void referLangOff() {
		try {
			if (mf != null) {
				this.mf.referLangOff();
				this.mr.referLangOff();
				this.blank.referLangOff();
				this.mRecord.referLangOff();
				/***********ball edit 19-03-04**********/
				this.referLang = false;
			}
			/***********************/
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	public void setParentDb(DbRecord db) {
		this.parentDb = db;
	}
	public DbRecord getParentDb() {
		return this.parentDb;
	}
	public void setRelationLink(Vector parent, Vector child) {
		this.parentList = parent;
		this.chList = child;
	}
/*	private boolean isUpdate() {
		try {
			di.refresh();
			String editBy, reditBy;
			String keyList;
			DbRecord db;
			Vector vDelete;
			while (di.next()) {
				editBy = di.getString("edit_by");
				if (editBy.equalsIgnoreCase(this.userPro.getUserId()))
					return true;
				else
					return false;
			}
			return true;
		} catch (RemoteException e) {
			e.printStackTrace();
			return true;
		}
	} */
	private void setCompanyFilter() {
		try {
			if (this.mr.getFieldList().indexOf("companyid") != -1) {
				if (this.fixFilter.length() == 0)
					this.fixFilter += " companyid='" + this.userPro.get("companyid") + "' ";
				else
					this.fixFilter += " and  companyid='" + this.userPro.get("companyid") + "' ";
			}
		} catch (Exception e) {
			MyLog.error(this, e);		
		}
	}
	private void setwfFilter() {
		if (this.mr.wfActive()) {
			if (this.fixFilter.length() == 0)
				this.fixFilter += " wf_status ='4' ";
			else
				this.fixFilter += " and wf_status ='4' ";
		}
	}
/*	
	private void initInquiry() {
		this.di = new InitialInquiry(this.userPro).getDbInquiry();
		try {
			di.initMyTable(this.vm.getTableName(), "", "");
			String filter = "screenname='" + this.param.get("__screen") + "' and  key_group ='" + this.keyGroup + "' and verify_group='2' and  verify_status='' and (status='I' OR status='U' OR status='D')";
			di.setColumn("*");
			di.setFilter(filter);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}
*/	
	public void setVMetaData(ConfigMetadata vm) {
		this.vm = vm;
	}
	private String getFixFilter(String buff) {
		if (this.fixFilter.length() > 0) {
			if (buff.length() == 0) {
				buff = this.fixFilter;
			} else {
				buff += " and " + this.fixFilter;
			}
		}
		return buff;
	}
	public void formatOn(){ 
		isFormat=true; 
	} 
	public void formatOff(){ 
		isFormat=false; 
	} 
	public void setFieldFormat(String type){ 
		for (int i=0;i<this.mRecord.size();i++){ 
			DbRecord db=(DbRecord)this.mRecord.elementAt(i); 
			db.setFieldFormat(type); 
		} 
	} 
		
		private void resetKey() {
			try {
				for (int i = 0; i < this.mRecord.size(); i++) {
					DbRecord db = (DbRecord) this.mRecord.elementAt(i);
					this.setHeadRecord(db);
				}
				for (int i = 0; i < this.mRecord.getVdelete().size(); i++) {
					DbRecord db = (DbRecord) this.mRecord.getVdelete().elementAt(i);
					this.setHeadRecord(db);
				}

			} catch (Exception e) {
				MyLog.error(this, e);		
			}
		}

		private void setHeadRecord(DbRecord db) {
			try {
				String mainKey = this.mf.getMainkey();
				String firstKey = ((DbRecord) this.mRecord.elementAt(0)).getString(mainKey);
				String headfield = (String) this.param.get("__headfield");
				StringTokenizer st = new StringTokenizer(headfield, ",");
				while (st.hasMoreTokens()) {
					String fieldName = st.nextToken();
					String data = ((DbRecord) this.mRecord.elementAt(0)).getString(fieldName);
					db.set(fieldName, data);
				}
				db.set(mainKey, firstKey);
			} catch (Exception e) {
				MyLog.error(this, e);		
			}
		}

		private void clearDupDelete() {
			try {
				Vector vDelete = this.mRecord.getVdelete();
				Vector tempDelete = new Vector();
				for (int i = 0; i < vDelete.size(); i++) {
					DbRecord db = (DbRecord) vDelete.elementAt(i);
					int find = this.find(this.getMinorKey(), db.getString(this.getMinorKey()));
					if (find != -1) {
						tempDelete.addElement(db);
					}
				}
				for (int i = 0; i < tempDelete.size(); i++) {
					vDelete.remove(tempDelete.elementAt(i));
				}
			} catch (Exception e) {
				MyLog.error(this, e);		
			}
		}
		
		private int find(String fieldName, String data) {
			DbRecord r;
			int no = -1;
			try {
				for (int i = 0; i < this.mRecord.size() && no < 0; i++) {
					r = (DbRecord) this.mRecord.elementAt(i);
					if (r.getString(fieldName).equals(data))
						no = i;
				}
			} catch (Exception e) {
				MyLog.error(this, "fieldName : "+fieldName);
				MyLog.error(this, e);		
			}
			return no;
		}
		/* (non-Javadoc)
		 * @see com.csc.library.session.DbTable#setLoasComponent(boolean)
		 */
		public void setLoasComponent(boolean load) {
			// TODO Auto-generated method stub
			
		}
		
		public void setParent(ChildManager ch) {
			int ok = 0;
			try {
				//this.logger.info("DBTABLE  oChild  $ UProfile :" + oChild.getUProfile());
				this.mr.setParent(ch);			
			} catch (Exception e) {
				MyLog.error(this, e);		
			}
		}
		public void setVerifyOff() {
			return;
		}
		
		public void setBlankRecord(int amt) {
			this.blankRecord = amt;
		}
		public int getBlankRecord() {
			return this.blankRecord;
		}
		public String getDataFormat(String fieldName) {
			try {
				return mf.getDataFormat(fieldName);
			} catch (Exception e) {
				MyLog.error(this,"Get fieldName :"+fieldName);
				MyLog.error(this, e);		
			}
			return "";
		}
		
		public void  goRec(int no,boolean isRefreshChild) {			
			boolean chk = false;
			if (this.recAmount > 0 && no < this.recAmount+1) {
				this.currentRecord = no;
				this.mf = (DbRecord) this.mRecord.elementAt(this.currentRecord - 1);
				chk=true;
				if(isRefreshChild)
						this.refreshChild();
			} else {
				this.currentRecord = this.recAmount + 1;	
				this.mf = this.blank;
			}			
		}
		
		public String getDescription() throws RemoteException {
			return this.mf.getDescription();
		}
		
		private boolean deleteTmpRecord(){
			try{
				if(this.param.containsKey("__delolddata")&& ((String)this.param.get("__delolddata")).equals("1")){
					this.deleteVrecord();
				}else{
					if(this.mRecord.getVdelete().size()>0){
						Vector vDelete = this.mRecord.getVdelete();
						DbRecord db=null;
						for(int v=0;v<vDelete.size();v++){
							 db = (DbRecord) this.mRecord.getVdelete().elementAt(v);
							 if(db.deleteForMyTable()<0)
								 return false;
						}					
					}
			  }
			}catch(Exception ex){
				MyLog.error(this,this.getUProfile(),"cann't Delete tem Reord");
				return false;
			}
			return true;
		}
		
		private void closeConnectionChild(Hashtable ht) throws Exception{
			Enumeration em = ht.keys();
			while (em.hasMoreElements()) {
				String childName = (String) em.nextElement();
				Object oCh = this.getChild(childName);
				 if (oCh instanceof DbInquiry){		
					 if(((DbInquiry) oCh).getChildTable().size()>0){
						 this.closeConnectionChild(((DbInquiry) oCh).getChildTable());
					 }
					 ((DbInquiry) oCh).closeConnection();
				 }
			}
		}
		@Override
		protected void finalize() throws Throwable {// finalize ͹Ѻѹ
			//this.closeConnectionChild(this.getChildTable()); // close child connection ͧҡ child ѧö next ҡ close connection 仡͹ռŷ next child ú
		}
		
		public String getObjectTrace() {
			StringBuilder build=new StringBuilder();
			/**
			 * 
			 * comment by pas  
			 * comment ͷͺ memory
			 * 
			 * 			
			build.append("====MyTable.toString()=").append(getClass().getName() + "@" + Integer.toHexString(hashCode()));
			build.append("mRecord =").append(mRecord).append("\n");
			build.append("originalRecord =").append(originalRecord).append("\n");
			build.append("mf =").append(mf.getObjectTrace()).append("\n");
			build.append("mr =").append(mr.getObjectTrace()).append("\n");
			build.append("blank =").append(blank).append("\n");
			build.append("key =").append(key).append("\n");
			build.append("field =").append(field).append("\n");
			build.append("aField =").append(aField).append("\n");
			build.append("currentRecord =").append(currentRecord).append("\n");
			build.append("recAmount =").append(recAmount).append("\n");
			build.append("c =").append(c).append("\n");
			build.append("oldCondition =").append(oldCondition).append("\n");
			build.append("usedFor =").append(usedFor).append("\n");
			build.append("autoRefresh =").append(autoRefresh).append("\n");
			build.append("error =").append(error).append("\n");
			build.append("filter =").append(filter).append("\n");
			build.append("orderBy =").append(orderBy).append("\n");
			build.append("minorKey =").append(minorKey).append("\n");
			build.append("lastUpDate =").append(lastUpDate).append("\n");
			build.append("refreshModel =").append(refreshModel).append("\n");
			build.append("tableName =").append(tableName).append("\n");
			build.append("parentDb =").append(parentDb).append("\n");
			build.append("parentList =").append(parentList).append("\n");
			build.append("vm =").append(vm).append("\n");
			build.append("message =").append(message).append("\n");
			build.append("saveReturn =").append(saveReturn).append("\n");
			build.append("multiCompanyLink =").append(multiCompanyLink).append("\n");
			build.append("fixFilter =").append(fixFilter).append("\n");
			build.append("loadComponent =").append(loadComponent).append("\n");
			build.append("editCheck =").append(editCheck).append("\n");
			build.append("isFormat =").append(isFormat).append("\n");
			build.append("myInq =").append(myInq.getObjectTrace()).append("\n");
			build.append("blankRecord =").append(blankRecord).append("\n");
			build.append("childCondi =").append(childCondi).append("\n");		
			build.append("=====================");
			**/
			return build.toString();	
		}

		public void setWFTransferOff() {
			this.wfTransfer=false;
		}

		public void setWFTransferOn(String wf_ref_doc) {
			this.wfTransfer=true;
			this.wfRefDoc=wf_ref_doc;
		}

		public boolean getWFTransfer() {
			return this.wfTransfer;
		}
		
		public String getWFRefDoc() {
			return this.wfRefDoc;
		}
		public MyRecordGroup getMyRecords() {
			return this.mRecord;
		}
		public int getCurrentRecordNumber() {
			return this.currentRecord;
		}
		
}