package com.csc.library.database;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Hashtable;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.UProfile;

public interface RecordManager {
	public void clearChild();
	public void clearField();
	//public  int addnewRec(Connection myCon);
	public int save();
	public int delete();
	public int save(Connection myCon);
	public int delete(Connection myCon);
	public void refresh();
	public void restore();
	public void restore(String fieldName);
	public void print();
	public void printList();
	public String getString(String fieldName);
	public boolean getBoolean(String fieldName);
	public byte getByte(String fieldName);
	public char[] getChars(String fieldName);
	public char getChar(String fieldName);
	public short getShort(String fieldName);
	public int getInt(String fieldName);
	public long getLong(String fieldName);
	public float getFloat(String fieldName);
	public double getDouble(String fieldName);
	public Timestamp getTimestamp(String fieldName);
	public java.sql.Date getDate(String fieldName);
	public BigDecimal getBigDecimal(String fieldName);
	public Time getTime(String fieldName);
	public CscCalendar getCscCalendar(String fieldName);
	public boolean set(String fieldName, String data);
	public boolean set(String fieldName, boolean data);
	public boolean set(String fieldName, byte data);
	public boolean set(String fieldName, char data[]);
	public boolean set(String fieldName, char data);
	public boolean set(String fieldName, short data);
	public boolean set(String fieldName, int data);
	public boolean set(String fieldName, long data);
	public boolean set(String fieldName, float data);
	public boolean set(String fieldName, double data);
	public boolean set(String fieldName, Timestamp data);
	public boolean set(String fieldName, java.sql.Date data);
	public boolean set(String fieldName, BigDecimal data);
	public boolean set(String fieldName, Time data);
	public boolean set(String fieldName, CscCalendar data);
	public String getNameKey(String No);
	public int getSizeKey();
	public String getFieldList();
	public String getTableName();
	public String getActualName();
	public void setTableName(String name);
	public void setActualName(String name);
	public FieldManager getField(String fieldName);
	//public Object myClone();
	public int assignField(DataSet ds);
	public void setFilter(String condition);
	public String getError();
	//public int zap();
	//public int zap(Connection myCon);
	public void deleteFor(String condition);
	public void setPropDB(String comp, String user, String pwd);
	public void setKey(String data);
	public void setKey(String data[]);
	public boolean setColumn(String columnList);
	public int setCondition(String condition[]);
	public int search();
	public String getListKey();
	public void setUsedFor(char usedFor);
	public char getUsedFor();
	public Hashtable getChildTable();
	public void setChildTable(Hashtable hashChild);
	public Hashtable getRelationInfo();
	public void setRelationInfo(Hashtable hashRelation);
	public void putRelation(Relation oRela);
	public void removeRelation(String tableName);
	public Relation getRelation(String tableName);
	public int putChild(ChildManager oChild);
	public int putChild(String childName, char type, char usedFor);
	public void removeChild(String childName);
	public void removeAllChild();
	public void refreshChild();
	public void refreshChild(String childName);
	public ChildManager getChild(String childName);
	public DbRecord getRecordManager(String childName);
	public DbTable getTableManager(String childName);
	public String listChild();
	//public boolean checkReference(String TableName, String dataKey);
	public void setAutoRefresh(byte status);
	public byte getAutoRefresh();
	public void refreshEffectTable(String fieldName);
	public Hashtable getEffectTable();
	public void setEffectTable(Hashtable hashEffectTable);
	//public void addReference(String tableName);
	//public void addReference(RecordManager rm);
	public boolean containsReference(String tableName);
	public Object getReferenceTable(String tableName);
	public boolean removeReference(String tableName);
	public void removeAllReference();
	public void refreshReference();
	public void refreshReference(String tableName);
	public void clearReference(String tableName);
	public void clearAllReference();
	public void setLastUpdate();
	public String getDescription();
	public int fieldGroupCount();
	public Vector getAllFieldGroupName();
	public void putFieldGroup(FieldGroup gf);
	public FieldGroup getFieldGroup(String groupCode);
	public String getLinkFieldChild(String childName);
	public String getLinkFieldParent(String childName);
	public boolean setColumn(FieldGroup fg);
	public boolean addChildColumn(String childName);
	public void setFieldGroupColumn(String groupCode);
	public boolean addColumn(String columnList);
	//********************************************

	public void setRefreshModel(byte model);
	//public void setJSPString(String fieldName,String data);
	//public String getJSPString(String fieldName);
	//public void createTable();
	//public void createAllTable();
	//public void dropTable();
	public void setConnectControl(ConnectManager con);
	public ConnectManager getConnectControl();
	public void appendFrom(DbRecord rec);
	public void appendFrom(DbInquiry inq);
	public void appendFrom(DbTable tab);
	//public void createIndex();
	public void setAllRequiredFound(boolean require);
	public void setRequiredFound(boolean require);
	public boolean getRequiredFound();
	public boolean foundData();
	public void setFoundData(boolean found);
	public void setUProfile(UProfile uPro);
	public UProfile getUProfile();
	public void setSecurity(RSecurityManager rm);
	public int searchForSecurity(String fieldNmae, String value);
	//public void rollback();
	public void setErrMess(String mess);

}