package com.csc.library.database;

import java.io.Serializable;
import java.rmi.RemoteException;
import java.util.Vector;

import com.csc.library.session.DbRecord;
public class Relation implements Serializable {

	private static final long serialVersionUID = 1L;
	
	public String tableName;
	private char u_Integrity = 'I';
	private char d_Integrity = 'I';
	private char i_Integrity = 'I';
	public Vector parentField = new Vector();
	public Vector childField = new Vector();
	private Vector effectField = new Vector();
	
	public String parentTableName, childTableName;

 	private String insertLevel="",deleteLevel="";
 	private String dependLevel="";
 	private String rtablename = "";
 	private String moduledelete = "";
 	private String mode="1";

	/**
	 * @return Returns the effectField.
	 */
	public Vector getEffectField() {
		return effectField;
	}
	/**
	 * @param effectField The effectField to set.
	 */
	public void setEffectField(Vector effectField) {
		this.effectField = effectField;
	}
	public Relation(String toTable, Vector parentFieldList, Vector childFieldList, char u_Integrity, char i_Integrity, char d_Integrity) {
		this.tableName = toTable; //.toUpperCase();
		this.childField = (Vector)childFieldList.clone();
		this.parentField = (Vector)parentFieldList.clone();
		this.u_Integrity = u_Integrity;
		this.i_Integrity = i_Integrity;
		this.d_Integrity = d_Integrity;
		this.separateData();
	}
	
	public Relation(String toTable, Vector parentFieldList, Vector childFieldList, String insertLevel,String deleteLevel,String dependLevel,String rtablename,String moduledelete,String mode) {
        this.tableName = toTable; //.toUpperCase();
        this.childField = (Vector)childFieldList.clone();
        this.insertLevel=insertLevel;
        this.deleteLevel=deleteLevel;
        this.parentField = (Vector)parentFieldList.clone();
        this.u_Integrity = 'R';
        this.i_Integrity = 'R';
        this.d_Integrity = 'R';
        this.dependLevel=dependLevel;
        this.rtablename = rtablename;
        this.moduledelete = moduledelete;
        this.mode=mode;
        this.separateData();
	}
	
	public Relation(String toTable, Vector parentFieldList, Vector childFieldList, String insertLevel,String deleteLevel,String dependLevel,String rtablename) {
        this.tableName = toTable; //.toUpperCase();
        this.childField = (Vector)childFieldList.clone();
        this.insertLevel=insertLevel;
        this.deleteLevel=deleteLevel;
        this.parentField = (Vector)parentFieldList.clone();
        this.u_Integrity = 'R';
        this.i_Integrity = 'R';
        this.d_Integrity = 'R';
        this.dependLevel=dependLevel;
        this.rtablename = rtablename;
        this.separateData();
	}
	
   public Relation(String toTable, Vector parentFieldList,
			Vector childFieldList, String insertLevel, String deleteLevel) {
		this.tableName = toTable; // .toUpperCase();
		this.childField = (Vector) childFieldList.clone();
		this.insertLevel = insertLevel;
		this.deleteLevel = deleteLevel;
		this.parentField = (Vector) parentFieldList.clone();
		this.u_Integrity = 'R';
		this.i_Integrity = 'R';
		this.d_Integrity = 'R';
		this.separateData();
	}

	public Relation(String toTable, Vector parentFieldList, Vector childFieldList) {
		this.tableName = toTable; // .toUpperCase();
		this.childField = (Vector)childFieldList.clone();
		this.parentField = (Vector)parentFieldList.clone();
		this.separateData();
	}

	public Relation(String toTable, String parentFieldName, String childFieldName) {
		this.tableName = toTable; //.toUpperCase();
		this.parentField.add(parentFieldName);
		this.childField.add(childFieldName);
		this.separateData();
	}

	public void remove(String parent) {
		int x;
		x = this.parentField.indexOf(parent);
		if (x >= -1) {
			this.parentField.removeElementAt(x);
			this.childField.removeElementAt(x);
		}
	}

	public void add(String parent, String child) {
		this.parentField.add(parent);
		this.childField.add(child);
		this.separateData();
	}

	public String toString() {
		String buff;
		buff = this.tableName;
		for (int i = 0; i < this.parentField.size(); i++) {
			buff = buff + "," + (String) this.parentField.elementAt(i) + "=" + (String) this.childField.elementAt(i);
		}
		return buff;
	}

	private void separateData() {
		String buff1, buff2;
		int fp, fc;
		buff1 = (String) this.parentField.elementAt(0);
		fp = buff1.indexOf('.');
		buff2 = (String) this.childField.elementAt(0);
		fc = buff2.indexOf('.');
		if (fp >= 0) {
			this.parentTableName = buff1.substring(0, fp);
			this.parentField.setElementAt(buff1.substring(fp + 1), 0);
		}
		if (fc >= 0) {
			this.childTableName = buff2.substring(0, fc);
			this.childField.setElementAt(buff2.substring(fc + 1), 0);
		}
		for (int i = 1; i < this.parentField.size(); i++) {
			buff1 = (String) this.parentField.elementAt(i);
			fp = buff1.indexOf('.');
			buff2 = (String) this.childField.elementAt(i);
			fc = buff2.indexOf('.');
			if (fp >= 0) {
				this.parentTableName = buff1.substring(0, fp);
				this.parentField.setElementAt(buff1.substring(fp + 1), i);
			}
			if (fc >= 0) {
				this.childTableName = buff2.substring(0, fc);
				this.childField.setElementAt(buff2.substring(fc + 1), i);
			}
		}
	}
	// ball 18-09-03
	/*public String[] GenCondtion(DbRecord oRecord) {
		String buff[] = null;
		if (this.parentTableName.equals("") && this.childTableName.equals("")) {
			buff = this.GenCondtion(this.parentField, this.childField, oRecord);
		} else {
			try {
				if (oRecord.getActualName().equalsIgnoreCase(this.childTableName))
					buff = this.GenCondtion(this.parentField, this.childField, oRecord);
				else
					buff = this.GenCondtion(this.childField, this.parentField, oRecord);
			} catch (RemoteException e) {}
		}
		return buff;
	}*/

      public String[] GenCondtion(DbRecord oRecord) {
                      String buff[] = null;
                      if (this.parentTableName.equals("") && this.childTableName.equals("")) {
                              buff = this.GenCondtion(this.parentField, this.childField, oRecord);
                      } else {
                              try {
                                      if (oRecord.getTableName().equalsIgnoreCase(this.childTableName)||oRecord.getActualName().equalsIgnoreCase(this.childTableName))
                                              buff = this.GenCondtion(this.parentField, this.childField, oRecord);
                                      else
                                              buff = this.GenCondtion(this.childField, this.parentField, oRecord);
                              } catch (RemoteException e) {}
                      }
                      return buff;
      }

      public String GenFieldDescription(DbRecord oRecord) throws RemoteException {
        String buff = "";
        if (this.parentTableName.equals("") && this.childTableName.equals("")) {
                buff = this.GenDescription(this.childField, oRecord);
        } else {
                try {
                        if (oRecord.getTableName().equalsIgnoreCase(this.childTableName))
                                buff = this.GenDescription(this.childField, oRecord);
                        else
                                buff = this.GenDescription(this.parentField, oRecord);
                } catch (RemoteException e) {}
        }
        return buff;
      }

      public boolean isNeedCheck(DbRecord oRecord) throws RemoteException {
	        boolean buff = true;
	        boolean emptyData = false;
	        if (this.parentTableName.equals("") && this.childTableName.equals("")) {
	                emptyData = this.isDataEmpty(this.childField, oRecord);
	        } else {
	                try {
	                	if (oRecord.getTableName().equalsIgnoreCase(this.childTableName)) {
	                		emptyData = this.isDataEmpty(this.childField, oRecord);
	                		buff = ! this.equalKeyField(this.childField, oRecord.getAllKey());
	                	} else { 
	                    	emptyData = this.isDataEmpty(this.parentField, oRecord);
	                		buff = ! this.equalKeyField(this.parentField, oRecord.getAllKey());
	                	}
	                } catch (RemoteException e) {}
	        }
	        if (buff) {
		        if (emptyData) {
		        	/**
		        	 * @edit by pas
		        	 * ó  set  ͧ table child    Mode = -1 ͧ礴
		        	 */
		        	if (this.getMode().equals("0")||this.getMode().equals("-1")) {
		        		buff = false;
		        	}
		        } else {
		        	if (this.getMode().equals("-1")) {
		        		buff = false;
		        	} else { 	
		        		buff = true;
		        	}	
		        }
	        }
	        return buff;
      }

      private boolean isDataEmpty(Vector fieldList, DbRecord oRecord) throws RemoteException {
	        boolean buff = false;
	        String data = "";
	    	for (int i = 0; i < fieldList.size() && !buff; i++) {
	            FieldManager fn = oRecord.getField((String) fieldList.elementAt(i));
	            data = fn.getString().trim();
	            if (data.equals("") || data.equals("NONE")) {
	            	buff = true;
	            }
	       	}
	        return buff;
      }
      
      private String[] GenCondtion(Vector data1, Vector data2, DbRecord oRecord) {
                      String buff[] = new String[data1.size() * 2];
                      int j = 0;
                      for (int i = 0; i < data1.size(); i++) {
                              buff[j] = (String) data1.elementAt(i);
                              try {
                                      FieldManager fn = oRecord.getField((String) data2.elementAt(i));
                                      String value = "";
                                      if (fn.getType().equalsIgnoreCase("AutoNumber"))
                                              value = fn.getString();
                                      else
                                              value = fn.getSaveString();
                                      buff[j + 1] = value;
                              } catch (RemoteException e) {}

                              j = j + 2;
                      }
                      return buff;
              }

      private String GenDescription(Vector data, DbRecord oRecord) throws RemoteException {
        int j = 0;
        String buff="";
        for (int i = 0; i < data.size(); i++) {
        	String field = (String) data.elementAt(i);
        	if (!field.equals("companyid")) {
	        	FieldManager fn = oRecord.getField(field);
	            String value = "";
	            value = fn.getDescription();
	            buff += field +"("+value+") = "+fn.getSaveString()+"\n";
        	}
        }
        return buff;
      }



	public String getFieldListParent() {
		String buff = new String();
		if (this.parentField.size() > 0) {
			buff = (String) this.childField.elementAt(0);
			for (int i = 1; i < this.parentField.size(); i++) {
				buff = buff + "," + (String) this.childField.elementAt(i);
			}
		}
		return buff;
	}

	public String getFieldtListChild() {
		String buff = new String();
		if (this.parentField.size() > 0) {
			buff = (String) this.parentField.elementAt(0);
			for (int i = 1; i < this.parentField.size(); i++) {
				buff = buff + "," + (String) this.parentField.elementAt(i);
			}
		}
		return buff;
	}
//Suk edit
	public Vector getVFieldListParent() {
		return this.childField;
	}

	public Vector getVFieldtListChild() {
		return this.parentField;
	}

	public String getInsertLevel() {
		return this.insertLevel;
	}

	public String getDeleteLevel() {
		return this.deleteLevel;
	}
        
	public String getDependLevel() {
		return this.dependLevel;
	}
	
	public String getModuleDelete() {
		return this.moduledelete;
	}
	
	public String getRTableName() {
		return this.rtablename;
	}
	
	public void setDeleteLevel(String deletelevel){
		this.deleteLevel= deletelevel;
	}
	
	public String getMode(){
		return this.mode;
	}
	
	public void setMode(String mode){
		this.mode=mode;
	}
	
	public boolean equalKeyField(Vector v1, Vector v2) {
		boolean buff = true;
		if (v1.size()==v2.size()) {
			for(int i = 0; i < v1.size() && buff;i++) {
				if (!v2.contains(v1.get(i))) {
					buff = false;
				}
			}
		} else {
			buff = false;
		}
		return buff;
	}
}
