package com.csc.library.database;
/**
 * @author cscuser
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.jdom.Element;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

public class SystemCode {
        public static Hashtable code = new Hashtable();
        private String sysXml = "";
        private static Element rootXml;
        private StaticCode staticcode;

        public void initValue(String systemcodeXml) {
                this.sysXml = systemcodeXml;
                ReadXml r = new ReadXml(this.sysXml);
                SystemCode.rootXml = r.getRootElement();
                SystemCode.scanCode();
        }
        public static StaticCode fetchDataToStaticCode(List dataList) {
                StaticCode staticcode= new StaticCode();
                String[][] tmp = new String[dataList.size()][2];//  { {"", "" }};
                Iterator it = dataList.iterator();
                int count = 0;
                while(it.hasNext()){
                        Element data = (Element)it.next();
                        tmp[count][0] = data.getChild("KEY").getTextTrim();
                        tmp[count][1] = data.getChild("VALUE").getTextTrim();
                        staticcode.put(data.getText(),tmp);
                        count++;
                }
                return staticcode;
        }
        private static boolean scanCode() {
                try {
                        Iterator it = SystemCode.rootXml.getChildren().iterator();
                        while (it.hasNext()) {
                                Element code = (Element) it.next();
                                List dataList = code.getChildren();
                                SystemCode.code.put(code.getName(), SystemCode.fetchDataToStaticCode(dataList));
                        }
                        return true;
                } catch (Exception e) {
                		MyLog.error("SystemCode Class :"+e.toString()); 
                        return false;
                }
        }
        public static boolean search(String validCode, String index) {
                boolean ok = false;
                StaticCode c = (StaticCode) code.get(validCode.toUpperCase());
                if (c != null) {
                        ok = c.search(index);
                } else
                	MyLog.warn("SystemCode Class :"+ "Can not find code table in the system!" + validCode.toUpperCase());
                return ok;
        }
        public static String getDescription(String validCode, String index) {
                String buff = "";
                StaticCode c = (StaticCode) code.get(validCode.toUpperCase());
                if (c != null) {
                        buff = c.getDescription(index);
                } else
                	MyLog.warn("SystemCode Class :"+"Can not find code table in the system!" + validCode.toUpperCase());
                return buff;
        }
        public static String[][] getContent(String validCode) {
                String[][] buff = { { "", "" }};
                StaticCode c = (StaticCode) code.get(validCode.toUpperCase());
                if (c != null) {
                        buff = c.getContent();
                } else
                	MyLog.warn("SystemCode Class :"+"Can not find code table in the system!" + validCode.toUpperCase());
                return buff;
        }
        public static String getValue(String validCode, int index) {
                String tmp[][] = SystemCode.getContent(validCode.toUpperCase());
                return tmp[index][1];
        }
        public static String getValue(String validCode, String key) {
                String tmp[][] = SystemCode.getContent(validCode.toUpperCase());
                for (int i = 0; i < tmp.length; i++) {
                        if (tmp[i][0].equalsIgnoreCase(key)) {
                                return tmp[i][1];
                        }
                }
                return "";
        }
        public static String getValue(String validCode, String key,String lang) {
            String value=getValue(validCode,key);
            if(value.indexOf(",")!=-1){
                if (lang.equalsIgnoreCase("eng")) {
                    value = value.substring(0, value.indexOf(","));
                } else {
                    value = value.substring(value.indexOf(",")+1);
                }
            }
        
            return value;
    }
        public static boolean containsKey(Object key){
                return SystemCode.code.containsKey(key);
        }
        
        public static String[][] getContentDWR(String[] data){
             String tmp[][] = (String[][])getContent(data[0]).clone();   
              String tmp1[][] =new String[tmp.length][tmp[0].length];             
             for(int i=0;i<tmp.length;i++){        
                for(int l=0;l<tmp[0].length;l++){ 
                    if(l==0)
                        tmp1[i][0]=new String(tmp[i][0]);
                    else
                        tmp1[i][l]=spilltLang(tmp[i][l],data[1]);
                }
             }
            return tmp1;
          }
        
          public static String  getValueDWR(String[] data){
            String desc = getValue(data[0],data[1]);
     //       System.out.println("desc>>>>>>>>>>>>>>>>"+desc);
     //       System.out.println("spillt>>>>>>>>>>"+spilltLang(desc,data[2]));
            return spilltLang(desc,data[2]);
          }
          
          private  static  String spilltLang(String value,String lang){
            if((value!=null)&&(value.indexOf(",")>0)){
             if (lang.equalsIgnoreCase("eng")) {                    
                return value.substring(0, value.indexOf(","));                  
             } else {                       
                return  value.substring(value.indexOf(",") + 1);
             }              
            }
             return value;
          } 
          
          public static List<Map<String, String>> getSystemCode(String validCode, String lang) {
      		final String tmp[][] = getContent(validCode);
      		final List<Map<String, String>> list = new ArrayList<Map<String, String>>();
      		Map<String, String> map;
      		for(String[] tmp1 : tmp) {
      			map = new HashMap<String, String>();
      			map.put("value", tmp1[0]);
      			map.put("text", spilltLang(tmp1[1], lang));
      			list.add(map);
      		}
      		
      		return list;
      	}
}
