package com.csc.library.factor;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.sql.*;
import java.util.*;

import com.csc.library.utilities.FileString;
import com.csc.library.utilities.MyLog;

public class FactorBase  implements Factorable {
  protected transient Connection con = null;
  protected transient Statement st = null;
  protected transient ResultSet rs = null;
  protected String tableName="";
  private String filter="", order="", sql="";
  private Properties propField=new Properties();
  public FactorBase() {}

  public void Refresh() {
    try {
      if (this.filter != null && !this.filter.equalsIgnoreCase(""))
        sql += " where " + filter;
      if (this.order != null && !this.order.equalsIgnoreCase(""))
        sql += " order by " + this.order;
      //System.out.println("Refresh in Factor : "+sql);
      this.st = this.con.createStatement();
      this.rs = st.executeQuery(sql);
    }
    catch (Exception ex) {
    	MyLog.error(this, ex);
    }
  }
  private String converseFilter(String filter){
    Enumeration em=this.propField.propertyNames();
    String fieldName,rFieldName;
    while(em.hasMoreElements()){
      fieldName=(String)em.nextElement();
      rFieldName=this.propField.getProperty(fieldName);
      if(rFieldName !=null && !rFieldName.equals("")){
       //filter = filter.replaceAll(fieldName, rFieldName);
       FileString fs=new FileString();
       fs.setData(filter);
       filter=fs.replaceAll(fieldName,rFieldName);
      }
    }
    return filter;
  }

  public void setFilter(String filter) {
    this.filter = this.converseFilter(filter);
  }

  public void setOrder(String order) {
    this.order =this.converseFilter(order);
  }

  public ResultSet getResultSet() {
    return this.rs;
  }

  public Connection getConnection() {
    return this.con;
  }

  public Statement getStatement() {
      return this.st;
    }


  public void Close() {
    try {
      this.st.close();
      this.con.close();
    }
    catch (Exception ex) {
    	MyLog.error(this, ex);
    }
  }

  protected void setSql(String sql) {
    this.sql = sql;
  }

  protected void setProperties(String sField, String rField) {
    this.propField.setProperty(sField, rField);
  }
  public int recCount(){
   int rec=0;
    try {
     java.sql.Statement st = this.con.createStatement();
     java.sql.ResultSet rs = st.executeQuery(this.getRecountSql());
      rs.next();
     rec=rs.getInt(1);
     //System.out.println("reCord Of Factor  = :> "+rec);
     rs.close();
     st.close();
     return rec ;
   }
   catch (Exception ex) {
	MyLog.error(this, ex);
     return 0;
   }
 }

  private String getRecountSql(){
  String con="";
  if(!this.filter.equals("")){
    con=" where "+this.filter;
  }
  String sql="select count(*)  from "+this.tableName+con;
//  System.out.println(" getReccountSql : >>>>>>>>>> "+sql);
  return sql;
}

}
