package com.csc.library.log;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;


public class EventLog{
	String logid="";
	String table_name="";
	String companyid="";
	String key_field="";
	String create_by="";
	String create_date="";
	String create_time="";
	String date_log="";
	String edit_by="";
	String edit_date="";
	String edit_time="";
	HashMap<String,String>  new_value=new HashMap<String,String>();
	HashMap<String,String> old_value=new HashMap<String,String>();
	String refer="";
	String status="";
	String time_log="";
	String user_code="";
	String table_desc="";
	HashMap<String,String> field_desc=new HashMap<String,String>();
	UProfile up;

	public EventLog() {
	}
	
	public void setRecord(DbRecord db) {
		try{
			this.up=db.getUProfile();
			CscCalendar cs=new CscCalendar();
			this.setLogid(String.valueOf(System.nanoTime()));		
			this.setTable_name(db.getTableName());
			this.setCreate_by((String)this.up.get("employeeid"));
			this.setCreate_date(cs.getYYYYMMDD());
			this.setCreate_time(cs.getHHMMSS());
			this.setEdit_date(cs.getYYYYMMDD());
			this.setEdit_by((String)this.up.get("employeeid"));
			this.setEdit_time(cs.getHHMMSS());
			this.setCompanyid((String)db.getUProfile().get("companyid"));
			this.setRefer(db.getString("runno"));
			this.setDate_log(cs.getYYYYMMDD());
			this.setTime_log(cs.getHHMMSS());
			this.setTable_desc(db.getDescThai());
		}catch(Exception ex){
			MyLog.error(this, ex.getMessage());
		}
	}  

	public String getLogid() {
		return logid;
	}

	public void setLogid(String logid) {
		this.logid = logid;
	}

	public String getTable_name() {
		return table_name;
	}

	public void setTable_name(String tableName) {
		table_name = tableName;
	}

	public String getCompanyid() {
		return companyid;
	}

	public void setCompanyid(String companyid) {
		this.companyid = companyid;
	}

	public String getKey_field() {
		return key_field;
	}

	public void setKey_field(String keyField) {
		key_field = keyField;
	}

	public String getCreate_by() {
		return create_by;
	}

	public void setCreate_by(String createBy) {
		create_by = createBy;
	}

	public String getCreate_date() {
		return create_date;
	}

	public void setCreate_date(String createDate) {
		create_date = createDate;
	}

	public String getCreate_time() {
		return create_time;
	}

	public void setCreate_time(String createTime) {
		create_time = createTime;
	}

	public String getDate_log() {
		return date_log;
	}

	public void setDate_log(String dateLog) {
		date_log = dateLog;
	}

	public String getEdit_by() {
		return edit_by;
	}

	public void setEdit_by(String editBy) {
		edit_by = editBy;
	}

	public String getEdit_date() {
		return edit_date;
	}

	public void setEdit_date(String editDate) {
		edit_date = editDate;
	}

	public String getEdit_time() {
		return edit_time;
	}

	public void setEdit_time(String editTime) {
		edit_time = editTime;
	}

	public HashMap getNew_value() {
		return new_value;
	}

	public void setNew_value(String fieldName,String data) {
		this.new_value.put(fieldName,data);
	}

	public HashMap getOld_value() {
		return old_value;
	}

	public void setOld_value(String fieldName,String data) {
		this.old_value.put(fieldName,data);
	}

	public String getRefer() {
		return refer;
	}

	public void setRefer(String refer) {
		this.refer = refer;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getTime_log() {
		return time_log;
	}

	public void setTime_log(String timeLog) {
		time_log = timeLog;
	}

	public String getUser_code() {
		return user_code;
	}

	public void setUser_code(String userCode) {
		user_code = userCode;
	}
	
	
	public String getTable_desc() {
		return table_desc;
	}

	public void setTable_desc(String tableDesc) {
		table_desc = tableDesc;
	}

	public HashMap<String, String> getField_desc() {
		return field_desc;
	}

	public void setField_desc(String fieldName,String data) {
		this.field_desc.put(fieldName,data);
	}

	public void update(){
		if(this.getNew_value()!=null&&this.getNew_value().size()>0){
		PreparedStatement stm = null;
		CscConnection con = null;
		try {
			con = (CscConnection) StaticProperties.myConnection.getConnection(up.getDbName(),up);
			con.setClassName("EventLog.update");
			con.setAutoCommit(false);
			String sql="insert into leventlog (logid,table_name,field_name,companyid,key_field,date_log,new_value,old_value,refer,time_log,user_code,create_by,create_date,create_time,edit_by,edit_date,edit_time,status,table_desc,field_desc) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			stm = con.prepareStatement(sql);
			Iterator it=this.getNew_value().keySet().iterator();
			String fieldName="";
			while(it.hasNext()){
				  fieldName=(String)it.next();	
			      stm.setString(1,this.getLogid());
			      stm.setString(2,this.getTable_name());
			      stm.setString(3,fieldName);
			      stm.setString(4, this.getCompanyid());
			      stm.setString(5, this.getKey_field());
			      stm.setString(6, this.getDate_log());
			      stm.setString(7, (String)this.getNew_value().get(fieldName));
			      stm.setString(8, (String)this.getOld_value().get(fieldName));
			      stm.setString(9, this.getRefer());
			      stm.setString(10, this.getTime_log());
			      stm.setString(11, (String)this.up.get("employeeid"));
			      stm.setString(12, this.getCreate_by());
			      stm.setString(13, this.getCreate_date());
			      stm.setString(14, this.getCreate_time());
			      stm.setString(15, this.getEdit_by());
			      stm.setString(16, this.getEdit_date());
			      stm.setString(17, this.getEdit_time());
			      stm.setString(18, "update");
			      stm.setString(19, this.getTable_desc());
			      stm.setString(20, (String)this.getField_desc().get(fieldName));
			      stm.addBatch();
			}		
			stm.executeBatch();
			con.commit();
		} catch (SQLException e) {
			try {
				con.rollback();
			} catch (SQLException e1) {
				e1.printStackTrace();
			}
			MyLog.error(this,this.up,">>>>>>>>>>>>>> Can not create <<<<<<<<<<<<<<<"+e.getMessage());
			e.printStackTrace();
		}finally{
			this.closeConnection(stm, con);
	       }
		}
	}

	public void create(){
		PreparedStatement stm = null;
		CscConnection con = null;
		if(this.getNew_value()!=null&&this.getNew_value().size()>0){
		try {
			con = (CscConnection) StaticProperties.myConnection.getConnection(up.getDbName(),up);
			con.setAutoCommit(false);
			con.setClassName("EventLog.create");
			String sql="insert into leventlog (logid,table_name,field_name,companyid,key_field,date_log,new_value,old_value,refer,time_log,user_code,create_by,create_date,create_time,edit_by,edit_date,edit_time,status,table_desc,field_desc) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			stm = con.prepareStatement(sql, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
			Iterator it=this.getNew_value().keySet().iterator();
			String fieldName="";
			while(it.hasNext()){
			  fieldName=(String)it.next();				
		      stm.setString(1,this.getLogid());
		      stm.setString(2,this.getTable_name());
		      stm.setString(3,fieldName);
		      stm.setString(4, this.getCompanyid());
		      stm.setString(5, this.getKey_field());
		      stm.setString(6, this.getDate_log());
		      stm.setString(7, (String)this.getNew_value().get(fieldName));
		      stm.setString(8, (String)this.getOld_value().get(fieldName));
		      stm.setString(9, this.getRefer());
		      stm.setString(10, this.getTime_log());
		      stm.setString(11, (String)this.up.get("employeeid"));
		      stm.setString(12, this.getCreate_by());
		      stm.setString(13, this.getCreate_date());
		      stm.setString(14, this.getCreate_time());
		      stm.setString(15, this.getEdit_by());
		      stm.setString(16, this.getEdit_date());
		      stm.setString(17, this.getEdit_time());
		      stm.setString(18, "create");
		      stm.setString(19, this.getTable_desc());
		      stm.setString(20, (String)this.getField_desc().get(fieldName));
		      stm.executeUpdate();
		      con.commit();
			}
		} catch (SQLException e) {
			try {
				con.rollback();
			} catch (SQLException e1) {
				e1.printStackTrace();
			}			
			MyLog.error(this,this.up,">>>>>>>>>>>>>> Can not delete <<<<<<<<<<<<<<<"+e.getMessage());
			e.printStackTrace();
		}finally{
			this.closeConnection(stm, con);
	       }
	  }
	}
	
	public void delete(){
		PreparedStatement stm = null;
		CscConnection con = null;
		try {
			con = (CscConnection) StaticProperties.myConnection.getConnection(up.getDbName(),up);
			con.setAutoCommit(false);
			con.setClassName("EventLog.delete");
			String sql="insert into leventlog (logid,table_name,field_name,companyid,key_field,date_log,new_value,old_value,refer,time_log,user_code,create_by,create_date,create_time,edit_by,edit_date,edit_time,status,table_desc,field_desc) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			stm = con.prepareStatement(sql, java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);
			String fieldName="companyid";
		      stm.setString(1,this.getLogid());
		      stm.setString(2,this.getTable_name());
		      stm.setString(3,fieldName);
		      stm.setString(4, this.getCompanyid());
		      stm.setString(5, this.getKey_field());
		      stm.setString(6, this.getDate_log());
		      stm.setString(7, "");
		      stm.setString(8, "");
		      stm.setString(9, "");
		      stm.setString(10, this.getTime_log());
		      stm.setString(11, (String)this.up.get("employeeid"));
		      stm.setString(12, this.getCreate_by());
		      stm.setString(13, this.getCreate_date());
		      stm.setString(14, this.getCreate_time());
		      stm.setString(15, this.getEdit_by());
		      stm.setString(16, this.getEdit_date());
		      stm.setString(17, this.getEdit_time());
		      stm.setString(18, "delete");
		      stm.setString(19, this.getTable_desc());
		      stm.setString(20, "");
		      stm.executeUpdate();
		      con.commit();
		} catch (SQLException e) {
			try {
				con.rollback();
			} catch (SQLException e1) {
				e1.printStackTrace();
			}			
			MyLog.error(this,this.up,">>>>>>>>>>>>>> Can not delete <<<<<<<<<<<<<<<"+e.getMessage());
			e.printStackTrace();
		}finally{
			this.closeConnection(stm, con);
	       }
	}
	
	public void clearObject(){
		this.getNew_value().clear();
		this.getOld_value().clear();
		this.getField_desc().clear();
	}
	
	private void closeConnection(PreparedStatement stm,CscConnection con){
		try {
			if(stm!=null)
				stm.close();
		} catch (SQLException e1) {}
		try{
			if(con!=null)
				con.close();
		}catch(Exception ex){}
	}
	
}
