package com.csc.library.mail;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.util.Properties;
import java.util.Vector;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.Authenticator;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeUtility;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class SendMail {
	//String Hostname, From, To, Cc, Subject, Content;
	MyHashMap data=new MyHashMap();
	Vector atchFile;
	private int port = 25;
	protected UProfile			upf=new UProfile();
	protected boolean keepmail=true;
	OutgoingMail outbox=null;

	public SendMail(){
		atchFile = new Vector();
	}
	
	/**
	 * Returns the upf.
	 * @return UProfile
	 */
	public UProfile getUProfile() {
		return upf;
	}
	/**
	 * Sets the upf.
	 * @param upf The upf to set
	 */
	public void setUProfile(UProfile upf) {
		this.upf = upf;
	}
	

	public SendMail(String hostname, String from, String to, String cc, String subject, String content,String referid) {
		String mailServer="";
		String port="";
		if(hostname.equals("")){
			mailServer = new InitialEnvironment("GLOBAL").getValue("MAILCONFIG-mailserver");
        	port = new InitialEnvironment("GLOBAL").getValue("MAILCONFIG-port");
        	this.setMailPort(Integer.parseInt(port));
		}else{
			mailServer = hostname;
		}
		System.out.println("================ Mail ==================");
		System.out.println("mailserver::"+mailServer);
		this.data.put("hostname",mailServer);
		this.data.put("from",from);
		this.data.put("to",to);
		this.data.put("cc",cc);
		this.data.put("subject",subject);
		this.data.put("content",content);
		this.data.put("referid",referid);
		atchFile = new Vector();
	}
	
	public SendMail(String hostname, String from, String to, String cc, String subject, String content) {
		String mailServer="";
		String port="";
		if(hostname.equals("")){
			mailServer = new InitialEnvironment("GLOBAL").getValue("MAILCONFIG-mailserver");
        	port = new InitialEnvironment("GLOBAL").getValue("MAILCONFIG-port");
        	this.setMailPort(Integer.parseInt(port));
		}else{
			mailServer = hostname;
		}
		System.out.println("================ Mail ==================");
		System.out.println("mailserver::"+mailServer);
		this.data.put("hostname",mailServer);
		this.data.put("from",from);
		this.data.put("to",to);
		this.data.put("cc",cc);
		this.data.put("subject",subject);
		this.data.put("content",content);
		this.data.put("referid","");
		atchFile = new Vector();
	}
	
	public void setData(String key,String value){
		this.data.put(key,value);
	}

	//Set Content from a file
	public String setContentFile(String filename) throws IOException {
		FileInputStream in = new FileInputStream(filename);
		byte inbyte[] = new byte[in.available()];
		int byteread = in.read(inbyte, 0, in.available());
		this.data.put("content",new String(inbyte));
		//    this.logger.info(Content);
		in.close();
		return this.data.getString("content");
	}

	public void addAttachFile(String filename) {
		this.atchFile.addElement(filename);
	}

	//force delete one by one
	public void deleteAttachFile(int index) {
		if (index >= 0 && index <= this.atchFile.size())
			this.atchFile.removeElementAt(index);
	}

	//get a list of attach file
	public String getAttachFileString() {
		StringBuffer allFile = new StringBuffer();
		for (int i = 0; i < this.atchFile.size(); i++)
			allFile.append((String) this.atchFile.elementAt(i));
		return allFile.toString();
	}

	public int send() {
		if (this.atchFile.size() > 0){
			return sendMailwithAttach();
		}else{
			return sendMailwithoutAttach();
		}		
	}
	
	private int sendMailwithAttach() {
		Session session = this.setMailProperties();
		//Create a message
		try {
			MimeMessage msg = new MimeMessage(session);
			this.setMessageConfig(msg);

			//Create and fill the first message part
			Multipart mp = new MimeMultipart();
			MimeBodyPart mbp1 = new MimeBodyPart();
			//mbp1.setText(this.data.getString("content"),"windows-874");
			mbp1.setContent(this.data.getString("content"),"text/html; charset=windows-874");
			mp.addBodyPart(mbp1);
			//Create the second message and Attach the file to the message
			for (int i = 0; i < this.atchFile.size(); i++) {
				MimeBodyPart mbp2 = new MimeBodyPart();
				//        this.logger.info("BodyPart2 Filename = "+Filename[i]);
				String fileName = (String) this.atchFile.elementAt(i);
				FileDataSource fds = new FileDataSource(fileName);
				mbp2.setDataHandler(new DataHandler(fds));
				/* comment by pas get filename from filedatasource
				int index = fileName.lastIndexOf("\\");
				String name = fileName.substring(index + 1, fileName.length());
				 * 
				 */
				String name=fds.getName();
				try {
					mbp2.setFileName(MimeUtility.encodeText(name));
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
				mp.addBodyPart(mbp2);
			}
			msg.setContent(mp);
			//Send the message
			Transport.send(msg);
			this.keepMail(null);
			return 1;
		} catch (MessagingException mex) {
			MyLog.error(this, this.upf, mex);
			Exception ex = null;
			if ((ex = mex.getNextException()) != null) {
				MyLog.error(this, this.upf, ex);
				this.keepMail(ex);
			}else{
				this.keepMail(mex);
			}
			return 0;
		}catch(Exception ex){
			this.keepMail(ex);
			return 0;
		}		
	}
	
	/*private int sendMailwithAttach() {
		Session session = this.setMailProperties();
		//Create a message
		try {
			MimeMessage msg = new MimeMessage(session);
			this.setMessageConfig(msg);

			//Create and fill the first message part
			Multipart mp = new MimeMultipart();
			MimeBodyPart mbp1 = new MimeBodyPart();
			mbp1.setText(this.data.getString("content"),"windows-874");
			mp.addBodyPart(mbp1);
			//Create the second message and Attach the file to the message
			for (int i = 0; i < this.atchFile.size(); i++) {
				MimeBodyPart mbp2 = new MimeBodyPart();
				//        this.logger.info("BodyPart2 Filename = "+Filename[i]);
				String fileName = (String) this.atchFile.elementAt(i);
				FileDataSource fds = new FileDataSource(fileName);
				mbp2.setDataHandler(new DataHandler(fds));
				int index = fileName.lastIndexOf("\\");
				String name = fileName.substring(index + 1, fileName.length());
				try {
					mbp2.setFileName(MimeUtility.encodeText(name));
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
				mp.addBodyPart(mbp2);
			}
			msg.setContent(mp,"text/html; charset=windows-874");
			//Send the message
			Transport.send(msg);
			this.keepMail(null);
			return 1;
		} catch (MessagingException mex) {
			MyLog.error(this, this.upf, mex);
			Exception ex = null;
			if ((ex = mex.getNextException()) != null) {
				MyLog.error(this, this.upf, ex);
				this.keepMail(ex);
			}else{
				this.keepMail(mex);
			}
			return 0;
		}catch(Exception ex){
			this.keepMail(ex);
			return 0;
		}		
	}	*/

	private int sendMailwithoutAttach() {
		Session session = this.setMailProperties();
		//Create a message
		try {
			MimeMessage msg = new MimeMessage(session);			
			this.setMessageConfig(msg);			
			//Set the ContentType
			msg.setContent(this.data.getString("content"), "text/html; charset=windows-874");
			//Send the messagemsg
			Transport.send(msg);					
			this.keepMail(null);
			return 1;
		} catch (MessagingException mex) {
			//      this.logger.info("--Exception handling in SendMail.java");
			MyLog.error(this, this.upf, mex);
			Exception ex = null;
			if ((ex = mex.getNextException()) != null){
				MyLog.error(this, this.upf, ex);
				this.keepMail(ex);
			}else{
				this.keepMail(mex);
			}
			return 0;
		}catch(Exception ex){
			this.keepMail(ex);
			return 0;
		}
	}

	private void setMessageConfig(MimeMessage msg) throws MessagingException {
		msg.setFrom(new InternetAddress(this.data.getString("from")));
		msg.setRecipients(Message.RecipientType.TO, InternetAddress.parse(this.data.getString("to"), false));
		msg.setRecipients(Message.RecipientType.CC, InternetAddress.parse(this.data.getString("cc"), false));		
		msg.setSubject(this.data.getString("subject"),"windows-874");
		msg.setSentDate(new Date());
	}

	private Session setMailProperties() {
		//Create some properties and get the default Session
		InitialEnvironment env=new InitialEnvironment("GLOBAL");
		Properties property = System.getProperties();
		property.put("mail.smtp.host", this.data.getString("hostname"));
		property.put("mail.smtp.port", String.valueOf(this.port));
		String password=env.getValue("MAILAUTH-password");
		if(password.trim().length()>0){
			property.put("mail.smtp.auth", "true");
		}else{
			property.put("mail.smtp.auth", "false");
		}
		String keepmail=env.getValue("MAILAUTH-keepmail");
		if(keepmail!=null && keepmail.equals("true")){
			this.keepmail=true;
			outbox=new OutgoingMail(upf);
		}else{
			this.keepmail=false;
		}
		Authenticator auth = new MailAuthenticator();
		Session session = Session.getDefaultInstance(property, auth);
		session.setDebug(true);
		return session;
	}
	
	public void setMailPort(int port){
		this.port = port;
	}
	
	private void keepMail(Exception exmsg){
		if(keepmail){
			try{			
				CscCalendar cs=new CscCalendar();
				outbox.setOutboxid("0");
				outbox.setCompanyid(this.upf.getCompanyid());
				outbox.setEmployeeid(this.upf.getEmvEmpId());
				outbox.setUsernameid(this.upf.getUserId());
				outbox.setSender(this.data.getString("from"));
				outbox.setReceiver(this.data.getString("to"));
				outbox.setCcreceiver(this.data.getString("cc"));
				outbox.setSubject(this.data.getString("subject"));
				outbox.setContent(this.data.getString("content"));
				outbox.setCreate_date(cs.getYYYYMMDD());
				outbox.setCreate_time(cs.getHHMMSS());
				outbox.setCreate_by(this.upf.getEmvEmpId());
				outbox.setEdit_date(cs.getYYYYMMDD());
				outbox.setEdit_time(cs.getHHMMSS());
				outbox.setEdit_by(this.upf.getEmvEmpId());
				outbox.setReferid(this.data.getString("referid"));		
				if(exmsg!=null){
					outbox.setMsgerror(getStackTrace(exmsg.getStackTrace()));
					outbox.sendError();
				}else{
					outbox.setMsgerror("");
					outbox.sendComplete();
				}
			}catch(Exception ex){
				ex.printStackTrace();
			}
		}
	}
	
	public String getStackTrace(StackTraceElement[] traceElements) {
		StringBuilder temp_sb = new StringBuilder();
		for (int i = 2 ; i < traceElements.length ; i++) {
			temp_sb.append(traceElements[i]).append("\n");
		}
		return temp_sb.toString();
	}	
}