package com.csc.library.process;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;

public class WorkflowProcess extends MyProcess {

	@Override
	public Vector getProcessList() {
		Vector vc = new Vector();
		vc.add("All");
		return vc;
	}

	@Override
	public void process() throws Exception {
		DbRecord workflow_data = new InitialRecord(this.getUProfile()).getDbRecord("Workflow_data_notrigger");
		workflow_data.setWFOff();
		workflow_data.setColumn(workflow_data.getListKey() + ",q_status");
		workflow_data.set("runno", (String) this.data.get("runno"));
		workflow_data.search("runno");
		if (workflow_data.foundData()) {
			this.data.put("doc_no", workflow_data.getString("doc_no"));
			workflow_data.set("q_status", "R");
			workflow_data.setWFOff();
			workflow_data.save();
		}
			try {
				Object wf = Class.forName("com.csc.library.databean.util.WFLClassImpl").newInstance();
				Class c = wf.getClass();
				Method m = c.getDeclaredMethod("wfprocess",	new Class[] { HashMap.class });
				m.invoke(wf, new Object[] { this.data });
			} catch (Exception ex) {
				MyLog.error(this, this.getUProfile(), ex);
				workflow_data.set("q_status", "E");
				workflow_data.setWFOff();
				workflow_data.save();
			}
			workflow_data.setColumn(workflow_data.getListKey() + ",q_status");
			workflow_data.search("runno");
			if (workflow_data.foundData()) {
					workflow_data.set("q_status", "F");
					workflow_data.setWFOff();
					workflow_data.save();
		}
	}

}
