package com.csc.library.report;

import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.utilities.MyLog;

public class GenCondition {
	private String condition;
	private Properties filter = new Properties();
	private Vector dataList = new Vector();
	private String operator = "AND OR";

	public GenCondition(String con) {
          //System.out.println("CONDITION BEFER GENERAT"+con);
		try {
			this.condition = con;
			this.setDataToVector();
			this.setDataToHash();
		} catch (RuntimeException e) {
		}
	}
	private void setDataToVector() {
		MyLog.info(this, "CONDITION " + this.condition);
		StringTokenizer st = new StringTokenizer(this.condition, "*");
		while (st.hasMoreTokens()) {
			this.dataList.addElement(st.nextToken());
		}
		MyLog.info("VEC " + this.dataList);
	}

	private void setDataToHash() {
		boolean first = true;
		String temp, key, value;
		boolean foundOperator = false;
		for (int i = 0; i < this.dataList.size(); i++) {
			temp = (String) dataList.elementAt(i);
			temp = temp.trim();
			MyLog.info("TEMP : " + temp);
			if (first) {
				key = temp.substring(0, temp.indexOf(".")).trim();
				value = temp.substring(temp.indexOf(".") + 1, temp.length()).trim();
				this.filter.put(key, value);
				first = false;
			} else {
				if (this.operator.indexOf(temp) == -1) {
					key = temp.substring(0, temp.indexOf(".")).trim();
					value = temp.substring(temp.indexOf(".") + 1, temp.length()).trim();
					if (this.filter.containsKey(key)) {
						this.updateToHash(key, "  " + (String) dataList.elementAt(i - 1) + " " + value);
					} else
						this.insertToHash(key, value);
				} else {
					if (!foundOperator) {
						foundOperator = this.checkOperator((String) dataList.elementAt(i - 1), temp, (String) dataList.elementAt(i + 1));
					}
				}
			}
		}
		MyLog.info("Filter : " + this.filter);
	}

	private boolean checkOperator(String befor, String operator, String affter) {
		String tableBefor, tableAffter;
		tableBefor = befor.substring(0, befor.indexOf("."));
		tableAffter = affter.substring(0, affter.indexOf("."));
		if (!tableBefor.equals(tableAffter)) {
			this.filter.put("operator", operator);
			return true;
		} else
			return false;
	}
	private void insertToHash(String key, String value) {
		this.filter.put(key, value);
	}
	private void updateToHash(String key, String value) {
		String temp = (String) this.filter.get(key);
		temp += value;
		this.filter.put(key, temp);
	}
	public Properties getCondition() {
		return this.filter;
	}
}
