package com.csc.library.report;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Vector;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class GenDataBaseMetaData {
	private String reportxml, dbName, outputPath;
	private ReportMetaData rm;
	private StringBuffer str = new StringBuffer();
	private UProfile upf=null;
	public void setUProfile(UProfile upf){
		this.upf=upf;
	}

	public GenDataBaseMetaData(String reportxml, String outputPath, String dbName) {
		try {
			this.reportxml = reportxml;
			this.dbName = dbName;
			this.outputPath = outputPath;
			rm = new ReportMetaData();
			rm.setReportXml(reportxml);
			rm.process();
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	}

	public void genFile() {
		try {
			File file = new File(this.outputPath);
			FileOutputStream fout = new FileOutputStream(file);
			Vector colName = rm.getColumnName();
			Vector colType = rm.getColumnType();
			Vector colPrecision = rm.getColumnPrecision();
			for (int i = 0; i < colName.size(); i++) {
				str.append(
					(String) colName.elementAt(i)
						+ "\t"
						+ rm.getFieldProperties((String) colType.elementAt(i))
						+ "\t"
						+ String.valueOf(colPrecision.elementAt(i))
						+ "\n");
			}
			byte[] b = str.toString().toUpperCase().getBytes();
			fout.write(b);
			MyLog.debug(this, this.upf, "String out put path : " + this.outputPath);
			MyLog.debug(this, this.upf, "String out put value : " + str.toString());

		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
	}

	public String getOutpurPath() {
		return this.outputPath;
	}
	public String getOutputValue() {
		return this.str.toString();
	}
	public static void main(String[] args) {}
}
