/**
 * @author Somsuksri Kasemsuk
 * @version MyHr Semi final
 * 
 */
package com.csc.library.report;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Properties;
import java.util.Vector;

import com.csc.library.database.FieldManager;
import com.csc.library.database.LoadProTable;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.FileString;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReportXml;
import com.csc.library.utilities.UProfile;

public class ReportMetaData implements ResultSetMetaData {
	    private ReportXml reportXml;
        private Vector vColName, vColType, vColPrecision;
        private HashMap orderByDesc, orderByLabel;
        private Vector componentFieldList, dbFieldList;
        private String dbName, uID;
        private Properties fType,fTypeFull;
        private int orderCount;
        private int precision;
        private LoadProTable propTable;
        private String sign = "__";
        private HashMap recordMap=new HashMap();
        private UProfile upf=null;
        private boolean isFieldObject =false;
        public void setUProfile(UProfile upf){
        	this.upf=upf;
        }
        public String getSign() {
                return this.sign;
        }
   
        public ReportMetaData() {
                fType = new Properties();
                 fTypeFull=new Properties();
                this.initField();
                vColName = new Vector();
                vColType = new Vector();
                vColPrecision = new Vector();
                propTable = new LoadProTable();
                orderByDesc = new HashMap();
                orderByLabel = new HashMap();
        }
        public String getReferLang(){
                return this.reportXml.getReferLang();
        }
        protected void initField() {
                fType.setProperty("String", "12");
                fType.setProperty("Integer", "4");
                fType.setProperty("AutoNumber", "4");
                fType.setProperty("Double", "8");
                fType.setProperty("BigDecimal", "8");
                fType.setProperty("Decimal", "8");
                fType.setProperty("Date", "91");
                fType.setProperty("Float", "8");
                fType.setProperty("Time", "92");
                fType.setProperty("TimeStamp", "93");

                fType.setProperty("12", "java.lang.String");
                fType.setProperty("4", "java.lang.Integer");
                fType.setProperty("8", "java.lang.Double");
                fType.setProperty("91", "java.sql.Date");
                fType.setProperty("92", "java.sql.Time");
                fType.setProperty("93", "java.sql.Timestamp");

                fTypeFull.setProperty("12", "java.lang.String");
                fTypeFull.setProperty("4", "java.lang.Integer");
                fTypeFull.setProperty("8", "java.lang.Double");
                fTypeFull.setProperty("91", "java.sql.Date");
                fTypeFull.setProperty("92", "java.sql.Time");
                fTypeFull.setProperty("93", "java.sql.Timestamp");

        }


        private void setOrderByField() {
                FieldManager pField = null;
                String table, fieldName, type, orderName, order;
                //reportMetaDataXml = new ReportXml(this.reportXml, dbName);
                Vector orderList = reportXml.getGroupByList();
                try {
                        for (int i = 0; i < orderList.size(); i++) {
                                order = (String) orderList.elementAt(i);
                                table = order.substring(0, order.indexOf("."));
                                fieldName = order.substring(order.indexOf(".") + 1, order.length());
                                orderName = "orderby" + (i + 1);
                                pField = this.getPropertieField(table, fieldName);
                                precision = pField.getWidth();
                                type = pField.getType();
                                
                                vColName.add(orderName);
                                vColType.add(this.fType.getProperty(type));
                                vColPrecision.add(new Integer(precision));
                                
                                vColName.add(orderName+"desc");
                                vColType.add("12");
                                vColPrecision.add(new Integer(250));                                
                                this.orderCount += 1;
                        }
                } catch (Exception ex) {
        			MyLog.error(this, this.upf, ex);
                }

        }

        public Vector getFieldDesc() {
                Vector field = new Vector();
                field.add(this.dbFieldList);
                field.add(vColName);
                field.add(vColType);
                field.add(vColPrecision);
                return field;
        }
        
        private void setDbField() {
                String table = "", fieldName = "", type = null;
                FieldManager pField = null;
                dbFieldList = new Vector();
                Vector field = reportXml.getAllField();
                String dbf = "";
                HashMap simtype=reportXml.getSimType();
                String stype,sprecision,temp;
                try {
                        for (int i = 0; i < field.size(); i++) {
                                try {
									dbf = (String) field.elementAt(i);
									table = dbf.substring(0, dbf.indexOf("."));
									fieldName = dbf.substring(dbf.indexOf(".") + 1, dbf.length());
									if(table.indexOf("$")!=-1){
										table=table.substring(table.indexOf("$")+1,table.length());
									}
//									System.out.println("TABLE : "+table+" fieldName : "+fieldName);
									pField = this.getPropertieField(table, fieldName);
									if(simtype.containsKey(dbf.toLowerCase())){
									        temp=(String)simtype.get(dbf.toLowerCase());
									        stype=temp.substring(0,temp.indexOf(":"));
									        sprecision=temp.substring(temp.indexOf(":")+1,temp.length());
									        type=stype;
									        precision =Integer.parseInt(sprecision);
									}else{
									        type = (String) pField.getType();
									        precision =  pField.getWidth();
									}
									vColName.add(table.toLowerCase() + sign + fieldName.toLowerCase());
									vColType.add(this.fType.getProperty(type));
									vColPrecision.add(new Integer(precision));
									dbFieldList.add(table.toLowerCase() + sign + fieldName.toLowerCase());
								} catch (RuntimeException e1) {
									// TODO Auto-generated catch block
									System.err.println(this.getClass().getName()+": Cannot get Properties "+fieldName);
									e1.printStackTrace();
								}
                        }
                } catch (Exception e) {
                		MyLog.error(this, this.upf, "------------------------Error In ReportMetaData Method getPropertieField : Table : " + table + " Field : " + fieldName);
            			MyLog.error(this, this.upf, e);
                }
        }
        private void setVirtualField(){
                HashMap pField = null;
                String fieldName, type,table;
                Vector vList = reportXml.getVFieldList();
//                FieldManager fm= null;
                try {
                        for (int i = 0; i < vList.size(); i++) {
                                pField=(HashMap)vList.elementAt(i);
                                fieldName = (String) pField.get("name");
                                table = fieldName.substring(0, fieldName.indexOf("."));
//                                fm=this.getPropertieField(table, fieldName);
                                //if(fm==null){
                                fieldName = fieldName.substring(fieldName.indexOf(".") + 1, fieldName.length());
                                precision = Integer.parseInt((String) pField.get("size"));
                                type = (String) pField.get("type");
                                
                                if(fieldName.indexOf("$")!=-1){
                                	FileString fs=new FileString();
                                	fs.setData(fieldName);
                                	fieldName=fs.replaceAll("$","9_9");
                                }
                                
                                if(!vColName.contains((table.toLowerCase() + sign + fieldName.toLowerCase()))){
                                		vColName.add(table.toLowerCase() + sign + fieldName.toLowerCase());
                                		vColType.add(this.fType.getProperty(type));
                                		vColPrecision.add(new Integer(precision));
                                		dbFieldList.add(table.toLowerCase() + sign + fieldName.toLowerCase());
                                  }
                                //}
                        }
                } catch (Exception ex) {
        			MyLog.error(this, this.upf, ex);
                }
        }

        public String getFieldProperties(String key) {
            try {
                return this.fType.getProperty(key);
            } catch (Exception e) {
    			MyLog.error(this, this.upf, e);
                 return null;
            }
        }
        
        public String getFieldPropertiesFull(String key) {
             try {
                 return this.fTypeFull.getProperty(key);
             } catch (Exception e) {
    			MyLog.error(this, this.upf, e);
                 return null;
             }
        }

		public String getRequiredFound(){
			return this.reportXml.getRequiredFound();

        }
		
		public void setFieldObject(String template){
			Vector vtmp=this.reportXml.getTemplate();
			HashMap hm=null;
			for(int v=0;v<vtmp.size();v++){
				    hm=(HashMap)vtmp.get(v);
				   if( hm.get("name").toString().equalsIgnoreCase(template)){
				   	    this.isFieldObject=(hm.get("isfieldobject").toString().equals("1") )?true:false;
				   	    break;
				   }
			}
		}

		/**
		 * @return Returns the isFieldObject.
		 */
		public boolean isFieldObject() {
			return isFieldObject;
		}

        private FieldManager getPropertieField(String table, String fieldName) {
			DbRecord db = null;
			FieldManager fm = null;
			try {
				if (this.recordMap.containsKey(table.toUpperCase())) {
					db = (DbRecord) this.recordMap.get(table.toUpperCase());
				} else {
					db = new InitialRecord(this.upf).getDbRecord(table);
					this.recordMap.put(table.toUpperCase(), db);
				}
				fm = db.getField(fieldName);
			} catch (Exception ex) {
				MyLog.error(this, this.upf, ex);
			}
			return fm;
        }

        public void process() throws Exception {
                this.setDbField();
                this.setVirtualField();
                this.setOrderByField();
                MyLog.info(this, "Field " + vColName);
                MyLog.info(this, "Type " + vColType);
                MyLog.info(this, "Pre " + vColPrecision);
                this.recordMap.clear();
        }
        public HashMap getFieldOrderDesc() {
                return this.orderByDesc;
        }

        public HashMap getFieldOrderLabel() {
                return this.orderByDesc;
        }

        public void setFieldOrderDesc(String key, String field) {
                String value = "";
                String fieldName[]=field.split(" ");
                value = reportXml.getGroupByDesc(fieldName[0]);
                this.orderByDesc.put(key, value);
        }

        public void setFieldOrderLabel(String key) {
                String value = "";
                value = reportXml.getLabel(key);
                this.orderByLabel.put(key, value);
        }

        public Vector getDbFieldList() {
                return this.dbFieldList;
        }

        public Vector getComponentFieldList() {
                return this.componentFieldList;
        }

        public int getColumnCount() {
                return vColName.size();
        }

        public int getColumnOrderCount() {
                return this.orderCount;
        }

        public String getColumnName(int column) throws SQLException {
                if (column <= 0 || column > getColumnCount()) {
                        throw new SQLException("The index is out of bound");
                }
                return (String) vColName.elementAt(column - 1);
        }

        public int getColumnType(int column) throws SQLException {
                if (column < 0 || column > getColumnCount()) {
                        throw new SQLException("The index is out of bound");
                }
                try {
                        int type = 0;
                        if(column==0)
                        	type=Integer.parseInt((String) vColType.elementAt(column));
                        else
                        	type=Integer.parseInt((String) vColType.elementAt(column-1));
                        return type;
                } catch (NumberFormatException ex) {
//                		MyLog.error(this, this.upf, ex);
                        return java.sql.Types.VARCHAR;
                }
        }

        public String getColumnTypeName(int column) throws SQLException {
                if (column <= 0 || column > getColumnCount()) {
                        throw new SQLException("The index is out of bound");
                }
                return (String) vColType.elementAt(column - 1);
        }

        public int getPrecision(int column) throws SQLException {
	            if (column <= 0 || column > getColumnCount()) {
	                    throw new SQLException("The index is out of bound");
	            }
	            return Integer.parseInt(vColPrecision.elementAt(column - 1).toString());
        }

        public void setReportXml(String reportXml) {
             this.reportXml = new ReportXml(reportXml,this.dbName,this.upf);
        }
        
        public void setReportXml(ReportXml reportXml) {
             this.reportXml = reportXml;
             this.reportXml.setUProfile(this.upf);
        }
        
        public void setDbName(String dbName){
             this.dbName=dbName;
        }


        public int getColumnDisplaySize(int column) {
                return 10;
        }
        public int getScale(int column) {
                return 0;
        }
        public int isNullable(int column) {
                return ResultSetMetaData.columnNoNulls;
        }
        public String getColumnLabel(int column) {
                return null;
        }
        public boolean isSigned(int column) {
                return false;
        }
        public String getSchemaName(int column) {
                return null;
        }
        public String getTableName(int column) {
                return null;
        }
        public String getCatalogName(int column) {
                return null;
        }
        public boolean isReadOnly(int column) {
                return false;
        }
        public boolean isWritable(int column) {
                return false;
        }
        public boolean isDefinitelyWritable(int column) {
                return false;
        }
        public boolean isAutoIncrement(int column) {
                return false;
        }
        public boolean isCaseSensitive(int column) {
                return false;
        }
        public boolean isSearchable(int column) {
                return false;
        }
        public boolean isCurrency(int column) {
                return false;
        }
        public String getColumnClassName(int column) {
                return null;
        }
        public Vector getColumnName() {
                return vColName;
        }
        public Vector getColumnType() {
                return vColType;
        }
        public Vector getColumnPrecision() {
                return vColPrecision;
        }
        
        public String getRequireFoundTable(){
        	return this.reportXml.getRequireFoundTable();
        }
        
        public int getColumnNumber(String columnName) {
        	return vColName.indexOf(columnName);
        }
        
        public int getColumnType(String columnName) {
        	int n = this.getColumnNumber(columnName.toLowerCase());
        	try {
				n = this.getColumnType(n);
			} catch (SQLException e) {
				MyLog.error(this,this.upf,"!!!! Not Found "+columnName+" in DBXML\nException "+e.getSQLState()+" : "+e.getMessage());				
			}
        	return n;
        }
		public boolean isWrapperFor(Class<?> iface) throws SQLException {
			// TODO Auto-generated method stub
			return false;
		}
		public <T> T unwrap(Class<T> iface) throws SQLException {
			// TODO Auto-generated method stub
			return null;
		}
}
