package com.csc.library.report;
import java.lang.reflect.Method;
import java.sql.Date;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Properties;
import java.util.StringTokenizer;

import com.csc.library.database.SystemCode;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.CurrencyToEng;
import com.csc.library.utilities.CurrencyToThai;
import com.csc.library.utilities.FileString;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadFile;
import com.csc.library.utilities.UProfile;
import com.csc.library.utilities.WriteFile;
public class ReportUDF {
	private String[][] sysCode = {{"", "" }};
	private String str_default="";
	public String getDateFormat(Date value, String format) {
		CscCalendar cs = new CscCalendar(value);
		try {
			Method m = cs.getClass().getDeclaredMethod("get" + format, new Class[] {});
			return (String) m.invoke(cs, new Object[] {});
		} catch (Exception ex) {
			MyLog.error(this, ex);
			return null;
		}
	}

	public String getSystemCode(String validCode, String lang, String key) {
		this.setValidCode(validCode, lang);
		String value = "", tmpKey = "";
		for (int point = 0; point < sysCode.length; point++) {
			tmpKey = sysCode[point][0];
			if(sysCode[point][1].indexOf(",")!=-1){
				if (lang.equalsIgnoreCase("eng")) {
					value = sysCode[point][1].substring(0, sysCode[point][1].indexOf(","));
				} else {
					value = sysCode[point][1].substring(sysCode[point][1].indexOf(",")+1);
				}
			}else{
				value = sysCode[point][1];				
			}
			if (tmpKey.equals(key))
				return value;
	/*		value = sysCode[point][1];
			if (tmpKey.equals(key))
				return value;*/
		}
		return "";
	}

	public String getTimeShort() {
		CscCalendar cs=new CscCalendar();
		return cs.getTimeShort();
	}

	public String getDateShort() {
		CscCalendar cs=new CscCalendar();
		return cs.getDateShort();
	}

	public String getTimeFull() {
		CscCalendar cs=new CscCalendar();
		return cs.getTimestamp().toString();
	}

        public String getDDMMYYYY(){
                CscCalendar cs=new CscCalendar();
                String tm=String.valueOf(cs.getDate())+"/"+String.valueOf(cs.getMonth()+1)+"/"+String.valueOf(cs.getYear());
                return tm;
        }
        /**
         * ѹ͡ٻẺ yyyy/mm/dd
         * @param cs ѹ ͧŧ                                                   
         */  
        public String getYYYYMMDD(CscCalendar cs){
            String tm=String.valueOf(cs.getYear())+"/"+String.valueOf(cs.getMonth()+1)+"/"+String.valueOf(cs.getDate());
            return tm;
        }
        /**
         * ѹ͡ٻẺ yy/mm/dd
         * @param cs ѹ ͧŧ                                                   
         */  
        public String getYYMMDD(CscCalendar cs){
            String tm=String.valueOf(cs.getEngYY())+"/"+String.valueOf(cs.getMonth()+1)+"/"+String.valueOf(cs.getDate());
            return tm;
        }
        
        public String getHHMMSS(){
               CscCalendar cs=new CscCalendar(); 
               return cs.getHHMMSS();

        }
		public String getRoundD(String d){
          FormulaString fs=new FormulaString();
          return fs.RoundD(d);
        }
        
        public String getDHM(String m,String h){
            int min=Integer.parseInt(m);
            double hr=Double.parseDouble(h);
            FormulaString fs=new FormulaString();           
            return fs.MTODhm(min,hr);
        }

        public String getAbsolute(String s){
          if(s.indexOf("-")>-1){
            s=s.substring(1,s.length());
          }
          return s;
        }

	public String getMoneyToText(String lang,int money){
		if(lang.equalsIgnoreCase("eng"))
			return new CurrencyToEng(money).getString();
		else return new CurrencyToThai(money).getString();
	}

	public String getMoneyToText(String lang,double money){
		if(lang.equalsIgnoreCase("eng"))
			return new CurrencyToEng(money).getString();
		else return new CurrencyToThai().getString(money);
	}

	public String getMoneyToText(String lang,Integer money){
		if(lang.equalsIgnoreCase("eng"))
			return new CurrencyToEng(money.intValue()).getString();
		else return new CurrencyToThai(money.intValue()).getString();
	}

	public String getMoneyToText(String lang,Double money){
		if(lang.equalsIgnoreCase("eng"))
			return new CurrencyToEng(money.doubleValue()).getString();
		else return new CurrencyToThai(money.doubleValue()).getString();
	}

	
	public String getMoneyToText(String lang,String money){
		if(lang.equalsIgnoreCase("eng")){
			//return new CurrencyToEng(money).getString();
			//edit by lieang 07-03-2006 ӡ¡ constructor ᷹
			return	new CurrencyToEng().getString(money);
		}else{
			//edit by lieang 07-03-2006 ӡ¡ constructor ᷹
			return new CurrencyToThai().getString(money);
		} 
	}

	
	public String getMoneyText(String lang,Double money){
		if(lang.equalsIgnoreCase("eng"))
			return new CurrencyToEng().getString(money.doubleValue());
		else return new CurrencyToThai().getString(money.doubleValue());
	}
	
	
	private void setValidCode(String validCode, String lang) {
		SystemCode sys = new SystemCode();
		if ((validCode != null) && (lang != null)) {
			sysCode = SystemCode.getContent(validCode);
		/*	for (int point = 0; point < sysCode.length; point++) {
				if (sysCode[point][1].indexOf(",") > 0) {
					if (lang.equalsIgnoreCase("eng")) {
						sysCode[point][1] = sysCode[point][1].substring(0, sysCode[point][1].indexOf(","));
					} else {
						sysCode[point][1] = sysCode[point][1].substring(sysCode[point][1].indexOf(",")+1);
					}

				}
			}*/
		}
	}
        public Boolean checkGroupPrint(String orderByValue){
          if(orderByValue != null && orderByValue.equalsIgnoreCase(""))
            return new Boolean (false);
          else return new Boolean(true);
        }
        
     public String getYmd2D(String  age){
            FormulaString fs=new FormulaString();            
            return String.valueOf(fs.ymd2day(age));
        }
        
        public String getD2Ymd(String age){
            FormulaString fs=new FormulaString();
            return fs.day2ymd(Integer.parseInt(age));
        }
        
    public String getCurrentMonth(){
    	CscCalendar c = new CscCalendar();
    	return "01/"+c.getMM()+"/"+c.getThaiYY()+" - "+c.getEndDateOfMonth()+"/"+c.getMM()+"/"+c.getThaiYY();
    }
    
    public String getMonth(String lang,String date){
        CscCalendar c = new CscCalendar(date);
        if(lang.equalsIgnoreCase("ENG")){        	
            return c.getEngLongMonth();
        }else{
        	return c.getThaiLongMonth(); 
        }
    }
    
    public String getYear(String date){
        CscCalendar c = new CscCalendar(date);
        return ""+c.getYear();
    }
    
   public String getYear(String lang,String date){
        CscCalendar c =null;
        String years="";
        try{
        	c=new CscCalendar(date);
        }catch(Exception ex){
        	c=new CscCalendar();
        }
    	if(lang.equalsIgnoreCase("ENG")){
    		years=String.valueOf(c.getYear());
    	}else{
    		years=String.valueOf(c.getThaiYYYY());
    	}
        return years;
    }
    
    public String getDay(String date){
        CscCalendar c = new CscCalendar(date);
        return ""+c.getDate();
    }
    
    public String getFullLongDate(String lang,String date){
        /**
         *  աá͡ return  ѹѨغѹ
         */        
        CscCalendar c =null;
        try{
            c=new CscCalendar(date);
        }catch(Exception ex){
			MyLog.error(this, ex);
            c=new CscCalendar(); 
        }
        if(lang.equalsIgnoreCase("ENG")){
            return c.getEngLongMonth()+", "+c.getDate()+" "+c.getEngYYYY();
        }else{
        	return c.getDate()+" "+c.getThaiLongMonth()+" "+c.getThaiYYYY();
        }        
    }
    
    public String getFullLongDate(String lang,String date,int operate,int numdate){
        /**
         *  աá͡ return  ѹѨغѹ
         * @param operate 㹡õǨͺҨкǡźѹ ¶ ҡѺ 0 ź 
         *                                        ҡ 0 кǡ
         *@param numdate ӹǹѹͧúǡź                                                          
         */        
        CscCalendar c =null;
        try{
            c=new CscCalendar(date);
                if(operate>0){
                    c.incDate(numdate);
                }else{
                    c.decDate(numdate);
                }
        }catch(Exception ex){
			MyLog.error(this, ex);
            c=new CscCalendar(); 
        }
        if(lang.equalsIgnoreCase("ENG")){
            return c.getEngLongMonth()+", "+c.getDate()+" "+c.getEngYYYY();
        }else{
            return c.getDate()+" "+c.getThaiLongMonth()+" "+c.getThaiYYYY();
        }        
    }

    
    public String getFullDate(String lang,String date){
        /**
         *  աá͡ return  ѹѨغѹ
         */
        CscCalendar c = null;
        try{
            c=new CscCalendar(date);
        }catch(Exception ex){
			MyLog.error(this, ex);
            c=new CscCalendar(); 
        }
        if(lang.equalsIgnoreCase("ENG")){
            return c.getEngShortMonth()+", "+c.getDate()+" " +c.getEngYY();
        }else{
        	return c.getDate()+" "+c.getThaiShortMonth()+" "+c.getThaiYY();
        }        
    }
    
    public String getFullDate(String lang,String date,int operate,int numdate){
        /**
         *  աá͡ return  ѹѨغѹ
         * @param operate 㹡õǨͺҨкǡźѹ ¶ ҡѺ 0 ź 
         *                                        ҡ 0 кǡ
         *@param numdate ӹǹѹͧúǡź                                                          
         */        
        CscCalendar c = null;
        try{
            c=new CscCalendar(date);
                if(operate>0){
                    c.incDate(numdate);
                }else{
                    c.decDate(numdate);
                }
        }catch(Exception ex){
			MyLog.error(this, ex);
            c=new CscCalendar(); 
        }
        if(lang.equalsIgnoreCase("ENG")){
            return c.getEngShortMonth()+", "+c.getDate()+" "+c.getEngYY();
        }else{
            return c.getDate()+" "+c.getThaiShortMonth()+" "+c.getThaiYY();
        }        
    }

    public String getMM(String date){
        CscCalendar c = new CscCalendar(date);
        return c.getMM();
    }
    
    public String getSubYY(String date){
        int a[];
        CscCalendar c = new CscCalendar();
        CscCalendar data = new CscCalendar(date);
        a= c.getArrayAge(data);
       // System.out.println(a[0]+"  <<>>  "+a[1]+"  <<>>   "+a[2]);
        return a[0]+"";
    }
    
    public String getSubMM(String date){
        int a[];
        CscCalendar c = new CscCalendar();
        CscCalendar data = new CscCalendar(date);
        a= c.getArrayAge(data);
       // System.out.println(a[0]+"  <<>>  "+a[1]+"  <<>>   "+a[2]);
        return a[1]+"";
    }
    
    public String getSubDD(String date){
        int a[];
        CscCalendar c = new CscCalendar();
        CscCalendar data = new CscCalendar(date);
        a= c.getArrayAge(data);
       // System.out.println(a[0]+"  <<>>  "+a[1]+"  <<>>   "+a[2]);
        return a[2]+"";
    }
    
    public String getDOWeng(String lang,String date){
        CscCalendar c = new CscCalendar(date);
        if(lang.equalsIgnoreCase("ENG")){
            return c.getDOWeng();
        }else{
        return c.getDOWthi();
        }
    }
    
    
    /***
     * 
     * edit by lieang ӡ override method Ѻӡ觵÷ Double  
     * ¹   ҷ
     * @param tm
     * @return
     */
    public String getTime2Min(Double tm){
        FormulaString fs=new FormulaString();
        return ""+fs.Tm_To_Min(tm.doubleValue());
    }
    
    /***
     * 
     * edit by lieang ӡ override method Ѻӡ觵÷ Double  
     * ¹ ҷ  
     * @param tm
     * @return
     */
    public String getMin2Time(Double tm){
        FormulaString fs=new FormulaString();
        return ""+fs.Min_to_tm((int)tm.doubleValue());
    }
    
    
    public String getTime2Min(String tm){
    	String value="0";
    	try {
        FormulaString fs=new FormulaString();
        	if (tm==null || tm.equals("")) tm = "0";
        	value = ""+fs.Tm_To_Min(Double.parseDouble(tm));
    	} catch (Exception e) {
			MyLog.error(this, e);
    }
        return value;
    }
     
    public String getMin2Time(String tm){
    	/**
    	 * Author : Nuiss
    	 * Date : 26/11/2552
    	 * Logic :  argument tm  (.) Ҵ 
    	 * <br>Integer.parseInt(tm)  error
    	 */
    	String value="0";
    	if(tm.indexOf(".")>=0){
    		String[] tmValue = tm.replace(".",":").split(":");
    		tm=tmValue[0];
    	}
    	try {
        FormulaString fs=new FormulaString();
        	if (tm==null || tm.equals("")) tm = "0";
        	value = ""+fs.Min_to_tm(Integer.parseInt(tm));
    	} catch (Exception e) {
			MyLog.error(this, e);
    }
        return value;        
    }
        
    /**
	 * author by lieang 2005/07/18
	 * This method check the date is equlas nowdate
	 * if equals return "";  
	 */
	public String IsCurrentdate(String date){
		String output	=	"";
		CscCalendar	cc	=	new	CscCalendar();
		if(!cc.getYYYYMMDD().equals(date)){
			output	=	date;
		}
		return output;
	}
	
	/**
	 * author by lieang  2005/07/19
	 * This mehtode check the pvf_type and macth the sign to
	 * PR064 REPORT 
	 * @param pvf_type
	 * @param lang
	 * @return output
	 */
	public String getSIGN_PVF_TYPE(String pvf_type , String lang){
		String output	=	"";
		if(pvf_type.equals("2")){
			if(lang.equalsIgnoreCase("eng")){
				output	= "Bath";
			}else{
				output	= "ҷ";		
			}
		}else if(pvf_type.equals("1")){
				output	=	"%";
		}
		return output;
	}
    
	/**
	 * author by lieang  2005/07/26
	 * ӡ͡ format ѹѺ§ҹ mode ¨  .
	 *  mode  繻 .
	 * @param date
	 * @param lang
	 * @return
	 */
	public String getThaiOrEngDate(String date , String lang){
		String output	=	"";
		if(lang.equalsIgnoreCase("tha")){
			output	=	new CscCalendar(date).getThaiDDMMYYYY(); 
		}else{
			output	=	new CscCalendar(date).getDDMMYYYY();
		}
		return output;
	}
	
	/**
	 * author by lieang 2005/09/02
	 * ӡҤᵡҧ
	 * @param current
	 * @param last
	 * @return
	 */
	public String getPer_diff(String current , String last){
		double	output		=	0.0;
		double	c   =	Double.parseDouble(setParamDefault(current,"0.0"));
		double	l	=	Double.parseDouble(setParamDefault(last,"0.0"));
		if(c>0.0){
			output = (Math.abs(l - c) / c) * 100.0;
		}
		return	String.valueOf(output);
	}
	
	/**
	 * author by lieang 2005/09/02 
	 *  methode Ѻ૵ҵҧѺ parameter
	 * @param st
	 * @param value
	 * @return
	 */
	public String setParamDefault(String st , String value){
		String	output	=	st;
		if((st.equals(""))||(st == null)){
			output	=	value;
		}
		return	output;
	}	
	
	public String calPercent(double all,double sec){
		double temp = (sec*100.0)/all;
		if(all==0) return String.valueOf(0);
		else return this.setFormatDec(temp);
	}
	
	public String setFormatDec(double d){
		DecimalFormat nformat = new DecimalFormat("#.##");
		return nformat.format(d);
	}
	
	public String getMonthName(String mon,String lang){
		String output="";
		String defaultdate="";
		if(mon != null && !mon.equalsIgnoreCase("")){
		if(mon.length()==1)defaultdate = "2005-0"+mon+"-01";
		else defaultdate = "2005-"+mon+"-01";
		CscCalendar monName = new CscCalendar(defaultdate);
		if(lang.equalsIgnoreCase("tha")){
			output	=	monName.getThaiMonth(); 
		}else{
			output	=	monName.getEngLongMonth();
		}
		}else output="";
		return output;
		
	}
	
	public String getDoubleFormat(String value,String newformat) {
		String output = "";
		String format = "#,###,##0.00";
		value = value.replaceAll(",","");
		if(value ==null || value.equals("") || value.equalsIgnoreCase("null")){
			value="0";
		}
		if (newformat != null && !newformat.equals("")) {
			format = new String(newformat);
		}
		DecimalFormat df = new DecimalFormat(format);
		output = df.format(Double.parseDouble(value));
		return output;
	}
	
	/**
	 * 
	 *  method ӡ˹ʴ繤ź ʹ
	 * author by lieang 
	 * @param value
	 * @return
	 */
	public Double setMinusData(Double value){
		Double output;
		double check = value.doubleValue();
		if(check != 0 ){
			check	= check*(-1);
		}	 
		output	=	Double.valueOf(String.valueOf(check));
		return output;
	}

	
	//㹡ûѴ OT ͧ EasyBuy	
	public String getRoundOTEasy(String value){
		String result="";
		try {
			String tmp = String.valueOf(value);
			double num = Double.valueOf(tmp.substring(0, tmp.indexOf("."))).doubleValue();
			double decimal = Double.valueOf(tmp.substring(tmp.indexOf("."), tmp.length())).doubleValue();
			String tmpTime = this.getDoubleFormat(String.valueOf(decimal),"0.00");
			tmpTime = tmpTime.replaceAll(",","");
			decimal = Double.parseDouble(tmpTime);
			double resultRound = 0;
			if (decimal<=0.07) {
				resultRound = 0;
			} else if (decimal>=0.08 && decimal<=0.22) {
				resultRound = 0.15;
			} else if (decimal>=0.23 && decimal<=0.37) {
				resultRound = 0.30;
			} else if (decimal>=0.38 && decimal<=0.52) {
				resultRound = 0.45;
			} else if (decimal>=0.53 && decimal<=0.60) {
				resultRound = 1;
			}
			double data = num+resultRound;
			return this.getDoubleFormat(String.valueOf(data),"");
		} catch (Exception e) {
			MyLog.error(this, e);
			result=value;
		}
		return result;
	}

	
	public String getTimeRate(String time, String hour) {
		String result="0.00";
		double t = Double.parseDouble(time);
		double h = Double.parseDouble(hour);
		double value = 1/(h/t);
		if (String.valueOf(value).equalsIgnoreCase("NaN")) {
			value = 0;
		}
		if (String.valueOf(value).equalsIgnoreCase("NaN")) {
			value = 0;
		}		
		DecimalFormat df = new DecimalFormat("0.00");
		result = df.format(value);
		return result;
	}
	
	//¹Ҩҡҹ100 繰ҹ60
	public String changBaseToTime(String time){
		String result="0.00";
		try {
			DecimalFormat df = new DecimalFormat("0.00");
			CscTime c = new CscTime(Float.parseFloat(time));
			result = df.format(Double.parseDouble(String.valueOf(c.getFloat())));
		} catch (Exception e) {
			MyLog.error(this, e);
			result=time;
		}
		return result;
	}	
	
	/***
	 * 
	 * edit by lieang method Ѻӡ Ҥҧѹ
	 * @param startdate
	 * @param enddate
	 * @param postfix
	 * @param lang
	 * @param flag ͵Ǩͺҵͧ   ͹ ѹ
	 * @return
	 */
	public String getCountAges(String st,String end, boolean postfix, String lang, boolean flag) {
		String output	=	"";
		CscCalendar	startdate;
		CscCalendar	enddate;
		if(!st.equals("")){
			startdate	=	new CscCalendar(st);
	        if(!end.equals("")){
	        	enddate	=	new CscCalendar(end);
	        }else{
	        	enddate	=	new CscCalendar();
}
			int[] dates = startdate.getCountDMY(enddate); 
	        String year = String.valueOf(dates[0]);
	        String month = String.valueOf(dates[1]);
	        String day = String.valueOf(dates[2]);
	        
	       if(postfix){ 
	           String mytxt[] = new String[3];
	           if (lang.equalsIgnoreCase("eng")) {
		           mytxt[0] = " Year ";
		           mytxt[1] = " Month ";
		           mytxt[2] = " Day ";
	           }else{
	               mytxt[0] = "  ";
	               mytxt[1] = " ͹ ";
	               mytxt[2] = " ѹ ";
	           }           
		       if (year.length() >0)
		           year =  year + mytxt[0];
		       if (month.length() >0)
		           month = month+ mytxt[1];
		       if (day.length() >0)
		           day = day+  mytxt[2];
	       }else{
	           if (year.length() > 0)
	                year +=":" ;
	            if (month.length() >0)
	                 month+=":";
	      }
	       if(flag){
	       		output	= year + month + day;
	       } else{
	       		output	= year + month;
	       }	
		}
		return	output;
	}
	
	/***
	 * 
	 * edit by joy method ѺҨӹǹŢ˹ҷȹ
	 * @param input
	 * @return str
	 */
	public String getNumberBefore(String input){
		System.out.println("output=================================>"+input);
		String str="";
		try{
			str=input.substring(0,input.indexOf("."));
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return str;
	}
	
	
	/**
	 * 
	 * 
	 *   Ѻӡ  substring  ѡҵͧ
	 *  Ѻ§ҹ PRR043_3
	 *  
	 * @return
	 */
	public String getColBranch(String branch , int st , int end){
		String output	=	"";
		try{
			if(branch.length()<6){
				FileString fs = new FileString();
				output	=  fs.addBlank(6, "0", "right", branch).substring(st,end); 
			}else{
				output	= branch.substring(st,end);
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	
	/***
	 * 
	 * edit by joy method ѺҨӹǹŢѧȹ
	 * @param input
	 * @return str2
	 */
	public String getNumberAfter(String input){
		String str2=input.substring(input.indexOf(".")+1,input.length());
		if(str2.length()<2){
			str2=str2+"0";
		}
			return str2;
	}
	
	/**
	 * 
	 * edit by lieang 09-02-2006
	 * ӡ set format ѵûЪҪ 
	 * @param id
	 */
	public String genFormatID_PEOPLE(String id){
		String output	= 	"";
		try{
			if(id.length()==13){
				output	=	id.substring(0,1)+"-"+
							id.substring(1,5)+"-"+
							id.substring(5,10)+"-"+
							id.substring(10,12)+"-"+
							id.substring(12,13);	
			}		
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	/**
	 * 
	 * edit by lieang 09-02-2006
	 * ӡ set format ѵûЪҪ 
	 * @param id
	 */
	public String genFormatID_TAX(String id){
		String output	= 	"";
		try{
			if(id.length()== 10){
				output	=	id.substring(0,1)+"-"+
							id.substring(1,5)+"-"+
							id.substring(5,9)+"-"+
							id.substring(9,10);
			}		
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	
	/**
	 * 
	 * edit by lieang 09-02-2006
	 * ӡ set format branchid ѡ 
	 * @param id
	 */
	public String genFormat_BranchID(String id,int st , int end){
		String output	= 	"";
		try{
			if(id.length()==6){
				output	=	id.substring(st,end);
			}		
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	/**
	 * 
	 * edit by lieang 09-02-2006
	 * ӡ set format zipcode ѡ 
	 * @param id
	 */
	public String genFormat_ZIPCODE(String id,int st , int end){
		String output	= 	"";
		try{
			if(id.length()==5){
				output	=	id.substring(st,end);
			}		
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	
	/**
	 * 
	 * edit by lieang 09-02-2006
	 * ӡ set format taxid ѡ 
	 * @param id
	 */
	public String genFormat_TAXID(String id,int st , int end){
		String output	= 	"";
		try{
			if(id.length()==10){
				output	=	id.substring(st,end);
			}		
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	/**
	 * 
	 * james 01-08-2006
	 * ӡ set format ʺѵûЪҪҧ ѡ
	 * 
	 */
	public String genFormat_PID(String id, int st , int end){
		String output	= 	"";
		try{
			if(id.length()==13){
				output	=	id.substring(st,end);
			}		
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}	
	
	/**
	 * 
	 * edit by lieang 09-02-2006
	 * ӡ ͧѺ tick ˹Ҩ ѡ 
	 * @param id
	 */
	public String genCheckMonth(String month ,String position , String sign){
		String output	=	"";
		try{
			if(month.equals(position)){
				output	=	sign;
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return	output;
	}
	
   // date : ѹ
   // day : ѹǡ
	public String addDate(String date,String day){
		CscCalendar cal = new CscCalendar();
		cal.setDate(this.reDate(date));
		cal.incDate(Integer.parseInt(day));
		return cal.getDDMMYYYY();
	}
	
	// FROM dd-mm-yyyy TO yyyy-mm-dd
	public String reDate(String date){
		String[] ar = date.split("-");
		return ar[2]+"-"+ar[1]+"-"+ar[0];
	}
	
	// converse money to text
	public String money2Text(String lang,String money){
		CheckNull chk = new CheckNull();
		money = chk.chkNullString(money,"0");
		if(lang.equalsIgnoreCase("eng"))
			return new CurrencyToEng().getString(money);
		else return new CurrencyToThai().getString(money);
	}

	
	/**
	 * 
	 * edit by lieang 10-03-2006
	 * method ѺӡõѴ੾ʵҧ͡
	 * 100.50  50 ͡
	 * @return
	 */
	public String getSatang(String value){
		String output	= "00";
		try{
			if(value.length()>0){
				String tmp	=	this.getDoubleFormat(value,"######0.00");
				output		=	tmp.substring(tmp.indexOf(".")+1,tmp.length()); 
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return	output;
	}
	
	/**
	 * 
	 * edit by lieang 10-03-2006
	 * method ѺӡõѴ੾ʵҧ͡
	 * 100.50  50 ͡
	 * 100.00   00 ͡
	 * 0.00  ҵ input 	
	 * @return
	 */
	public String getSatang(String value,String input){
		String output	= input;;
		try{
			if(value.length()>0){
				String tmp	=	this.getDoubleFormat(value,"######0.00");
				if(Double.parseDouble(tmp)>0){
					output		=	tmp.substring(tmp.indexOf(".")+1,tmp.length());
				}
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return	output;
	}
	
	/**
	 * 
	 * edit by lieang 10-03-2006
	 * method ѺӡõѴҺҷ
	 * 100.50  100 ͡
	 * @return
	 */
	public String getBath(String value){
		String output	=	"00";
		try{
			if(value.length()>0){
				String tmp	=	this.getDoubleFormat(value,"######0.00");
				output		=	tmp.substring(0,tmp.indexOf("."));
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	
	
	/**
	 * 
	 * edit by lieang 10-03-2006
	 * method ѺӡõѴҺҷ
	 * 100.50  100 ͡
	 * 0.50 	 0
	 * 0.00     ҵ input 
	 * @return
	 */
	public String getBath(String value,String input){
		String output	=	input;
		try{
			if(value.length()>0){
				String tmp	=	this.getDoubleFormat(value,"######0.00");
				if(Double.parseDouble(tmp)>0){
					output = tmp.substring(0,tmp.indexOf(".")); 
				}
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	
	/**
	 * 
	 * edit by lieang 18-04-2006
	 * ӡѭͧǡźȹ
	 * @param value
	 * @return
	 */
	public String setTaxPhorKnorDor(String value){
		String output	=	"";
		try{
			DecimalFormat decimal 	= new DecimalFormat("#######0.00");
			String chk				= decimal.format(Double.parseDouble(value));
			if(chk.equals("-0.00")){
				output	=	"0.00";
			}else{
				output	=	chk;
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	
	public String getDefault(){
		return this.str_default;
	}
	 
	public void setDefault(String input){
		this.str_default = input;
	}
	
//	For Report TA Easybuy Only !!!
	public String getCalPerHead(String otHour, int empCount) {
    	DecimalFormat	df	=	new	 DecimalFormat("0.00");    	
        String tmp = this.getRoundOTEasy(otHour);
    	tmp = tmp.replaceAll(",","");
        double ot = Double.parseDouble(tmp); 
        String x = df.format(ot);
        ot = Double.parseDouble(x);
        int emp = empCount;
//        System.out.println("step 0 ==== tmp="+tmp+" : emp="+emp);
        if (emp > 0) {
        	FormulaString util = new FormulaString();    	
    		//step 1
    		int OTperStaff = (int) ot/emp;
//    		System.out.println("step 1 ==== "+OTperStaff);
    		//step 2
    		double totalOTbase100 = util.Tm_To_Dec(ot);
    		//int result2 =  (int) ((totalOTbase100*60)/emp);
    		DecimalFormat d = new DecimalFormat();
    		d.applyPattern("0");
    		int result2 = Integer.parseInt(d.format(((totalOTbase100*60)/emp)));
//    		System.out.println("step 2 ==== "+result2);
    		//step 3		
    		int result3 = OTperStaff*60;
//    		System.out.println("step 3 ==== "+result3);
    		//step 4
    		int result4 = result3-result2;
    		if (result4<0) { 
    			result4 = result4*(-1);
    		}
    		double result4Total = (result4*0.01);
//    		System.out.println("step 4 ==== "+result4Total);
    		//step 5
    		double value = OTperStaff+result4Total;
//    		System.out.println("step 5 ==== "+value);        	
        	
        	return df.format(value);
        } 
        return "0";
    }
	
	public String getStarData(String data,String compare){
		if(data.equalsIgnoreCase(compare)) return "*";
		else return "";
	}
	
	//-- descripttion ͧԹ
	public String getDescAll(int pos,String lang){
		String[][] tmp = SystemCode.getContent("ALLO_COST");
		String[] ay = tmp[pos][1].split(",");
		
		return "";
	}
	
	public String getCurrentdate(String lang){
		CscCalendar c = new CscCalendar();
		String dat="";
		if(lang.equalsIgnoreCase("tha"))
			dat = c.getDate()+" "+c.getThaiLongMonth()+" "+c.getThaiYYYY();
		else dat = c.getDate()+" "+c.getEngLongMonth()+" "+c.getEngYYYY();
		
		return dat;
	}
	
	public String getCurrentDateMMDDYYYY(String lang){
		CscCalendar c = new CscCalendar();
		String dat="";
		if(lang.equalsIgnoreCase("tha"))
			dat = c.getDate()+" "+c.getThaiLongMonth()+" "+c.getThaiYYYY();
		else dat = c.getEngLongMonth()+" "+c.getDate()+", "+c.getEngYYYY();
		return dat;
	}
	
	/**
	 * 
	 * author by james 24/07/2006
	 * leadStr Ѻ " " ˹ string 
	 * @param str  string ͧʵԧ
	 * @param length 繤Ƿͧ
	 * @return
	 */
	public String leadStr(String str, int length){
		while(str.length()<length){
			str = " "+str;
		}
		return str;
	}
	
	/**
	 * overide leadStr
	 * @param str  string ͧʵԧ
	 * @param length 繤Ƿͧ
	 * @param space  string ͧ
	 * @return
	 */
	public String leadStr(String str, int length, String space){
		while(str.length()<length){
			str = space+str;
		}
		return str;
	}

	
	/**
	 * splitStringToken Ѻ string 
	 * 
	 * @author James
	 * @param togen g string ͧ  xxx|xxxxx|xxxx
	 * @param sp  regular expressions 繵   -  "-" , |  "\\|"
	 * @param index ӴѺͧ ҡ 1
	 * @return
	 */
	public String splitStringToken(String togen, String sp, int index){
		
		//System.out.println("Begin process....");
		
	    String [] temp = null;
	    String output = "";
	    
	    try{
		    temp = togen.split(sp);
		    
		    if(index>0 && index<=temp.length){
		    	output =temp[index-1];
		    }
		
		    //System.out.println("End process...\n");
	    }catch(Exception e){
			MyLog.error(this, e);
	    }
			
		return output;
	}

	
	public String get2Digit(String value ,int digit){
		String output	= "00";
		try{
			if (value!=null) {
				if(value.trim().length()>0 && !value.trim().equalsIgnoreCase("null")){
					String tmp	=	this.getDoubleFormat(value,"######0.00");
					if (tmp.indexOf(".")>-1) {
						output		=	tmp.substring(tmp.indexOf(".")+1,tmp.length());
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return	output;
	}
	
	
	public String getDecimal(String value){
		String output	=	"00";
		try{
			if (value!=null) {
				if(value.trim().length()>0 && !value.trim().equalsIgnoreCase("null")){
					String tmp	=	this.getDoubleFormat(value,"######0.00");
					if (tmp.indexOf(".")>-1) {
						output		=	tmp.substring(0,tmp.indexOf("."));
					}else{
						output = value.trim();
					}
				} else {
					MyLog.warn(this, "Have null value!");
				}
			}
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
	/**
	 * getMMYY  return ѹ͡ ..49
	 * 
	 * @author lambkin 11-10-2006
	 * @param date ѹͧŧ
	 * @param lang Ңͧѹͧ
	 * @return newDate
	 */	
	public String getMMYY(String lang, String date){
		  /**
         *  աá͡ return  ѹѨغѹ  
         */
		CscCalendar c = null;
		try{
			c=new CscCalendar(date);
		}catch(Exception e){
			MyLog.error(this, e);
			c=new CscCalendar();
		}
		
		String newDate="";
		if(lang.equalsIgnoreCase("ENG")){
			newDate=c.getEngShortMonth()+" "+c.getEngYY();
		}else{
			newDate=c.getThaiShortMonth()+c.getThaiYY();
		}
		
		return newDate;

	}
	

	public String writeSUM_PND(String data){
		String output	=	"";
		try{
			InitialEnvironment en 	= 	new InitialEnvironment("GLOBAL");	      
			String path				=	(en.getValue("exportfile-dir")); 
			WriteFile	wf			=	new	WriteFile(path+"PND.txt");
			wf.writeString(data);
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return	 output;
	}
	
	
	public void readFile(){
		try{
			InitialEnvironment 	en 		= 	new InitialEnvironment("GLOBAL");	      
			String 				path	=	(en.getValue("exportfile-dir")); 
			ReadFile			rf		=	new	ReadFile(path+"PND.txt");
			String 				value	=	rf.getStringWithEnter();
			System.out.println(value);
		}catch(Exception e){
			MyLog.error(this, e);
		}
	}
	
	
	public void readPNDFile(){
		String	count	=	"";
		String	income	=	"";
		String	tax		=	"";
		InitialEnvironment 	en 		= 	new InitialEnvironment("GLOBAL");	      
		String 				path	=	(en.getValue("exportfile-dir")); 
		ReadFile			rf		=	new	ReadFile(path+"PND.txt");
		String 				value	=	rf.getStringWithEnter();
		StringTokenizer 	token 	= 	new StringTokenizer(value, ",");
		if(token.hasMoreElements()){
			count	=	token.nextToken();
			income	=	setFormat(token.nextToken());
			tax		=	setFormat(token.nextToken());
		}
	}

	public String setFormat(String value){
		String output	=	"";
		try{
			DecimalFormat 	df	= 	new DecimalFormat("#,###.00");
			output				=	df.format(Double.parseDouble(value));
		}catch(Exception e){
			MyLog.error(this, e);
		}
		return output;
	}
	
    public String getBlank(String param){
        
        return param;
    }
	
	public static void main(String args[]){
		ReportUDF r = new ReportUDF();
		r.readPNDFile();		
	}
    
	public String[] getSystemCode(String validCode, String lang) {		
		this.setValidCode(validCode, lang);
		String[] systemcode=new String[sysCode.length];
		String  tmpKey = "";
		for (int point = 0; point < sysCode.length; point++) {
			tmpKey = sysCode[point][0];
			if(sysCode[point][1].indexOf(",")!=-1){
				if (lang.equalsIgnoreCase("eng")) {
					systemcode[point] =tmpKey+","+ sysCode[point][1].substring(0, sysCode[point][1].indexOf(","));
				} else {
					systemcode[point]  =tmpKey+","+ sysCode[point][1].substring(sysCode[point][1].indexOf(",")+1);
				}
			}else{
				systemcode[point]  =tmpKey+","+ sysCode[point][1];				
			}
		}
		return systemcode;
	}	
	
/** 
 * Create Date:11/11/2551
 * Author: nuiss 
 * Ѻ§ҹ TAR_GRFTN001
 * site GRIFFITH 繵á
 * @return
 * 	 ʡ = ͸Ժ , ...n
 */
	public String getShiftCodeDesc(){
		String strReturn = "";
		
		UProfile up = new UProfile(); 
		up.setDbName("GRIFFITHDB");
		up.setSchemaName("dbo");
		up.setUserName("myhradmin");
		up.set("companyid", "1234");
		up.set("employeeid", "1234");
		up.set("lang", "eng");
        up.set("appname", "TA");
        
        HashMap param = new HashMap();
		Properties pr = new Properties();
		DbInquiry inq = new InitialInquiry(up).getDbInquiry();		
		
		try{
			inq.setSchemaName(up.getSchemaName());
			inq.setParam(param);
			inq.initMyTable("mtime0", "", "");
			inq.setColumn("time0id,TDESC,EDESC");
			
			inq.refresh();
			int row = 1 ;
			while (inq.next()) {
				if(strReturn.equals("")){
					strReturn = inq.getString("time0id") + " = " +  inq.getString("TDESC") ;
				}else{
					strReturn +=" , "+ inq.getString("time0id") + " = " +  inq.getString("TDESC") ;
				}//end if 
				row++;
				if (row==5){
					strReturn +="\n\t";
					row =1;
				}//end if 
			}//end while
		}catch(Exception ex){
			System.out.print("Error in ReportUDF.getShiftCodeDesc() by Nuiss...");
		}//end try 
	
		return strReturn;
	}//end getShiftCodeDesc
	
	/**
	 * Nov, 14  08
	 * @author lambkin
	 * ŧǧѹٻẺ 8-9 .. 50 (Nov 8-9, 07)
	 * parameter date1 ѹ, date2 ѹش, lang 
	 * return String ѹٻẺ 8-9 .. 50 (8-9 Nov 07) 
	 * 
	 */
	
	 public String date2Format(String date1, String date2, String lang){
	        CscCalendar d1 = new CscCalendar(date1);
	        CscCalendar d2 = new CscCalendar(date2);
	        String result ="";
	        
	        if(d1.getYear() != d2.getYear()){
	        	 if(lang.equalsIgnoreCase("ENG")){
	        		 result = d1.getEngShortMonth()+" "+d1.getDate()+", "+d1.getEngYY()+" - "+d2.getEngShortMonth()+" "+d2.getDate()+", "+d2.getEngYY();
	 	        }else{
	 	        	result = d1.getDate()+" "+d1.getThaiShortMonth()+" "+d1.getEngYY()+" - "+d2.getDate()+" "+d2.getThaiShortMonth()+" "+d2.getThaiYY();
	 	        }
	        }else if (d1.getMonth() != d2.getMonth()){
	        	if(lang.equalsIgnoreCase("ENG")){
	        		result = d1.getEngShortMonth()+" "+d1.getDate()+" - "+d2.getDate()+" "+d2.getEngShortMonth()+", "+d1.getEngYY();
	        	}else{
	        		result = d1.getDate()+" "+d1.getThaiShortMonth()+" - "+d2.getDate()+" "+d2.getThaiShortMonth()+" "+d1.getThaiYY();
	        	}
	        }else if(d1.getDate() != d2.getDate()){
	        	if(lang.equalsIgnoreCase("ENG")){
	        		result = d1.getEngShortMonth()+" "+d1.getDate()+" - "+d2.getDate()+", "+d1.getEngYY();
	        	}else{
	        		result = d1.getDate()+" - "+d2.getDate()+" "+d1.getThaiShortMonth()+" "+d1.getThaiYY();
	        	}
	        }else{
	        	if(lang.equalsIgnoreCase("ENG")){
	        		result = d1.getEngShortMonth()+" "+d1.getDate()+", "+d1.getEngYY();
	        	}else{
	        		result = d1.getDate()+" "+d1.getThaiShortMonth()+" "+d1.getThaiYY();
	        	}
	        }        	       
	        return result;	
	  }
}
	

