package com.csc.library.security;

import java.util.StringTokenizer;

import com.csc.library.database.FSecurityManager;
import com.csc.library.database.FieldManager;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class FSecurity implements FSecurityManager {
	Boolean bGet;
	Boolean bSet;

	public boolean get(FieldManager mf) {
		boolean check = false;
		if (mf.getUProfile() == null)
			return true;
		if (bGet == null) {
			String lGroup = this.iniInq(mf, "sinquiry");
			if (this.checkLevel(mf.getUProfile(), lGroup)) {
				bGet = new Boolean(true);
			} else {
				bGet = new Boolean(false);
			}
			check = bGet.booleanValue();
		} else {
			check = bGet.booleanValue();
		}
		return check;

	}
	public boolean set(FieldManager mf) {
		boolean check = false;
		if (mf.getUProfile() == null)
			return true;
		if (bSet == null) {
			String lGroup = this.iniInq(mf, "supdate");
			if (this.checkLevel(mf.getUProfile(), lGroup)) {
				bSet = new Boolean(true);
			} else {
				bSet = new Boolean(false);
			}
			check = bSet.booleanValue();
		} else {
			check = bSet.booleanValue();
		}
		return check;
	}
	private boolean checkLevel(UProfile us, String levelGroup) {
		boolean check = false;
		for (StringTokenizer token = new StringTokenizer(levelGroup, ","); token.hasMoreTokens();) {
			if (us.getLevel().trim().equalsIgnoreCase(token.nextToken())) {
				check = true;
				break;
			}

		}
		return check;
	}

	private String iniInq(FieldManager mf, String returnField) {
		String data = "";
		try {
			DbInquiry inq = new InitialInquiry(mf.getUProfile()).getDbInquiry();
			inq.setSchemaName(mf.getUProfile().getSchemaName());
			inq.initMyTable("psecurityt", "", "");

			inq.setColumn("STYPE,FIELDNAME,TABLENAME,COMCODE,SECURITYID," + returnField);
			String fieldS = mf.getParent().getNameKey(String.valueOf(mf.getParent().getSizeKey()));
			inq.setFilter(
				"comcode='"
					+ mf.getParent().getString(fieldS)
					+ "' and stype='F' and tablename='"
					+ mf.getParent().getTableName()
					+ "' and fieldname='"
					+ mf.getName()
					+ "'");
			inq.refresh();
			if (inq.next()) {
				data = inq.getString(returnField);
			}
		} catch (Exception ex) {
         	MyLog.error(this, ex);
		}
		return data;
	}
}
