package com.csc.library.session;
import java.rmi.RemoteException;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

import javax.naming.Context;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
import com.csc.library.utilities.UProfile;
/**

 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class InitialRecord {
	private String tableName;
	private UProfile user = null;
	private Context ctx = null;
	private DbRecord db = null;
	private Object home;
	private HashMap param = new HashMap();
	public static Hashtable TempolaryCacheRecord = new Hashtable();
	public static Hashtable PermanentCacheRecord = new Hashtable();
	public static Hashtable CacheIndexName = new Hashtable();
	public static Hashtable CacheIndexTime = new Hashtable();
//	private static Vector PermanentTable = new Vector();
//	private static int CacheSize = 60;
//	private static int ClearSize = 60;
	
	public InitialRecord() {
		this.user = new UProfile();
		user.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
		user.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
		user.set("lang", "eng");
	}
	public InitialRecord(UProfile user) {
		this.user = user;
	}
	public InitialRecord(UProfile user, HashMap param) {
		if (param != null) {
			this.param = param;	
		}
		this.user = user;
	}
	private boolean isGlobal(String gablename) {
		//return StaticProperties.isGobal(gablename);
                //fix for non Data Center
                return false;
	}
	public DbRecord getDbRecord(String tableName, char inquiry) {
		try {
			this.setRecord(tableName);
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
		}
		return this.db;
	}
	public DbRecord getDbRecord(String tableName) {
		try {
			this.setRecord(tableName);
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
		}
		return this.db;
	}
	private String convertTable(String tableName) {
		StringBuilder tName = new StringBuilder();
		if (tableName.indexOf(".") == -1) {
			tName.append("com.csc.library.databean.");
			tName.append(tableName.toLowerCase().substring(0, 1).toUpperCase());
			tName.append(tableName.toLowerCase().substring(1, tableName.toLowerCase().length()));
		} else {
//			String tmp="";
//			int i = tableName.lastIndexOf(".");
//			tmp = tableName.substring(i+1);
//			tableName = tableName.substring(0,i+1);
			tName.append(tableName);
//			tName.append(tmp.substring(0, 1).toUpperCase());
//			tName.append(tmp.substring(1, tmp.length()));
		}
		return tName.toString();
	}
	
	private javax.transaction.UserTransaction getTransactoin() {
		return new InitialTransaction().getUserTransaction();
	}
	private void setRecord(String tableName) throws Exception {
		if(tableName==null)
			return;
		this.tableName = tableName;
		String actualName = "";
		UProfile uf;
		if (this.isGlobal(tableName)) {
			uf = (UProfile) this.user.clone();
			uf.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
			uf.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
		} else {
			uf = this.user;
		}
			
		tableName = this.convertTable(tableName);
		actualName = tableName;
		

		DbRecord keepRec = this.loadFromCache(tableName);
		db = (DbRecord) Class.forName(actualName).newInstance();
		if (keepRec == null) {						
			db.setParam(this.param);		
			db.setDatabaseName(uf.getDbName());
			db.setUProfile(uf);
			if (db.getActualName().equals(db.getTableName())) {
				db.setProperties();
				db.setCreateBy("Normal");
			} else {
				DbRecord motherClass = this.getMotherClass(this.convertTable(db.getTableName()));
				if (motherClass!=null) {
					db.setProperty(motherClass);
					db.setCreateBy("Mother Class");
				} else {
					db.setProperties();
					db.setCreateBy("Normal");
				}
			}	
			 keepRec=db.clone(uf);
			if (StaticProperties.PermanentTable.contains(tableName)) {
				PermanentCacheRecord.put(tableName,keepRec);
			} else {
				this.putCache(tableName, keepRec);
			}

		}else {
			db.setParam(this.param);		
			db.setDatabaseName(uf.getDbName());
			db.setUProfile(uf);
			db.setCreateBy("Cache");
			db.setProperty(keepRec.clone(uf));			
		}
		db.startUp();
		if (db.getKeyPropertyRec().isEmpty()) {
			System.out.println(db.getTableName()+":"+db.getCreateBy());
		}
	}
	
	private void putCache(String tableName, Object O) {
		if (TempolaryCacheRecord.size() == StaticProperties.maxtemporary) {
			Enumeration em = CacheIndexTime.elements();
			String key;
			String table;
			Vector removeList = new Vector();
			for (int i = 0; em.hasMoreElements() && i < StaticProperties.ClearSize;i++) {
				key = (String)em.nextElement();
				table =(String)CacheIndexTime.get(key);
				removeList.add(table);
			}
			for (int i = 0; i< removeList.size(); i++) {
				this.removeCache((String)removeList.get(i));
			}
		}
		
		TempolaryCacheRecord.put(tableName, O);
		this.putTime(tableName);
		
	}
	
	private void putTime(String tableName) {
		CscCalendar d  = new CscCalendar();
			CacheIndexName.put(tableName, d.getYYYYMMDDHHMMSS());
			CacheIndexTime.put(d.getYYYYMMDDHHMMSS()+" - "+tableName, tableName);
	}
	
	private void removeCache(String tableName) {
		if(tableName==null)
			return;
		this.removeTime(tableName);
		TempolaryCacheRecord.remove(tableName);
	}
	
	private void removeTime(String tableName) {
		String key = "";
			if (tableName!=null&&CacheIndexName.containsKey(tableName)) {
				key = (String)CacheIndexName.get(tableName);
				CacheIndexName.remove(tableName);
				if(key!=null){
						CacheIndexTime.remove(key+" - "+tableName);
				}
		}
	}
	
	static void clearCache() {
		TempolaryCacheRecord = new Hashtable();
		PermanentCacheRecord = new Hashtable();
		CacheIndexName = new Hashtable();
		CacheIndexTime = new Hashtable();
	}
	
	private DbRecord loadFromCache(String tableName) throws RemoteException {
		DbRecord db0 = null;
		if(db0==null){ //ͷͺջѭҨҡçԧ
			return null;
		}
		db0 = 	(DbRecord) PermanentCacheRecord.get(tableName);
		if (db0==null) {
			db0 = 	(DbRecord) TempolaryCacheRecord.get(tableName);
			if (db0!=null) {
				db0 = (DbRecord) db0.clone(this.user);
				db0.setUProfile(this.user);
				this.removeTime(tableName);
				this.putTime(tableName);
			}
		} else {
			db0 = (DbRecord) db0.clone(this.user);
		}
		return db0;
	}
	
	private DbRecord getMotherClass(String tableName) throws RemoteException {
		DbRecord db0 = null;
		if(db0==null){ //ͷͺջѭҨҡçԧ
			return null;
		}		
		db0 = 	(DbRecord) PermanentCacheRecord.get(tableName);
		if (db0==null) {
			db0 = 	(DbRecord) TempolaryCacheRecord.get(tableName);
		} else {
			db0 = (DbRecord) db0;
		}
		return db0;
	}
	
	
	public DbRecord getDbRecord(String tableName, boolean isSave) {
		try {
			this.setRecord(tableName);
			db.isSave(isSave);
		} catch (Exception e) {
			MyLog.error(this, this.user, e);
		}
		return db;
	}
	
}
