package com.csc.library.session;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;
import com.csc.library.database.FieldManager;
import com.csc.library.database.LoadSimXml;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.SimRecord;
import com.csc.library.database.StaticProperties;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;
/**
 * @author paecsc
 *
 * Cls ѡ ҧ record  sim  record 
 */
public class RecordCmp extends SimRecord {
    private static final long serialVersionUID = 1L;
    public boolean simWorking = true;
    public RecordCmp(String a, String b) {
        super(a, b);
    }
    public RecordCmp(String a, String b, boolean c) {
        super(a, b, c);
        this.simWorking = c;
    }
    public String simTable = "", simFilter = "";
    protected MyHashMap hFieldSim = new MyHashMap(true);
    protected MyHashMap hKeySim = new MyHashMap(true);
    protected String simNameField = "", simEDesc = "", simTDesc = "", simValue = "", screen = "", companyid = "", param_companyid = "";
    protected boolean isSave;
    protected DbInquiry inq;
    public void setSimField(String NameField, String EDesc, String TDesc, String Value) { //FOR SIM INQUIRY
        this.simNameField = NameField; //TableName.FieldName
        this.simEDesc = EDesc; //TableName.FieldName
        this.simTDesc = TDesc; //TableName.FieldName
        this.simValue = Value; //TableName.FieldName
    }
    public void setFieldSim(String NameField, String Value) { //FOR SIM XML
        this.simNameField = NameField; //TableName.FieldName
        this.simValue = Value; //TableName.FieldName
    }
    public void setCompanyID(String companyid) {
        this.param.put("screen_companyid", companyid);
        //this.companyid=companyid;
    }
    public void startUp() {
        if (this.simWorking == true) {
//            super.setProperties();
            this.initialSimField();
        }
//        else
///            super.setProperties();
    }
    
    public void initialSimField() {
    	this.configInq();
    }
    
    public void loadSimXmlEnv(String fileName) {
        LoadSimXml lsx = new LoadSimXml();
        lsx.initEnv(this.getUProfile());
        lsx.setFileName(fileName);
        this.hFieldSim = lsx.getSimXmlHash();
    }
    public String keyValue(DbInquiry inq, Vector vKeyList) {
        String keyFieldName, tmpKeyValue = "";
        for (int i = 0; i < vKeyList.size(); i++) {
            keyFieldName = vKeyList.elementAt(i).toString();
            try {
                if (i == 0) {
                    tmpKeyValue = inq.getString(keyFieldName);
                } else {
                    tmpKeyValue = tmpKeyValue + "," + inq.getString(keyFieldName);
                }
            } catch (RemoteException e) {
    			MyLog.error(this, this.getUProfile(), e);
            }
        }
        return tmpKeyValue;
    }
    public String getSimValue(DbInquiry inq, String key) {
        String simTable = key.substring(0, key.indexOf("$"));
        String simField = key.substring(key.indexOf("$") + 1);
        String data = "";
        try {
            if (inq.getTableName().equalsIgnoreCase(simTable)) {
                data = inq.getString(simField);
            } else {
                Object obj = inq.getChild(simTable.toUpperCase());
                if (obj instanceof DbInquiry) {
                    data = ((DbInquiry) inq.getChild(simTable)).getString(simField);
                } else {
                    if (obj instanceof DbRecord) {
                        data = ((DbRecord) inq.getChild(simTable)).getString(simField);
                    }
                }
            }
        } catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    public MyHashMap setHKeySim() {
        MyHashMap keyField = new MyHashMap(true);
        StringTokenizer st = new StringTokenizer(this.getListKey(), ",");
        while (st.hasMoreTokens()) {
            String keyName = st.nextToken();
            keyField.put(keyName, this.getString(keyName));
        }
        return keyField;
    }
    public MyHashMap setHKeySim(DbRecord simRec) {
        MyHashMap keyField = new MyHashMap();
        try {
            StringTokenizer st = new StringTokenizer(simRec.getListKey(), ",");
            while (st.hasMoreTokens()) {
                String keyName = st.nextToken();
                keyField.put(keyName, simRec.getString(keyName));
            }
        } catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return keyField;
    }
    public void setKeyFieldManager(DbInquiry inq) {
        FieldManager fm = null;
        String key = "";
        try {
            key = this.getSimValue(inq, this.simNameField);
            if (this.hFieldSim.containsKey(key)) {
                fm = (FieldManager) this.hFieldSim.get(key);
            } else {
                fm = (FieldManager) this.hFieldSim.get("default");
                fm.setName(key);
            }
            fm.setUProfile(this.getUProfile());
            fm.setWorking(true);
            if (!this.simTDesc.equals("") && (this.userPro.get("lang").equalsIgnoreCase("tha"))) {
                fm.setDescription(this.getSimValue(inq, this.simTDesc));
            } else {
                if (!this.simEDesc.equals("") && (this.userPro.get("lang").equalsIgnoreCase("eng"))) {
                    fm.setDescription(this.getSimValue(inq, this.simEDesc));
                }
            }
            //fm.setDescription(this.getSimValue(inq,this.simEDesc));
            fm.set(this.getSimValue(inq, this.simValue));
            //System.out.println(">>>>>>>>>>>>>>>>>>>> fm.getName=" + fm.getName() + " >>> key=" + key);
            this.hKeySim.put(key, this.setHKeySim(inq.getCurrentDbRecord()));
        } catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public void loadSimTable(String tableName) {
        MyHashMap hKey = new MyHashMap(true); //MyHashTable KeyField	
        MyHashMap hField = new MyHashMap(true);
        Iterator it = this.hFieldSim.keySet().iterator();
        while (it.hasNext()) {
            String field = it.next().toString();
            FieldManager fm = (FieldManager) this.hFieldSim.get(field);
            fm.setWorking(true);
            fm.setUProfile(this.userPro);
            if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
            	fm.setDescription(fm.getProperty("DESC_THAI"));
            } else if (this.userPro.get("lang").equalsIgnoreCase("eng")) {
            	fm.setDescription(fm.getProperty("DESC_ENG"));
            }
          //  fm.setDescription("Test Test");
            fm.setName(tableName + "$" + field);
            hField.put(field, fm);
        }
        hKey.put("0", hField);
        super.getHTable().put(tableName, hKey);
    }
    public void loadSimTable(DbInquiry inq) {
        MyHashMap hKey = new MyHashMap(true); //MyHashTable KeyField	
        MyHashMap hField = new MyHashMap(true);
        DbRecord rec;
        String keyFieldName, tmpKeyValue = "";
        try {
            String inqTableName = inq.getTableName().toString();
            FieldManager tmpField;
            while (inq.next()) {
                this.setKeyFieldManager(inq);
                //Code For Map 
                rec = inq.getCurrentDbRecord();
                rec.setProperties(true);
                tmpKeyValue = this.getSimValue(inq, this.simNameField);
                tmpField = (FieldManager) this.hFieldSim.get(tmpKeyValue);
                if (tmpField == null) {
                    tmpField = (FieldManager) this.hFieldSim.get("default");
                    FieldManager tmpDefault = this.initField(tmpField.getType(), tmpField.getName(), tmpField.getWidth(), tmpField.getDecimal(), tmpField.getDescription());
                    Iterator itD = tmpField.getProperty().keySet().iterator();
                    String keyData = "";
                    while (itD.hasNext()) {
                        keyData = (String) itD.next();
                        tmpDefault.setProperty(keyData, tmpField.getProperty(keyData));
                    }
                    tmpField = tmpDefault;
                }
                tmpField.setUProfile(this.getUProfile());
                tmpField.setWorking(true);
                if (!this.simTDesc.equals("") && (!this.userPro.get("lang").equalsIgnoreCase("eng"))) {
                    tmpField.setDescription(this.getSimValue(inq, this.simTDesc));
                } else {
                    if (!this.simEDesc.equals("") && (this.userPro.get("lang").equalsIgnoreCase("eng"))) {
                        tmpField.setDescription(this.getSimValue(inq, this.simEDesc));
                    }
                }
                tmpField.setName(inqTableName + "$" + tmpKeyValue);
                hField.put(tmpKeyValue, tmpField);
            }
            hKey.put("0", hField);
            super.getHTable().put(inqTableName, hKey);
        } catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    /*
    protected void actRecord() {
		String tableName;
		DbRecord tableRec;
		Iterator iTable = this.getSimTableAll();
		try {
			while (iTable.hasNext()) {
				tableName = iTable.next().toString().toLowerCase();
				tableRec = this.initRecord(tableName);
				tableRec.setColumn("*");
				Iterator iField = this.getFieldSimListKey(tableName);
				while (iField.hasNext()) {
					String fieldName = iField.next().toString().toLowerCase();
					FieldManager fm = this.getSimField(tableName, fieldName);
					// Get Primary Key And Set To DbRecord
					MyHashMap hm = (MyHashMap) this.hKeySim.get(fieldName.toLowerCase());
					Iterator it = hm.keySet().iterator();
					while (it.hasNext()) {
						String st = it.next().toString();
						String stTmp = (String) hm.get(st);
						fm.setProperty(st, stTmp);
						tableRec.set(st, stTmp);
					}
					tableRec.set(this.simValue.substring(this.simValue
							.indexOf("$") + 1, this.simValue.length()), fm
							.getString());
					tableRec.save();
				}
			}
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}
    */ 
    protected void actRecordXML() {
        String tableName;
        DbRecord tableRec;
        try {
            MyHashMap hm = this.setHKeySim();
            Iterator iTable = this.getSimTableAll();
            while (iTable.hasNext()) {
                tableName = iTable.next().toString();
                tableRec = this.initRecord(tableName);
                tableRec.setColumn("*");
                Iterator iField = this.getFieldSimListKey(tableName);
                while (iField.hasNext()) {
                    String fieldName = iField.next().toString();
                    FieldManager fm = this.getSimField(tableName, fieldName);
                    Iterator it = hm.keySet().iterator();
                    while (it.hasNext()) {
                        String key = it.next().toString();
                        tableRec.set(key, hm.get(key).toString());
                    }
                    tableRec.set(this.simNameField.substring(this.simNameField.indexOf("$") + 1, this.simNameField.length()), fieldName);
                    tableRec.set(this.simValue.substring(this.simValue.indexOf("$") + 1, this.simValue.length()), fm.getString());
                    tableRec.save();
                }
            }
        } catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    protected void setSimFieldValue(String tableName, String fieldName, String filter, String simTable, String pk) {
        String tmpValue = "", tmpKey = "";
        MyHashMap hmTmp = new MyHashMap();
        try {
            DbInquiry inqTmp = new InitialInquiry(this.userPro).getDbInquiry(simTable, filter, false);
            inqTmp.setColumn("*");
            inqTmp.refresh();
            while (inqTmp.next()) {
                tmpValue = inqTmp.getString(fieldName);inqTmp.getCurrentDbRecord().getField(fieldName).isEncrypt();
                tmpKey = inqTmp.getString(pk);
                //System.out.println("ooooo tableName=" + tableName + " ooooo tmpValue=" + tmpValue + " ooooo tmpKey=" + tmpKey + " obj=" + this.getSimField(tableName, tmpKey).getName());
                FieldManager fm = this.getSimField(tableName, tmpKey);
                if (fm!=null) {
	                if (fm.isEncrypt())
	                    fm.encryption(tmpValue);
	                else
	                    fm.set(tmpValue);
                } else {
        			MyLog.error(this, this.getUProfile(), "Could not found simfield : ! tableName=" + tableName + " fieldName=" + fieldName + " filter=" + filter + " simTable=" + simTable + " pk=" + pk + " -->tmpValue=" + tmpValue + " tmpKey=" + tmpKey);
                }
            }
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
			MyLog.error(this, this.getUProfile(), "ERROR !!! tableName=" + tableName + " ooooo fieldName=" + fieldName + " ooooo filter=" + filter + " simTable=" + simTable + " pk=" + pk + " -->tmpValue=" + tmpValue + " tmpKey=" + tmpKey);
        }
    }
    public void clearField() {
    	super.clearField();
    	this.clearSimField();
    }
    
    public int search() {
//    	int result =0;
//        if (this.simWorking == true) {
//            result = super.search();
//           this.configInq();
//            super.refreshChild();
//            return result;
//        } else {
 //           super.refreshChild();
    	this.clearSimField();
        return super.search();
 //       }
    }
    protected void saveRecord() throws Exception {
        if (this.simWorking == true) {
           this.actRecord();
 //           this.configInq();
        }
        super.saveRecord();
    }
    protected void updateRecord() {
        if (this.simWorking == true) {
           this.actRecord();
//            this.configInq();
        } 
        try {
			super.updateRecord();
//        	super.save();
		} catch (SQLException e) {
			try {
				StaticProperties.myConnection.rollback(this.userPro, this);
			} catch (SQLException e1) {
				MyLog.error(this, this.getUProfile(), e);
			}
		}
    }
    
	protected void actRecord(){	
	}
    
    protected void keepDataForUpdate() {
        super.keepDataForUpdate();
    }
    
    public String getDataFormat(String fieldName){
    	if(this.getField(fieldName)!=null)
    		return this.getField(fieldName).getDataFormat();
    	else
    		return "";
    }
    
    public void saveHashMapData(String tableName, MyHashMap hmResult) {
		try {
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord(tableName);
			rec.setColumn("*");
			if (!hmResult.isEmpty()) {
				String key="", key2="";
				Iterator it = hmResult.keySet().iterator();
				while (it.hasNext()) {
					key = (String) it.next();
					MyHashMap hm = (MyHashMap) hmResult.get(key);
					rec.clearField();
					Iterator it2 = hm.keySet().iterator();
					while (it2.hasNext()) {
						key2 = (String) it2.next();
						rec.set(key2, hm.getString(key2));
					}
					rec.save();
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
    
    public void saveHashMapData(String tableName, MyTreeMap hmResult) {
		try {
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord(tableName);
			rec.setColumn("*");
			if (!hmResult.isEmpty()) {
				String key="", key2="";
				Iterator it = hmResult.keySet().iterator();
				while (it.hasNext()) {
					key = (String) it.next();
					MyHashMap hm = (MyHashMap) hmResult.get(key);
					rec.clearField();
					Iterator it2 = hm.keySet().iterator();
					while (it2.hasNext()) {
						key2 = (String) it2.next();
						rec.set(key2, hm.getString(key2));
					}
					rec.save();
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}
       
}
