package com.csc.library.system;

import java.util.Hashtable;

import com.csc.library.entry.ScreenManager;
import com.csc.library.utilities.UProfile;
import com.csc.library.utilities.MyLog;
public class MySystem {

	protected UProfile user = null;
	protected Hashtable blackBox;
	protected String prvPage, sessionId;

	public MySystem() {
		blackBox = new Hashtable();
		prvPage = sessionId = "";
	}

	public String getComCode() {
		try {
			return user.get("comcode");
		} catch (Exception ex) {
			MyLog.error(this, user, ex);
			return null;
		}
	}

	public String getUser() {
		try {
			return user.get("fullname");
		} catch (Exception ex) {
			MyLog.error(this, user, ex);
			return null;
		}
	}

	public String getPassword() {
		try {
			return user.get("password");
		} catch (Exception ex) {
			MyLog.error(this, user, ex);
			return null;
		}
	}

	public void setUserProfile(UProfile uPro) {
		this.user = uPro;
	}

	public UProfile getUserProfile() {
		return this.user;
	}

	public void cleanObj() {
		this.blackBox.clear();
	}

	public boolean removeScr(String objName) {
		boolean check = false;
		if (this.blackBox.containsKey(objName)) {
			this.blackBox.remove(objName);
			check = true;
		}
		return check;
	}

	public Object getScr(String objName) {
		if (this.blackBox.containsKey(objName)) {
			return (Object) this.blackBox.get(objName);
		}
		return null;
	}

	public void saveScr(String objName, ScreenManager oScr) {
		this.prvPage = objName;
		this.blackBox.put(objName, oScr);
	}

	public String getId() {
		return this.sessionId;
	}

	public void setId(String id) {
		this.sessionId = id;
	}
}
