package com.csc.library.util.session;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionBindingEvent;
import javax.servlet.http.HttpSessionBindingListener;

import com.csc.library.database.StaticProperties;
import com.csc.library.security.ActionLogImp;
import com.csc.library.utilities.UProfile;

public class SessionListener implements HttpSessionBindingListener {

	private UProfile up = null;
	private boolean unbound = true;

	public SessionListener(final UProfile up) {
		super();
		this.up = up;
	}

	public void valueBound(HttpSessionBindingEvent event) {
		
		final HttpSession session = event.getSession();
		StaticProperties.activeSessionsMap.put(session.getId(), session);
		
		this.saveLoginLog( session );
		
	}

	public void valueUnbound(HttpSessionBindingEvent event) {
		
		final HttpSession session = event.getSession();
		StaticProperties.activeSessionsMap.remove( session.getId() );
		
		if (unbound) {
			this.saveLogoutLog( session );
		}
	}

	private void saveLoginLog(HttpSession session) {
		ActionLogImp al = (ActionLogImp) this.up.getObject("actionlogid");
		al.loginComplete();
	}

	private void saveLogoutLog(HttpSession session) {
		try {
			ActionLogImp al = (ActionLogImp) this.up.getObject("actionlogid");
			al.noLogout();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void setUnbound(boolean unbound) {
		this.unbound = unbound;
	}

}
