package com.csc.library.util.session;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionBindingEvent;
import javax.servlet.http.HttpSessionBindingListener;

import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.UProfile;


@Deprecated
public class SessionNotifier implements HttpSessionBindingListener {
	
	private UProfile up = null;
    private String remoteip="";
    private String sessionid="";
    private String companyid="";
    private String userid="";
    
	public SessionNotifier(UProfile up){
		super();
		this.up = up;        
	}
	
	public void valueBound(HttpSessionBindingEvent event){
		//System.out.println("The session has started : "+event.getSession().getId());
		this.saveLoginLog(event.getSession());
		StaticProperties.employeeOnline.put(up.get("employeeid").toString(),Long.valueOf(System.currentTimeMillis()));
	}
	
	public void valueUnbound(HttpSessionBindingEvent event){
		///System.out.println("The session has ended : "+event.getSession().getId());
		this.saveLogoutLog(event.getSession());
		StaticProperties.employeeOnline.remove(up.get("employeeid").toString());
	}
	
    private void saveLoginLog(HttpSession session) {
        DbRecord db = new InitialRecord(this.up).getDbRecord("LOGIN_LOG");
        try{
             sessionid=session.getId();
             remoteip=session.getAttribute("remote_id").toString(); 
             companyid=up.get("companyid").toString();
             userid=up.getUserId();
            db.set("logid", String.valueOf(System.currentTimeMillis()));
            db.set("user_code", userid);
            db.set("session_id",sessionid);
            db.set("remote_ip", remoteip);
            db.set("companyid", companyid);
            db.save();
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void saveLogoutLog(HttpSession session) {
        DbRecord db = new InitialRecord(this.up).getDbRecord("LOGIN_LOGHIS");
        try{
            db.set("logid",String.valueOf(System.currentTimeMillis()));
            db.set("user_code", userid);
            db.set("session_id",sessionid);
            db.set("remote_ip", remoteip);
            db.set("companyid", companyid);
            db.save();            
        }catch (Exception e) {
            e.printStackTrace();
        }
    }
    
}
