package com.csc.library.utilities;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.session.InitialEnvironment;


public class Checkbox {

	private String strXMLPath = ""; // input/ouput xml file
	private String strFile = "";
	private StringBuffer sb = new StringBuffer();

	private org.jdom.Element propElement; // keep properties items
	private org.w3c.dom.Document doc; // keep xml documnet (for write)
	private org.w3c.dom.Element root; // root element

	private Map menu = new TreeMap();
	private List list;
	private String strLang = "";
	private UProfile uprofile = null;

	public Checkbox() {
	}

	private void setLanguage(UProfile ulang) {
		String myLang = "";
		try {
			if (ulang.get("lang") != null) {
				myLang = ulang.get("lang");
				if (myLang.equalsIgnoreCase("tha")) {
					this.strLang = "tname";
				} else {
					this.strLang = "ename";
				}
			}
		} catch (Exception e) {
			MyLog.error(this, uprofile, "Error (menus.setLanguage) : " + e);
		}
	}

	private String getLanguage() {
		return this.strLang;
	}

	private void setUprofile(UProfile uf) {
		this.uprofile = uf;
	}

	private UProfile getUprofile() {
		return this.uprofile;
	}

	public Checkbox(UProfile u) {
           String xmlPath="";
           String xmlFile="";
		try {
                  InitialEnvironment en = new InitialEnvironment("GLOBAL");
                  xmlPath=u.get("menu").toString()+"-dir";
                  xmlFile=u.get("menu")+"-file";
                 // System.out.println("-------------------------------->DIR ="+xmlPath);
                  //System.out.println("-------------------------------->FILE ="+xmlFile);
                  setUprofile(u);
                  String strXMLPath = en.getValue(xmlPath);
                  String strFile = en.getValue(xmlFile);
                  setXMLPath(strXMLPath);
                  setXMLFile(strFile);
                  setLanguage(u);
		} catch (Exception e) {
			MyLog.error(this, u, "(checkbox.constructure) : " + e);
		}
	}

        public Checkbox(String strXMLPath,String strFile,UProfile uf) {
                        try {
                                setUprofile(uf);
                                setXMLPath(strXMLPath);
                                setXMLFile(strFile);
                                setLanguage(uf);
                        } catch (Exception e) {
                        		MyLog.error(this, uf, "(checkbox.constructure) : " + e);
                        }
                }

	public void getProperties() { // get data from menus.xml
		try {
			SAXBuilder builder = new SAXBuilder();
			org.jdom.Document docProp = builder.build(new File(this.strXMLPath + this.strFile));
			propElement = docProp.getRootElement(); // get xml root element from xml file
		} catch (Exception e) {
			MyLog.error(this, this.uprofile, "(checkbox.getProperties) : " + e);
		}
	}

	public void setXMLPath(String xmlpath) {
		try {
			strXMLPath = xmlpath;
		} catch (Exception e) {
			MyLog.error(this, this.uprofile,"(checkbox.setXMLPath) : " + e);
		}
	}

	public void setXMLFile(String xmlfile) {
		try {
			strFile = xmlfile;
		} catch (Exception e) {
			MyLog.error(this,this.uprofile,"(checkbox.setXMLFile) : " + e);
		}
	}


	public String getMenu(String menuList) {
		try {
			getProperties();
			genMenu(propElement, menuList);
		} catch (Exception e) {
			MyLog.error(this,this.uprofile,"checkbox.getMenu() : " + e);
		}

		return "<div nowrap><ul>" + sb.toString() + "</ul></div>";
	}

        /**
         * create by pas for getMenu for tranfer working to sunordinate
         **/
        public String getMenu(String menuName,String menuList) {
                try {
                        getProperties();
                        genMenu(propElement, menuList,menuName);
                } catch (Exception e) {
                		MyLog.error(this,this.uprofile," propElement : "+propElement+" menuList : "+menuList);
      					MyLog.error(this,this.uprofile,"(checkbox.getMenuActor) : " + e);
                }

                return "<div nowrap><ul>" + sb.toString() + "</ul></div>";
        }


        public String getGlobalMenu(String menuList) {
                try {
                        getProperties();
                        genGlobalMenu(propElement, menuList);
                } catch (Exception e) {
                		MyLog.error(this,this.uprofile,"checkbox.getGlobalMenu : " + e);
                }

                return "<div nowrap><ul>" + sb.toString() + "</ul></div>";
        }
        public String getGlobalMenu(String menuName,String menuList) {
                try {
                        getProperties();
                        genGlobalMenu(propElement, menuList,menuName);
                } catch (Exception e) {
                		System.out.println(" propElement : "+propElement+" menuList : "+menuList);
					MyLog.error(this,this.uprofile,"(checkbox.getGlobalMenuActor) : " + e);
                }

                return "<div nowrap><ul>" + sb.toString() + "</ul></div>";
        }


	public void showMenu() {
		try {
			MyLog.info(this,this.uprofile,"<ul>" + sb.toString() + "</ul>");
		} catch (Exception e) {
			MyLog.error(this,this.uprofile,"Error checkbox.showMenu() : " + e);
		}
	}

	public String ByteArrayStream(String str) {
		String strTemp = "";
		try {
			ByteArrayInputStream bin = new ByteArrayInputStream(str.getBytes());
			ByteArrayOutputStream bout = new ByteArrayOutputStream();
			int c;
			while ((c = bin.read()) != -1)
				bout.write((byte) c);

			strTemp = bout.toString();
			bout.close();
			bin.close();
		} catch (Exception e) {
			MyLog.error(this, this.uprofile,"Error (checkbox.ByteArrayStream) : " + e);
		}
		return strTemp;
	}

	public String getCheckBox(String code, String menuList,String strGroup) {
		String strChk = "";
		try {
			if (menuList.indexOf("," + code + ",") > -1) {
				strChk = "<input type='checkbox' name='__menu' value='" + code + "' onclick=\"actionScript('"+code+"','"+strGroup+"',this.checked)\" id='"+strGroup+"' checked>";
			} else {
				strChk = "<input type='checkbox' name='__menu' value='" + code + "' onclick=\"actionScript('"+code+"','"+strGroup+"',this.checked)\" id='"+strGroup+"'>";
			}
		} catch (Exception e) {
			MyLog.error(this, this.uprofile,"Error (checkbox.getCheckBox) " + e);
		}
		return strChk;
	}

        public String getCheckBox(String code, String menuList,String strGroup,String menuName) {
                String strChk = "";
                try {
                        if (menuList.indexOf("," + code + ",") > -1) {
                                strChk = "<input type='checkbox' name='"+menuName+"' value='" + code + "' onclick=\"actionScript('"+code+"','"+strGroup+"',this.checked)\" id='"+strGroup+"' checked>";
                        } else {
                                strChk = "<input type='checkbox' name='"+menuName+"' value='" + code + "' onclick=\"actionScript('"+code+"','"+strGroup+"',this.checked)\" id='"+strGroup+"'>";
                        }
                } catch (Exception e) {
                		MyLog.error(this, this.uprofile,"Error (checkbox.getCheckBox) " + e);
                }
                return strChk;
        }


	public void genMenu(Element menuNode, String menuList,String menuName) {
		/*Element child;
		List list1;
		String strName, strCode ,strGroup;
//                HashMap hmap = new HashMap();
//                Authorizable sc = null;
                String nmenu="__"+menuName.substring(0,(menuName.lastIndexOf("_")));
		try {
//            sc = new InitialAuthorize(uprofile.get("username"),uprofile.get("password"),uprofile.getDbName()).getAuthorize();
			list1 = menuNode.getChildren("MENU");
			for (int i = 0; i < list1.size(); i++) {
				child = (Element) list1.get(i);
				strName   = child.getAttributeValue(this.getLanguage());
				strCode   = child.getAttributeValue("code");
                                strGroup  = child.getAttributeValue("group");
                                uprofile.set("menu",menuName);
//                                hmap.put("menucode", child.getAttributeValue("code"));
                                    //if (sc.checkmenu(uprofile, hmap)) { // check user level if this user have authority to access return true
                                if (StaticProperties.jspAuthen.checkmenu(uprofile, (String)child.getAttributeValue("code"))){
                                      if (child.getChildren("MENU").size() > 0) {
                                        sb.append("<li><font size='2'>").append(getCheckBox(strCode,
                                            menuList, strGroup, nmenu)).append(strName).append(
                                            "</font></li>\n");
                                        sb.append("<ul>\n");
                                        genMenu(child, menuList, menuName);
                                        sb.append("</ul>");
                                      }
                                      else {
                                          sb.append("<li><font size='2'>").append(getCheckBox(strCode,
                                              menuList, strGroup, nmenu)).append(strName).append(
                                              "</font></li>\n");
                                      }
                                    }
			}
			//this.logger.info("Menu name : " + sb.toString());
		} catch (Exception e) {
			MyLog.error(this, this.uprofile,"Error checkbox.genMenu() : " + e);
//			MyLog.error(this, this.uprofile," Authorizable : "+sc);
		}*/
	}

        public void genMenu(Element menuNode, String menuList) {
                Element child;
                List list1;
                String strName, strCode ,strGroup;
                try {
                        list1 = menuNode.getChildren("MENU");
                        for (int i = 0; i < list1.size(); i++) {
                                child = (Element) list1.get(i);
                                strName   = child.getAttributeValue(this.getLanguage());
                                strCode   = child.getAttributeValue("code");
                                strGroup  = child.getAttributeValue("group");
                                //this.logger.info("Menu name : " + strName);

                                if (child.getChildren("MENU").size() > 0) {
                                        sb.append("<li><font size='2'>").append(getCheckBox(strCode, menuList,strGroup)).append(strName).append("</font></li>\n");
                                        sb.append("<ul>\n");
                                        genMenu(child, menuList);
                                        sb.append("</ul>");
                                } else {
                                        sb.append("<li><font size='2'>").append(getCheckBox(strCode, menuList,strGroup)).append(strName).append("</font></li>\n");
                                }
                        }
                        //this.logger.info("Menu name : " + sb.toString());
                } catch (Exception e) {
                		MyLog.error(this, this.uprofile,"Error (checkbox.genMenu) : " + e);
                }
        }


        public void genGlobalMenu(Element menuNode, String menuList,String menuName) {
       /*         Element child;
                List list1;
                String strName, strCode ,strGroup;
//                HashMap hmap = new HashMap();
                String nmenu="__"+menuName.substring(0,(menuName.lastIndexOf("_")));
//                 Authorizable sc =null;
                try {
//                   sc = new InitialAuthorize(uprofile.get("username"),uprofile.get("password"),uprofile.getDbName()).getAuthorize();
                  list1 = menuNode.getChildren("MENU");
                  sb.append("<table width=\"100%\" border=\"0\" cellspacing=\"3\" cellpadding=\"3\">");
                        for (int i = 0,j=0; i < list1.size(); i++,j++) {
                                child = (Element) list1.get(i);
                                strCode   = child.getAttributeValue("code");
                                strGroup  = child.getAttributeValue("group");
                                uprofile.set("menu",menuName);
//                                hmap.put("menucode", child.getAttributeValue("code"));
                                if (j == 0)sb.append("<tr>");
//                                  if (sc.checkmenu(uprofile, hmap)) { // check user level if this user have authority to access return true
                                if (StaticProperties.jspAuthen.checkmenu(uprofile, (String)child.getAttributeValue("code"))){                                
                                    sb.append("<td><div align=\"center\">").append(getCheckBox(strCode,menuList, strGroup,nmenu));
                                    sb.append("<img src=\"" + child.getAttributeValue("img") +"\" border=\"" + child.getAttributeValue("border") +"\"></div></td>");
                                  }
                                if (j == 2) {
                                    sb.append("</tr>");
                                    j = -1;
                                  }
                        }
                        sb.append("</table>");
                } catch (Exception e) {
                		MyLog.error(this, this.uprofile,"Error checkbox.genGlobalMenuActor() : " + e);
//                		MyLog.error(this, this.uprofile," Authorizable : "+sc);
                }
                */
        }
        public void genGlobalMenu(Element menuNode, String menuList) {
                Element child;
                List list1;
                String strName, strCode ,strGroup;
                try {
                        list1 = menuNode.getChildren("MENU");
                        sb.append("<table width=\"100%\" border=\"0\" cellspacing=\"3\" cellpadding=\"3\">");
                        for (int i = 0,j=0; i < list1.size(); i++,j++) {
                                child = (Element) list1.get(i);
                                strCode   = child.getAttributeValue("code");
                                strGroup  = child.getAttributeValue("group");
                                if(j==0){
                                   sb.append("<tr>");
                                }
                                  sb.append("<td><div align=\"center\">").append(getCheckBox(strCode, menuList,strGroup));
                                  sb.append("<img src=\""+child.getAttributeValue("img")+"\" border=\""+child.getAttributeValue("border")+"\"></div></td>");
                                  if(j==2){
                                     sb.append("</tr>");
                                     j=-1;
                                  }

                        }
                        sb.append("</table>");
                        //this.logger.info("Menu name : " + sb.toString());
                } catch (Exception e) {
                		MyLog.error(this, this.uprofile,"Error (checkbox.genMenu) : " + e);
                }
        }

}
