package com.csc.library.utilities;


public class Command {
	private Parameter p;
	//cmd=type/objectCode/html/className/method(parameter)
	protected String[] cmdArr = new String[5];

	public Command() {
		super();
	}

	public Command(String cmd) {
		initCommand(cmd);
	}

	public void initCommand(String cmd) {
		int lastPosition = 0;
		int thisPosition = 0;

		for (int i = 0; i < cmdArr.length; i++) {
			thisPosition = cmd.indexOf("/", lastPosition);
			if (thisPosition != -1) {
				cmdArr[i] = cmd.substring(lastPosition, thisPosition);
			} else {
				if (i == cmdArr.length - 1) {
					setMethod(cmd.substring(lastPosition));
				} else {
					cmdArr[i] = cmd.substring(lastPosition);
					break;
				}
			}
			lastPosition = thisPosition + 1;
		}
	}

	private void setMethod(String buffer) {
		//buffer must contain something like 'save(someword)'
		int openParam = buffer.indexOf("(");
		int closeParam = buffer.indexOf(")");
		this.p = new Parameter();

		//token #1 is method name
		if (openParam != -1)
			if (openParam == 1)
				cmdArr[cmdArr.length - 1] = "";
			else
				cmdArr[cmdArr.length - 1] = buffer.substring(0, openParam);
		else
			cmdArr[cmdArr.length - 1] = buffer;

		//if token > 1, it's means the method also contains some parameters inside
		if (openParam != -1 && closeParam != -1) {
			String param = buffer.substring(openParam + 1, closeParam);
			this.p.separate(param);
		}
	}

	public String getType() {
		return cmdArr[0];
	}

	public String getObjectCode() {
		return cmdArr[1];
	}

	public String getHTML() {
		return cmdArr[2];
	}

	public String getClassName() {
		return cmdArr[3];
	}

	public String getMethod() {
		return cmdArr[4];
	}

	public Object getParameter(String field) {
		return this.p.getParameter(field);
	}

	public String[] getKey() {
		return this.p.getKey();
	}
}
