package com.csc.library.utilities;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.session.InitialEnvironment;

public class CscIndexTable {
    private UProfile uprofile;
    private String indexno;
    private String tablename;
    private String columnlist;
    private String quantity="1";
    private String dbName="";
    private String driverName ="";        
    private String dbURL ="";
    private String userName ="";
    private String password ="";
    private String databaseName="";
    private String schema="";
    private String whereList="";
    private String orderList="";
    private String dbType="MSSQL";
    private InitialEnvironment inv;
//    static private boolean loaddriver =false;
    private boolean iscreate=true;
    static private HashMap hloaddriver;
//    static private HashMap hiscreate;
    
    private transient Connection conn=null;

    //private ResultSet rst;
    
    
    public CscIndexTable(UProfile up){  
        this.uprofile=up;
       this.conn=this.createConnection();
       this.checkHiddenTable();
    }
    
    public CscIndexTable(UProfile up,String tablename,String column){   
        this.uprofile=up;
        this.setTablename(tablename);
        this.setColumnlist(column);
       this.conn= this.createConnection();
        this.checkHiddenTable();
    }

    public String getColumnlist() {
        return columnlist;
    }

    public String getAppname(){
            if((this.uprofile.get("appname")==null) || this.uprofile.get("appname").toString().trim().length()==0)
                return "company";
            return this.uprofile.get("appname").toString();
    }
    
    public void setColumnlist(String columnlist) {
        try{
           String[] oper = {">=","<=","!=","=","<>",">","<"," like "," between "," in "," and "," or ","=?","?"," where ","(",")"};
           columnlist=columnlist.replaceAll("'","");
//           System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>> COLUMNLIST >"+columnlist);
           StringTokenizer  tk=new StringTokenizer(columnlist.toLowerCase()," ");
           Vector v=new Vector();
           while(tk.hasMoreTokens()){
                    String col=" "+(String) tk.nextToken()+" ";
                    int count=0;
                    for(int vc=0;vc<oper.length;vc++){
                        if((col.toLowerCase().equalsIgnoreCase(oper[vc]))||(col.toLowerCase().indexOf(oper[vc])>-1)){
                            if(vc<=6 || vc==15){                                
                                col=col.trim();
                                int sub=col.indexOf(oper[vc]);
                                if(col.equals(oper[vc])||(sub==(col.length()-oper[vc].length()))){
                                    try{
                                    tk.nextToken();
                                    }catch(Exception ex){MyLog.error(this, ex);
}
                                }
                                if(sub==0)
                                    if(vc!=15)
                                        count++;
                                            else      
                                        col=col.substring(col.indexOf(oper[vc])+1);
                                else
                                    col=col.substring(0,col.indexOf(oper[vc]));
                            }else{
                                if(vc==7)
                                    tk.nextToken();
                                if(vc==8){
                                    tk.nextToken();
                                    tk.nextToken();
                                    tk.nextToken();
                                }

                                count++;
                            }
                                break;
                        }
                    }
                    col=col.trim();
                    if(count==0 && col.length()>0){
                         v.add(col);
                    }
           }
           String cL="";
           for(int c=0;c<v.size();c++){
               cL+=(String)v.get(c);
               if(c!=v.size()-1){
                   cL+=",";
               }
           }      
//           System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>> COLUMNLIST RESULT >"+cL);
        this.columnlist = cL;
        }catch(Exception ex){}
    }

    public String getIndexno() {
        return indexno;
    }

    public void setIndexno(String indexno) {
        this.indexno = indexno;
    }

    public String getQuantity() {
        return quantity;
    }

    public void setQuantity(String quantity) {
        this.quantity = quantity;
    }

    public String getTablename() {
        return tablename;
    }

    public void setTablename(String tablename) {
        this.tablename = tablename;
    }

    public UProfile getUprofile() {
        return uprofile;
    }

    public void setUprofile(UProfile uprofile) {
        this.uprofile = uprofile;
    }
    
    public void setData(String tablename,String column){
        this.setTablename(tablename);
        this.setColumnlist(column);
    }
       
    private Connection initConnection(String dbURL,String schema,String databaseName,String userName,String password,String driverName){
        Connection con =null;
        try {
            String url=dbURL+";user="+userName+";password="+password;
            Class.forName(driverName);
            con = DriverManager.getConnection(url);
            return con;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
    
    public ResultSet executeQuery(Connection connect,String sql){
        Statement stm =null;
        try {
            stm = connect.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
            return stm.executeQuery(sql);
        } catch (SQLException e) {
            //e.printStackTrace();
            return null;
        }           
    }
            
    public int executeUpdate(Connection connect,String sql){
        Statement stm =null;
        try {
            stm = connect.createStatement(ResultSet.TYPE_FORWARD_ONLY,ResultSet.CONCUR_UPDATABLE);
            return stm.executeUpdate(sql);
        } catch (SQLException e) {
            //e.printStackTrace();
        }finally {
            closeConnection(connect,stm);
        }         
        return 0;
    }
    private void closeConnection(Connection connection, Statement statement) {
        try {
            if (statement != null) {
                statement.close();
            }
        } catch (SQLException e) {
        }
        try {
            if (connection != null) {
                connection.close();
            }
        } catch (SQLException e) {
        }
    }    
    
    private void closeConnection(Connection connection) {
        try {
            if (connection != null) {
                connection.close();
            }
        } catch (SQLException e) {
        }
    } 
    
    public boolean search(){
       boolean searchindex=false;       
       try {
                   String sql="select indexno,tablenames,columnlist,quantity from cscindextable ";
                   sql+=" where modulename='"+this.getAppname()+"' and tablenames='"+tablename+"' and columnlist='"+columnlist+"' order by tablenames";
                   ResultSet rst=this.executeQuery(conn,sql);
                   searchindex=rst.next();
                   if(searchindex)
                   this.quantity=String.valueOf(rst.getInt("quantity")+1);          
                   rst.close();
    } catch (Exception e) {
       // e.printStackTrace();
    }
       return searchindex;
   } 
  
//   public boolean save(){    
//     try {
//     if(this.search()){
//             String qty=String.valueOf(rst.getInt("quantity")+1);
//             rst.updateString("quantity",qty);
//             rst.updateRow();
//     }else{
//             rst.moveToInsertRow();   
//             rst.updateString("tablename",this.tablename);
//             rst.updateString("columnlist",this.columnlist);
//             rst.updateString("quantity","1");
//             rst.insertRow();
//      } 
//     return true;
//     }catch(Exception ex){
//   }finally {
//          closeConnection(connect);
//      } 
//     return false;
//   }

    public void save(){
        this.save("C");
    }
    
    public boolean save(String type){
        //Connection con=null;
       try {
           String sql="";             
           if(columnlist.length()>0){
       if(this.search()){
               sql="update cscindextable set quantity='"+this.quantity+"'";
               sql+=" where modulename='"+this.getAppname()+"' and tablenames='"+tablename+"' and columnlist='"+columnlist+"' and sourcetype='"+type+"'";
       }else{
           sql="insert into cscindextable (modulename,tablenames,columnlist,quantity,sourcetype) values('"+this.getAppname()+"','"+this.tablename+"','"+this.columnlist+"','"+this.quantity+"','"+type+"')";
        } 
           
        //con=this.createConnection();
       this.executeUpdate(conn,sql);
       return true;
           }
       }catch(Exception ex){
    }finally {
            closeConnection(conn);
        } 
       return false;
    }

    private Connection createConnection(){
        Connection con=null;
        if(hloaddriver==null)
            hloaddriver=new HashMap();
        dbName=this.uprofile.getDbName();
        if(!hloaddriver.containsKey(dbName)){                
                inv=new InitialEnvironment(dbName);
                hloaddriver.put(dbName,inv);
                iscreate=false;
        }else{
            inv=(InitialEnvironment)hloaddriver.get(dbName);            
        }        
        driverName = inv.getValue("datasource-driver");        
        dbURL = inv.getValue("datasource-url");
        userName = inv.getValue("datasource-username");
        password = inv.getValue("datasource-password");
        databaseName=inv.getValue("datasource-dbname");
        schema=inv.getValue("schema-name");          
        dbType=inv.getValue("datasource-dbtype");        
        con=this.initConnection(dbURL,schema,databaseName,userName,password,driverName);
        return con;
    }       
    
   public static void main(String args[]){
       UProfile up=new UProfile();
       up.setDbName("ESBDB");
       up.set("lang", "eng");
       up.set("user","supervisor");
       up.set("employeeid","M01");
       up.set("companyid","001");
       up.set("schemaname","dbo");
       System.out.println("Start : "+System.currentTimeMillis());
       CscIndexTable ct=new CscIndexTable(up);
       ct.setTablename("memployee");
       ct.setColumnlist("usernameid='M01' and password like 'M01' and (startdate between '2006-01-01' and '2006-41-20') or (startdate between '2006-01-01' and '2006-41-20' )or empid = '5555' and companyid = ? and comapnyid = '10' and comapnyid='10' and comapnyid= '10' ");
      //ct.setColumnlist("usernameid= 'M01'");
       System.out.println(" > "+ct.columnlist);
     //  ct.save();
       System.out.println("End : "+System.currentTimeMillis());

   }

public String getOrderList() {
    return orderList;
}

public void setOrderList(String orderList) {
    this.orderList = orderList;
}

public String getWhereList() {
    return whereList;
}

public void setWhereList(String whereList) {
    this.whereList = whereList;
}

public void checkHiddenTable(){
    if(!iscreate){
    try {
        String script="select * from cscindextable";
        ResultSet rs=this.executeQuery(conn,script);
        if(rs==null){
            this.createTable();
        }
    } catch (Exception e) {
    }
   }
}

private void createTable(){
    try {
        String script="";
        if(dbType.equalsIgnoreCase("ORACLE")){
            script=" CREATE TABLE CSCINDEXTABLE( \n"+
            " INDEXNO INT NOT NULL,\n"+
            " MODULENAME VARCHAR2(30) NOT NULL,\n"+
            " TABLENAMES VARCHAR2(30) NOT NULL,\n"+
            " COLUMNLIST VARCHAR2(1000) NULL,\n"+
            " QUANTITY INT DEFAULT(1) NULL,\n"+
            " SOURCETYPE  VARCHAR2(30) NULL,\n"+
            " PRIMARY KEY(INDEXNO,MODULENAME,TABLENAMES)\n"+
            " ); ";
            this.executeQuery(conn,script);            
            script=" create sequence cscindextable_seq;";
            this.executeQuery(conn,script);        
            script="create or replace trigger cscindextable_ins_trig\n"
                +"before insert on cscindextable\n"
                +"for each row\n"
                +"declare\n"
                +"seq_val number;\n"
                +"begin\n"
                +"select cscindextable_seq.nextval\n"
                +"into seq_val from dual;\n"
                +":new.indexno := seq_val;\n"
                +"end;\n";
            
        }else{
         script=" CREATE TABLE CSCINDEXTABLE( \n"+
                      " INDEXNO INT IDENTITY (1, 1) NOT NULL,\n"+
                      " MODULENAME VARCHAR(30) NOT NULL,\n"+
                      " TABLENAMES VARCHAR(30) NOT NULL,\n"+
                      " COLUMNLIST VARCHAR(1000) NULL,\n"+
                      " QUANTITY INT DEFAULT(1) NULL,\n"+
                      " SOURCETYPE  VARCHAR(30) NULL,\n"+
                      " PRIMARY KEY(INDEXNO,MODULENAME,TABLENAMES)"+
                      " ); ";
        }
            this.executeQuery(conn,script);            
    } catch (Exception e) {
        e.printStackTrace();
    }
    iscreate=true;
}

}
