package com.csc.library.utilities;

import java.math.RoundingMode;
import java.text.DecimalFormat;

public class CscTime {
	
	private int HH;
	private int MM;
	private boolean isPositive = true;
	private int HHH, MMM;
	private boolean isPositivePositive;

	public CscTime() {
	}
	
	public CscTime(float HHMM) {
		this.separateHHMM(HHMM);
		this.HH = this.HHH;
		this.MM = this.MMM;
		this.isPositive = this.isPositivePositive;
	}

	private void separateHHMM(float HHMM) {
		if (HHMM < 0) {
			this.isPositivePositive = false;
			HHMM = -(HHMM);
		} else {
			this.isPositivePositive = true;
		}
		this.MMM = 0;
		this.HHH = (int) HHMM;
		if (this.HHH != HHMM) {
			float buff = ((HHMM * 100) - (this.HHH * 100));
			DecimalFormat f = new DecimalFormat("00");				
			this.MMM = Integer.parseInt((String) f.format(buff));
			//this.MMM = (int) buff;
			if (this.MMM > 59) {
				this.HHH += (int) (this.MMM / 60);
				this.MMM = this.MMM % 60;
			}
		}
	}

	public CscTime(int HH, int MM) {
		this.HH = HH;
		this.MM = MM;
	}

	public float DTOT(float tm) {
		// Convert Decimal unit to Time unit (12.50 -> 12.30)
		int buff;
		float buff1;
		boolean minus = false;
		if (tm != 0) {
			if (tm < 0) {
				tm = -(tm);
				minus = true;
			}
			buff = (int) tm;
			buff1 = (float) (tm - buff);
			if (buff1 != 0) {
				buff1 = (buff1 * 6) / 10;
				tm = buff + buff1;
			}
			DecimalFormat df = new DecimalFormat("00.00");
			tm = Float.valueOf(df.format((double) tm)).floatValue();
			if (minus) {
				tm = -(tm);
			}
		}
		return tm;
	}

	public float TTOD(float tm) {
		// Convert Time unit to Decimal unit (12.30 -> 12.50)
		int buff;
		float buff1;
		boolean minus = false;
		if (tm != 0) {
			if (tm < 0) {
				tm = -(tm);
				minus = true;
			}
			buff = (int) tm;
			buff1 = (float) (tm - buff);
			if (buff1 != 0) {
				buff1 = (buff1 * 100) / 60;
				tm = buff + buff1;
			}
			if (minus) {
				tm = -(tm);
			}
		}
		return tm;
	}

	public float TTOD() {
		float result = 0;
		result = (float) this.HH;
		if (this.MM > 0)
			result += ((float) this.MM) / 60;
		if (!this.isPositive) {
			result = -(result);
		}
		return result;
	}

	public float getFloat() {
		float result = 0;
		result = ((float) (this.HH));
		if (this.MM > 0)
			result += ((float) this.MM) / 100;

		if (!this.isPositive) {
			result = -(result);
		}
		return result;
	}

	public int getHour() {
		int result = 0;
		result = this.HH;
		if (!this.isPositive) {
			result = -(result);
		}
		return result;
	}

	public int getMinute() {
		int result = 0;
		result = this.MM;
		if (!this.isPositive) {
			result = -(result);
		}
		return result;
	}

	public void setHour(int HH) {
		if (HH < 0) {
			HH = -(HH);
		}
		this.HH = HH;
	}

	public void setMinute(int MM) {
		if (MM < 0) {
			MM = -(MM);
		}
		this.MM = MM;
	}
	
	public void add(double HHMM) {
		this.add(Float.parseFloat(String.valueOf(HHMM)));
	}

	public void add(float HHMM) {
		this.separateHHMM(HHMM);
		if (this.isPositive) {
			if (this.isPositivePositive) {
				this.addHour(this.HHH);
				this.addMinute(this.MMM);
			} else {
				this.subHour(this.HHH);
				this.subMinute(this.MMM);
			}
		} else {
			if (this.isPositivePositive) {
				this.subHour(this.HHH);
				this.subMinute(this.MMM);
			} else {
				this.addHour(this.HHH);
				this.addMinute(this.MMM);
			}
		}
	}
	
	public void sub(double HHMM) {
		this.sub(Float.parseFloat(String.valueOf(HHMM)));
	}

	public void sub(float HHMM) {
		this.separateHHMM(HHMM);
		if (this.isPositive) {
			if (this.isPositivePositive) {
				this.subHour(this.HHH);
				this.subMinute(this.MMM);
			} else {
				this.addHour(this.HHH);
				this.addMinute(this.MMM);
			}
		} else {
			if (this.isPositivePositive) {
				this.addHour(this.HHH);
				this.addMinute(this.MMM);
			} else {
				this.subHour(this.HHH);
				this.subMinute(this.MMM);
			}
		}
	}

	public void addMinute(int MM) {
		this.MM += MM;
		if (this.MM > 59) {
			this.HH += (int) (this.MM / 60);
			this.MM = this.MM % 60;
		}
	}

	public void addHour(int HH) {
		this.HH += HH;
	}

	public void subMinute(int MM) {
		if (this.MM < MM) {
			if (this.HH > 0) {
				this.HH -= 1;
				this.MM += 60;
			} else {
				this.reverse();
				this.MM = MM - this.MM;
				MM = 0;
			}
		}
		this.MM -= MM;
	}

	public void subHour(int HH) {
		if (this.HH < HH) {
			this.HH = HH - this.HH;
			int buff = this.MM;
			this.MM = this.MMM;
			this.MMM = buff;
			this.reverse();
		} else {
			this.HH -= HH;
		}
	}

	public void reverse() {
		if (this.isPositive) {
			this.isPositive = false;
		} else {
			this.isPositive = true;
		}
	}

	public void add(CscTime t) {
		this.add(t.getFloat());
	}

	public void sub(CscTime t) {
		this.sub(t.getFloat());
	}

	public void inc() {
		this.addMinute(1);
	}

	public void dec() {
		this.subMinute(1);
	}

	public void resetTime() {
		this.setHour(0);
		this.setMinute(0);
	}
	
	public double getDouble() {
		return Double.parseDouble(String.valueOf(this.getFloat()));
	}
}