package com.csc.library.utilities;

import java.io.File;
import java.util.Vector;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.session.InitialEnvironment;
public class DataLanguageXml {
	private String fieldLabel, fidleName, dataIndex, dbName;
	private Vector sfield;
	private Element rootObj, fieldObj;
	private SAXBuilder builder;
	private InitialEnvironment env;
	private ThaiUtilities th=new ThaiUtilities();
   private UProfile uPro=null;

	public DataLanguageXml(String dbName, String fieldName, String dataIndex) {
		this.initEnv();
		this.fidleName = fieldName;
		this.dataIndex = dataIndex;
		builder = new SAXBuilder();
		Document stru = null;
		try { 
			stru = builder.build(new File(env.getValue("xmlpath-reportxml") + "DataDic.xml"));
			rootObj = stru.getRootElement();
			fieldObj = rootObj.getChild(fieldName.toUpperCase());
		} catch (Exception ex) {
			MyLog.debug(this, uPro, "Field : " + fieldName + " Not Founed InDataDic");
		}
		this.process();
	}
    
    public DataLanguageXml(UProfile uPro, String fieldName, String dataIndex) {
        this.setUProfile(uPro);
        this.initEnv();
        this.fidleName = fieldName;
        this.dataIndex = dataIndex;
       this.initDoc(fieldName);
        this.process();
    }

    public void setUProfile(UProfile upro){
        this.uPro=upro;
    } 
    
    public Object getUProfile(String uName){
          try {
            if(this.uPro!=null && this.uPro.containsKey(uName)){
                  return this.uPro.get(uName);
              }
        } catch (Exception e) {
            MyLog.error(this,  uPro, "Upfofile can't get : " + uName + " Not Found");
        }  
        return null;
    }
    
    private void initDoc(String fieldName){
        builder = new SAXBuilder();
        Document stru = null;
        try { 
            String appname="";
            if((this.getUProfile("appname")!=null) && (this.getUProfile("appname").toString().length()>0)){
                  appname=(String)this.getUProfile("appname")+"/";
            }            
             try {
                        stru = builder.build(new File(env.getValue("xmlpath-reportxml") +appname+ "DataDic.xml"));
                   } catch (Exception e) {
                    MyLog.info(this, uPro,  " ::::::::::::::::::::::::: Load DataDic From Center");
                        stru = builder.build(new File(env.getValue("xmlpath-reportxml") +"DataDic.xml"));
                 }
            rootObj = stru.getRootElement();
            fieldObj = rootObj.getChild(fieldName.toUpperCase());
        } catch (Exception ex) {
        	 MyLog.error(this,  uPro, "*************************** Field : " + fieldName + " Not Founed InDataDic");
        }        
    } 
    
	private void process() {
		if (fieldObj != null && fieldObj.getAttributeValue("CENTRAL") != null) {
			fieldObj = rootObj.getChild(fieldObj.getAttributeValue("CENTRAL").toUpperCase());
		}
		try {
			if (this.dataIndex.equals("DEFAULT"))
				this.fieldLabel = fieldObj.getAttributeValue("T");
			else
				this.fieldLabel = fieldObj.getChild(this.dataIndex).getText();

		} catch (Exception e) {
			this.fieldLabel = this.fidleName;
			//e.printStackTrace();
			MyLog.error(this, uPro,  "***************************  Field " + this.fidleName + " Notfound in DataDic");
		}
	}

	public String getFieldLabel() {
		return th.ASCII2Unicode(fieldLabel);
	}
	private void initEnv() {
		//wut edit 21/10/03 tisco
		env = new InitialEnvironment("GLOBAL");
	}
    
    private void initEnv(String dbName) {
        //pas edit 28122005 
        env = new InitialEnvironment(dbName);
    }    
/*public static void main(String[] args) {
		DataLanguageXml d = new DataLanguageXml("TT3", "EMPNAME", "DEFAULT");
		System.out.println(d.getFieldLabel());
	}*/
}
