package com.csc.library.utilities;

import java.rmi.RemoteException;
import java.util.HashMap;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;

/**
 * @author
 * @SoCooL@
 * 
 */
public class DbData {
	private UProfile uprofile = null;

	private HashMap cacheData = new HashMap();
	
	private HashMap param = new HashMap();

	private boolean cache = false;


	public DbData(UProfile up) {
		this.setUProfile(up);
	}

	private String fetchDataToHash(String table, String field, String filter,
			String order, HashMap data) {
		try {
// comment by pas ͧҡ  initalInquiry Ẻö param 件֧ record 	Ҩ set param 仵ͧ set ͹ initMyTable		
//			DbInquiry inq = new InitialInquiry(this.getUprofile()).getDbInquiry(table, false);
			DbInquiry inq = new InitialInquiry(this.getUProfile()).getDbInquiry();
			if(this.param!=null&&this.param.size()>0)
				inq.setParam(param);
			inq.initMyTable(table,"","");
			if ((filter != null) && (!filter.equals(""))) {
				inq.setFilter(filter);
			}
			if ((order != null) && (!order.equals(""))) {
				inq.setOrderBy(order);
			}
			inq.setGroupfield("import");
			inq.refresh();
			inq.next();
			if (data != null)
				data.put(table, inq.getDataSet("").get("0"));
			return inq.getString(field);
		} catch (RemoteException e) {
			MyLog.error(this, this.getUProfile(),  e);
		}
		return "";
	}

	private String getFetchData(String table, String field) {
		return this.fetchDataToHash(table, field, "", "", null);
	}

	public String getString(String table, String field) {
		return this.getString(table, field, "", "");
	}

	public String getString(String table, String field, String filter) {
		return this.getString(table, field, filter, "");
	}

	public String getString(String table, String field, String filter,
			String order) {
		String fetchData = "";
		if (this.isCache()) {
			if (this.getCacheData().containsKey(table)) {// have
																						// data
																						// in
																						// cache
				return this.getFieldCache(table, field);
			} else {
				this.fetchDataToHash(table, field, filter, order, this
						.getCacheData());
				return this.getFieldCache(table, field);
			}
		} else {
			return this.getFetchData(table, field);
		}
	}

	public boolean isCache() {
		return cache;
	}

	public void setCache(boolean cache) {
		this.cache = cache;
	}

	protected String getFieldCache(String table, String field) {
		if (this.getCacheData().containsKey(table)) {
			HashMap result = (HashMap) this.getCacheData().get(table);
			if (result != null)
				return (String) result.get(field);
			return "";
		} else {
			MyLog.warn(this, getUProfile(),"Not Found Key:" + table);
			return null;
		}
	}

	protected HashMap getCacheData() {
		return cacheData;
	}

	protected void setCacheData(HashMap cacheData) {
		this.cacheData = cacheData;
	}

	/**
	 * Returns the uprofile.
	 * 
	 * @return UProfile
	 */
	public UProfile getUProfile() {
		return uprofile;
	}

	/**
	 * Sets the uprofile.
	 * 
	 * @param uprofile
	 *                   The uprofile to set
	 */
	public void setUProfile(UProfile uprofile) {
		this.uprofile = uprofile;
	}

	public void clearCacheData() {
		this.getCacheData().clear();
	}

	public HashMap getParam() {
		return param;
	}

	public void setParam(HashMap param) {
		this.param = param;
	}
	
	
}
