package com.csc.library.utilities;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.NamingEnumeration;
import javax.naming.directory.Attribute;
import javax.naming.directory.Attributes;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;

import com.csc.library.session.InitialEnvironment;

public class LdapAuthen {
	private InitialEnvironment env=new InitialEnvironment("GLOBAL");
	private String returnValue="";
	public LdapAuthen(){		
	}
	
	/*
	 * Oracle ldap
	public boolean authen(String UserName,String Password){
		try{
			InitialEnvironment env=new InitialEnvironment("GLOBAL");
			UserName="cn="+UserName;
			String hostName=env.getValue("ldap-host");
			String post=env.getValue("ldap-post");
			InitialDirContext ctx =  ConnectionUtil.getDefaultDirCtx(hostName, post,UserName,Password);
			User thisUser =  new User(ctx, Util.IDTYPE_SIMPLE, UserName, Util.IDTYPE_DN, null, false);	    	
		}catch(Exception ex){
			ex.printStackTrace();
			return false;
		}
		return true;
	}
	*/
	
	public boolean authen(String userName, String passWord) {
        try {  
        	userName=this.search(userName);
			Hashtable authEnv = new Hashtable();
			String url="ldap://"+env.getValue("ldap-host");
				if(env.getValue("ldap-port").trim().length()>0)
				url+=":"+env.getValue("ldap-port");

			String dn = env.getValue("ldap-search")+"="+userName ;
				if(env.getValue("ldap-basedn").trim().length()>0)
				dn+=","+env.getValue("ldap-basedn");

			authEnv.put(Context.INITIAL_CONTEXT_FACTORY, env.getValue("ldap-factory"));
			authEnv.put(Context.PROVIDER_URL, url);
			authEnv.put(Context.SECURITY_AUTHENTICATION, env.getValue("ldap-authen"));
			authEnv.put(Context.SECURITY_PRINCIPAL, dn);
			authEnv.put(Context.SECURITY_CREDENTIALS, passWord);
			DirContext ctx = new InitialDirContext(authEnv);
			Attributes attr = ctx.getAttributes(dn);
			this.returnValue=(String)((Attribute)attr.get(env.getValue("ldap-return"))).get();
		    ctx.close();
			return true;
		} catch (Exception e) {
			MyLog.error("Ldap Authen fail !!!!! > "+e);
			return false;
		}
	}
	
	public String getLdapReturn(){
		return this.returnValue.trim();
	}
	
	  public String search(String userName){
		    String attReturn=userName; 
		    if(env.getValue("ldap-filter").trim().length()==0)
		    	  return attReturn;
			    try{		    
				    Hashtable auEnv = new Hashtable();
		
				    auEnv.put(Context.INITIAL_CONTEXT_FACTORY, env.getValue("ldap-factory"));
		
				    String ldapUrl = "ldap://"+env.getValue("ldap-host")+":"+env.getValue("ldap-port")+"/";
				    String dn=env.getValue("ldap-basedn");
				    String base = dn.substring(0,dn.indexOf(","));
				    
				    ldapUrl+=dn.substring(dn.indexOf(",")+1,dn.length());
				    
				    auEnv.put(Context.PROVIDER_URL, ldapUrl);

				    DirContext dctx = new InitialDirContext(auEnv);
				    
				    SearchControls sc = new SearchControls();
				    String[] attributeFilter = {env.getValue("ldap-search"),env.getValue("ldap-filter")};
				    sc.setReturningAttributes(attributeFilter);
				    sc.setSearchScope(SearchControls.SUBTREE_SCOPE);
		
				    String filter = "(&("+env.getValue("ldap-filter")+"="+userName+"))";
				    NamingEnumeration results = dctx.search(base, filter, sc);
				    while (results.hasMore()) {
				      SearchResult sr = (SearchResult) results.next();
				      Attributes attrs = sr.getAttributes();
				      Attribute attr = attrs.get(env.getValue("ldap-search"));
				      attReturn=(String)attr.get();
				    }
				    dctx.close();
			    }catch(Exception ex){			    	
			    	return attReturn;
			    }
		    return attReturn;
		  }			
	
}
