package com.csc.library.utilities;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.database.StaticProperties;
import com.csc.library.session.InitialEnvironment;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 * using example :
 * String strXMLPath = new getProfiles("menuxml","XMLPATH").getValue() ; // get xml file path
 * String strFile = "menus.xml"; // set xml file name
 * 
 * menus menu = new menus();
 * String strMenu = menu.getMenu(strXMLPath,strFile,screen.getuProfile()); // get menu
 **/
public class Menus {
	private String					strXMLPath	= "";								// input/ouput xml file path
	private String					strFile		= "";								// input xml file name
	private String					strLang		= "";								// input/ouput xml file path
	private StringBuffer			sb			= new StringBuffer();
	private org.jdom.Element		propElement;									// keep properties items
	private org.w3c.dom.Document	doc;											// keep xml document (for write)
	private org.w3c.dom.Element		root;											// root element
	private Map						menu		= new TreeMap();
	private List					list;
	private InitialEnvironment		env;
	private UProfile				upf=null;
    private String formMenuXML="WF09A";//  group ͧẺ͡ WF_MENU.xml    
    
	public Menus() {
	}
	public Menus(UProfile upf) {
		this.upf = upf;
	}
	/**
	 * function : get data items from menus.xml
	 */
	private void getProperties() {
		try {
			SAXBuilder builder = new SAXBuilder();
			org.jdom.Document docProp = builder.build(new File(this.strXMLPath + this.strFile));
			propElement = docProp.getRootElement(); // get xml root element from xml file
		} catch (Throwable e) {
			MyLog.error(this, this.upf, "Error (menus.getProperties) : " + e);
		}
	}
	/**
	 *
	 * @param xmlpath
	 * function : set xml path
	 */
	public void setXMLPath(String xmlpath) {
		try {
			strXMLPath = xmlpath;
		} catch (Throwable e) {
			MyLog.error(this, this.upf,"Error (menus.setXMLPath) : " + e);
		}
	}
	/**
	 *
	 * @param xmlfile
	 * function : set xml file name
	 */
	public void setXMLFile(String xmlfile) {
		try {
			strFile = xmlfile;
		} catch (Throwable e) {
			MyLog.error(this, this.upf, "Error (menus.setXMLFile) : " + e);
		}
	}
	/**
	 *
	 * @param xmlpath
	 * @param xmlfile
	 * @param user
	 * @return
	 * function :
	 *    - read menu item from config file
	 *    - check each menu with user authority and generate tag menu to html format
	 */
	public String getMenu(String xmlpath, String xmlfile, UProfile user) {
		StringBuffer sbMenu = new StringBuffer();
		try {
			setXMLPath(xmlpath);
			setXMLFile(xmlfile);
			setLanguage(user);
			getProperties();
			genMenu(propElement, user);
			sbMenu.append("<div nowrap><ul id='foldinglist' style=&{head};>");
			sbMenu.append(sb.toString());
			if (this.getLanguage().equalsIgnoreCase("tname")) {
				sbMenu.append("<li><a href=\"javascript:logout();\"><font size='2'>&nbsp;&nbsp;Ѻ˹Ҩѡ</font></a></li>");
			} else
				sbMenu.append("<li><a href=\"javascript:logout();\"><font size='2'>&nbsp;&nbsp;Global Menu</font></a></li>");
			sbMenu.append("</ul></div>");
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return sbMenu.toString();
	}
    
    public String getWFMenu(String xmlpath, String xmlfile, UProfile user){
        StringBuffer sbMenu = new StringBuffer();
        try {
            setXMLPath(xmlpath);
            setXMLFile(xmlfile);
            setLanguage(user);
            getProperties();
            genWFMenu(propElement, user);
            sbMenu.append("<div nowrap>");
            sbMenu.append(sb.toString());
            sbMenu.append("</div>");
        } catch (Exception e) {
			MyLog.error(this, this.upf, e);
        }
        return sbMenu.toString();
    }
    
    private void genWFMenu(Element menuNode, UProfile user) {
        Element child;
        List list1;
        String strName;
        HashMap hmap = new HashMap();     
        try {
            this.initEnv();
//          Authorizable sc = new InitialAuthorize(user.get("username"), user.get("password"), user.getDbName()).getAuthorize();
            list1 = menuNode.getChildren("MENU");
            int z=0;
            for (int i = 0; i < list1.size(); i++) {
                child = (Element) list1.get(i);
                strName = child.getAttributeValue(this.getLanguage());
                hmap.put("menucode", child.getAttributeValue("code"));
                if (StaticProperties.jspAuthen.checkmenu(user, (String)child.getAttributeValue("code"))) { // check user level if this user have authority to access return true
                    if(child.getAttributeValue("group").indexOf(formMenuXML)!=-1){//check  group ͧẺ͡  
                        if (child.getChildren("MENU").size() > 0) {
                            if(z%2!=0){
                                sb.append("<td height='15'><div align='left'>").append("&nbsp;").append("</div></td></tr>");
                                z++;
                            }
                            if(child.getAttributeValue("group").equalsIgnoreCase(formMenuXML))
                                sb.append("<tr bgcolor='#EFF7FA'><td height='15' colspan='2' bgcolor='#00CCCC'<div align='center'><b>").append(strName).append("</b></div></td></tr>");
                            else
                                sb.append("<tr bgcolor='#EFF7FA'><td height='15' colspan='2' bgcolor='#00CCCC'<div align='center'>").append(strName).append("</div></td></tr>");
                            genWFMenu(child, user);
                        } else {
                            if(z%2==0){//ͨѴ2
                                sb.append("<tr bgcolor='#EFF7FA'><td height='15'><div align='left'><INPUT TYPE='radio' NAME='web_link'  VALUE='").append(child.getAttributeValue("link")).append("'>&nbsp;").append(strName).append("</div></td>");
                                z++;
                            }
                            else{
                                sb.append("<td height='15'><div align='left'><INPUT TYPE='radio' NAME='web_link'  VALUE='").append(child.getAttributeValue("link")).append("'>&nbsp;").append(strName).append("</div></td></tr>");
                                z++;
                            }
                        }
                    }
                }
            }
            if(z%2!=0)
                sb.append(" <td height='15'><div align='left'>").append("&nbsp;").append("</div></td></tr>");
        } catch (Exception e) {
			MyLog.error(this, this.upf, "Error (menus.genMenu) : " + e);
        }
    }
    public String getGlobalMenuNSTDA(String xmlpath, String xmlfile, UProfile user) {
		StringBuffer sbMenu = new StringBuffer();
		try {
			setXMLPath(xmlpath);
			setXMLFile(xmlfile);
			setLanguage(user);
			getProperties();
			genGlobalMenu(propElement, user);
			sbMenu.append("<table width=\"100%\" border=\"0\" cellspacing=\"3\" cellpadding=\"3\">");
			sbMenu.append(sb.toString());
			Element menuNode= propElement;
		      Element child;
		        List list1;
		        StringBuffer fbMenu = new StringBuffer();
		        try {
		            list1 = menuNode.getChildren("SETTINGMENU");
		            child = (Element) list1.get(0);    
		            // Ѻ Ƿ
		            fbMenu.append("<td><div align=\"center\"><a href=\"" + child.getAttributeValue("link") + "\"><img src=\"" + child.getAttributeValue("img") + "\" border=\"" + child.getAttributeValue("border") + "\"></a></div></td></tr>");
		            fbMenu.append("<tr>");		        
		            fbMenu.append("<td>&nbsp;</td>");
		            list1 = menuNode.getChildren("LOGOUTMENU");
		            child = (Element) list1.get(0);
		            fbMenu.append("<td><div align=\"center\"><a href=\"" + child.getAttributeValue("link") + "\"><img src=\"" + child.getAttributeValue("img") + "\" border=\"" + child.getAttributeValue("border") + "\"></a></div></td>");
		            fbMenu.append("<td>&nbsp;</td>");
		            fbMenu.append("</tr></table>");
		        } catch (Exception e) {
		            MyLog.error(this,"Error (menus.genMenu) : " + e);
		            fbMenu.append("<tr>");
		            fbMenu.append("<td><div align=\"center\"><a href=\"javascript:linkModule('SETTING/SET_Index.jsp');\"><img src=\"images/icon/system_set.jpg\" border=\"0\"></a></div></td>");
		            fbMenu.append("<td>&nbsp;</td>");
		            fbMenu.append("<td><div align=\"center\"><a href=\"javascript:logout();\"><img src=\"images/icon/exit.jpg\" border=\"0\"></a></div></td>");		            
		            fbMenu.append("</tr></table>");
		        }
			
		        sbMenu.append(fbMenu.toString());
        } catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return sbMenu.toString().replaceFirst("<td></td></tr>", "");
	}
    public String getGlobalMenu(String xmlpath, String xmlfile, UProfile user) {
		StringBuffer sbMenu = new StringBuffer();
		try {
			setXMLPath(xmlpath);
			setXMLFile(xmlfile);
			setLanguage(user);
			getProperties();
			genGlobalMenu(propElement, user);
			sbMenu.append("<table width=\"100%\" border=\"0\" cellspacing=\"3\" cellpadding=\"3\">");
			sbMenu.append(sb.toString());
            sbMenu.append(genFooterGlobalMenu(propElement, user));
        } catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return sbMenu.toString();
	}
	/**
	 * function :
	 *    - this method is recusive function
	 *    - read each xml element (menu element) ,check menu group_id with group_id in uProfile
	 *      return true(authority pass) or false(can't access this menu)
	 *    - generate tag html
	 * @param ulang
	 */
	private void setLanguage(UProfile ulang) {
		String myLang = "";
		try {
			if (ulang.get("lang") != null) {
				myLang = ulang.get("lang");
				if (myLang.equalsIgnoreCase("tha")) {
					this.strLang = "tname";
				} else {
					this.strLang = "ename";
				}
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, "Error (menus.setLanguage) : " + e);
		}
	}
	private String getLanguage() {
		return this.strLang;
	}
	private void genMenu(Element menuNode, UProfile user) {
		Element child;
		List list1;
		String strName, strUser;
		HashMap hmap = new HashMap();
		try {
			this.initEnv();
//			Authorizable sc = new InitialAuthorize(user.get("username"), user.get("password"), user.getDbName()).getAuthorize();
			list1 = menuNode.getChildren("MENU");
			for (int i = 0; i < list1.size(); i++) {
				child = (Element) list1.get(i);
				strName = child.getAttributeValue(this.getLanguage());
				hmap.put("menucode", child.getAttributeValue("code"));
				if (StaticProperties.jspAuthen.checkmenu(user, (String)child.getAttributeValue("code"))) { // check user level if this user have authority to access return true
                    if(child.getAttributeValue("group").indexOf(formMenuXML)==-1){//check WF_MENU.xml ҵͧ仵çѺ group ͧẺ͡ 
    					if (child.getChildren("MENU").size() > 0) {
    						sb.append("<li id='foldheader'><font size='2'>&nbsp;&nbsp;").append(strName).append("</font></li>\n");
    						sb.append("<ul id='foldinglist' style='display:none' style=&{head};>\n");
    						genMenu(child, user);
    						/*
    						 if(this.getLanguage().equalsIgnoreCase("tname")){
    						 sb.append("<MENU name=\"͡ҡк\" link=\"javascript:logout();\"/>");
    						 }else
    						 sb.append("<MENU name=\"Logout\" link=\"javascript:logout();\"/>");
    						 */
    						sb.append("</ul>");
    					} else {
    						sb.append("<li><a href=\"").append(child.getAttributeValue("link")).append("\"").append(" target=\"").append(child.getAttributeValue("target")).append("\"");
    						sb.append("><font size='2'>&nbsp;&nbsp;" + strName + "</font></a></li>\n");
    					}
                    }
				}
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, "Error (menus.genMenu) : " + e);
		}
	}
	private void genGlobalMenu(Element menuNode, UProfile user) {
		Element child;
		List list1;
		String strName, strUser;
		HashMap hmap = new HashMap();
		try {
			this.initEnv();
//			Authorizable sc = new InitialAuthorize(user.get("username"), user.get("password"), user.getDbName()).getAuthorize();
			list1 = menuNode.getChildren("MENU");
			int j = 0;
			for (int i = 0; i < list1.size(); i++, j++) {
				child = (Element) list1.get(i);
				strName = child.getAttributeValue(this.getLanguage());
				hmap.put("menucode", child.getAttributeValue("code"));
				if (j == 0) {
					sb.append("<tr>");
				}
				if (StaticProperties.jspAuthen.checkmenu(user, (String)child.getAttributeValue("code"))) { // check user level if this user have authority to access return true
					sb.append("<td><div align=\"center\"><a href=\"" + child.getAttributeValue("link") + "\"><img src=\"" + child.getAttributeValue("img") + "\" border=\"" + child.getAttributeValue("border") + "\"></a></div></td>");
				} else {
					sb.append("<td><div align=\"center\"><img src=\"" + child.getAttributeValue("disimg") + "\" border=\"" + child.getAttributeValue("border") + "\"></div></td>");
				}
				if (j == 2) {
					sb.append("</tr>");
					j = -1;
				}
			}
			if(j==1){
				sb.append("<td></td></tr>");
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, "Error (menus.genMenu) : " + e);
		}
	}
    
    private String genFooterGlobalMenu(Element menuNode, UProfile user) {
        Element child;
        List list1;
        StringBuffer fbMenu = new StringBuffer();
        try {
            list1 = menuNode.getChildren("SETTINGMENU");
            child = (Element) list1.get(0);            
            fbMenu.append("<tr>");
            fbMenu.append("<td><div align=\"center\"><a href=\"" + child.getAttributeValue("link") + "\"><img src=\"" + child.getAttributeValue("img") + "\" border=\"" + child.getAttributeValue("border") + "\"></a></div></td>");
            fbMenu.append("<td>&nbsp;</td>");
            list1 = menuNode.getChildren("LOGOUTMENU");
            child = (Element) list1.get(0);
            fbMenu.append("<td><div align=\"center\"><a href=\"" + child.getAttributeValue("link") + "\"><img src=\"" + child.getAttributeValue("img") + "\" border=\"" + child.getAttributeValue("border") + "\"></a></div></td>");
            fbMenu.append("</tr></table>");
        } catch (Exception e) {
            MyLog.error(this,"Error (menus.genMenu) : " + e);
            fbMenu.append("<tr>");
            fbMenu.append("<td><div align=\"center\"><a href=\"javascript:linkModule('SETTING/SET_Index.jsp');\"><img src=\"images/icon/system_set.jpg\" border=\"0\"></a></div></td>");
            fbMenu.append("<td>&nbsp;</td>");
            fbMenu.append("<td><div align=\"center\"><a href=\"javascript:logout();\"><img src=\"images/icon/exit.jpg\" border=\"0\"></a></div></td>");
            fbMenu.append("</tr></table>");
            return fbMenu.toString();
        }
        return fbMenu.toString();
    }
    
    
	private void initEnv() {
		env = new InitialEnvironment("GLOBAL");
	}
	
    public String getMenuHR(String xmlpath, String xmlfile, UProfile user) {
		StringBuffer sbMenu = new StringBuffer();
		try {
			setXMLPath(xmlpath);
			setXMLFile(xmlfile);
			setLanguage(user);
			getProperties();
			genMenuHR(propElement, user);
			sbMenu.append("<tr><td>");
			sbMenu.append(sb.toString());
			sbMenu.append("</td></tr>");
		} catch (Exception e) {
			MyLog.error(this, user, e);
		}
		return sbMenu.toString();
	}
    
    
	private void genMenuHR(Element menuNode, UProfile user) {
		/*Element child;
		List list1;
		String strName, strUser;
		HashMap hmap = new HashMap();
		try {
			this.initEnv();
//			Authorizable sc = new InitialAuthorize(user.get("username"), user.get("password"), user.getDbName()).getAuthorize();
			list1 = menuNode.getChildren("MENU");
			String mu="";
			for (int i = 0; i < list1.size(); i++) {
				child = (Element) list1.get(i);
				strName = child.getAttributeValue(this.getLanguage());
				hmap.put("menucode", child.getAttributeValue("code"));
				if (StaticProperties.jspAuthen.checkmenu(user, (String)child.getAttributeValue("code"))) { // check user level if this user have authority to access return true
    					mu+="<a href=\""+child.getAttributeValue("link")+"\""+" target=\""+child.getAttributeValue("target")+"\"";
    					mu+=">&nbsp;&nbsp;" + strName + "</a>|";
				}
			}
			if(mu.length()>0)
				sb.append(mu.substring(0, mu.toString().length()-1));
		} catch (Exception e) {
			MyLog.error(this, this.upf, "Error (menus.genMenu) : " + e);
		}*/
	}	
}
