package com.csc.library.utilities;

import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.InitialEnvironment;

public class MessagePools {
	private MyHashMap msgPools=null;
	
	public MessagePools(){
		
	}
	
	public void loadMessage(){
		msgPools=new MyHashMap();
		InitialEnvironment inv=new InitialEnvironment();
		Element root=this.getRootElement(inv.getValue("config-dir")+"MESSAGE");
		List list=root.getChildren("MSG");
		MessageProperties msg=null;
		for(int n=0;n<list.size();n++){
			Element e= (Element)list.get(n);
			msg=new MessageProperties();
			msg.setMSGCODE(e.getAttributeValue("code"));
			msg.setMSGTYPE(e.getAttributeValue("type"));
//			System.out.println("name="+e.getName()+" code="+msg.getMSGCODE()+" type="+msg.getMSGTYPE());
			Element tha=e.getChild("THA");
			Element eng=e.getChild("ENG");
			msg.setMSGTHA(tha.getChildText("MSG"));
			msg.setMSGENG(eng.getChildText("MSG"));
			msg.setSUGGESTTHA(tha.getChildText("SUGGEST"));
			msg.setSUGGESTENG(eng.getChildText("SUGGEST"));
			msgPools.put(msg.getMSGCODE(),msg);
		}
	}

    private Element getRootElement(String fileName) {
        SAXBuilder builder = new SAXBuilder();
        Document stru = null;
        try {
                stru = builder.build(fileName+".xml");
                return stru.getRootElement();
        } catch (Exception ex) {
                return null;
        }
    }        
    
    public MessageProperties getMessage(String msgcode){
    	if(msgPools.containsKey(msgcode.toUpperCase())){
    		return (MessageProperties)msgPools.get(msgcode.toUpperCase());
    	}
    	return null;
    }    

    public String getMessage(String msgcode,String lang){
    	MessageProperties ms=this.getMessage(msgcode);
    	if(ms!=null){
    		ms.setLANG(lang.toUpperCase());
    		return ms.getMessage();
    	}
    	return "";
    } 
    
    public String getAllMessage(String msgcode,String lang){
    	MessageProperties ms=this.getMessage(msgcode);
    	String message="";
    	if(ms!=null){
    		ms.setLANG(lang.toUpperCase());
    		message+=ms.getMessage();
    		message+="\n"+ms.getSuggest();
    	}
    	return message;
    }
    
    public String getSuggest(String msgcode,String lang){
    	MessageProperties ms=this.getMessage(msgcode);
    	if(ms!=null){
    		ms.setLANG(lang.toUpperCase());
    		return ms.getSuggest();
    	}
    	return "";
    }    

    
    public static void main(String args[]){
    	MessagePools p=new MessagePools();
    	p.loadMessage();
    }
}
