package com.csc.library.utilities;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

public class MyLoadClass extends ClassLoader {

	public MyLoadClass() {}

	public Class loadClass(String name, boolean resolve) throws ClassNotFoundException {
		try {
			return findSystemClass(name);
		} catch (ClassNotFoundException e) {	
			MyLog.error(this, e);
			} catch (NoClassDefFoundError e) {
				MyLog.error(this,e.getMessage());
}

		byte[] buf = bytesForClass(name);
		if (buf == null)
			throw new ClassNotFoundException(name);

		Class newClass = defineClass(name, buf, 0, buf.length);
		if (newClass == null)
			throw new ClassNotFoundException(name);
		//this.logger.info("newClass: " + newClass);

		if (resolve)
			resolveClass(newClass);
		return newClass;
	}

	private byte[] bytesForClass(String name) {
		String fullName = name + ".class";
		File inputFile = new File(fullName);
		FileInputStream in = null;
		try {
			in = new FileInputStream(inputFile);
			ByteArrayOutputStream buffer = new ByteArrayOutputStream();
			int ch;
			while ((ch = in.read()) != -1)
				buffer.write(ch);

			return buffer.toByteArray();
		} catch (IOException e) {
			MyLog.error(this, e);
			if (in != null) {
				try {
					in.close();
				} catch (IOException e2) {	MyLog.error(this, e2);}
			}
			return null;
		}
	}
}
