package com.csc.library.utilities;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;

import javax.mail.MessagingException;

import koala.dynamicjava.interpreter.InterpreterException;

import org.jdom.JDOMException;

import com.csc.library.database.RecordManager;
import com.csc.library.database.StaticProperties;
import com.csc.library.process.MyProcess;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbTable;
import com.csc.library.session.RecordCmp;
import com.csc.library.session.RecordCmp0;
import com.csc.library.session.keepLog;

public class MyLog {
	static boolean Debug = false;
	static boolean Display = true;
	static boolean Info = false;
	static boolean Production = true;
	static boolean Warning = false;
	static CscCalendar mydate=null;
	static String trace="tracefile";
	static String tracename="tracername";
	static DateFormat myLogDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss,sss");
	
	static public void debug(DbInquiry o, Exception e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(DbInquiry o, RemoteException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(DbInquiry o, SQLException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(DbInquiry o, String e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(DbTable o, Exception e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(DbTable o, RemoteException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(DbTable o, SQLException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(DbTable o, String e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(keepLog o, Exception e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(keepLog o, RemoteException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(keepLog o, SQLException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(Object o, double message) {
		MyLog.debugLogMessage(o, null, String.valueOf(message));
	}

	static public void debug(Object o, String message) {
		MyLog.debugLogMessage(o, null, message);
	}

	static public void debug(Object o, Exception e) {
		debugLogMessage(o, null, e);
	}

	static public void debug(Object o, UProfile up, Exception e) {
		debugLogMessage(o, up, e);
	}

	static public void debug(Object o, UProfile up, String message) {
		debugLogMessage(o, up, message);
	}

	static public void debug(RecordCmp0 o, RemoteException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(RecordCmp0 o, SQLException e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(RecordCmp0 o, String e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void debug(String message) {
		MyLog.debugLogMessage(null, null, message);
	}

	static public void error(DbInquiry o, String e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(MyProcess o, Exception e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(MyProcess o, RemoteException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, ClassCastException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, ClassNotFoundException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, double message) {
		MyLog.errorLogMessage(o, null, String.valueOf(message));
	}

	static public void error(Object o, Exception e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(RecordCmp o, NumberFormatException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(RecordCmp0 o, NumberFormatException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, FileNotFoundException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, IllegalAccessException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, InstantiationException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, InterpreterException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, IOException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o,java.security.InvalidAlgorithmParameterException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, java.security.InvalidKeyException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, java.security.NoSuchAlgorithmException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, javax.crypto.NoSuchPaddingException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, JDOMException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, MessagingException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, NumberFormatException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, RemoteException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, RuntimeException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, SQLException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(Object o, String message) {
		MyLog.errorLogMessage(o, null, message);
	}

	static public void error(Object o, UProfile up, Exception e) {
		errorLogMessage(o, up, e);
	}

	static public void error(Object o, UProfile up, InterpreterException e) {
		errorLogMessage(o, up, e);
	}

	static public void error(Object o, UProfile up, ParseException e) {
		MyLog.errorLogMessage(o, up, e);
	}

	static public void error(Object o, UProfile up, SQLException e) {
		MyLog.errorLogMessage(o, up, e);
	}

	static public void error(Object o, UProfile up, String message) {
		errorLogMessage(o, up, message);
	}

	static public void error(RecordCmp o, Exception e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(RecordCmp o, RemoteException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(RecordCmp o, RuntimeException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(keepLog o, Exception e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(RecordCmp o, SQLException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(RecordCmp0 o, Exception e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void error(String message) {
		MyLog.errorLogMessage(null, null, message);
	}

	static public void fatal(DbInquiry o, Exception e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(DbInquiry o, RemoteException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(DbInquiry o, SQLException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(DbInquiry o, String e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(DbTable o, Exception e) {
		MyLog.debugLogMessage(o, null, e);
	}

	static public void fatal(DbTable o, RemoteException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(DbTable o, SQLException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(DbTable o, String e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(keepLog o, Exception e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void error(keepLog o, RemoteException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void fatal(keepLog o, RemoteException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void error(keepLog o, SQLException e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void fatal(keepLog o, SQLException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(Object o, double message) {
		MyLog.fatalLogMessage(o, null, String.valueOf(message));
	}

	static public void fatal(Object o, String message) {
		MyLog.debugLogMessage(o, null, message);
	}

	static public void fatal(RecordCmp0 o, Exception e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(RecordCmp0 o, RemoteException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void fatal(RecordCmp0 o, SQLException e) {
		MyLog.fatalLogMessage(o, null, e);
	}

	static public void error(keepLog o, String e) {
		MyLog.errorLogMessage(o, null, e);
	}

	static public void fatal(RecordCmp0 o, String e) {
		MyLog.fatalLogMessage(o, null, e);
	}



	static public void info(DbInquiry o, Exception e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(DbInquiry o, RemoteException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(DbInquiry o, SQLException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(DbInquiry o, String e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(DbTable o, Exception e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(DbTable o, RemoteException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(DbTable o, SQLException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(DbTable o, String e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(keepLog o, Exception e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(keepLog o, RemoteException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(keepLog o, SQLException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(Object o, double message) {
		MyLog.infoLogMessage(o, null, String.valueOf(message));
	}

	static public void info(Object o, String message) {
		MyLog.infoLogMessage(o, null, message);
	}

	static public void info(Object o, UProfile up, Exception e) {
		infoLogMessage(o, up, e);
	}

	static public void info(Object o, UProfile up, String message) {
		infoLogMessage(o, up, message);
	}

	static public void info(RecordCmp0 o, Exception e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(RecordCmp0 o, RemoteException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(RecordCmp0 o, SQLException e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(RecordCmp0 o, String e) {
		MyLog.infoLogMessage(o, null, e);
	}

	static public void info(String message) {
		MyLog.infoLogMessage(null, null, message);
	}

	static public void infoLogMessage(Object o, UProfile up, Exception e) {
		if (o != null && up != null) {
			if ((MyLog.Production  || MyLog.Display)&& up.getLogInFo()) {
				MyLog.writeLog("i", o, up, MyLog.getString(e));
			}
		} else {
			if (up != null) {
				if ((MyLog.Production|| MyLog.Display)&& up.getLogInFo()) {
					MyLog.writeLog("i", up, MyLog.getString(e));
				}
			} else {
				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("i", MyLog.getString(e));
				}
			}
		}
	}

	static public void error(Object o, RecordCmp0 db, Exception e) {
		if (o != null) {
			if (MyLog.Production||db.getUProfile().getLogProduction()|| MyLog.Display||db.getUProfile().getLogDisplay()) {
				MyLog.writeLog("e", db, o.getClass().getName() + " : "+ MyLog.getString(e));
			}
		} else {
			e.printStackTrace();
		}
	}

	static public void error(Object o, RecordManager db, Exception e) {
		if (o != null) {
			if (MyLog.Production||db.getUProfile().getLogProduction()|| MyLog.Display||db.getUProfile().getLogDisplay()) {
				MyLog.writeLog("e", db, o.getClass().getName() + " : "+ MyLog.getString(e));
			}
		} else {
				e.printStackTrace();
		}
	}

	static public void error(Object o, RecordManager db, String message) {
		if (o != null) {
			if (MyLog.Production||db.getUProfile().getLogProduction()|| MyLog.Display||db.getUProfile().getLogDisplay()) {
				MyLog.writeLog("e", db, o.getClass().getName() + " : "+ message);
			}
		} else {
				System.out.println(message);
		}
	}

	static public void message(DbInquiry db, String message) {
		MyLog.message(db, null, message);
	}

	static public void message(DbTable db, String message) {
		MyLog.message(db, null, message);
	}

	static public void message(RecordCmp0 db, String message) {
		MyLog.message(db, null, message);
	}

	static public void warn(DbInquiry o, String e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(DbTable o, Exception e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(DbTable o, RemoteException e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(DbTable o, SQLException e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(DbTable o, String e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(keepLog o, Exception e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(keepLog o, RemoteException e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(keepLog o, SQLException e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(Object o, double message) {
		MyLog.warnLogMessage(o, null, String.valueOf(message));
	}

	static public void warn(Object o, Exception e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(Object o, String message) {
		MyLog.warnLogMessage(o, null, message);
	}

	static public void warn(Object o, UProfile up, Exception e) {
		warnLogMessage(o, up, e);
	}

	static public void warn(Object o, UProfile up, String message) {
		warnLogMessage(o, up, message);
	}

	static public void warn(RecordCmp0 o, Exception e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(RecordCmp0 o, RemoteException e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(RecordCmp0 o, SQLException e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(RecordCmp0 o, String e) {
		MyLog.warnLogMessage(o, null, e);
	}

	static public void warn(String message) {
		if (MyLog.Production) {
			MyLog.writeLog("w", message);
		}
		if (MyLog.Display) {
			System.out.println(message);
		}
	}
	
	static public String getYYYYMMDDHHMMSS(){
		/*if(MyLog.mydate==null){
			MyLog.mydate=new CscCalendar();
		}
		return MyLog.mydate.getYYYYMMDDHHMMSS();*/
		/* Log ѹ ǡѹ ͷǨͺ By Tong_Zuu*/
		return myLogDateFormat.format(GregorianCalendar.getInstance().getTime());
	} 

	static private UProfile getUprofile(RecordCmp0 db) {
		UProfile up = null;
		if (db != null) {
			up = db.getUProfile();
		}
		if (up == null)
			up = new UProfile();
		return up;
	}

	static private UProfile getUprofile(DbInquiry db) {
		UProfile up = null;
		if (db != null) {
			up = db.getUProfile();
		}
		if (up == null)
			up = new UProfile();
		return up;
	}

	static private UProfile getUprofile(DbTable db) {
		UProfile up = null;
		if (db != null) {
			up = db.getUProfile();
		}
		if (up == null)
			up = new UProfile();
		return up;
	}	
	static public void debugLogMessage(Object o, UProfile up, Exception e) {
		if (o != null && up != null) {
			if ((MyLog.Production || MyLog.Display)&& (up.getLogDebug()||up.getProcessid().length()>0)) {
				MyLog.writeLog("d", o, up, MyLog.getString(e));
			}
		} else {
			if (up != null) {
				if ((MyLog.Production|| MyLog.Display) && (up.getLogDebug()||up.getProcessid().length()>0)) {
					MyLog.writeLog("d", up, MyLog.getString(e));
				}
			} else {
				if (MyLog.Production  || MyLog.Display) {
					MyLog.writeLog("d", MyLog.getString(e));
				}
			}
		}
	}

	static public void debugLogMessage(Object o, UProfile up, String message) {
		if (o != null && up != null) {
			if ((MyLog.Production || MyLog.Display)&& (up.getLogDebug()||up.getProcessid().length()>0) ) {
				MyLog.writeLog("d", o, up, message);
			}
		} else {
			if (up != null) {
				if ((MyLog.Production || MyLog.Display)&& (up.getLogDebug()||up.getProcessid().length()>0)) {
					MyLog.writeLog("d", up, message);
				}
			} else {
				if (MyLog.Production||MyLog.Display) {
					MyLog.writeLog("d", message);
				}
			}
		}
	}
	
	static public void errorLogMessage(Object o, UProfile up, Exception e) {//error ͧ write log 
		if (o != null && up != null) {
//			if (MyLog.Production || up.getProcessid().length() > 0 || MyLog.Display) {
				MyLog.writeLog("e", o, up, MyLog.getString(e));
//			}
		} else {
			if (up != null) {
//				if (MyLog.Production || up.getProcessid().length() > 0 || MyLog.Display) {
					MyLog.writeLog("e", up, MyLog.getString(e));
//				}
			} else {
//				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("e", MyLog.getString(e));
//				}
			}
		}
	}

	static public void errorLogMessage(Object o, UProfile up,InterpreterException e) { //error ͧ write log 
		if (o != null && up != null) {
//			if (MyLog.Production || up.getProcessid().length() > 0 || MyLog.Display) {
				MyLog.writeLog("e", o, up, MyLog.getString(e));
//			}
		} else {
			if (up != null) {
//				if (MyLog.Production || up.getProcessid().length() > 0 || MyLog.Display) {
					MyLog.writeLog("e", up, MyLog.getString(e));
//				}
			} else {
//				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("e", MyLog.getString(e));
//				}
			}
		}
	}

	static public void errorLogMessage(Object o, UProfile up, String message) { //error ͧ write log 
		if (o != null && up != null) {
//			if ((MyLog.Production) || up.getProcessid().length() > 0||MyLog.Display) {
				MyLog.writeLog("e", o, up, message);
//			}
		} else {
			if (up != null) {
//				if ((MyLog.Production) || up.getProcessid().length() > 0||MyLog.Display) {
					MyLog.writeLog("e", up, message);
//				}
			} else {
//				if (MyLog.Production ||MyLog.Display) {
					MyLog.writeLog("e", message);
//				}
			}
		}
	}
	static public void fatalLogMessage(Object o, UProfile up, Exception e) { //fatal ͧ write log 
		if (o != null && up != null) {
//			if (MyLog.Production || up.getProcessid().length() > 0 || MyLog.Display) {
				MyLog.writeLog("f", o, up, MyLog.getString(e));
//			}
		} else {
			if (up != null) {
//				if ((MyLog.Production) || up.getProcessid().length() > 0 || MyLog.Display) {
					MyLog.writeLog("f", up, MyLog.getString(e));
//				}
			} else {
//				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("f", MyLog.getString(e));
//				}
			}
		}
	}

	static public void fatalLogMessage(Object o, UProfile up, String message) { //error ͧ write log 
		if (o != null && up != null) {
//			if ((MyLog.Production) || up.getProcessid().length() > 0 || MyLog.Display) {
				MyLog.writeLog("f", o, up, message);
//			}
		} else {
			if (up != null) {
//				if (MyLog.Production || up.getProcessid().length() > 0 || MyLog.Display) {
					MyLog.writeLog("f", up, message);
//				}
			} else {
//				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("f", message);
//				}
			}
		}
	}

	static private String getDescMessageType(String type) {
		String aType = "iwefdm";
		String aDesc[] = { "Info", "Warning", "Error", "Fatal", "Debug",
				"Message" };
		return aDesc[aType.indexOf(type)];
	}

	static private String getString(Exception e) {
		String mess = "";
		if (e instanceof Exception) {
			StackTraceElement[] el = e.getStackTrace();
			mess += e.getMessage() + "\r\n";
			for (int i = 0; i < el.length; i++) {
				mess += el[i].toString() + "\r\n";
			}
		} else if (e instanceof SQLException) {
			mess = getString((SQLException) e);
		}
		return mess;
	}

	static private String getString(Object o) {
		String s = "";
		if (o != null) {
			s = o.getClass().getName();
		}
		return s;
	}

	static private String getString(SQLException e) {
		String mess = "";
		StackTraceElement[] el = e.getStackTrace();
		mess += e.getMessage() + "\r\n";
		mess += e.getSQLState() + "\r\n";
		mess += String.valueOf(e.getErrorCode()) + "\r\n";
		for (int i = 0; i < el.length; i++) {
			mess += el[i].toString() + "\r\n";
		}
		return mess;
	}

	static private String getUserName(com.csc.library.session.keepLog db) {
		return db.getDataBaseName() + "." + db.getTableName() + ":"+ MyLog.getUserName(db.getUProfile());
	}

	static private String getUserName(RecordCmp0 db) {
		return db.getActualName() + ":" + MyLog.getUserName(db.getUProfile());
	}

	static private String getUserName(DbInquiry db) {
		try {
			return db.getActualName() + ":"+ MyLog.getUserName(db.getUProfile());
			} catch (RemoteException e) {
			return "???? Noname ???? :";
		}
	}

	static private String getUserName(DbTable db) {
		try {
			return db.getActualName() + ":"	+ MyLog.getUserName(db.getUProfile());
		} catch (RemoteException e) {
			return "???? Noname ???? :";
		}
	}

	static private String getUserName(UProfile up) {
		if (up == null) {
			return "???? Noname ???? :";
		} else {
			return up.getUserName() + " : ";
		}
	}
	static public void infoLogMessage(Object o, UProfile up, String message) {
		if (o != null && up != null) {
			if ((MyLog.Production ||MyLog.Display) && up.getLogInFo()) {
				MyLog.writeLog("i", o, up, message);
			}
		} else {
			if (up != null) {
				if ((MyLog.Production  || MyLog.Display)&& up.getLogInFo()) {
					MyLog.writeLog("i", up, message);
				}
			} else {
				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("i", message);
				}
			}
		}
	}

	
	static public void message(Object o, UProfile up, String message) {
		if (o != null && up != null) {
			if (MyLog.Production && up.getLogDebug() || MyLog.Display) {
				MyLog.writeLog("m", o, up, message);
			}
		} else {
			if (up != null) {
				if (MyLog.Production && up.getLogDebug() || MyLog.Display) {
					MyLog.writeLog("m", up, message);
				}
			} else {
				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("m", message);
				}
			}
		}
	}
	
	
	static public void warnLogMessage(Object o, UProfile up, Exception e) {
		if (o != null && up != null) {
			if ((MyLog.Production || MyLog.Display)&& up.getLogWarning() ) {
				MyLog.writeLog("w", o, up, MyLog.getString(e));
			}
		} else {
			if (up != null) {
				if ((MyLog.Production|| MyLog.Display)&& up.getLogWarning()) {
					MyLog.writeLog("w", up, MyLog.getString(e));
				}
			} else {
				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("w", MyLog.getString(e));
				}
			}
		}
	}

	static public void warnLogMessage(Object o, UProfile up, String message) {
		if (o != null && up != null) {
			if ((MyLog.Production|| MyLog.Display)&& up.getLogWarning() ){
				MyLog.writeLog("w", o, up, message);
			}
		} else {
			if (up != null) {
				if ((MyLog.Production || MyLog.Display)&& up.getLogWarning()) {
					MyLog.writeLog("w", up, message);
				}
			} else {
				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("w", message);
				}
			}
		}
	}
	static public void message(Object o, UProfile up, Exception e) {
		if (o != null && up != null) {
			if (MyLog.Production && up.getLogDebug() || MyLog.Display) {
				MyLog.writeLog("m", o, up, MyLog.getString(e));
			}
		} else {
			if (up != null) {
				if (MyLog.Production && up.getLogDebug() || MyLog.Display) {
					MyLog.writeLog("m", up, MyLog.getString(e));
				}
			} else {
				if (MyLog.Production || MyLog.Display) {
					MyLog.writeLog("m", MyLog.getString(e));
				}
			}
		}
	}

	static private void writeLog(String type, Object o, String message) {
		MyLog.writeLog(type, "csc-system", MyLog.getString(o) + ":" + message);
	}

	static private void writeLog(String type, keepLog db, String message) {
		MyLog.writeLog(type, db.getUProfile(), db.getTableName() + " : "+ message);
	}

	static private void writeLog(String type, RecordCmp0 db, String message) {
		MyLog.writeLog(type, MyLog.getUprofile(db), db.getActualName() + " : "+ message);
	}

	static private void writeLog(String type, DbInquiry db, String message) {
		try {
			MyLog.writeLog(type, MyLog.getUprofile(db), db.getActualName()+ " : " + message);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	static private void writeLog(String type, DbTable db, String message) {
		try {
			MyLog.writeLog(type, MyLog.getUprofile(db), db.getActualName()+ " : " + message);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}	

	static private void writeLog(String type, Object o, UProfile upf,String message) {
		MyLog.writeLog(type, upf, MyLog.getString(o) + ":" + message);
	}

	static private void writeLog(String type, String message) {
		MyLog.writeLog(type, "csc-system", message);
	}

	static private void writeLog(String type, String user, String message) {
		String aType = "iwefdm";
		String aDesc[] = { "Info", "Warning", "Error", "Fatal", "Debug","Message" };
		StringBuilder bf=new StringBuilder();
		bf.append("[ ").append(aDesc[aType.indexOf(type)]).append(" ] [").append(user).append("]").append(message);
		if(MyLog.Display){
			System.out.println(bf.toString());
		}
	}

	static private void writeLog(String type, UProfile upf, String message) {
		if (upf != null) {
			String shortMessage = message;
			int indexof = message.indexOf(":");
			int last = message.length();
			if (message.length() > 80) {
				if (indexof > 80) {
					last = indexof + 80;
					if (last > message.length()) {
						last = message.length();
					}
				}
				if (indexof > -1) {
					shortMessage = message.substring(indexof + 1, last);
				} else {
					shortMessage = message.substring(0, last);
				}
			} else {
				if (indexof > -1) {
					shortMessage = message.substring(indexof, last);
				}
			}
			
			if (upf.containsKey("processID")) {//óշա process
				String pid = upf.get("processID").toString();
				try {
					StaticProperties.serverManager.writeMessageLog(pid, "\n"+ MyLog.getYYYYMMDDHHMMSS()+" "+message);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}else if(upf.containsKey(MyLog.tracename)){
				String tracename=(String)upf.get(MyLog.tracename);
				String filename=tracename+"_"+((String)upf.get(MyLog.trace+"_"+tracename.toLowerCase()));
				MyLog.writeFile(filename+".log",message);
			}else{//óշ˹Ҩ ж¡з memory ҡеͧա  log 
				upf.setMessage(type, "[ "+MyLog.getDescMessageType(type) + " ]\r\n"+ message + "\r\n\r\n", shortMessage + "\r\n");
			}
			if(upf.getLogDisplay()){
				MyLog.writeLog(type,upf.getUserName(),message);
			}
		}
	}
	
	public static void beginTrace(UProfile up,String tracename){
		if(up!=null){
			String key=System.nanoTime()+"_"+up.getRandomString();	
			up.set(MyLog.trace+"_"+tracename.toLowerCase(), key);
			up.set(MyLog.tracename, tracename);
		}
	}
	
	public static void endTrace(UProfile up,String tracename){
		if(up!=null){
			if(up.containsKey(MyLog.tracename)){
				up.remove(MyLog.tracename);
				up.remove(MyLog.trace+"_"+tracename.toLowerCase());
			}
		}
	}
	
	public static boolean writeFile(String toFile, String message) {
		FileWriter fstream = null;
		BufferedWriter writer = null;
		String path=System.getProperty("jboss.server.log.dir")+"\\trace\\";
		File f=new File(path);
		if(!f.exists()){
			f.mkdir();
		}		
		path+=toFile;
		try {
			fstream = new FileWriter(path, true);
			writer = new BufferedWriter(fstream);
			writer.newLine();
			writer.write(message);
			return true;
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		} finally {
			try {
				if (writer != null) {
					writer.close();
				}
				if (fstream != null) {
					fstream.close();
				}
			} catch (Exception ex) {
			}
		}
	}	
	
}
