package com.csc.library.utilities;

import java.util.Calendar;
import java.util.StringTokenizer;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;

public abstract class MyTimerTask extends TimerTask {
	
	private UProfile up=null;
	
	private String pattern;
	private String classname;
	
	private Timer timer;
	private Vector year;
	private Vector mon;
	private Vector dow;
	private Vector day;
	private Vector hour;
	private Vector min;
	private Vector sec;
	private long delay = 0;
	private long period = 0;
	private Calendar cal;
		
	public MyTimerTask() {
	}
	
	public void setDelay(long delay) {
		this.delay = delay;
	}
	
	public long getDelay() {
		return this.delay;
	}
	
	public void setPeriod(long period) {
		this.period = period;
	}
	
	public long getPeriod() {
		return this.period;
	}
	
	public void setTimer(Timer timer) {
		this.timer = timer;
	}
	
	public Timer getTimer() {
		return this.timer;
	}
	
	public void setClassname(String classname) {
		this.classname = classname;
	}
	
	public String getClassname() {
		return this.classname;
	}
	
	public void setPattern(String pattern) {
		this.pattern = pattern;
	}
	
	public String getPattern() {
		return this.pattern;
	}
	
	public void setUProfile(UProfile up) {
		this.up = up;
	}
	
	public UProfile getUProfile() {
		return this.up;
	}
	
	public void setData(String pattern) {
		this.setPattern(pattern);
		StringTokenizer stn = new StringTokenizer(pattern," ");
		String sec = stn.nextToken();
		String min = stn.nextToken();
		String hour = stn.nextToken();
		String day = stn.nextToken();
		String mon = stn.nextToken();
		String dow = stn.nextToken();
		String year = stn.nextToken();
		this.setData(year,dow,mon,day,hour,min,sec);
	}
	
	public void setData(String year,String dow,String mon,String day,String hour,String min,String sec) {
		this.year = this.reformTime(this.extractTime(year));
		this.mon = this.reformTime(this.extractTime(mon));
		this.dow = this.reformTime(this.extractTime(dow));
		this.day = this.reformTime(this.extractTime(day));
		this.hour = this.reformTime(this.extractTime(hour));
		this.min = this.reformTime(this.extractTime(min));
		this.sec = this.reformTime(this.extractTime(sec));
	}
	
	public void run() {
		this.process();
		this.setDelay(0);
		this.setPeriod(0);
		this.calcTime();
		if (this.getDelay() > 0) {
			this.schedule(true);
		}
	}
	
	protected abstract void process();
	
	private Vector reformTime(String data) {
		Vector vec = new Vector();
		StringTokenizer stn = new StringTokenizer(data,",");
		while (stn.hasMoreTokens()) {
			vec.add(stn.nextToken());
		}
		return vec;
	}
	
	private String extractTime(String data) {
		String result = "";
		if (data.equals("0") || data.equals("*")) {
			result = data;
		} else {
			int oper = data.indexOf(","); 
			if (oper > -1) {
				String sub01 = this.extractTime(data.substring(0,oper));
				String sub02 = this.extractTime(data.substring(oper+1));
				result = sub01 + "," + sub02;
			} else {
				oper = data.indexOf("-");
				if (oper > -1) {
					int begin = Integer.parseInt(data.substring(0,oper));
					int end = Integer.parseInt(data.substring(oper+1));
					for (int i=begin;i<=end;i++) {
						result = result + "," + i;
					}
					result = result.substring(1);
				} else {
					result = data;
				}
			}
		}
		return result;
	}
	
	public void calcTime() { 
		this.cal = Calendar.getInstance();
		String[] caldatasec = this.chkcalcTime(this.cal,Calendar.SECOND,this.cal.get(Calendar.SECOND),this.sec,"1",false,1000);
		String[] caldatamin = this.chkcalcTime(this.cal,Calendar.MINUTE,this.cal.get(Calendar.MINUTE),this.min,caldatasec[1],false,60*1000);
		String[] caldatahour = this.chkcalcTime(this.cal,Calendar.HOUR_OF_DAY,this.cal.get(Calendar.HOUR_OF_DAY),this.hour,caldatamin[1],false,60*60*1000);
		String[] caldataday = this.chkcalcTime(this.cal,Calendar.DAY_OF_MONTH,this.cal.get(Calendar.DAY_OF_MONTH),this.day,caldatahour[1],true,24*60*60*1000);
		String[] caldatamon = this.chkcalcTime(this.cal,Calendar.MONTH,this.cal.get(Calendar.MONTH)+1,this.mon,caldataday[1],false,30*24*60*60*1000);
		String[] caldatayear = this.chkcalcTime(this.cal,Calendar.YEAR,this.cal.get(Calendar.YEAR),this.year,caldatamon[1],false,12*30*24*60*60*1000);
		int calsec = Integer.parseInt(caldatasec[0]);
		int calmin = Integer.parseInt(caldatamin[0]);
		int calhour = Integer.parseInt(caldatahour[0]);
		int calday = Integer.parseInt(caldataday[0]);
		int calmon = Integer.parseInt(caldatamon[0]);
		int calyear = Integer.parseInt(caldatayear[0]);
		Calendar expectcal = Calendar.getInstance();
		expectcal.set(Calendar.SECOND,calsec);
		expectcal.set(Calendar.MINUTE,calmin);
		expectcal.set(Calendar.HOUR_OF_DAY,calhour);
		expectcal.set(Calendar.DAY_OF_MONTH,calday);
		expectcal.set(Calendar.MONTH,calmon);
		expectcal.set(Calendar.YEAR,calyear);
		long curmilsec = this.cal.getTimeInMillis();
		long expectmilsec = expectcal.getTimeInMillis();
		this.setDelay(expectmilsec - curmilsec);
		this.setPeriod(0);
	}
	
    private String[] chkcalcTime(Calendar calccal,int compareTime,int cur,Vector data,String next,boolean checkdow,long timeincrease) {
        int datasize = data.size();
        String output = "0";
        String datanext = "0";
        if (datasize ==1) {
            output = (String) data.get(0);
            if (output.equals("0")) {
                if (compareTime == Calendar.YEAR || compareTime == Calendar.MONTH  || compareTime == Calendar.DAY_OF_MONTH) {
                    if (next.equals("1")) {
                        long timemil = calccal.getTimeInMillis()+timeincrease ;
                        Calendar caltmp = (Calendar) calccal.clone();
                        caltmp.setTimeInMillis(timemil);
                        output = String.valueOf(caltmp.get(compareTime));
                    } else {
                        output = String.valueOf(calccal.get(compareTime));
                    }
                }
                if (output.equals("0")) {
                    datanext = "1";
                } else if (output.equals("1") && (compareTime == Calendar.DAY_OF_MONTH || compareTime == Calendar.YEAR )) {
                    datanext = "1";
                } else {
                    datanext = "0";
                }
            } else if (output.equals("*")) {
                Calendar caltmp = (Calendar) calccal.clone();
                int oldval = caltmp.get(compareTime);
                caltmp.setTimeInMillis(caltmp.getTimeInMillis()+timeincrease);
                int newval = caltmp.get(compareTime);
                if (next.equals("1"))
                    output = String.valueOf(newval);
                else 
                    output = String.valueOf(oldval);
                if (output.equals("0")) {
                    datanext = "1";
                } else if (output.equals("1") && (compareTime == Calendar.DAY_OF_MONTH || compareTime == Calendar.YEAR )) {
                    datanext = "1";
                } else {
                    datanext = "0";
                }
                if (checkdow && this.dow.size() > 1) {
                    caltmp.set(Calendar.DAY_OF_MONTH,Integer.parseInt(output));
                    int curdow = caltmp.get(Calendar.DAY_OF_WEEK);
                    if (!this.dow.contains(String.valueOf(curdow))) {
                        String[] tmp = this.chkcalcTime(caltmp,compareTime,Integer.parseInt(output),data,"1",true,timeincrease);
                        output = tmp[0];
                        datanext = tmp[1];
                    }
                }
            } else {
                datanext = "1";
                Calendar caltmp = (Calendar) calccal.clone();
                int curval = caltmp.get(compareTime);
                int outval = Integer.parseInt(output);
                if (curval < outval || next.equals("0")) {
                    datanext = "0";
                } else if (curval == outval ) {
                    next = datanext;
                }
            }
        } else {
            int i = 0;
            for (i=0;i<datasize;i++) {
                int tmp = Integer.parseInt((String) data.get(i));
                if (cur == tmp && next.equals("0")) {
                    output = String.valueOf(tmp);
                    datanext = "0";
                    break;
                } else if (cur < tmp && next.equals("1")) {
                    output = String.valueOf(tmp);
                    datanext = "0";
                    break;
                }
            }
            if (i >= datasize) {
                output = (String) data.get(0);
                datanext = "1";
            }   
            if (checkdow && this.dow.size() > 1) {
                Calendar cal01 = (Calendar) calccal.clone();
                cal01.set(Calendar.DAY_OF_MONTH,Integer.parseInt(output));
                int curdow = cal01.get(Calendar.DAY_OF_WEEK);
                if (!this.dow.contains(String.valueOf(curdow))) {
                    String[] tmp = this.chkcalcTime(cal01,compareTime,Integer.parseInt(output),data,datanext,true,timeincrease);
                    output = tmp[0];
                    datanext = tmp[1];
                }
            }
        }
        String[] result = {output,datanext};
        return result;  
    }

	public void schedule(boolean reschedule) {
		if (this.getDelay() > 0) {
			try {
				if (reschedule) {
					MyTimerTask mtt = (MyTimerTask) Class.forName(this.getClassname()).newInstance();
					mtt.setTimer(this.getTimer());
					mtt.setClassname(this.getClassname());
					mtt.setData(this.getPattern());
					mtt.calcTime();
					mtt.setUProfile(this.up);
					mtt.schedule(false);
				} else {
					if (this.getPeriod() > 0) {
						this.timer.schedule(this,this.getDelay(),this.getPeriod());
					} else { 
						this.timer.schedule(this,this.getDelay());
					}
				}
			} catch (Exception e) {
				MyLog.error(this, this.up, e);
			} 
		}
	}
	
}
