package com.csc.library.utilities;

import java.io.File;
import java.io.FileFilter;
import java.io.FilenameFilter;
import java.io.Serializable;

/**
 * 
 * @author James
 *
 */
public class ProtableFileFilter implements FileFilter, FilenameFilter, Serializable {

	private static final long serialVersionUID = 2902754211731128273L;
	private static final String CVS = "CVS";
	private static final String DIFF = "DIFFXML";
	private static final String XML_EXTENSION= ".xml";
	private boolean includeDir = true;
	
	public ProtableFileFilter() {
		super();
	}
	
	public ProtableFileFilter(boolean includeDir) {
		super();
		this.includeDir = includeDir;
	}
	
	public boolean accept(File dir, String name) {
		if(name == null) {
			throw new NullPointerException();
		}
		File file = new File(dir.getPath() + File.separator + name);
	    return this.accept(file);

	}

	public boolean accept(File pathname) {
		if(pathname == null) {
			throw new NullPointerException();
		}
		
		if(includeDir && pathname.isDirectory() && !CVS.equalsIgnoreCase(pathname.getName())&& !DIFF.equalsIgnoreCase(pathname.getName())) {
			return true;
			
		} else if (pathname.getName().toLowerCase().endsWith(XML_EXTENSION)) {
			return true;
			
		}
		
		return false;

	}
	
	public static void main(String[] args) {
		File filepath = new File("D:/EnterprisePT/JbossServices/server/default/deploy/HRPEAP.ear/XML/DBXML/");
		ProtableFileFilter filter = new ProtableFileFilter();
		
		File[] fileList = filepath.listFiles((FilenameFilter)filter);
		System.out.println("File num "+fileList.length);
		int i=1;
		for(File tmp : fileList ) {
			System.out.println((i++)+"."+tmp.getName());
		}
	}

}
