package com.csc.library.utilities;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Random;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;

public class RelationPools {
	
	private HashMap relation;
	private HashMap tb;
	private Vector    vc;
	private RelationProperties reprop;
	
	public RelationPools() {	
	}
	
	public void clear(){
		this.relation=new HashMap();
	}	
	
	
	public void setRelation(String tableName,String childTableName,Vector parent,Vector child,HashMap hre,Vector vkey){
		try{
			if(relation==null)
				relation=new HashMap();
			String tmpP[];
			String tmpC[];
			String fnP="";
			String fnC="";
			String childName="";
			vc=new Vector();
			if(parent.size()==child.size()){
					for(int v=0;v<parent.size();v++){
						fnP=((String)parent.get(v)).toLowerCase();
						fnP=fnP.replace(".", ",");
						tmpP=fnP.split(",");
						
						fnC=((String)child.get(v)).toLowerCase();
						fnC=fnC.replace(".", ",");
						tmpC=fnC.split(",");
		
						if(tableName.toLowerCase().equals(tmpP[0])){
							childName=tmpC[0];
							vc.add(tmpP[1]+","+tmpC[1]);
						}
		
						if(tableName.toLowerCase().equals(tmpC[0])){
							childName=tmpP[0];
							vc.add(tmpC[1]+","+tmpP[1]);
						}				
					}
		
					if(relation.containsKey(tableName.toUpperCase())){
						tb=(HashMap)this.relation.get(tableName.toUpperCase());						
					}else{
						tb=new HashMap();						
					}
					if(tb.containsKey(childTableName.toUpperCase())){
						reprop=(RelationProperties)tb.get(childTableName.toUpperCase());
					}else{
						reprop=new RelationProperties();
					}
					reprop.setRtablename((String)hre.get("RTABLENAME"));
					reprop.setDeleteLevel((String)hre.get("DELETELEVEL"));
					reprop.setInsertLevel((String)hre.get("INSERTLEVEL"));
					reprop.setModuledelete((String)hre.get("MODULEDELETE"));
					reprop.setDependLevel((String)hre.get("DEPENDLEVEL"));
					reprop.setMode((String)hre.get("MODE"));
					reprop.setChildList(vc);
					tb.put("KEYLIST",vkey);
					tb.put(childTableName.toUpperCase(), reprop);
					relation.put(tableName.toUpperCase(), tb);
					/*if(!relation.containsKey(childName.toUpperCase())){
						this.setRelation(childName, parent, child,hre);
					}*/
			}else{
				MyLog.error(this," Please check Relation on Protable "+tableName);
			}
			
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	public RelationProperties getRelation(String parentName,String childName){
		RelationProperties ch=null;
		try{
			if(this.relation.containsKey(parentName.toUpperCase())){
				HashMap ph=(HashMap)this.relation.get(parentName);
				if(ph.containsKey(childName)){
					ch=(RelationProperties)ph.get(childName);
				}
			}
		}catch(Exception ex){
			ex.printStackTrace();
		}
		return ch;
	}

	public HashMap getRelation(String parentName){
		HashMap ph=null;
		try{
			if(this.relation.containsKey(parentName.toUpperCase())){
				ph=(HashMap)this.relation.get(parentName);
			}
		}catch(Exception ex){
			ex.printStackTrace();
		}
		return ph;
	}

	public HashMap getRelation(){
		return this.relation;
	}
	
	public void MoveRelation2Master(){
		try{
			HashMap mprela=(HashMap)relation.clone();
			Iterator it=mprela.keySet().iterator();
			String parentName="";
			String childName="";
			while(it.hasNext()){
				parentName=(String)it.next();
				HashMap parent=(HashMap)((HashMap)mprela.get(parentName)).clone();
				Iterator itC=parent.keySet().iterator();
				while(itC.hasNext()){
					childName=(String)itC.next();
					if(!childName.equals("KEYLIST")){
						RelationProperties rel=(RelationProperties)parent.get(childName);
						compareRelation((Vector)parent.get("KEYLIST"), rel,parentName,childName);
					}
				}
			}
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	public void compareRelation(Vector keylist,RelationProperties rel,String parentName,String childName){
		
			Vector child=rel.getChildList();
			String tmp[];
			boolean ismove=false;
			if(keylist.size()>child.size()){
				ismove=true;
			}else{
				MyHashMap pro = (MyHashMap) ((MyHashMap) StaticProperties.proTable.get(parentName.toLowerCase()));
				String mainkey =(String) pro.get("mainkey");
				if(mainkey!=null&&keylist.contains(mainkey.toLowerCase())){
					ismove=false;
				}else{
					for(int i=0;i<child.size();i++){
						tmp=((String)child.get(i)).split(",");
						if(!keylist.contains(tmp[0])){
							ismove=true;
							break;
						}
					}
				}
			}
			HashMap mp2=null;
			RelationProperties rela=null;
			Vector tmpChild=null;
		try{
			if(ismove&& !childName.equals(parentName)){
				HashMap mp=(HashMap)relation.get(parentName);
				rela=(RelationProperties)mp.get(childName);
				tmpChild=new Vector();
				for(int i=0;i<child.size();i++){
					tmp=((String)child.get(i)).split(",");
					tmpChild.add(tmp[1]+","+tmp[0]);				
				}						
							
				mp2=(HashMap)relation.get(childName);
				String keyname="";
				if(mp2==null){
					mp2=(HashMap)relation.get(rela.getRtablename());
					if(mp2==null){
						relation.put(rela.getRtablename(), new HashMap());
						mp2=(HashMap)relation.get(rela.getRtablename());
					}
					Random rand=new Random();
					keyname="V1"+rand.nextInt(100)+parentName;
				}else{
					if(mp2.containsKey(parentName)){
						Random rand=new Random();
						keyname="V1"+rand.nextInt(100)+parentName;
					}else{
						keyname=parentName;
					}
				}
				rela.setChildList(tmpChild);
				rela.setRtablename(parentName);
				mp2.put(keyname,rela);
				mp.remove(childName);
			}
		}catch(Exception ex){
			System.out.println("rela = "+rela+" mp2 = "+mp2+" tmpChild="+tmpChild);
			ex.printStackTrace();
		}
	}

	  public static void main(String args[]) {
		  	Random rand=new Random();
		    System.out.println( rand.nextInt(1000));
		  }

	
}
