package com.csc.library.utilities;

import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.session.InitialEnvironment;

public class ReportXml {
	private Element				reportObject, dbObject;
	private String				dataManager, reportXml;
	private InitialEnvironment	env;
	private String				dbName;
	private UProfile			upf=null;
	String groupDB="false";
	private String 				reqlist="";	
	public void setUProfile(UProfile upf) {
		this.upf = upf;
	}
	public ReportXml(String objName, String dbName, UProfile upf) {
		this.upf = upf;
		this.dbName = dbName;
		this.initEnv();
		this.reportXml = objName;
		try {
			SAXBuilder builder = new SAXBuilder();
			String pathName = "";
			String appName = this.upf.get("appname");
//			String cssite=this.upf.get("cssite");
			if (appName != null && !appName.equals("") && !appName.equals("null")) {
				pathName = env.getValue("xmlpath-reportxml") + appName + "/" + objName + ".xml";
				File file = new File(pathName);
				if (!file.exists()) {
					pathName = env.getValue("xmlpath-reportxml") + objName + ".xml";
				}
			} else {
				pathName = env.getValue("xmlpath-reportxml") + objName + ".xml";
			}
			Document stru = builder.build(new File(pathName));
			reportObject = stru.getRootElement();
			dataManager = reportObject.getChild("DATAMANAGER").getText();
			/****************  Nuball edit 26 12 06 *******************/
			if((reportObject.getChild("DATAMANAGER").getAttributeValue("groupdb")!=null)&&(reportObject.getChild("DATAMANAGER").getAttributeValue("groupdb").equalsIgnoreCase("true"))){
				this.groupDB="true";
			}
			/*********************************************************/
			this.connectDbXml();
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
	}

	public String getGroupDB(){
		return this.groupDB;
	}
	public Vector getAllField() {
		Vector fieldList = new Vector();
		String tableName = "";
		Vector tableList = this.getTableList();
		Vector fieldTable = new Vector();
		for (int i = 0; i < tableList.size(); i++) {
			tableName = (String) tableList.elementAt(i);
			fieldTable = this.getFielddTable(tableName);
			for (int j = 0; j < fieldTable.size(); j++) {
				fieldList.add(tableName + "." + (String) fieldTable.elementAt(j));
			}
		}
		return fieldList;
	}
	public String getGroupByDesc(String field) {
		StringTokenizer st = null;
		String tableName, fieldName = "", desc;
		Element obj = null;
		if (reportObject.getChild("GROUP")==null) return ""; 
		List list = reportObject.getChild("GROUP").getChildren();
		if (list==null) return ""; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getText().equalsIgnoreCase(field)) {
				desc = obj.getAttributeValue("DESC");
				if (desc.indexOf(".") != -1) {
					tableName = desc.substring(0, desc.indexOf("."));
					fieldName = desc.substring(desc.indexOf(".") + 1, desc.length());
				} else {
					tableName = field.substring(0, field.indexOf("."));
					fieldName = desc;
				}
				return tableName + "@" + fieldName;
			}
		}
		return "";
	}
	public String getLabel(String field) {
		String tableName, fieldName = "";
		Element obj = null;
		if (reportObject.getChild("GROUP")==null) return ""; 
		List list = reportObject.getChild("GROUP").getChildren();
		if (list==null) return ""; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getText().equalsIgnoreCase(field)) {
				return obj.getAttributeValue("LABEL");
			}
		}
		return "";
	}
	public Vector getTemplate() {
		Vector tList = new Vector();
		Element obj = null;
		if (reportObject.getChild("TEMPLATE")==null) return tList; 
		List list = reportObject.getChild("TEMPLATE").getChildren();
		HashMap h = null;
		if (list==null) return tList; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			h = new HashMap();
			h.put("name", obj.getAttributeValue("name"));
			h.put("tdesc", obj.getAttributeValue("tdesc"));
			h.put("edesc", obj.getAttributeValue("edesc"));
			h.put("size", obj.getAttributeValue("size"));
			if(obj.getAttributeValue("lang")==null)
				h.put("lang", "A");
			else
				h.put("lang", obj.getAttributeValue("lang"));
			if(obj.getAttributeValue("isfieldobject")!=null){
				h.put("isfieldobject",obj.getAttributeValue("isfieldobject"));
			}else{
				h.put("isfieldobject","0");
			}
			tList.add(h);
		}
		return tList;
	}
	public String getReferLang() {
		String value = "false";
		try {
			value = this.reportObject.getChild("REFER_LANG").getText();
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, "Not found element REFER_LANG");
		}
		return value;
	}
	public String getHelp(String tableName) {
		Element obj = null;
		if (reportObject.getChild("HELP")==null) return null; 
		List list = reportObject.getChild("HELP").getChildren();
		if (list==null) return null; 
		Iterator it = list.iterator();
		String tmp = "";
		while (it.hasNext()) {
			obj = (Element) it.next();
			tmp = obj.getAttributeValue("name");
			if (tmp.equalsIgnoreCase(tableName)) {
				return obj.getAttributeValue("help");
			}
		}
		return null;
	}
	public HashMap getReportHeader() {
		Element obj = reportObject.getChild("REPORTHEADER");
		HashMap h = new HashMap();
		h.put("tdesc", obj.getAttributeValue("tdesc"));
		h.put("edesc", obj.getAttributeValue("edesc"));
		return h;
	}
	public String getDataManager() {
		return this.dataManager;
	}
	public String getReportXml() {
		return this.reportXml;
	}
	public Vector getTableList() {
		Vector vec = new Vector();
		Element obj = null;
		if (dbObject==null) return vec; 
		List list = dbObject.getChildren();
		if (list==null) return vec; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getName().equalsIgnoreCase("TABLE")) {
				if (obj.getAttributeValue("rname") != null && !obj.getAttributeValue("rname").equals(""))
					vec.add(obj.getAttributeValue("rname"));
				else if (obj.getAttributeValue("vname") != null && !obj.getAttributeValue("vname").equals(""))
					vec.add(obj.getAttributeValue("vname") + "$" + obj.getAttributeValue("name"));
				else
					vec.add(obj.getAttributeValue("name"));
			}
		}
		return vec;
	}
	public Vector getLinkTableList() {
		Vector vec = new Vector();
		Element obj = null;
		if (reportObject.getChild("LINKTABLE")==null) return vec; 
		List list = reportObject.getChild("LINKTABLE").getChildren();
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			vec.add(obj.getText());
		}
		return vec;
	}
	public String getMainTable() {
		Vector vec = new Vector();
		Element obj = null;
		if (dbObject==null) return null; 
		List list = dbObject.getChildren();
		if (list==null) return null; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if ((obj.getAttributeValue("central") != null) && (obj.getAttributeValue("central").equalsIgnoreCase("true"))) {
				if (obj.getAttributeValue("rname") != null && !obj.getAttribute("rname").equals(""))
					return obj.getAttributeValue("rname");
				if (obj.getAttributeValue("vname") != null && !obj.getAttribute("vname").equals(""))
					return obj.getAttributeValue("vname");
				else
					return obj.getAttributeValue("name");
			}
		}
		return null;
	}
	public Vector getFielddTable(String tableName) {
		Vector vec = new Vector();
		Element obj = null;
		String dbTableName = "";
		if (dbObject==null) return vec; 
		List list = dbObject.getChildren();
		if (list==null) return vec; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getName().startsWith("TABLE")) {
				if (obj.getAttributeValue("rname") != null && !obj.getAttributeValue("rname").equals(""))
					dbTableName = obj.getAttributeValue("rname");
				else if (obj.getAttributeValue("vname") != null && !obj.getAttributeValue("vname").equals(""))
					dbTableName = obj.getAttributeValue("vname") + "$" + obj.getAttributeValue("name");
				else
					dbTableName = obj.getAttributeValue("name");
				if (dbTableName.equalsIgnoreCase(tableName)) {
					vec.add(obj.getChildren());
					break;
				}
			}
		}
		return this.processField(vec);
	}
	public String getTableStatus(String tableName) {
		Vector vec = new Vector();
		Element obj = null;
		String dbTableName = "";
		if (dbObject==null) return null; 
		List list = dbObject.getChildren();
		if (list==null) return null; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getName().startsWith("TABLE")) {
				dbTableName = obj.getAttributeValue("name");
				if (dbTableName.equalsIgnoreCase(tableName)) {
					return obj.getAttributeValue("status");
				}
			}
		}
		return null;
	}
	/*	public String getRtableName(String tableName) {
	 Vector vec = new Vector();
	 Element obj = null;
	 String dbTableName = "";
	 List list = dbObject.getChildren();
	 Iterator it = list.iterator();
	 while (it.hasNext()) {
	 obj = (Element) it.next();
	 if (obj.getName().startsWith("TABLE")) {
	 dbTableName = obj.getAttributeValue("name");
	 if (dbTableName.equals(tableName)) {
	 return obj.getAttributeValue("rname");
	 }
	 }
	 }
	 return null;
	 }
	 */
	public Vector getTemplateElement() {
		Vector vec = new Vector();
		if (reportObject.getChild("TEMPLATE")==null) return vec; 
		List list = reportObject.getChild("TEMPLATE").getChildren();
		if (list==null) return vec; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			vec.add((Element) it.next());
		}
		return vec;
	}
	public HashMap getTemplateSize() {
		HashMap data = new HashMap();
		if (reportObject.getChild("TEMPLATE")==null) return data; 
		List list = reportObject.getChild("TEMPLATE").getChildren();
		if (list==null) return data; 
		Iterator it = list.iterator();
		Element template;
		while (it.hasNext()) {
			template = (Element) it.next();
			data.put(template.getAttributeValue("name"), template.getAttributeValue("size"));
		}
		return data;
	}
	public Vector getTableElement() {
		Vector vec = new Vector();
		Element obj = null;
		if (dbObject==null) return vec; 
		List list = dbObject.getChildren();
		if (list==null) return vec; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getName().equals("TABLE"))
				vec.addElement(obj);
		}
		return vec;
	}
	public Vector getGroupByList() {
		Vector vec = new Vector();
		Element obj = null;
		if (reportObject.getChild("GROUP")==null) return vec; 
		List list = reportObject.getChild("GROUP").getChildren();
		if (list==null) return vec; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			vec.add(obj.getText());
		}
		return vec;
	}
	public Vector getOrderByList() {
		Vector vec = new Vector();
		Element obj = null, obj2 = null;
		String dbTableName = "", central = "";
		Iterator it = null, it2 = null;
		if (dbObject==null) return vec; 
		it = dbObject.getChildren().iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			central = obj.getAttributeValue("central");
			dbTableName = obj.getAttributeValue("name");
			if (central != null && central.equalsIgnoreCase(("true"))) {
				it2 = obj.getChild("ORDER").getChildren().iterator();
				while (it2.hasNext()) {
					obj2 = (Element) it2.next();
					vec.add(obj2.getText());
				}
			}
		}
		return vec;
	}
	public Vector getVFieldList() {
		Vector vec = new Vector();
		try {
			Element obj = null;
			HashMap temp;
			if (reportObject.getChild("VFIELD")==null) return vec; 
			List list = reportObject.getChild("VFIELD").getChildren();
			if (list==null) return vec; 
			Iterator it = list.iterator();
			while (it.hasNext()) {
				obj = (Element) it.next();
				temp = new HashMap();
				temp.put("name", obj.getText());
				temp.put("type", obj.getAttributeValue("type"));
				temp.put("size", obj.getAttributeValue("size"));
				vec.add(temp);
			}
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, e);
		}
		return vec;
	}
	public Vector getConditionPropList() {
		Vector vec = new Vector();
		try {
			Element obj = null, com = null;
			Properties temp;
			if (reportObject.getChild("COMPONENT")==null) return vec; 
			List list = reportObject.getChild("COMPONENT").getChildren();
			if (list==null) return vec; 
			Iterator it = list.iterator();
			while (it.hasNext()) {
				obj = (Element) it.next();
				temp = new Properties();
				List list2 = obj.getAttributes();
				Iterator it2 = list2.iterator();
				while (it2.hasNext()) {
					Attribute at = (Attribute) it2.next();
					if (at.getName().equalsIgnoreCase("type"))
						temp.setProperty("COMTYPE", at.getValue());
					temp.setProperty(at.getName(), at.getValue());
				}
				Element datalink = obj.getChild("DATALINK");
				if (datalink != null) {
					temp.setProperty("dl-table",datalink.getAttributeValue("table"));
					temp.setProperty("dl-field",datalink.getAttributeValue("field"));
					temp.setProperty("dl-filter",datalink.getAttributeValue("filter"));
					temp.setProperty("dl-orderby",datalink.getAttributeValue("orderby"));
					temp.setProperty("dl-addcompanyid",datalink.getAttributeValue("addcompanyid"));
				}
				vec.add(temp);
			}
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, e);
		}
		return vec;
	}
	public Vector getComponentList() {
		String name, size = null;
		Vector vec = new Vector();
		if (reportObject.getChild("COMPONENT")==null) return vec; 
		List list = reportObject.getChild("COMPONENT").getChildren();
		if (list==null) return vec; 
		Iterator it = list.iterator();
		Element com = null;
		while (it.hasNext()) {
			com = (Element) it.next();
			name = com.getText();
			size = com.getAttributeValue("size");
			vec.add(name + "," + size);
		}
		return vec;
	}
	public Vector getDateFormatList() {
		Vector vec = new Vector();
		String name, format = null;
		Element obj = null;
		if (reportObject.getChild("DFORMAT")==null) return vec; 
		List list = reportObject.getChild("DFORMAT").getChildren();
		if (list==null) return vec; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			name = obj.getAttributeValue("name");
			format = obj.getText();
			vec.add(name + "," + format);
		}
		MyLog.info(this, this.upf, "Vec " + vec);
		return vec;
	}
	private void connectDbXml() {
		SAXBuilder builder = new SAXBuilder();
		Document stru = null;
		try {
			String pathName = "";
			String appName = this.upf.get("appname");
//			String cssite=this.upf.get("cssite");
			if (appName != null && !appName.equals("") && !appName.equals("null")) {
				pathName = env.getValue("xmlpath-dbxml") + appName + "/" + this.dataManager + ".xml";
				File file = new File(pathName);
				if (!file.exists()) {
					pathName = env.getValue("xmlpath-dbxml") + this.dataManager + ".xml";
				}
			} else {
				pathName = env.getValue("xmlpath-dbxml") + this.dataManager + ".xml";
			}
			stru = builder.build(new File(pathName));
		} catch (Exception ex) {
			MyLog.error(this, this.upf, ex);
		}
		dbObject = stru.getRootElement();
	}
	private Vector processField(Vector vField) {
		Vector vec = new Vector();
		Element obj = null;
		if (vField==null) return vec; 
		List list = (List) vField.elementAt(0);
		if (list==null) return vec; 
		Iterator it = list.iterator();
		while (it.hasNext()) {
			obj = (Element) it.next();
			if (obj.getName().equals("FIELD"))
				vec.addElement(obj.getText());
		}
		return vec;
	}
	public Vector getChRequire() {
		Vector vec = new Vector();
		try {
			Element obj = null;
			if (this.reportObject.getChild("CHILD_REQUIRE")==null) return vec; 
			List list = this.reportObject.getChild("CHILD_REQUIRE").getChildren();
			if (list==null) return vec; 
			Iterator it = list.iterator();
			while (it.hasNext()) {
				obj = (Element) it.next();
				vec.add(obj.getAttributeValue("name") + "$" + obj.getText());
			}
		} catch (Exception e) {
			MyLog.error(this, this.upf, e);
		}
		return vec;
	}
	public Vector getFixFilter() {
		Vector tList = new Vector();
		try {
			if(reportObject.getChild("FIXFILTER")!=null){
				Element obj = null;
				List list = reportObject.getChild("FIXFILTER").getChildren();
				if (list==null) return tList; 
				HashMap h = null;
				Iterator it = list.iterator();
				while (it.hasNext()) {
					obj = (Element) it.next();
					h = new HashMap();
					h.put("tablename", obj.getAttributeValue("tablename"));
					h.put("value", obj.getAttributeValue("value"));
					tList.add(h);
				}
			}
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, e);
		}
		return tList;
	}
	public HashMap getSimType() {
		try {
			Element obj = null;
			HashMap data = new HashMap();
			if (reportObject.getChild("SIMTYPE")==null)  return data;
			List list = reportObject.getChild("SIMTYPE").getChildren();
			if (list==null) return data; 
			Iterator it = list.iterator();
			while (it.hasNext()) {
				obj = (Element) it.next();
				data.put(obj.getText(), obj.getAttributeValue("ntype") + ":" + obj.getAttributeValue("size"));
			}
			return data;
		} catch (Exception e) {
			MyLog.warn(this, this.upf, e);
			return new HashMap();
		}
	}
	private void initEnv() {
		env = new InitialEnvironment("GLOBAL");
	}
	public String getRequiredFound() {
		try {
			if (this.reportObject.getChild("REQUIRED_FOUND")==null) return "false";
			String tablenames=(this.reportObject.getChild("REQUIRED_FOUND").getAttributeValue("table")!=null)?this.reportObject.getChild("REQUIRED_FOUND").getAttributeValue("table"):"";
			this.setRequireFoundTable(tablenames);
			String data = this.reportObject.getChild("REQUIRED_FOUND").getText();
			return data;
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, e);
		}
		return "";
	}
	
	public void setRequireFoundTable(String tablelist){
		this.reqlist=tablelist;
	}
	
	public String getRequireFoundTable(){
		return this.reqlist;
	}	
	
	public String getChildChk() {
		try {
			if(this.reportObject.getChild("CHILD_CHK")!=null){
				String data = this.reportObject.getChild("CHILD_CHK").getText();
				return data;
			}
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, e);
		}
		return "";
	}
	public String getComponentPage() {
		String data = reportObject.getChild("COMPONENT").getAttributeValue("link");
		return data;
	}
	public  String getConditon(){
		Element obj=reportObject.getChild("CONDITION");
		if(obj ==null)
			return  null;
		else 	
			return obj.getText();
	}	
	public String getOptionRequire() {
		try {
			if(this.reportObject.getChild("OPTION_REQUIRE")!=null){
				String option = this.reportObject.getChild("OPTION_REQUIRE").getText();
				String desc = "";
				String lang = this.upf.get(("lang"));
				if (lang.equalsIgnoreCase("eng"))
					desc = this.reportObject.getChild("OPTION_REQUIRE").getAttributeValue("edesc");
				else 
					desc = this.reportObject.getChild("OPTION_REQUIRE").getAttributeValue("tdesc");
				return option + "::" + desc;
			}
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, e);
		}
		return "";
	}
	
	public boolean isLinkField() {
		try {
			if(this.reportObject.getChild("LINKFIELD")!=null){
				String data = this.reportObject.getChild("LINKFIELD").getText();
				if(data.equalsIgnoreCase("false")){
					return false;
				}
			}
		} catch (RuntimeException e) {
			MyLog.error(this, this.upf, e);
		}
		return true;
	}
	
	public boolean hasComponent() {
		
		boolean hascomponent = false;
		Element component = reportObject.getChild("COMPONENT");
		if( component != null && component.getChildren()!= null && component.getChildren().size() > 0) {
			hascomponent = true; 
		}
		return hascomponent;
	}
	
	
}
