package com.csc.library.utilities;

import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;
import org.jdom.Attribute;

import org.jdom.Element;

import com.csc.library.session.InitialEnvironment;

public class TimerSchedule {
	
	private static Timer timer;
	private static Vector tasks;
	
	public TimerSchedule() {
		this.tasks = new Vector();
		this.initialTimer(false,false);
	}
		
	public void initialTimer(boolean loadTaskDef,boolean loadTask) {
		if (timer != null) timer.cancel();
		timer = new Timer();
		if (loadTaskDef) this.initialTaskDef();
		if (loadTask) this.initialTask();
	}
	
	public void initialTask() {
		for (int i=0;i<this.tasks.size();i++) {
			HashMap hm = (HashMap) this.tasks.get(i);
			String classname = (String) hm.get("classname");
			String pattern = (String) hm.get("pattern");
			UProfile up = new UProfile();
			for (Iterator iter = hm.keySet().iterator(); iter.hasNext();) {
				String keytmp = (String) iter.next();
				if (keytmp.indexOf("userprofile-") > -1) {
					String value = (String) hm.get(keytmp);
					up.set(keytmp.substring(keytmp.indexOf("-")+1),value);
				}
			} 
			
			if (classname != null && !classname.equals("")) {
				try {
					MyTimerTask mtt = (MyTimerTask) Class.forName(classname).newInstance();
					mtt.setTimer(timer);
					mtt.setClassname(classname);
					mtt.setData(pattern);
					mtt.calcTime();
					mtt.setUProfile(up);
					mtt.schedule(false);
				} catch (Exception e) {
					MyLog.error(this,e);
				} 
			}
		}
	}
	
	/**
	 * load task definition from xml
	 */
	public void initialTaskDef() {
		InitialEnvironment ie = new InitialEnvironment();
		String dir = ie.getValue("CONFIG-dir") + "TASKDEF.xml";
		ReadXml rx = new ReadXml(dir);
		Element root = rx.getRootElement();
		Vector vectask = new Vector(root.getChildren());
		for (int i=0;i<vectask.size();i++) {
			Element task = (Element) vectask.get(i);
			Element pattern = task.getChild("PATTERN");
			String classname = task.getChild("CLASS").getText();
			HashMap hm = new HashMap();
			StringBuffer strp = new StringBuffer(); 
			strp.append(pattern.getChild("SECOND").getText());
			strp.append(" ");strp.append(pattern.getChild("MINUTE").getText());
			strp.append(" ");strp.append(pattern.getChild("HOUR").getText());
			strp.append(" ");strp.append(pattern.getChild("DAY").getText());
			strp.append(" ");strp.append(pattern.getChild("MONTH").getText());
			strp.append(" ");strp.append(pattern.getChild("DOW").getText());
			strp.append(" ");strp.append(pattern.getChild("YEAR").getText());
			hm.put("pattern",strp.toString());
			hm.put("classname",classname);
			Vector vec = new Vector(pattern.getAttributes());
			for (int index=0;index<vec.size();index++) {
				Attribute  attrtmp = (Attribute) vec.get(index);
				String name = attrtmp.getName();
				String value = attrtmp.getValue();
				hm.put("userprofile-"+name,value);
			}
			tasks.add(hm);
		}
	}
}
