package com.csc.library.utilities.compare;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * @author somsuksri
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class CompareDatabase {
	private String protable, error = "ERROR !! ", warn = "WARN !! ", info = "INFO ";
	private StringBuffer msg = new StringBuffer();
	private Connection con1,con2;
	private String db1Schema,db2Schema;
	private Vector compare=new Vector();
	private int errorCount, warnCount;
	private String log="c:/compare/db-db.txt";
	private void initProtable() {
		try {
			File file1 = new File(this.protable);
			String fileList[] = file1.list();
			msg.append(this.info + "---- START COMPARE DATABASE ----\n");
			msg.append(this.info + "---- DATABASE1 " + this.con1.getMetaData().getURL() + "\n");
			msg.append(this.info + "---- DATABASE2 " + this.con2.getMetaData().getURL() + "\n");

			for (int i = 0; i < fileList.length; i++) {
				String fName = fileList[i];
				fName=fName.substring(0,fName.indexOf("."));
				System.out.print(fName+" in progress .");
				this.compare(fName,this.getMetaData(fName,this.db1Schema,this.con1),this.getMetaData(fName,this.db2Schema,this.con2));
				System.out.println("\t\tcompleted !!");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private ResultSetMetaData getMetaData(String tableName,String schema,Connection con){
		ResultSetMetaData rm=null;
		System.out.print(".");
		try {
			String sql="select * from "+schema+tableName;
				Statement st=con.createStatement();
				ResultSet rs=st.executeQuery(sql);
				rm = rs.getMetaData();
		} catch (Exception e) {
			//e.printStackTrace();
		}
		System.out.print(".");
		return rm;
	}	

	private void compare(String tableName,ResultSetMetaData rm1,ResultSetMetaData rm2) {
		System.out.print(".");
		this.msg.append("\n\n");
		if(rm1==null){
			msg.append(this.error + "\t\t\t- DATABASE1 not found table "+tableName+ " But was found in PROTABLE\n");
			this.errorCount++;
		}else if(rm2==null){
			msg.append(this.error + "\t\t\t- DATABASE2 not found table "+tableName+ " But was found in DB1 \n");
			this.errorCount++;
		}else{
			
			
			HashMap tm1=new HashMap();
			HashMap tm2=new HashMap(); 			
			try {
				for(int i=1;i<=rm1.getColumnCount();i++){
					String fieldName=rm1.getColumnName(i);
					int size=rm1.getPrecision(i);
					String type=String.valueOf(rm1.getColumnType(i));
					if(type.equals("91")){
						type="93";
					}	
					String typeName=rm1.getColumnTypeName(i);
					TableObj to1=new TableObj();
					to1.setColTypeName(typeName);
					to1.setColName(fieldName);
					to1.setColType(type);
					to1.setColSize(size);
					tm1.put(fieldName,to1);
				}	
				System.out.print(".");
				for(int i=1;i<=rm2.getColumnCount();i++){
					String fieldName=rm2.getColumnName(i);
					int size=rm2.getPrecision(i);
					String typeName=rm2.getColumnTypeName(i);
					String type=String.valueOf(rm2.getColumnType(i));
					if(type.equals("91")){
						type="93";
					}	
					TableObj to2=new TableObj();
					to2.setColTypeName(typeName);
					to2.setColName(fieldName);
					to2.setColType(type);
					to2.setColSize(size);
					tm2.put(fieldName,to2);
				}	
				this.Compare(tableName,tm1,tm2);
			} catch (SQLException e) {
			}
			

		}		
		System.out.print(".");	

	}	
	
	private void Compare(String tableName,HashMap m1,HashMap m2){
		Iterator it=m1.keySet().iterator();
		System.out.print(".");
		while(it.hasNext()){
			String key=(String)it.next();
			TableObj to1=(TableObj)m1.get(key);
			TableObj to2=(TableObj)m2.get(key);
				if(to2==null){
				if(this.compare.size()==0 || this.compare.contains("field")){
				msg.append(this.error + "\t\t\t- DATABASE table "+tableName+ " not found Field "+to1.getColName()+" \n");
				this.errorCount++;
				}
			}else{
				if(this.compare.size()==0 || this.compare.contains("type")){
				if(!to1.getColType().equalsIgnoreCase(to2.getColType())){
					msg.append(this.error + "\t\t\t- DATABASE table "+tableName+ " Field "+to1.getColName()+" type  missmatch\n");
					msg.append("\t\t\t\t\t\t\t\t Found  -->"+to1.getColTypeName()+ "<-- AND -->"+to2.getColTypeName()+"<-- \n");
					msg.append("\t\t\t\t\t\t\t\t Found  -->"+to1.getColName()+":"+to1.getColType()+":"+to1.getColSize()+ "<-- AND -->"+to2.getColName()+":"+to2.getColType()+":"+to2.getColSize()+"<-- \n");
					this.errorCount++;
				}}
				if(this.compare.size()==0 || this.compare.contains("size")){						
				if(to1.getColSize()!=to2.getColSize()){
					msg.append(this.error + "\t\t\t- DATABASE table "+tableName+ " Field "+to1.getColName()+" size  missmatch\n");
					msg.append("\t\t\t\t\t\t\t\t Found  -->"+to1.getColSize()+ "<-- AND -->"+to2.getColSize()+"<-- \n");
					msg.append("\t\t\t\t\t\t\t\t Found  -->"+to1.getColName()+":"+to1.getColType()+":"+to1.getColSize()+ "<-- AND -->"+to2.getColName()+":"+to2.getColType()+":"+to2.getColSize()+"<-- \n");
					this.errorCount++;
				}	}
	

			}		
		}
		System.out.print(".");	
	}	
	
	public void setProtablePath(String protablePath){
		this.protable=protablePath;
	}	
	
	public  void setDb1Properties(String driver,String url,String user,String password,String schema){
		this.con1=this.getConnection(driver,url,user,password);
		if(schema == null || schema.equals("")){
			schema="";
		}else{
			schema=schema+".";
		}	
		this.db1Schema=schema;
	}	
	
	public void setDb2Properties(String driver,String url,String user,String password,String schema){
		this.con2=this.getConnection(driver,url,user,password);
		if(schema == null || schema.equals("")){
			schema="";
		}else{
			schema=schema+".";
		}	
		this.db2Schema=schema;
	}	
	
	public void process(){
		this.initProtable();
		try {
			this.con1.close();
			this.con2.close();
		} catch (SQLException e) {
		}
		this.msg.append("\n\nCompleted found error " + this.errorCount + " warn " + this.warnCount + "\n");
		this.outFile();
		System.out.println("\n\nCompleted found error " + this.errorCount + " warn " + this.warnCount + "\n");
		System.out.println("Please see log in "+this.log);	
	}	
	
	private void outFile(){
		try {
			File f=new File(this.log);
			FileOutputStream fo=new FileOutputStream(f);
			byte [] b=this.msg.toString().getBytes();
			fo.write(b);
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
	}	
	
	private Connection getConnection(String driver,String url,String user,String password){
		try {
			Class.forName(driver);
			Properties	prop = new Properties();
			prop.put("user", user);
			prop.put("password", password);
			Connection con=DriverManager.getConnection(url, prop);
			return con;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}	
	}	 
	
	
public void setCompare(String compare) {
		//this.compare = new Vector();
		StringTokenizer st = new StringTokenizer(compare, ",");
		while (st.hasMoreTokens()) {
			this.compare.addElement(st.nextToken());
		}
	}


}

class TableObj{
	private String colName,colType,colTypeName;
	int colSize;
	
	/**
	 * Returns the colName.
	 * @return String
	 */
	public String getColName() {
		return colName;
	}

	/**
	 * Returns the colSize.
	 * @return int
	 */
	public int getColSize() {
		return colSize;
	}

	/**
	 * Returns the colType.
	 * @return String
	 */
	public String getColType() {
		return colType;
	}

	/**
	 * Sets the colName.
	 * @param colName The colName to set
	 */
	public void setColName(String colName) {
		this.colName = colName;
	}

	/**
	 * Sets the colSize.
	 * @param colSize The colSize to set
	 */
	public void setColSize(int colSize) {
		this.colSize = colSize;
	}

	/**
	 * Sets the colType.
	 * @param colType The colType to set
	 */
	public void setColType(String colType) {
		this.colType = colType;
	}
	
	/**
	 * Returns the colTypeName.
	 * @return String
	 */
	public String getColTypeName() {
		return colTypeName;
	}

	/**
	 * Sets the colTypeName.
	 * @param colTypeName The colTypeName to set
	 */
	public void setColTypeName(String colTypeName) {
		this.colTypeName = colTypeName;
	}

}	
