package com.csc.library.utilities.compare;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.util.Iterator;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.database.SystemCode;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.UProfile;
import com.csc.library.utilities.WriteXml;
/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class CompareDbPro {
	private String dbPath, proPath;
	private String[] dbList;
	private StringBuffer msg = new StringBuffer();
	private UProfile upf;
	private String log = "c:/compare/compareDb-Prolog.txt";
	private String outFile="c:/compare/dbChange/";
	private boolean isWrite=false;
	private Element activeElement;
	private String activeFile;
	public void process() {
		//	this.init();
		this.setDbList();
		this.compare();
		this.outFile();
	}
	private void init() {
		System.setProperty("payroll_config", "D:/EnterprisePT/TiscoFWCMPWUT/PREAPINT1P/XML/CONFIGXML/");
		System.out.println("::::: Start load protable  waiting......");
		StaticTest l = new StaticTest();
		l.process();
		System.out.println("::::: Load protable  commited......");
		String resource = new InitialEnvironment("GLOBAL").getValue("config-dir");
		new SystemCode().initValue(resource + "systemcode.xml");
		//DOMConfigurator.configure(resource + "logcfg.xml");
	}
	private void setDbList() {
		File f = new File(dbPath);
		this.dbList = f.list();
	}
	private void compare() {
		for (int i = 0; i < dbList.length; i++) {
			//String fileName=dbList[i].substring(0,dbList[i].indexOf("."));
			this.isWrite=false;
			String fileName = dbList[i];
			Element dbElement = this.getRootElement(this.dbPath, fileName);
			this.activeElement = dbElement;
			this.activeFile=fileName.substring(0,fileName.indexOf("."));
			this.compare(fileName, dbElement);
			if(isWrite){
				this.writeXML();
			}	
		}
	}
	private void compare(String fileName, Element dbElement) {
		Iterator it = dbElement.getChildren().iterator();
		while (it.hasNext()) {
			Element emTable = (Element) it.next();
			Element emPro = this.getRootElement(this.proPath, emTable.getAttributeValue("name") + ".xml");
			this.compare(fileName, emTable, emPro);
		}
	}
	private void writeXML() {
		WriteXml wx = new WriteXml((Element)this.activeElement.clone(), this.outFile + this.activeFile.toUpperCase());
		wx.output();
	}
	
	private void compare(String fName, Element emTable, Element emPro) {
		DbRecord db = null;
		if (emPro == null) {
			db = this.testRecord(fName, emTable.getAttributeValue("name"));
			if (db == null) {
				this.msg.append(fName + " Table " + emTable.getAttributeValue("name") + "  Not found \n");
				this.isWrite=true;
			}
		} else if (emPro != null || db != null) {
			Iterator it = emTable.getChildren().iterator();
			while (it.hasNext()) {
				Element em = (Element) it.next();
				if (em.getName().equals("FIELD")) {
					String fieldName = em.getText();
					if (this.getFieldElement(db, emPro, fieldName) == null) {
						boolean b = this.testField(db, fName, emTable.getAttributeValue("name"), fieldName);
						if (!b){
							this.msg.append(fName + " Table " + emTable.getAttributeValue("name") + " FieldName " + fieldName + " Not found \n");
							this.isWrite=true;
						}	
					}
				} else if (em.getName().equals("ORDER")) {
					Iterator it2 = em.getChildren().iterator();
					while (it2.hasNext()) {
						Element em2 = (Element) it2.next();
						String fieldName = em2.getText();
						if (this.getFieldElement(db, emPro, fieldName) == null) {
							boolean b = this.testField(db, fName, emTable.getAttributeValue("name"), fieldName);
							if (!b){
								this.msg.append(fName + " Table " + emTable.getAttributeValue("name") + " ORDER FieldName " + fieldName + " Not found \n");
								this.isWrite=true;
							}	
						}
					}
				}
			}
		}
	}
	private Element getFieldElement(DbRecord db, Element emPro, String fieldName) {
		Element data = null;
		try {
			if (emPro == null) {
				emPro = this.getRootElement(this.proPath, db.getTableName().toUpperCase() + ".xml");
			}
			if (emPro != null) {
				data = emPro.getChild("FIELD").getChild(fieldName.toUpperCase());
			}
		} catch (RemoteException e) {
		}
		return data;
	}
	private DbRecord testRecord(String fName, String table) {
		DbRecord db = null;
		try {
			db = new InitialRecord(this.upf).getDbRecord(this.converse(table));
		} catch (Exception e) {
			System.out.println("Chk table error   " + fName + " table   " + this.converse(table));
		}
		return db;
	}
	private String converse(String fName) {
		String data = null;
		try {
			data = fName.substring(0, 1).toUpperCase() + fName.substring(1, fName.length()).toLowerCase();
		} catch (RuntimeException e) {
		}
		return data;
	}
	private boolean testField(DbRecord db, String fName, String table, String field) {
		try {
			if (db == null) {
				db = new InitialRecord(this.upf).getDbRecord(this.converse(table));
			}
			System.out.println("Table  " + table + " Field  " + field + "   " + db.getField(field));
			if (db.getField(field) != null)
				return true;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}
	private Element getRootElement(String path, String fileName) {
		SAXBuilder builder = new SAXBuilder();
		Document stru = null;
		try {
			stru = builder.build(path + "/" + fileName);
			return stru.getRootElement();
		} catch (Exception ex) {
			return null;
		}
	}
	private void outFile() {
		try {
			File f = new File(this.log);
			FileOutputStream fo = new FileOutputStream(f);
			byte[] b = this.msg.toString().getBytes();
			fo.write(b);
			fo.close();
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
	}
	/**
	 * Sets the dbPath.
	 * @param dbPath The dbPath to set
	 */
	public void setDbPath(String dbPath) {
		this.dbPath = dbPath;
	}
	/**
	 * Sets the log.
	 * @param log The log to set
	 */
	public void setLog(String log) {
		this.log = log;
	}
	/**
	 * Sets the proPath.
	 * @param proPath The proPath to set
	 */
	public void setProPath(String proPath) {
		this.proPath = proPath;
	}
	public static void main(String args[]) {
		CompareDbPro com = new CompareDbPro();
		com.setDbPath("C:/compare/dbxml");
		com.setProPath("C:/compare/protable/pro1");
		com.process();
	}
	/**
	 * Sets the upf.
	 * @param upf The upf to set
	 */
	public void setUpf(UProfile upf) {
		this.upf = upf;
	}
}
