package com.csc.library.utilities.compare;
import java.io.File;
import java.util.Iterator;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

import com.csc.library.utilities.WriteXml;
/**
 * @author somsuksri
 *
 */
public class GenNormalProtable {
	private String mainProtable;
	private String log = "c:/compare/pro-pro.txt", outFileDir = "c:/compare/output/";
	private GenProLog gen = new GenProLog();
	
	public void process() {
		try {
			File file = new File(this.mainProtable);
			String fileList[] = file.list();
			for (int i = 0; i < fileList.length; i++) {
				String fName = fileList[i];
				Element root = this.getRootElement(this.mainProtable, fName);
				this.compare(root);
			}
		} catch (RuntimeException e) {
			e.printStackTrace();
		}
	}
			
	private void compare(Element root) {
		try {
			this.chkFixTableData("verify", "E",root);
			Iterator it=root.getChild("FIELD").getChildren().iterator();
			while(it.hasNext()){
				Element em=(Element)it.next();
				this.chkFixFieldData(root.getName(),"encrypt","false",em);
				this.chkFixFieldData(root.getName(),"verify","false",em);
			}	
			this.writeXML(root);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	private void chkFixFieldData(String tName,String key, String value,Element em) {
		try {
			em.getAttribute(key).setValue(value);
		} catch (RuntimeException e) {
			System.err.print("Table  "+ tName +" Field " + em.getName() + " Cannot find attribute " + key + " \n");
		}
	}
	private void chkFixTableData(String key, String value,Element root) {
		try {
			if (value != null) {
				root.getAttribute(key).setValue(value);
			}
		} catch (RuntimeException e) {
			System.err.print("FIELD ERROR Table " + root.getName() + "  cannot find attribute " + key + "  \n");
		}
	}
	private Element getRootElement(String path, String fileName) {
		SAXBuilder builder = new SAXBuilder();
		Document stru = null;
		try {
			stru = builder.build(path + "/" + fileName);
			return stru.getRootElement();
		} catch (Exception ex) {
			return null;
		}
	}
	private void writeXML(Element em) {
		WriteXml wx = new WriteXml(em, outFileDir + em.getName().toUpperCase());
		wx.output();
	}
	public void setMainProtable(String fileDir) {
		this.mainProtable = fileDir;
	}
}
