package com.csc.upload;
/***
 * @author Workflow
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import com.csc.library.utilities.MyLog;

public class FileManager {

	public FileManager(){
		
	}
	public void move2Realpath(String temppath, String targetpath){
        File tempf = new File(temppath);
        File f = new File(targetpath);
        
        if( tempf.exists() ){
            if( !f.exists() ){
                f.mkdirs();
            }
           	File ftemp = new File(temppath);
           	copyFolder2Folder(temppath,targetpath);
            delDir(temppath);
        }

	}	
    public void copyFolder2Folder(String src_folder, String target_folder) {
        if (!src_folder.endsWith("/"))
            src_folder += "/";
        if (!target_folder.endsWith("/"))
            target_folder += "/";
        
        File srcfolder = new File(src_folder);// read file in folder email
        File[] files = srcfolder.listFiles();
        
        try {
            for (int i = 0; i < files.length; i++)
                this.copy(files[i].getPath(),target_folder+files[i].getName());
        } catch (IOException e) {
            System.err.println(e.getMessage());
        }
    }
    
    public void copy(String source_name, String dest_name) throws IOException
	{
	    File source_file = new File(source_name);
	    File destination_file = new File(dest_name);
	    FileInputStream source = null;
	    FileOutputStream destination = null;
	    byte[] buffer;
	    int bytes_read;
	    try {
	        // First make sure the specified source file 
	        // exists, is a file, and is readable.
	        if (!source_file.exists() || !source_file.isFile())
	            throw new IOException("FileCopy: no such source file: " + source_name);
	        if (!source_file.canRead())
	            throw new IOException("FileCopy: source file " + "is unreadable: " + source_name);
	            File parentdir = parent(destination_file);
	            if (!parentdir.exists())
	                throw new IOException("FileCopy: destination " + "directory doesn't exist: " + dest_name);
	            if (!parentdir.canWrite())
	                throw new IOException("FileCopy: destination " + "directory is unwriteable: " + dest_name);
//	        }
	        
	        // If we've gotten this far, then everything is okay; we can
	        // copy the file.
	        source = new FileInputStream(source_file);
	        destination = new FileOutputStream(destination_file);
	        buffer = new byte[1024];
	        while(true) {
	            bytes_read = source.read(buffer);
	            if (bytes_read == -1) break;
	            destination.write(buffer, 0, bytes_read);
	        }
	    }
	    // No matter what happens, always close any streams we've opened.
	    finally {
	        if (source != null) 
	            try { source.close(); } catch (IOException e) { ; }
	        if (destination != null) 
	            try { destination.close(); } catch (IOException e) { ; }
	    }
	}
    public void delDir(String remDir) {
        // delete existing file in folder
        File file = new File(remDir);// read all files in folder]
        File[] files = file.listFiles();
        for( int i=0;i<files.length;i++ )
            files[i].delete();
        boolean success = (new File(remDir)).delete();
        if (success) {
            MyLog.info("Successfully deleted directory: " + remDir);
        } else {
        	MyLog.info("Failed to deletete directory: " + remDir);
        }
    }    
    
	private  File parent(File f) {
	    String dirname = f.getParent();
	    if (dirname == null) {
	        if (f.isAbsolute()) return new File(File.separator);
	        else return new File(System.getProperty("user.dir"));
	    }
	    return new File(dirname);
	}    
}
